use dadsops
go
drop procedure new_fos
go
create procedure new_fos as
/* newly delivered calibration files */
declare @new_file_name varchar(50)
declare @new_expansion_number int
declare @ref_type varchar(50)
declare @useafter_date datetime
declare @stop_date datetime
/* observation start time */
declare @expstart datetime
/* data set name, to be used for error checking/handling, should extract */
/* datatype from dt_mapping rather than hardcode it here, this will do for now */
declare @data_set_name varchar(39)
/* severity level variables, to be reused for each reference file type */
declare @orig_equiv_sev int
declare @orig_equiv_mod int
declare @equiv_sev int
declare @equiv_mod int
/* used to store @@rowcount global variable */
declare @num_cal_files int
/* observation modes, calibration files used in the pipeline, */
/* best, and best_loc files */
declare @fsr_fchnl int
declare @fsr_nxsteps int
declare @fsr_overscan int
declare @fsr_ccg2 char(18)
declare @fsr_ccs0 char(18)
declare @fsr_ccs1 char(18)
declare @fsr_ccs2 char(18)
declare @fsr_ccs3 char(18)
declare @fsr_ccs4 char(18)
declare @fsr_ccs5 char(18)
declare @fsr_ccs6 char(18)
declare @fsr_ccs7 char(18)
declare @fsr_ccs8 char(18)
declare @fsr_ccs9 char(18)
declare @fsr_ccsa char(18)
declare @fsr_ccsb char(18)
declare @fsr_ccsc char(18)
declare @fsr_ccsd char(18)
declare @fsr_aper_id char(3)
declare @fsr_fgwa_id char(3)
declare @fsr_detector char(5)
declare @fsr_polar_id char(1)
declare @fsr_aishfile char(18)
declare @fsr_bachfile char(18)
declare @fsr_best_ais char(18)
declare @fsr_best_bac char(18)
declare @fsr_best_ddt char(18)
declare @fsr_best_ret char(18)
declare @fsr_ddthfile char(18)
declare @fsr_dq1hfile char(18)
declare @fsr_dq2hfile char(18)
declare @fsr_fl1hfile char(18)
declare @fsr_fl2hfile char(18)
declare @fsr_iv1hfile char(18)
declare @fsr_iv2hfile char(18)
declare @fsr_rethfile char(18)
declare @fsr_pcphfile char(18)
declare @fsr_best_ccg2 char(18)
declare @fsr_best_ccs0 char(18)
declare @fsr_best_ccs1 char(18)
declare @fsr_best_ccs2 char(18)
declare @fsr_best_ccs3 char(18)
declare @fsr_best_ccs4 char(18)
declare @fsr_best_ccs5 char(18)
declare @fsr_best_ccs6 char(18)
declare @fsr_best_ccs7 char(18)
declare @fsr_best_ccs8 char(18)
declare @fsr_best_ccs9 char(18)
declare @fsr_best_ccsa char(18)
declare @fsr_best_ccsb char(18)
declare @fsr_best_ccsc char(18)
declare @fsr_best_ccsd char(18)
declare @fsr_best_flt1 char(18)
declare @fsr_best_flt2 char(18)
declare @fsr_best_ivs1 char(18)
declare @fsr_best_ivs2 char(18)
declare @fsr_best_qin1 char(18)
declare @fsr_best_qin2 char(18)
declare @fsr_best_pcp char(18)
declare @fsr_best_loc_ais varchar(9)
declare @fsr_best_loc_bac varchar(9)
declare @fsr_best_loc_ddt varchar(9)
declare @fsr_best_loc_ret varchar(9)
declare @fsr_best_loc_ccg2 varchar(9)
declare @fsr_best_loc_ccs0 varchar(9)
declare @fsr_best_loc_ccs1 varchar(9)
declare @fsr_best_loc_ccs2 varchar(9)
declare @fsr_best_loc_ccs3 varchar(9)
declare @fsr_best_loc_ccs4 varchar(9)
declare @fsr_best_loc_ccs5 varchar(9)
declare @fsr_best_loc_ccs6 varchar(9)
declare @fsr_best_loc_ccs7 varchar(9)
declare @fsr_best_loc_ccs8 varchar(9)
declare @fsr_best_loc_ccs9 varchar(9)
declare @fsr_best_loc_ccsa varchar(9)
declare @fsr_best_loc_ccsb varchar(9)
declare @fsr_best_loc_ccsc varchar(9)
declare @fsr_best_loc_ccsd varchar(9)
declare @fsr_best_loc_flt1 varchar(9)
declare @fsr_best_loc_flt2 varchar(9)
declare @fsr_best_loc_ivs1 varchar(9)
declare @fsr_best_loc_ivs2 varchar(9)
declare @fsr_best_loc_qin1 varchar(9)
declare @fsr_best_loc_qin2 varchar(9)
declare @fsr_best_loc_pcp varchar(9)
declare @aper_pos varchar(6)	/* mod */
declare @pass_dir int		/* mod */
/**************************************************************************/
/************************ New   fos ***********************/
/**************************************************************************/

declare new_fos_cursor cursor for
        select  file_name, expansion_number
        from    new_cal_files
        where   instrument = 'FOS'
for read only

open new_fos_cursor

fetch new_fos_cursor into @new_file_name, @new_expansion_number

while (@@sqlstatus = 0)/* more newly delivered calibration files*/
begin

select @ref_type = fos_file.reference_file_type,
@useafter_date = fos_file.useafter_date,
@equiv_sev = fos_row.equivalence_class_severe,
@equiv_mod = fos_row.equivalence_class_moderate
,@fsr_fchnl=fos_row.fchnl
,@fsr_aper_id=fos_row.aper_id
,@fsr_fgwa_id=fos_row.fgwa_id
,@fsr_nxsteps=fos_row.nxsteps
,@fsr_detector=fos_row.detector
,@fsr_overscan=fos_row.overscan
,@fsr_polar_id=fos_row.polar_id
,@aper_pos = fos_row.aper_pos		/* mod */
,@pass_dir = fos_row.pass_dir		/* mod */
from fos_file fos_file, fos_row fos_row
where fos_file.file_name = @new_file_name 
and fos_row.file_name = @new_file_name
and fos_file.expansion_number = @new_expansion_number
and fos_row.expansion_number = @new_expansion_number


        if (@ref_type = 'CCG2')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCG2"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccg2_update_cursor cursor for
                select fsr_ccg2
                  /* Add modes to the select list, if rft = table */
                ,fsr_detector
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccg2_update_cursor

                fetch ccg2_update_cursor into @fsr_ccg2
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_detector

                while (@@sqlstatus = 0) /* While more ccg2 files */

                begin
/* mod - don't compute loc - detector value=1,2 in table, amber,blue in db */
                  if (@fsr_ccg2 = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccg2 = "N/A"
                  else if (@new_file_name = @fsr_ccg2)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccg2 = "NO CHANGE"
                  else
                        select @fsr_best_loc_ccg2 = "N/A"
/* end mod */
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccg2= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccg2 = @fsr_best_loc_ccg2
                   where  current of ccg2_update_cursor
        
                  fetch ccg2_update_cursor into @fsr_ccg2
                  /* Print modes, if rft = table */
                ,@fsr_detector
 

                end /* while more ccg2 files */

                close ccg2_update_cursor

                deallocate cursor ccg2_update_cursor
        end /* if @ref_type = 'CCG2') */


        if (@ref_type = 'CCS0')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCS0"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccs0_update_cursor cursor for
                select fsr_ccs0
                  /* Add modes to the select list, if rft = table */
                ,fsr_aper_id
                ,fsr_detector
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccs0_update_cursor

                fetch ccs0_update_cursor into @fsr_ccs0
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_aper_id
                ,@fsr_detector

                while (@@sqlstatus = 0) /* While more ccs0 files */

                begin
/* mod - can't compute loc - need aper_pos */
                  if (@fsr_ccs0 = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccs0 = "N/A"
                  else if (@new_file_name = @fsr_ccs0)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccs0 = "NO CHANGE"
                  else
                        select @fsr_best_loc_ccs0 = "N/A"
/* end mod */ 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccs0= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccs0 = @fsr_best_loc_ccs0
                   where  current of ccs0_update_cursor
        

                  fetch ccs0_update_cursor into @fsr_ccs0
                  /* Print modes, if rft = table */
                ,@fsr_aper_id
                ,@fsr_detector
 

                end /* while more ccs0 files */

                close ccs0_update_cursor

                deallocate cursor ccs0_update_cursor

        end /* if @ref_type = 'CCS0') */


        if (@ref_type = 'CCS1')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCS1"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccs1_update_cursor cursor for
                select fsr_ccs1
                  /* Add modes to the select list, if rft = table */
                ,fsr_fgwa_id
                ,fsr_detector
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccs1_update_cursor

                fetch ccs1_update_cursor into @fsr_ccs1
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_fgwa_id
                ,@fsr_detector

                while (@@sqlstatus = 0) /* While more ccs1 files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = fos_row.equivalence_class_severe,
                                @equiv_mod = fos_row.equivalence_class_moderate
                        from fos_row fos_row
                        where fos_row.file_name = @new_file_name
                        and fos_row.expansion_number = @new_expansion_number
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_ccs1 = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccs1 = "N/A"
                  else if (@new_file_name = @fsr_ccs1)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccs1 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ccs1 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_ccs1
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ccs1 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ccs1 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ccs1 = "MODERATE"
                             else select @fsr_best_loc_ccs1 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccs1= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccs1 = @fsr_best_loc_ccs1
                   where  current of ccs1_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch ccs1_update_cursor into @fsr_ccs1
                  /* Print modes, if rft = table */
                ,@fsr_fgwa_id
                ,@fsr_detector
 

                end /* while more ccs1 files */

                close ccs1_update_cursor

                deallocate cursor ccs1_update_cursor
        end /* if @ref_type = 'CCS1') */


        if (@ref_type = 'CCS2')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCS2"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccs2_update_cursor cursor for
                select fsr_ccs2
                  /* Add modes to the select list, if rft = table */
                ,fsr_fchnl
                ,fsr_fgwa_id
                ,fsr_nxsteps
                ,fsr_detector
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccs2_update_cursor

                fetch ccs2_update_cursor into @fsr_ccs2
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_fchnl
                ,@fsr_fgwa_id
                ,@fsr_nxsteps
                ,@fsr_detector

                while (@@sqlstatus = 0) /* While more ccs2 files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = fos_row.equivalence_class_severe,
                                @equiv_mod = fos_row.equivalence_class_moderate
                        from fos_row fos_row
                        where fos_row.file_name = @new_file_name
                        and fos_row.expansion_number = @new_expansion_number
                        and fos_row.fchnl = @fsr_fchnl
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.nxsteps = @fsr_nxsteps
                        and fos_row.detector = @fsr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_ccs2 = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccs2 = "N/A"
                  else if (@new_file_name = @fsr_ccs2)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccs2 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ccs2 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_ccs2
                        and fos_row.fchnl = @fsr_fchnl
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.nxsteps = @fsr_nxsteps
                        and fos_row.detector = @fsr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ccs2 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ccs2 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ccs2 = "MODERATE"
                             else select @fsr_best_loc_ccs2 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccs2= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccs2 = @fsr_best_loc_ccs2
                   where  current of ccs2_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch ccs2_update_cursor into @fsr_ccs2
                  /* Print modes, if rft = table */
                ,@fsr_fchnl
                ,@fsr_fgwa_id
                ,@fsr_nxsteps
                ,@fsr_detector
 

                end /* while more ccs2 files */

                close ccs2_update_cursor

                deallocate cursor ccs2_update_cursor
        end /* if @ref_type = 'CCS2') */


        if (@ref_type = 'CCS3')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCS3"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccs3_update_cursor cursor for
                select fsr_ccs3
                  /* Add modes to the select list, if rft = table */
                ,fsr_detector
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccs3_update_cursor

                fetch ccs3_update_cursor into @fsr_ccs3
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_detector

                while (@@sqlstatus = 0) /* While more ccs3 files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = fos_row.equivalence_class_severe,
                                @equiv_mod = fos_row.equivalence_class_moderate
                        from fos_row fos_row
                        where fos_row.file_name = @new_file_name
                        and fos_row.expansion_number = @new_expansion_number
                        and fos_row.detector = @fsr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_ccs3 = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccs3 = "N/A"
                  else if (@new_file_name = @fsr_ccs3)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccs3 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ccs3 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_ccs3
                        and fos_row.detector = @fsr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ccs3 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ccs3 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ccs3 = "MODERATE"
                             else select @fsr_best_loc_ccs3 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccs3= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccs3 = @fsr_best_loc_ccs3
                   where  current of ccs3_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch ccs3_update_cursor into @fsr_ccs3
                  /* Print modes, if rft = table */
                ,@fsr_detector
 

                end /* while more ccs3 files */

                close ccs3_update_cursor

                deallocate cursor ccs3_update_cursor
        end /* if @ref_type = 'CCS3') */


        if (@ref_type = 'CCS4')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCS4"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccs4_update_cursor cursor for
                select fsr_ccs4
                  /* Add modes to the select list, if rft = table */
                ,fsr_fgwa_id
                ,fsr_detector
                ,fsr_polar_id
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccs4_update_cursor

                fetch ccs4_update_cursor into @fsr_ccs4
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_fgwa_id
                ,@fsr_detector
                ,@fsr_polar_id

                while (@@sqlstatus = 0) /* While more ccs4 files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = fos_row.equivalence_class_severe,
                                @equiv_mod = fos_row.equivalence_class_moderate
                        from fos_row fos_row
                        where fos_row.file_name = @new_file_name
                        and fos_row.expansion_number = @new_expansion_number
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.polar_id = @fsr_polar_id

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_ccs4 = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccs4 = "N/A"
                  else if (@new_file_name = @fsr_ccs4)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccs4 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ccs4 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_ccs4
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.polar_id = @fsr_polar_id
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ccs4 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ccs4 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ccs4 = "MODERATE"
                             else select @fsr_best_loc_ccs4 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccs4= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccs4 = @fsr_best_loc_ccs4
                   where  current of ccs4_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch ccs4_update_cursor into @fsr_ccs4
                  /* Print modes, if rft = table */
                ,@fsr_fgwa_id
                ,@fsr_detector
                ,@fsr_polar_id
 

                end /* while more ccs4 files */

                close ccs4_update_cursor

                deallocate cursor ccs4_update_cursor
        end /* if @ref_type = 'CCS4') */


        if (@ref_type = 'CCS5')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCS5"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccs5_update_cursor cursor for
                select fsr_ccs5
                  /* Add modes to the select list, if rft = table */
                ,fsr_aper_id
                ,fsr_fgwa_id
                ,fsr_nxsteps
                ,fsr_detector
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccs5_update_cursor

                fetch ccs5_update_cursor into @fsr_ccs5
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_aper_id
                ,@fsr_fgwa_id
                ,@fsr_nxsteps
                ,@fsr_detector

                while (@@sqlstatus = 0) /* While more ccs5 files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = fos_row.equivalence_class_severe,
                                @equiv_mod = fos_row.equivalence_class_moderate
                        from fos_row fos_row
                        where fos_row.file_name = @new_file_name
                        and fos_row.expansion_number = @new_expansion_number
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.nxsteps = @fsr_nxsteps
                        and fos_row.detector = @fsr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_ccs5 = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccs5 = "N/A"
                  else if (@new_file_name = @fsr_ccs5)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccs5 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ccs5 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_ccs5
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.nxsteps = @fsr_nxsteps
                        and fos_row.detector = @fsr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ccs5 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ccs5 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ccs5 = "MODERATE"
                             else select @fsr_best_loc_ccs5 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccs5= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccs5 = @fsr_best_loc_ccs5
                   where  current of ccs5_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch ccs5_update_cursor into @fsr_ccs5
                  /* Print modes, if rft = table */
                ,@fsr_aper_id
                ,@fsr_fgwa_id
                ,@fsr_nxsteps
                ,@fsr_detector
 

                end /* while more ccs5 files */

                close ccs5_update_cursor

                deallocate cursor ccs5_update_cursor
        end /* if @ref_type = 'CCS5') */


        if (@ref_type = 'CCS6')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCS6"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccs6_update_cursor cursor for
                select fsr_ccs6
                  /* Add modes to the select list, if rft = table */
                ,fsr_aper_id
                ,fsr_fgwa_id
                ,fsr_detector
                ,fsr_polar_id
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccs6_update_cursor

                fetch ccs6_update_cursor into @fsr_ccs6
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_aper_id
                ,@fsr_fgwa_id
                ,@fsr_detector
                ,@fsr_polar_id

                while (@@sqlstatus = 0) /* While more ccs6 files */

                begin
/* mod - can't compute loc - need aper_pos */
                  if (@fsr_ccs6 = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccs6 = "N/A"
                  else if (@new_file_name = @fsr_ccs6)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccs6 = "NO CHANGE"
                  else
                        select @fsr_best_loc_ccs6 = "N/A"
/* end mod */ 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccs6= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccs6 = @fsr_best_loc_ccs6
                   where  current of ccs6_update_cursor
        

                  fetch ccs6_update_cursor into @fsr_ccs6
                  /* Print modes, if rft = table */
                ,@fsr_aper_id
                ,@fsr_fgwa_id
                ,@fsr_detector
                ,@fsr_polar_id
 

                end /* while more ccs6 files */

                close ccs6_update_cursor

                deallocate cursor ccs6_update_cursor
        end /* if @ref_type = 'CCS6') */


        if (@ref_type = 'CCS7')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCS7"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccs7_update_cursor cursor for
                select fsr_ccs7
                  /* Add modes to the select list, if rft = table */
                ,fsr_detector
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccs7_update_cursor

                fetch ccs7_update_cursor into @fsr_ccs7
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_detector

                while (@@sqlstatus = 0) /* While more ccs7 files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = fos_row.equivalence_class_severe,
                                @equiv_mod = fos_row.equivalence_class_moderate
                        from fos_row fos_row
                        where fos_row.file_name = @new_file_name
                        and fos_row.expansion_number = @new_expansion_number
                        and fos_row.detector = @fsr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_ccs7 = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccs7 = "N/A"
                  else if (@new_file_name = @fsr_ccs7)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccs7 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ccs7 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_ccs7
                        and fos_row.detector = @fsr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ccs7 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ccs7 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ccs7 = "MODERATE"
                             else select @fsr_best_loc_ccs7 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccs7= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccs7 = @fsr_best_loc_ccs7
                   where  current of ccs7_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch ccs7_update_cursor into @fsr_ccs7
                  /* Print modes, if rft = table */
                ,@fsr_detector
 

                end /* while more ccs7 files */

                close ccs7_update_cursor

                deallocate cursor ccs7_update_cursor
        end /* if @ref_type = 'CCS7') */


        if (@ref_type = 'CCS8')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCS8"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccs8_update_cursor cursor for
                select fsr_ccs8
                  /* Add modes to the select list, if rft = table */
                ,fsr_detector
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccs8_update_cursor

                fetch ccs8_update_cursor into @fsr_ccs8
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_detector

                while (@@sqlstatus = 0) /* While more ccs8 files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = fos_row.equivalence_class_severe,
                                @equiv_mod = fos_row.equivalence_class_moderate
                        from fos_row fos_row
                        where fos_row.file_name = @new_file_name
                        and fos_row.expansion_number = @new_expansion_number
                        and fos_row.detector = @fsr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_ccs8 = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccs8 = "N/A"
                  else if (@new_file_name = @fsr_ccs8)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccs8 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ccs8 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_ccs8
                        and fos_row.detector = @fsr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ccs8 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ccs8 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ccs8 = "MODERATE"
                             else select @fsr_best_loc_ccs8 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccs8= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccs8 = @fsr_best_loc_ccs8
                   where  current of ccs8_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch ccs8_update_cursor into @fsr_ccs8
                  /* Print modes, if rft = table */
                ,@fsr_detector
 

                end /* while more ccs8 files */

                close ccs8_update_cursor

                deallocate cursor ccs8_update_cursor
        end /* if @ref_type = 'CCS8') */


        if (@ref_type = 'CCS9')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCS9"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccs9_update_cursor cursor for
                select fsr_ccs9
                  /* Add modes to the select list, if rft = table */
                ,fsr_fgwa_id
                ,fsr_detector
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccs9_update_cursor

                fetch ccs9_update_cursor into @fsr_ccs9
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_fgwa_id
                ,@fsr_detector

                while (@@sqlstatus = 0) /* While more ccs9 files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = fos_row.equivalence_class_severe,
                                @equiv_mod = fos_row.equivalence_class_moderate
                        from fos_row fos_row
                        where fos_row.file_name = @new_file_name
                        and fos_row.expansion_number = @new_expansion_number
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_ccs9 = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccs9 = "N/A"
                  else if (@new_file_name = @fsr_ccs9)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccs9 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ccs9 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_ccs9
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ccs9 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ccs9 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ccs9 = "MODERATE"
                             else select @fsr_best_loc_ccs9 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccs9= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccs9 = @fsr_best_loc_ccs9
                   where  current of ccs9_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch ccs9_update_cursor into @fsr_ccs9
                  /* Print modes, if rft = table */
                ,@fsr_fgwa_id
                ,@fsr_detector
 

                end /* while more ccs9 files */

                close ccs9_update_cursor

                deallocate cursor ccs9_update_cursor
        end /* if @ref_type = 'CCS9') */


        if (@ref_type = 'CCSA')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCSA"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccsa_update_cursor cursor for
                select fsr_ccsa
                  /* Add modes to the select list, if rft = table */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccsa_update_cursor

                fetch ccsa_update_cursor into @fsr_ccsa
                  /* Add modes to the fetch statement, if rft = table */

                while (@@sqlstatus = 0) /* While more ccsa files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = fos_row.equivalence_class_severe,
                                @equiv_mod = fos_row.equivalence_class_moderate
                        from fos_row fos_row
                        where fos_row.file_name = @new_file_name
                        and fos_row.expansion_number = @new_expansion_number

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_ccsa = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccsa = "N/A"
                  else if (@new_file_name = @fsr_ccsa)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccsa = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ccsa = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_ccsa
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ccsa = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ccsa = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ccsa = "MODERATE"
                             else select @fsr_best_loc_ccsa = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccsa= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccsa = @fsr_best_loc_ccsa
                   where  current of ccsa_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch ccsa_update_cursor into @fsr_ccsa
                  /* Print modes, if rft = table */
 

                end /* while more ccsa files */

                close ccsa_update_cursor

                deallocate cursor ccsa_update_cursor
        end /* if @ref_type = 'CCSA') */


        if (@ref_type = 'CCSB')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCSB"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccsb_update_cursor cursor for
                select fsr_ccsb
                  /* Add modes to the select list, if rft = table */
                ,fsr_aper_id
                ,fsr_fgwa_id
                ,fsr_detector
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccsb_update_cursor

                fetch ccsb_update_cursor into @fsr_ccsb
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_aper_id
                ,@fsr_fgwa_id
                ,@fsr_detector

                while (@@sqlstatus = 0) /* While more ccsb files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = fos_row.equivalence_class_severe,
                                @equiv_mod = fos_row.equivalence_class_moderate
                        from fos_row fos_row
                        where fos_row.file_name = @new_file_name
                        and fos_row.expansion_number = @new_expansion_number
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_ccsb = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccsb = "N/A"
                  else if (@new_file_name = @fsr_ccsb)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccsb = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ccsb = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_ccsb
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ccsb = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ccsb = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ccsb = "MODERATE"
                             else select @fsr_best_loc_ccsb = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccsb= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccsb = @fsr_best_loc_ccsb
                   where  current of ccsb_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch ccsb_update_cursor into @fsr_ccsb
                  /* Print modes, if rft = table */
                ,@fsr_aper_id
                ,@fsr_fgwa_id
                ,@fsr_detector
 

                end /* while more ccsb files */

                close ccsb_update_cursor

                deallocate cursor ccsb_update_cursor
        end /* if @ref_type = 'CCSB') */


        if (@ref_type = 'PCP')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "PCP"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare pcp_update_cursor cursor for
                select fsr_pcphfile
                  /* Add modes to the select list, if rft = table */
                ,fsr_aper_id
                ,fsr_fgwa_id
                ,fsr_detector
		,fsr_polar_id
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open pcp_update_cursor

                fetch pcp_update_cursor into @fsr_pcphfile
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_aper_id
                ,@fsr_fgwa_id
                ,@fsr_detector
		,@fsr_polar_id

                while (@@sqlstatus = 0) /* While more pcp files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = fos_row.equivalence_class_severe,
                                @equiv_mod = fos_row.equivalence_class_moderate
                        from fos_row fos_row
                        where fos_row.file_name = @new_file_name
                        and fos_row.expansion_number = @new_expansion_number
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
			and fos_row.polar_id = @fsr_polar_id

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_pcphfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_pcp = "N/A"
                  else if (@new_file_name = @fsr_pcphfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_pcp = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_pcp = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_pcphfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
			and fos_row.polar_id = @fsr_polar_id
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_pcp = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_pcp = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_pcp = "MODERATE"
                             else select @fsr_best_loc_pcp = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_pcp = @new_file_name, /* if rft = image or table */
                       fsr_best_loc_pcp = @fsr_best_loc_pcp
                   where  current of pcp_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch pcp_update_cursor into @fsr_pcphfile
                  /* Print modes, if rft = table */
                ,@fsr_aper_id
                ,@fsr_fgwa_id
                ,@fsr_detector
		,@fsr_polar_id
 

                end /* while more pcp files */

                close pcp_update_cursor

                deallocate cursor pcp_update_cursor
        end /* if @ref_type = 'PCP') */


        if (@ref_type = 'CCSC')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCSC"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccsc_update_cursor cursor for
                select fsr_ccsc
                  /* Add modes to the select list, if rft = table */
                ,fsr_aper_id
                ,fsr_detector
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccsc_update_cursor

                fetch ccsc_update_cursor into @fsr_ccsc
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_aper_id
                ,@fsr_detector

                while (@@sqlstatus = 0) /* While more ccsc files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = fos_row.equivalence_class_severe,
                                @equiv_mod = fos_row.equivalence_class_moderate
                        from fos_row fos_row
                        where fos_row.file_name = @new_file_name
                        and fos_row.expansion_number = @new_expansion_number
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.detector = @fsr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_ccsc = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccsc = "N/A"
                  else if (@new_file_name = @fsr_ccsc)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccsc = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ccsc = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_ccsc
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.detector = @fsr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ccsc = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ccsc = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ccsc = "MODERATE"
                             else select @fsr_best_loc_ccsc = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccsc= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccsc = @fsr_best_loc_ccsc
                   where  current of ccsc_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch ccsc_update_cursor into @fsr_ccsc
                  /* Print modes, if rft = table */
                ,@fsr_aper_id
                ,@fsr_detector
 

                end /* while more ccsc files */

                close ccsc_update_cursor

                deallocate cursor ccsc_update_cursor
        end /* if @ref_type = 'CCSC') */


        if (@ref_type = 'CCSD')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "CCSD"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccsd_update_cursor cursor for
                select fsr_ccsd
                  /* Add modes to the select list, if rft = table */
                ,fsr_fgwa_id
                ,fsr_detector
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open ccsd_update_cursor

                fetch ccsd_update_cursor into @fsr_ccsd
                  /* Add modes to the fetch statement, if rft = table */
                ,@fsr_fgwa_id
                ,@fsr_detector

                while (@@sqlstatus = 0) /* While more ccsd files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = fos_row.equivalence_class_severe,
                                @equiv_mod = fos_row.equivalence_class_moderate
                        from fos_row fos_row
                        where fos_row.file_name = @new_file_name
                        and fos_row.expansion_number = @new_expansion_number
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_ccsd = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ccsd = "N/A"
                  else if (@new_file_name = @fsr_ccsd)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ccsd = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ccsd = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_ccsd
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ccsd = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ccsd = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ccsd = "MODERATE"
                             else select @fsr_best_loc_ccsd = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ccsd= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ccsd = @fsr_best_loc_ccsd
                   where  current of ccsd_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch ccsd_update_cursor into @fsr_ccsd
                  /* Print modes, if rft = table */
                ,@fsr_fgwa_id
                ,@fsr_detector
 

                end /* while more ccsd files */

                close ccsd_update_cursor

                deallocate cursor ccsd_update_cursor
        end /* if @ref_type = 'CCSD') */


        if (@ref_type = 'AIS')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "AIS"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ais_update_cursor cursor for
                select fsr_aishfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open ais_update_cursor

                fetch ais_update_cursor into @fsr_aishfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more ais files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_aishfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ais = "N/A"
                  else if (@new_file_name = @fsr_aishfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ais = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ais = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_aishfile
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ais = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ais = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ais = "MODERATE"
                             else select @fsr_best_loc_ais = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ais= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ais = @fsr_best_loc_ais
                   where  current of ais_update_cursor
        
                  fetch ais_update_cursor into @fsr_aishfile
                  /* Don't print modes, if rft = image */
 

                end /* while more ais files */

                close ais_update_cursor

                deallocate cursor ais_update_cursor
        end /* if @ref_type = 'AIS') */


        if (@ref_type = 'BAC')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "BAC"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare bac_update_cursor cursor for
                select fsr_bachfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                for update

                open bac_update_cursor

                fetch bac_update_cursor into @fsr_bachfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more bac files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_bachfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_bac = "N/A"
                  else if (@new_file_name = @fsr_bachfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_bac = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_bac = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_bachfile
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_bac = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_bac = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_bac = "MODERATE"
                             else select @fsr_best_loc_bac = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_bac= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_bac = @fsr_best_loc_bac
                   where  current of bac_update_cursor
        
                  fetch bac_update_cursor into @fsr_bachfile
                  /* Don't print modes, if rft = image */
 

                end /* while more bac files */

                close bac_update_cursor

                deallocate cursor bac_update_cursor
        end /* if @ref_type = 'BAC') */


        if (@ref_type = 'DDT')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "DDT"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.detector = @fsr_detector
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ddt_update_cursor cursor for
                select fsr_ddthfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_detector = @fsr_detector
                for update

                open ddt_update_cursor

                fetch ddt_update_cursor into @fsr_ddthfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more ddt files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_ddthfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ddt = "N/A"
                  else if (@new_file_name = @fsr_ddthfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ddt = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ddt = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_ddthfile
                        and fos_row.detector = @fsr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ddt = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ddt = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ddt = "MODERATE"
                             else select @fsr_best_loc_ddt = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ddt= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ddt = @fsr_best_loc_ddt
                   where  current of ddt_update_cursor
        
                  fetch ddt_update_cursor into @fsr_ddthfile
                  /* Don't print modes, if rft = image */
 

                end /* while more ddt files */

                close ddt_update_cursor

                deallocate cursor ddt_update_cursor
        end /* if @ref_type = 'DDT') */


        if (@ref_type = 'RET')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "RET"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ret_update_cursor cursor for
                select fsr_rethfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open ret_update_cursor

                fetch ret_update_cursor into @fsr_rethfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more ret files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_rethfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ret = "N/A"
                  else if (@new_file_name = @fsr_rethfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ret = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ret = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_rethfile
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
 

                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ret = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ret = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ret = "MODERATE"
                             else select @fsr_best_loc_ret = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ret= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ret = @fsr_best_loc_ret
                   where  current of ret_update_cursor
        
                  fetch ret_update_cursor into @fsr_rethfile
                  /* Don't print modes, if rft = image */
 

                end /* while more ret files */

                close ret_update_cursor

                deallocate cursor ret_update_cursor
        end /* if @ref_type = 'RET') */


        if (@ref_type = 'FLT')
        begin
/* mod - entire section */
if (@aper_pos = 'SINGLE' and @pass_dir = 0)  /* single aperture */
begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "FLT"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 0
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare flt_update_cursor cursor for
                select fsr_fl1hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open flt_update_cursor

                fetch flt_update_cursor into @fsr_fl1hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more flt files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_fl1hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_flt1 = "N/A"
                  else if (@new_file_name = @fsr_fl1hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_flt1 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_flt1 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_fl1hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 0 

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_flt1 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_flt1 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_flt1 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_flt1 = "MODERATE"
                             else select @fsr_best_loc_flt1 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_flt1= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_flt1 = @fsr_best_loc_flt1
                   where  current of flt_update_cursor
        
                  fetch flt_update_cursor into @fsr_fl1hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more flt files */

                close flt_update_cursor

                deallocate cursor flt_update_cursor

end /* single aperture*/
else
 if (@aper_pos = 'SINGLE' and @pass_dir = 1)	/* polarimetry - compute flt1*/
 begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "FLT"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 1
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare flt_update_cursor cursor for
                select fsr_fl1hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open flt_update_cursor

                fetch flt_update_cursor into @fsr_fl1hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more flt files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_fl1hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_flt1 = "N/A"
                  else if (@new_file_name = @fsr_fl1hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_flt1 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_flt1 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_fl1hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 1

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_flt1 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_flt1 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_flt1 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_flt1 = "MODERATE"
                             else select @fsr_best_loc_flt1 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_flt1= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_flt1 = @fsr_best_loc_flt1
                   where  current of flt_update_cursor
        
                  fetch flt_update_cursor into @fsr_fl1hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more flt files */

                close flt_update_cursor

                deallocate cursor flt_update_cursor

 end /* polarimetry - flt1*/
 else
  if (@aper_pos = 'SINGLE' and @pass_dir=2)	/* polarimetry - flt2 */ 
  begin
                       /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "FLT"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 2
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare flt_update_cursor cursor for
                select fsr_fl2hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open flt_update_cursor

                fetch flt_update_cursor into @fsr_fl2hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more flt files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_fl2hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_flt2 = "N/A"
                  else if (@new_file_name = @fsr_fl2hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_flt2 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_flt2 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_fl2hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 2

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_flt2 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_flt2 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_flt2 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_flt2 = "MODERATE"
                             else select @fsr_best_loc_flt2 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_flt2= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_flt2 = @fsr_best_loc_flt2
                   where  current of flt_update_cursor
        
                  fetch flt_update_cursor into @fsr_fl2hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more flt files */

                close flt_update_cursor

                deallocate cursor flt_update_cursor

  end /* polarimetry - flt2 */
  else
   if (@aper_pos = 'LOWER')	/* paired aperture - flt1 */
   begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "FLT"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'LOWER'
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare flt_update_cursor cursor for
                select fsr_fl1hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open flt_update_cursor

                fetch flt_update_cursor into @fsr_fl1hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more flt files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_fl1hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_flt1 = "N/A"
                  else if (@new_file_name = @fsr_fl1hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_flt1 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_flt1 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_fl1hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'LOWER'

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_flt1 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_flt1 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_flt1 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_flt1 = "MODERATE"
                             else select @fsr_best_loc_flt1 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_flt1= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_flt1 = @fsr_best_loc_flt1
                   where  current of flt_update_cursor
        
                  fetch flt_update_cursor into @fsr_fl1hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more flt files */

                close flt_update_cursor

                deallocate cursor flt_update_cursor

   end /* paired aperture - flt1 */
   else
    if (@aper_pos = 'UPPER')	/* paired aperture - flt2 */
    begin
                       /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "FLT"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'UPPER'
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare flt_update_cursor cursor for
                select fsr_fl2hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open flt_update_cursor

                fetch flt_update_cursor into @fsr_fl2hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more flt files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

                  if (@fsr_fl2hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_flt2 = "N/A"
                  else if (@new_file_name = @fsr_fl2hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_flt2 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_flt2 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_fl2hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'UPPER'

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_flt2 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_flt2 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_flt2 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_flt2 = "MODERATE"
                             else select @fsr_best_loc_flt2 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_flt2= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_flt2 = @fsr_best_loc_flt2
                   where  current of flt_update_cursor
        
                  fetch flt_update_cursor into @fsr_fl2hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more flt files */

                close flt_update_cursor

                deallocate cursor flt_update_cursor

    end /* paired aperture - flt2 */

        end /* if @ref_type = 'FLT') */
/* mod - end */

        if (@ref_type = 'IVS')
        begin
/* mod - entire section */
if (@aper_pos = 'SINGLE' and @pass_dir = 0)  /* single aperture */
begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "IVS"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 0
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ivs_update_cursor cursor for
                select fsr_iv1hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open ivs_update_cursor

                fetch ivs_update_cursor into @fsr_iv1hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more ivs files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_iv1hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ivs1 = "N/A"
                  else if (@new_file_name = @fsr_iv1hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ivs1 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ivs1 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_iv1hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 0 

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_ivs1 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ivs1 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ivs1 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ivs1 = "MODERATE"
                             else select @fsr_best_loc_ivs1 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ivs1= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ivs1 = @fsr_best_loc_ivs1
                   where  current of ivs_update_cursor
        
                  fetch ivs_update_cursor into @fsr_iv1hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more ivs files */

                close ivs_update_cursor

                deallocate cursor ivs_update_cursor

end /* single aperture*/
else
 if (@aper_pos = 'SINGLE' and @pass_dir = 1)	/* polarimetry - compute ivs1*/
 begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "IVS"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 1
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ivs_update_cursor cursor for
                select fsr_iv1hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open ivs_update_cursor

                fetch ivs_update_cursor into @fsr_iv1hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more ivs files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_iv1hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ivs1 = "N/A"
                  else if (@new_file_name = @fsr_iv1hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ivs1 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ivs1 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_iv1hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 1

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_ivs1 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ivs1 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ivs1 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ivs1 = "MODERATE"
                             else select @fsr_best_loc_ivs1 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ivs1= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ivs1 = @fsr_best_loc_ivs1
                   where  current of ivs_update_cursor
        
                  fetch ivs_update_cursor into @fsr_iv1hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more ivs files */

                close ivs_update_cursor

                deallocate cursor ivs_update_cursor

 end /* polarimetry - ivs1*/
 else
  if (@aper_pos = 'SINGLE' and @pass_dir=2)	/* polarimetry - ivs2 */ 
  begin
                       /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "IVS"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 2
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ivs_update_cursor cursor for
                select fsr_iv2hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open ivs_update_cursor

                fetch ivs_update_cursor into @fsr_iv2hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more ivs files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_iv2hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ivs2 = "N/A"
                  else if (@new_file_name = @fsr_iv2hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ivs2 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ivs2 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_iv2hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 2

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_ivs2 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ivs2 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ivs2 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ivs2 = "MODERATE"
                             else select @fsr_best_loc_ivs2 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ivs2= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ivs2 = @fsr_best_loc_ivs2
                   where  current of ivs_update_cursor
        
                  fetch ivs_update_cursor into @fsr_iv2hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more ivs files */

                close ivs_update_cursor

                deallocate cursor ivs_update_cursor

  end /* polarimetry - ivs2 */
  else
   if (@aper_pos = 'LOWER')	/* paired aperture - ivs1 */
   begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "IVS"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'LOWER'
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ivs_update_cursor cursor for
                select fsr_iv1hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open ivs_update_cursor

                fetch ivs_update_cursor into @fsr_iv1hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more ivs files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_iv1hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ivs1 = "N/A"
                  else if (@new_file_name = @fsr_iv1hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ivs1 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ivs1 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_iv1hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'LOWER'

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_ivs1 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ivs1 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ivs1 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ivs1 = "MODERATE"
                             else select @fsr_best_loc_ivs1 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ivs1= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ivs1 = @fsr_best_loc_ivs1
                   where  current of ivs_update_cursor
        
                  fetch ivs_update_cursor into @fsr_iv1hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more ivs files */

                close ivs_update_cursor

                deallocate cursor ivs_update_cursor

   end /* paired aperture - ivs1 */
   else
    if (@aper_pos = 'UPPER')	/* paired aperture - ivs2 */
    begin
                       /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "IVS"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'UPPER'
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ivs_update_cursor cursor for
                select fsr_iv2hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open ivs_update_cursor

                fetch ivs_update_cursor into @fsr_iv2hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more ivs files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_iv2hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_ivs2 = "N/A"
                  else if (@new_file_name = @fsr_iv2hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_ivs2 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_ivs2 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_iv2hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'UPPER'

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_ivs2 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_ivs2 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_ivs2 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_ivs2 = "MODERATE"
                             else select @fsr_best_loc_ivs2 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_ivs2= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_ivs2 = @fsr_best_loc_ivs2
                   where  current of ivs_update_cursor
        
                  fetch ivs_update_cursor into @fsr_iv2hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more ivs files */

                close ivs_update_cursor

                deallocate cursor ivs_update_cursor

    end /* paired aperture - ivs2 */

        end /* if @ref_type = 'IVS') */
/* mod - end */


        if (@ref_type = 'QIN')
        begin
/* mod - entire section */
if (@aper_pos = 'SINGLE' and @pass_dir = 0)  /* single aperture */
begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "QIN"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 0
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare qin_update_cursor cursor for
                select fsr_dq1hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open qin_update_cursor

                fetch qin_update_cursor into @fsr_dq1hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more qin files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_dq1hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_qin1 = "N/A"
                  else if (@new_file_name = @fsr_dq1hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_qin1 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_qin1 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_dq1hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 0 

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_qin1 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_qin1 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_qin1 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_qin1 = "MODERATE"
                             else select @fsr_best_loc_qin1 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_qin1= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_qin1 = @fsr_best_loc_qin1
                   where  current of qin_update_cursor
        
                  fetch qin_update_cursor into @fsr_dq1hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more qin files */

                close qin_update_cursor

                deallocate cursor qin_update_cursor

end /* single aperture*/
else
 if (@aper_pos = 'SINGLE' and @pass_dir = 1)	/* polarimetry - compute qin1*/
 begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "QIN"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 1
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare qin_update_cursor cursor for
                select fsr_dq1hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open qin_update_cursor

                fetch qin_update_cursor into @fsr_dq1hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more qin files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_dq1hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_qin1 = "N/A"
                  else if (@new_file_name = @fsr_dq1hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_qin1 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_qin1 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_dq1hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 1

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_qin1 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_qin1 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_qin1 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_qin1 = "MODERATE"
                             else select @fsr_best_loc_qin1 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_qin1= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_qin1 = @fsr_best_loc_qin1
                   where  current of qin_update_cursor
        
                  fetch qin_update_cursor into @fsr_dq1hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more qin files */

                close qin_update_cursor

                deallocate cursor qin_update_cursor

 end /* polarimetry - qin1*/
 else
  if (@aper_pos = 'SINGLE' and @pass_dir=2)	/* polarimetry - qin2 */ 
  begin
                       /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "QIN"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 2
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare qin_update_cursor cursor for
                select fsr_dq2hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open qin_update_cursor

                fetch qin_update_cursor into @fsr_dq2hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more qin files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_dq2hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_qin2 = "N/A"
                  else if (@new_file_name = @fsr_dq2hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_qin2 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_qin2 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_dq2hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'SINGLE'
			and fos_row.pass_dir = 2

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_qin2 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_qin2 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_qin2 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_qin2 = "MODERATE"
                             else select @fsr_best_loc_qin2 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_qin2= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_qin2 = @fsr_best_loc_qin2
                   where  current of qin_update_cursor
        
                  fetch qin_update_cursor into @fsr_dq2hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more qin files */

                close qin_update_cursor

                deallocate cursor qin_update_cursor

  end /* polarimetry - qin2 */
  else
   if (@aper_pos = 'LOWER')	/* paired aperture - qin1 */
   begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "QIN"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'LOWER'
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare qin_update_cursor cursor for
                select fsr_dq1hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open qin_update_cursor

                fetch qin_update_cursor into @fsr_dq1hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more qin files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_dq1hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_qin1 = "N/A"
                  else if (@new_file_name = @fsr_dq1hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_qin1 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_qin1 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_dq1hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'LOWER'

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_qin1 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_qin1 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_qin1 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_qin1 = "MODERATE"
                             else select @fsr_best_loc_qin1 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_qin1= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_qin1 = @fsr_best_loc_qin1
                   where  current of qin_update_cursor
        
                  fetch qin_update_cursor into @fsr_dq1hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more qin files */

                close qin_update_cursor

                deallocate cursor qin_update_cursor

   end /* paired aperture - qin1 */
   else
    if (@aper_pos = 'UPPER')	/* paired aperture - qin2 */
    begin
                       /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  fos_file.useafter_date
                from fos_file fos_file, fos_row fos_row
                        where fos_row.file_name = fos_file.file_name
                        and fos_row.expansion_number = fos_file.expansion_number
                        and fos_file.reference_file_type = "QIN"
                        and fos_file.reject_flag = "N"
                        and fos_file.opus_flag = "Y"
                        and fos_file.useafter_date > @useafter_date
                        and fos_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'UPPER'
                order by fos_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare qin_update_cursor cursor for
                select fsr_dq2hfile
                  /* Modes aren't added to the select list, if rft = image */
                from fos_ref_data
                where fsr_expstart >= @useafter_date
                and fsr_expstart < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and fsr_aper_id = @fsr_aper_id
                        and fsr_fgwa_id = @fsr_fgwa_id
                        and fsr_detector = @fsr_detector
                        and fsr_overscan = @fsr_overscan
                        and fsr_polar_id = @fsr_polar_id
                for update

                open qin_update_cursor

                fetch qin_update_cursor into @fsr_dq2hfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more qin files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@fsr_dq2hfile = NULL)  /* no file was used in pipeline */
                        select @fsr_best_loc_qin2 = "N/A"
                  else if (@new_file_name = @fsr_dq2hfile)  /* recommended = was used, if rft = image or table */
                        select @fsr_best_loc_qin2 = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @fsr_best_loc_qin2 = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = fos_row.equivalence_class_severe,
                                @orig_equiv_mod = fos_row.equivalence_class_moderate
                        from        fos_row fos_row
                        where        fos_row.file_name = @fsr_dq2hfile
                        and fos_row.aper_id = @fsr_aper_id
                        and fos_row.fgwa_id = @fsr_fgwa_id
                        and fos_row.detector = @fsr_detector
                        and fos_row.overscan = @fsr_overscan
                        and fos_row.polar_id = @fsr_polar_id
			and fos_row.aper_pos = 'UPPER'

			select @num_cal_files = @@rowcount
			if (@num_cal_files = 0)
			 select @fsr_best_loc_qin2 = 'N/A'
			else
                        if (@orig_equiv_sev = -1)
                        select @fsr_best_loc_qin2 = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @fsr_best_loc_qin2 = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @fsr_best_loc_qin2 = "MODERATE"
                             else select @fsr_best_loc_qin2 = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update fos_ref_data
                   set fsr_best_qin2= @new_file_name, /* if rft = image or table */
                       fsr_best_loc_qin2 = @fsr_best_loc_qin2
                   where  current of qin_update_cursor
        
                  fetch qin_update_cursor into @fsr_dq2hfile
                  /* Don't print modes, if rft = image */
 

                end /* while more qin files */

                close qin_update_cursor

                deallocate cursor qin_update_cursor

    end /* paired aperture - qin2 */

        end /* if @ref_type = 'QIN') */
/* mod - end */

fetch new_fos_cursor into @new_file_name, @new_expansion_number

end /* while more newly delivered calibration files */

close new_fos_cursor

deallocate cursor new_fos_cursor
return
go






