use dadsops
go
drop procedure new_stis
go
create procedure new_stis as
/* newly delivered calibration files */
declare @new_file_name varchar(50)
declare @new_expansion_number int
declare @ref_type varchar(50)
declare @useafter_date datetime
declare @stop_date datetime
/* observation start time */
declare @expstart datetime
/* data set name, to be used for error checking/handling, should extract */
/* datatype from dt_mapping rather than hardcode it here, this will do for now */
declare @data_set_name varchar(39)
/* severity level variables, to be reused for each reference file type */
declare @orig_equiv_sev int
declare @orig_equiv_mod int
declare @equiv_sev int
declare @equiv_mod int
/* used to store @@rowcount global variable */
declare @num_cal_files int
/* observation modes, calibration files used in the pipeline, */
/* best, and best_loc files */
declare @ssr_cenwave int
declare @ssr_ccdoffst int
declare @ssr_ccdamp char(3)
declare @ssr_ccdtab char(18)
declare @ssr_idctab char(18)
declare @ssr_sdctab char(18)
declare @ssr_apertab char(18)
declare @ssr_atodtab char(18)
declare @ssr_bpixtab char(18)
declare @ssr_ccdgain int
declare @ssr_crsplit int
declare @ssr_disptab char(18)
declare @ssr_lamptab char(18)
declare @ssr_mlintab char(18)
declare @ssr_mofftab char(18)
declare @ssr_phottab char(18)
declare @ssr_apdestab char(18)
declare @ssr_biasfile char(18)
declare @ssr_binaxis1 int
declare @ssr_binaxis2 int
declare @ssr_crrejtab char(18)
declare @ssr_darkfile char(18)
declare @ssr_dfltfile char(18)
declare @ssr_inangtab char(18)
declare @ssr_lfltfile char(18)
declare @ssr_pfltfile char(18)
declare @ssr_sdstfile char(18)
declare @ssr_shadfile char(18)
declare @ssr_sptrctab char(18)
declare @ssr_xtractab char(18)
declare @ssr_pctab char(18)
declare @ssr_best_bias char(18)
declare @ssr_best_dark char(18)
declare @ssr_best_dflt char(18)
declare @ssr_best_lflt char(18)
declare @ssr_best_pflt char(18)
declare @ssr_best_sdst char(18)
declare @ssr_best_shad char(18)
declare @ssr_obstype varchar(14)
declare @ssr_opt_elem varchar(8)
declare @ssr_aperture varchar(16)
declare @ssr_best_ccdtab char(18)
declare @ssr_best_idctab char(18)
declare @ssr_best_sdctab char(18)
declare @ssr_detector varchar(10)
declare @ssr_best_apertab char(18)
declare @ssr_best_atodtab char(18)
declare @ssr_best_bpixtab char(18)
declare @ssr_best_disptab char(18)
declare @ssr_best_lamptab char(18)
declare @ssr_best_mlintab char(18)
declare @ssr_best_mofftab char(18)
declare @ssr_best_phottab char(18)
declare @ssr_best_apdestab char(18)
declare @ssr_best_crrejtab char(18)
declare @ssr_best_inangtab char(18)
declare @ssr_best_sptrctab char(18)
declare @ssr_best_xtractab char(18)
declare @ssr_best_pctab char(18)
declare @ssr_best_loc_pctab char(9)
declare @ssr_best_loc_bias varchar(9)
declare @ssr_best_loc_dark varchar(9)
declare @ssr_best_loc_dflt varchar(9)
declare @ssr_best_loc_lflt varchar(9)
declare @ssr_best_loc_pflt varchar(9)
declare @ssr_best_loc_sdst varchar(9)
declare @ssr_best_loc_shad varchar(9)
declare @ssr_best_loc_ccdtab varchar(9)
declare @ssr_best_loc_idctab varchar(9)
declare @ssr_best_loc_sdctab varchar(9)
declare @ssr_best_loc_apertab varchar(9)
declare @ssr_best_loc_atodtab varchar(9)
declare @ssr_best_loc_bpixtab varchar(9)
declare @ssr_best_loc_disptab varchar(9)
declare @ssr_best_loc_lamptab varchar(9)
declare @ssr_best_loc_mlintab varchar(9)
declare @ssr_best_loc_mofftab varchar(9)
declare @ssr_best_loc_phottab varchar(9)
declare @ssr_best_loc_apdestab varchar(9)
declare @ssr_best_loc_crrejtab varchar(9)
declare @ssr_best_loc_inangtab varchar(9)
declare @ssr_best_loc_sptrctab varchar(9)
declare @ssr_best_loc_xtractab varchar(9)

/**************************************************************************/
/************************ New   stis ***********************/
/**************************************************************************/

declare new_stis_cursor cursor for
        select  file_name, expansion_number
        from    new_cal_files
        where   instrument = 'STIS'
for read only

open new_stis_cursor

fetch new_stis_cursor into @new_file_name, @new_expansion_number

while (@@sqlstatus = 0)/* more newly delivered calibration files*/
begin

select @ref_type = stis_file.reference_file_type,
@useafter_date = stis_file.useafter_date,
@equiv_sev = stis_row.equivalence_class_severe,
@equiv_mod = stis_row.equivalence_class_moderate
,@ssr_aperture=stis_row.aperture
,@ssr_binaxis1=stis_row.binaxis1
,@ssr_binaxis2=stis_row.binaxis2
,@ssr_ccdamp=stis_row.ccdamp
,@ssr_ccdgain=stis_row.ccdgain
,@ssr_ccdoffst=stis_row.ccdoffst
,@ssr_cenwave=stis_row.cenwave
,@ssr_crsplit=stis_row.crsplit
,@ssr_detector=stis_row.detector
,@ssr_obstype=stis_row.obstype
,@ssr_opt_elem=stis_row.opt_elem
from stis_file stis_file, stis_row stis_row
where stis_file.file_name = @new_file_name 
and stis_row.file_name = @new_file_name
and stis_file.expansion_number = @new_expansion_number
and stis_row.expansion_number = @new_expansion_number


        if (@ref_type = 'BIA')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "BIA"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and stis_row.ccdamp = @ssr_ccdamp
                        and stis_row.ccdgain = @ssr_ccdgain
                        and stis_row.binaxis1 = @ssr_binaxis1
                        and stis_row.binaxis2 = @ssr_binaxis2
                        and stis_row.ccdoffst = @ssr_ccdoffst
                        and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare bia_update_cursor cursor for
                select ssr_biasfile
                  /* Modes aren't added to the select list, if rft = image */
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and ssr_ccdamp = @ssr_ccdamp
                        and ssr_ccdgain = @ssr_ccdgain
                        and ssr_binaxis1 = @ssr_binaxis1
                        and ssr_binaxis2 = @ssr_binaxis2
                        and ssr_ccdoffst = @ssr_ccdoffst
                        and ssr_detector = @ssr_detector
                for update

                open bia_update_cursor

                fetch bia_update_cursor into @ssr_biasfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more bia files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_biasfile = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_bias = "N/A"
                  else if (@new_file_name = @ssr_biasfile)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_bias = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_bias = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_biasfile
                        and stis_row.ccdamp = @ssr_ccdamp
                        and stis_row.ccdgain = @ssr_ccdgain
                        and stis_row.binaxis1 = @ssr_binaxis1
                        and stis_row.binaxis2 = @ssr_binaxis2
                        and stis_row.ccdoffst = @ssr_ccdoffst
                        and stis_row.detector = @ssr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_bias = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_bias = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_bias = "MODERATE"
                             else select @ssr_best_loc_bias = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_bias= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_bias = @ssr_best_loc_bias
                   where  current of bia_update_cursor
        
                  fetch bia_update_cursor into @ssr_biasfile
                  /* Don't print modes, if rft = image */
 

                end /* while more bia files */

                close bia_update_cursor

                deallocate cursor bia_update_cursor
        end /* if @ref_type = 'BIA') */


        if (@ref_type = 'DFL')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "DFL"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare dfl_update_cursor cursor for
                select ssr_dfltfile
                  /* Modes aren't added to the select list, if rft = image */
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and ssr_detector = @ssr_detector
                for update

                open dfl_update_cursor

                fetch dfl_update_cursor into @ssr_dfltfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more dfl files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_dfltfile = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_dflt = "N/A"
                  else if (@new_file_name = @ssr_dfltfile)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_dflt = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_dflt = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_dfltfile
                        and stis_row.detector = @ssr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_dflt = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_dflt = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_dflt = "MODERATE"
                             else select @ssr_best_loc_dflt = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_dflt= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_dflt = @ssr_best_loc_dflt
                   where  current of dfl_update_cursor
        
                  fetch dfl_update_cursor into @ssr_dfltfile
                  /* Don't print modes, if rft = image */
 

                end /* while more dfl files */

                close dfl_update_cursor

                deallocate cursor dfl_update_cursor
        end /* if @ref_type = 'DFL') */


        if (@ref_type = 'DRK')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
/* mod - only use ccdamp and ccdgain if detector = 'CCD' */
	   if (@ssr_detector = 'CCD')
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "DRK"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and stis_row.ccdamp = @ssr_ccdamp
                        and stis_row.ccdgain = @ssr_ccdgain
                        and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only
	   else /* detector <> 'CCD' */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "DRK"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor

/* mod - only use ccdamp and ccdgain if detector = 'CCD' */
		if (@ssr_detector = 'CCD')
                declare drk_update_cursor cursor for
                select ssr_darkfile
                  /* Modes aren't added to the select list, if rft = image */
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and ssr_ccdamp = @ssr_ccdamp
                        and ssr_ccdgain = @ssr_ccdgain
                        and ssr_detector = @ssr_detector
                for update
		else /* detector <> 'CCD' */
                declare drk_update_cursor cursor for
                select ssr_darkfile
                  /* Modes aren't added to the select list, if rft = image */
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and ssr_detector = @ssr_detector
                for update

                open drk_update_cursor

                fetch drk_update_cursor into @ssr_darkfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more drk files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_darkfile = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_dark = "N/A"
                  else if (@new_file_name = @ssr_darkfile)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_dark = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_dark = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
/* mod - only use ccdamp and ccdgain if detector='CCD' */
		     if (@ssr_detector = 'CCD')
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_darkfile
                        and stis_row.ccdamp = @ssr_ccdamp
                        and stis_row.ccdgain = @ssr_ccdgain
                        and stis_row.detector = @ssr_detector
		     else /* detector <> 'CCD' */
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_darkfile
                        and stis_row.detector = @ssr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_dark = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_dark = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_dark = "MODERATE"
                             else select @ssr_best_loc_dark = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_dark= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_dark = @ssr_best_loc_dark
                   where  current of drk_update_cursor
        
                  fetch drk_update_cursor into @ssr_darkfile
                  /* Don't print modes, if rft = image */
 

                end /* while more drk files */

                close drk_update_cursor

                deallocate cursor drk_update_cursor
        end /* if @ref_type = 'DRK') */


        if (@ref_type = 'LFL')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
/* mod - use aperture if obstype=imaging, use cenwave if obstype=spectro */
	   if (@ssr_obstype = 'IMAGING')
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "LFL"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and stis_row.obstype = @ssr_obstype
                        and stis_row.aperture = @ssr_aperture
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
                order by stis_file.useafter_date
                for read only
	    else
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "LFL"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and stis_row.cenwave = @ssr_cenwave
                        and stis_row.obstype = @ssr_obstype
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


/* mod - use aperture if obstype=imaging, use cenwave if obstype=spectro */
	     if (@ssr_obstype = 'IMAGING')
                declare lfl_update_cursor cursor for
                select ssr_lfltfile
                  /* Modes aren't added to the select list, if rft = image */
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and ssr_obstype = @ssr_obstype
                        and ssr_aperture = @ssr_aperture
                        and ssr_detector = @ssr_detector
                        and ssr_opt_elem = @ssr_opt_elem
                for update
	     else
                declare lfl_update_cursor cursor for
                select ssr_lfltfile
                  /* Modes aren't added to the select list, if rft = image */
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and ssr_cenwave = @ssr_cenwave
                        and ssr_obstype = @ssr_obstype
                        and ssr_detector = @ssr_detector
                        and ssr_opt_elem = @ssr_opt_elem
                for update

                open lfl_update_cursor

                fetch lfl_update_cursor into @ssr_lfltfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more lfl files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_lfltfile = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_lflt = "N/A"
                  else if (@new_file_name = @ssr_lfltfile)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_lflt = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_lflt = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
/* mod - use aperture if obstype=imaging, use cenwave if obstype=spectro */
		     if (@ssr_obstype = 'IMAGING')
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_lfltfile
                        and stis_row.obstype = @ssr_obstype
                        and stis_row.aperture = @ssr_aperture
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
		     else
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_lfltfile
                        and stis_row.cenwave = @ssr_cenwave
                        and stis_row.obstype = @ssr_obstype
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_lflt = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_lflt = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_lflt = "MODERATE"
                             else select @ssr_best_loc_lflt = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_lflt= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_lflt = @ssr_best_loc_lflt
                   where  current of lfl_update_cursor
        
                  fetch lfl_update_cursor into @ssr_lfltfile
                  /* Don't print modes, if rft = image */
 

                end /* while more lfl files */

                close lfl_update_cursor

                deallocate cursor lfl_update_cursor
        end /* if @ref_type = 'LFL') */


        if (@ref_type = 'PFL')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
/* mod -use aperture if obstype=imaging, use cenwave if obstype=spectro */
	   if (@ssr_obstype = 'IMAGING')
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "PFL"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and stis_row.obstype = @ssr_obstype
                        and stis_row.aperture = @ssr_aperture
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
                order by stis_file.useafter_date
                for read only
	   else
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "PFL"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and stis_row.cenwave = @ssr_cenwave
                        and stis_row.obstype = @ssr_obstype
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


	     if (@ssr_obstype = 'IMAGING')
                declare pfl_update_cursor cursor for
                select ssr_pfltfile
                  /* Modes aren't added to the select list, if rft = image */
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and ssr_obstype = @ssr_obstype
                        and ssr_aperture = @ssr_aperture
                        and ssr_detector = @ssr_detector
                        and ssr_opt_elem = @ssr_opt_elem
                for update
	     else
                declare pfl_update_cursor cursor for
                select ssr_pfltfile
                  /* Modes aren't added to the select list, if rft = image */
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and ssr_cenwave = @ssr_cenwave
                        and ssr_obstype = @ssr_obstype
                        and ssr_detector = @ssr_detector
                        and ssr_opt_elem = @ssr_opt_elem
                for update

                open pfl_update_cursor

                fetch pfl_update_cursor into @ssr_pfltfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more pfl files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_pfltfile = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_pflt = "N/A"
                  else if (@new_file_name = @ssr_pfltfile)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_pflt = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_pflt = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
/* mod */
		      if (@ssr_obstype = 'IMAGING')
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_pfltfile
                        and stis_row.obstype = @ssr_obstype
                        and stis_row.aperture = @ssr_aperture
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
		      else
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_pfltfile
                        and stis_row.cenwave = @ssr_cenwave
                        and stis_row.obstype = @ssr_obstype
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_pflt = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_pflt = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_pflt = "MODERATE"
                             else select @ssr_best_loc_pflt = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_pflt= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_pflt = @ssr_best_loc_pflt
                   where  current of pfl_update_cursor
        
                  fetch pfl_update_cursor into @ssr_pfltfile
                  /* Don't print modes, if rft = image */
 

                end /* while more pfl files */

                close pfl_update_cursor

                deallocate cursor pfl_update_cursor
        end /* if @ref_type = 'PFL') */


        if (@ref_type = 'SSC')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "SSC"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ssc_update_cursor cursor for
                select ssr_shadfile
                  /* Modes aren't added to the select list, if rft = image */
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and ssr_detector = @ssr_detector
                for update

                open ssc_update_cursor

                fetch ssc_update_cursor into @ssr_shadfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more ssc files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_shadfile = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_shad = "N/A"
                  else if (@new_file_name = @ssr_shadfile)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_shad = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_shad = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_shadfile
                        and stis_row.detector = @ssr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_shad = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_shad = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_shad = "MODERATE"
                             else select @ssr_best_loc_shad = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_shad= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_shad = @ssr_best_loc_shad
                   where  current of ssc_update_cursor
        
                  fetch ssc_update_cursor into @ssr_shadfile
                  /* Don't print modes, if rft = image */
 

                end /* while more ssc files */

                close ssc_update_cursor

                deallocate cursor ssc_update_cursor
        end /* if @ref_type = 'SSC') */


        if (@ref_type = 'SSD')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "SSD"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
                        /* Print out the modes, if rft = image */
                        and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ssd_update_cursor cursor for
                select ssr_sdstfile
                  /* Modes aren't added to the select list, if rft = image */
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
                  /* Add modes to the where clause, if rft = image */
                        and ssr_detector = @ssr_detector
                for update

                open ssd_update_cursor

                fetch ssd_update_cursor into @ssr_sdstfile
                  /* Don't add modes to the fetch statement, if rft = image */

                while (@@sqlstatus = 0) /* While more ssd files */

                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_sdstfile = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_sdst = "N/A"
                  else if (@new_file_name = @ssr_sdstfile)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_sdst = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_sdst = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_sdstfile
                        and stis_row.detector = @ssr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_sdst = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_sdst = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_sdst = "MODERATE"
                             else select @ssr_best_loc_sdst = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_sdst= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_sdst = @ssr_best_loc_sdst
                   where  current of ssd_update_cursor
        
                  fetch ssd_update_cursor into @ssr_sdstfile
                  /* Don't print modes, if rft = image */
 

                end /* while more ssd files */

                close ssd_update_cursor

                deallocate cursor ssd_update_cursor
        end /* if @ref_type = 'SSD') */


        if (@ref_type = 'CCD')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "CCD"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* mod - use detector as table selector */
			and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare ccd_update_cursor cursor for
                select ssr_ccdtab
                  /* Add modes to the select list, if rft = table */
                ,ssr_ccdamp
                ,ssr_ccdgain
                ,ssr_binaxis1
                ,ssr_binaxis2
                ,ssr_ccdoffst
                ,ssr_detector
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
/* mod - use detector as table selector */
		and ssr_detector = @ssr_detector
                for update

                open ccd_update_cursor

                fetch ccd_update_cursor into @ssr_ccdtab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_ccdamp
                ,@ssr_ccdgain
                ,@ssr_binaxis1
                ,@ssr_binaxis2
                ,@ssr_ccdoffst
                ,@ssr_detector

                while (@@sqlstatus = 0) /* While more ccd files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
/* mod - wildcards */
                        and stis_row.ccdamp = @ssr_ccdamp
                        and (stis_row.ccdgain = @ssr_ccdgain or
			     stis_row.ccdgain = -1)
                        and (stis_row.binaxis1 = @ssr_binaxis1 or
			     stis_row.binaxis1 = -1)
                        and (stis_row.binaxis2 = @ssr_binaxis2 or
			     stis_row.binaxis2 = -1)
                        and (stis_row.ccdoffst = @ssr_ccdoffst or
			     stis_row.ccdoffst = -1)
                        and stis_row.detector = @ssr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_ccdtab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_ccdtab = "N/A"
                  else if (@new_file_name = @ssr_ccdtab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_ccdtab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_ccdtab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_ccdtab
/* mod - wildcards */
                        and stis_row.ccdamp = @ssr_ccdamp
                        and (stis_row.ccdgain = @ssr_ccdgain or
			     stis_row.ccdgain = -1)
                        and (stis_row.binaxis1 = @ssr_binaxis1 or
			     stis_row.binaxis1 = -1)
                        and (stis_row.binaxis2 = @ssr_binaxis2 or
			     stis_row.binaxis2 = -1)
                        and (stis_row.ccdoffst = @ssr_ccdoffst or
			     stis_row.ccdoffst = -1)
                        and stis_row.detector = @ssr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_ccdtab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_ccdtab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_ccdtab = "MODERATE"
                             else select @ssr_best_loc_ccdtab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_ccdtab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_ccdtab = @ssr_best_loc_ccdtab
                   where  current of ccd_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch ccd_update_cursor into @ssr_ccdtab
                  /* Print modes, if rft = table */
                ,@ssr_ccdamp
                ,@ssr_ccdgain
                ,@ssr_binaxis1
                ,@ssr_binaxis2
                ,@ssr_ccdoffst
                ,@ssr_detector
 

                end /* while more ccd files */

                close ccd_update_cursor

                deallocate cursor ccd_update_cursor
        end /* if @ref_type = 'CCD') */


        if (@ref_type = 'IDC')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "IDC"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* mod - use detector as table selector */
			and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare idc_update_cursor cursor for
                select ssr_idctab
                  /* Add modes to the select list, if rft = table */
                ,ssr_aperture
                ,ssr_detector
                ,ssr_opt_elem
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
/* mod - use detector as table selector */
		and ssr_detector = @ssr_detector
                for update

                open idc_update_cursor

                fetch idc_update_cursor into @ssr_idctab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_aperture
                ,@ssr_detector
                ,@ssr_opt_elem

                while (@@sqlstatus = 0) /* While more idc files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
                        and stis_row.aperture = @ssr_aperture
                        and stis_row.detector = @ssr_detector
/* mod wildcard */
                        and (stis_row.opt_elem = @ssr_opt_elem or
			     stis_row.opt_elem = 'ANY')

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_idctab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_idctab = "N/A"
                  else if (@new_file_name = @ssr_idctab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_idctab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_idctab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_idctab
                        and stis_row.aperture = @ssr_aperture
                        and stis_row.detector = @ssr_detector
/* mod - wilcard */
                        and (stis_row.opt_elem = @ssr_opt_elem or
			     stis_row.opt_elem = 'ANY')
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_idctab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_idctab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_idctab = "MODERATE"
                             else select @ssr_best_loc_idctab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_idctab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_idctab = @ssr_best_loc_idctab
                   where  current of idc_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch idc_update_cursor into @ssr_idctab
                  /* Print modes, if rft = table */
                ,@ssr_aperture
                ,@ssr_detector
                ,@ssr_opt_elem
 

                end /* while more idc files */

                close idc_update_cursor

                deallocate cursor idc_update_cursor
        end /* if @ref_type = 'IDC') */


        if (@ref_type = 'SDC')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "SDC"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* mod - use detector as table selector */
			and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare sdc_update_cursor cursor for
                select ssr_sdctab
                  /* Add modes to the select list, if rft = table */
                ,ssr_cenwave
                ,ssr_detector
                ,ssr_opt_elem
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
/* mod - use detector as table selector */
		and ssr_detector = @ssr_detector
                for update

                open sdc_update_cursor

                fetch sdc_update_cursor into @ssr_sdctab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_cenwave
                ,@ssr_detector
                ,@ssr_opt_elem

                while (@@sqlstatus = 0) /* While more sdc files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
/* mod - wildcard */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_sdctab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_sdctab = "N/A"
                  else if (@new_file_name = @ssr_sdctab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_sdctab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_sdctab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_sdctab
/* mod - wildcard */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_sdctab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_sdctab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_sdctab = "MODERATE"
                             else select @ssr_best_loc_sdctab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_sdctab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_sdctab = @ssr_best_loc_sdctab
                   where  current of sdc_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch sdc_update_cursor into @ssr_sdctab
                  /* Print modes, if rft = table */
                ,@ssr_cenwave
                ,@ssr_detector
                ,@ssr_opt_elem
 

                end /* while more sdc files */

                close sdc_update_cursor

                deallocate cursor sdc_update_cursor
        end /* if @ref_type = 'SDC') */


        if (@ref_type = 'A2D')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "A2D"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* mod - use detector as table selector */
			and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare a2d_update_cursor cursor for
                select ssr_atodtab
                  /* Add modes to the select list, if rft = table */
                ,ssr_ccdamp
                ,ssr_ccdgain
                ,ssr_detector
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
/* mod - use detector as table selector */
		and ssr_detector = @ssr_detector
                for update

                open a2d_update_cursor

                fetch a2d_update_cursor into @ssr_atodtab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_ccdamp
                ,@ssr_ccdgain
                ,@ssr_detector

                while (@@sqlstatus = 0) /* While more a2d files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
/* mod - wildcards */
                        and (stis_row.ccdamp = @ssr_ccdamp or
			     stis_row.ccdamp = 'ANY')
                        and (stis_row.ccdgain = @ssr_ccdgain or
			     stis_row.ccdgain = -1)
                        and stis_row.detector = @ssr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_atodtab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_atodtab = "N/A"
                  else if (@new_file_name = @ssr_atodtab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_atodtab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_atodtab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_atodtab
/* mod - wildcard */
                        and (stis_row.ccdamp = @ssr_ccdamp or
			     stis_row.ccdamp = 'ANY')
                        and (stis_row.ccdgain = @ssr_ccdgain or
			     stis_row.ccdgain = -1)
                        and stis_row.detector = @ssr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_atodtab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_atodtab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_atodtab = "MODERATE"
                             else select @ssr_best_loc_atodtab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_atodtab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_atodtab = @ssr_best_loc_atodtab
                   where  current of a2d_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch a2d_update_cursor into @ssr_atodtab
                  /* Print modes, if rft = table */
                ,@ssr_ccdamp
                ,@ssr_ccdgain
                ,@ssr_detector
 

                end /* while more a2d files */

                close a2d_update_cursor

                deallocate cursor a2d_update_cursor
        end /* if @ref_type = 'A2D') */


        if (@ref_type = 'APT')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
/* mod - remove unnecessary join to stis_row */
                from stis_file stis_file
                        where 
                            stis_file.reference_file_type = "APT"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare apt_update_cursor cursor for
                select ssr_apertab
                  /* Add modes to the select list, if rft = table */
                ,ssr_aperture
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open apt_update_cursor

                fetch apt_update_cursor into @ssr_apertab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_aperture

                while (@@sqlstatus = 0) /* While more apt files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
                        and stis_row.aperture = @ssr_aperture

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_apertab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_apertab = "N/A"
                  else if (@new_file_name = @ssr_apertab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_apertab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_apertab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_apertab
                        and stis_row.aperture = @ssr_aperture
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_apertab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_apertab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_apertab = "MODERATE"
                             else select @ssr_best_loc_apertab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_apertab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_apertab = @ssr_best_loc_apertab
                   where  current of apt_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch apt_update_cursor into @ssr_apertab
                  /* Print modes, if rft = table */
                ,@ssr_aperture
 

                end /* while more apt files */

                close apt_update_cursor

                deallocate cursor apt_update_cursor
        end /* if @ref_type = 'APT') */


        if (@ref_type = 'BPX')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "BPX"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* mod - use detector as table selector */
			and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare bpx_update_cursor cursor for
                select ssr_bpixtab
                  /* Add modes to the select list, if rft = table */
                ,ssr_detector
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
/* mod - use detector as table selector */
		and ssr_detector = @ssr_detector
                for update

                open bpx_update_cursor

                fetch bpx_update_cursor into @ssr_bpixtab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_detector

                while (@@sqlstatus = 0) /* While more bpx files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
                        and stis_row.detector = @ssr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_bpixtab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_bpixtab = "N/A"
                  else if (@new_file_name = @ssr_bpixtab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_bpixtab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_bpixtab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_bpixtab
                        and stis_row.detector = @ssr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_bpixtab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_bpixtab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_bpixtab = "MODERATE"
                             else select @ssr_best_loc_bpixtab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_bpixtab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_bpixtab = @ssr_best_loc_bpixtab
                   where  current of bpx_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch bpx_update_cursor into @ssr_bpixtab
                  /* Print modes, if rft = table */
                ,@ssr_detector
 

                end /* while more bpx files */

                close bpx_update_cursor

                deallocate cursor bpx_update_cursor
        end /* if @ref_type = 'BPX') */


        if (@ref_type = 'DSP')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "DSP"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* mod - use detector as table selector */
			and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare dsp_update_cursor cursor for
                select ssr_disptab
                  /* Add modes to the select list, if rft = table */
                ,ssr_cenwave
                ,ssr_detector
                ,ssr_opt_elem
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
/* mod - use detector as table selector */
		and ssr_detector = @ssr_detector
                for update

                open dsp_update_cursor

                fetch dsp_update_cursor into @ssr_disptab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_cenwave
                ,@ssr_detector
                ,@ssr_opt_elem

                while (@@sqlstatus = 0) /* While more dsp files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
/* mod - wildcard */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_disptab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_disptab = "N/A"
                  else if (@new_file_name = @ssr_disptab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_disptab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_disptab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_disptab
/* mod - wildcard */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_disptab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_disptab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_disptab = "MODERATE"
                             else select @ssr_best_loc_disptab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_disptab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_disptab = @ssr_best_loc_disptab
                   where  current of dsp_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch dsp_update_cursor into @ssr_disptab
                  /* Print modes, if rft = table */
                ,@ssr_cenwave
                ,@ssr_detector
                ,@ssr_opt_elem
 

                end /* while more dsp files */

                close dsp_update_cursor

                deallocate cursor dsp_update_cursor
        end /* if @ref_type = 'DSP') */


        if (@ref_type = 'LIN')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
/* mod - remove unnecessary join to stis_row */
                from stis_file stis_file
                        where 
                            stis_file.reference_file_type = "LIN"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare lin_update_cursor cursor for
                select ssr_mlintab
                  /* Add modes to the select list, if rft = table */
                ,ssr_detector
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open lin_update_cursor

                fetch lin_update_cursor into @ssr_mlintab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_detector

                while (@@sqlstatus = 0) /* While more lin files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
                        and stis_row.detector = @ssr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_mlintab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_mlintab = "N/A"
                  else if (@new_file_name = @ssr_mlintab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_mlintab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_mlintab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_mlintab
                        and stis_row.detector = @ssr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_mlintab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_mlintab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_mlintab = "MODERATE"
                             else select @ssr_best_loc_mlintab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_mlintab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_mlintab = @ssr_best_loc_mlintab
                   where  current of lin_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch lin_update_cursor into @ssr_mlintab
                  /* Print modes, if rft = table */
                ,@ssr_detector
 

                end /* while more lin files */

                close lin_update_cursor

                deallocate cursor lin_update_cursor
        end /* if @ref_type = 'LIN') */


        if (@ref_type = 'LMP')
        begin
/* begin mod - OPR 35873 - 12/30/97 - useafter_date is only selection */
/*                                    criteria                        */
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "LMP"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare lmp_update_cursor cursor for
                select ssr_lamptab
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
                for update

                open lmp_update_cursor

                fetch lmp_update_cursor into @ssr_lamptab

                while (@@sqlstatus = 0) /* While more lmp files */

                begin
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin

                  if (@ssr_lamptab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_lamptab = "N/A"
                  else if (@new_file_name = @ssr_lamptab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_lamptab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_lamptab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_lamptab

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_lamptab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_lamptab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_lamptab = "MODERATE"
                             else select @ssr_best_loc_lamptab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_lamptab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_lamptab = @ssr_best_loc_lamptab
                   where  current of lmp_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch lmp_update_cursor into @ssr_lamptab

                end /* while more lmp files */

                close lmp_update_cursor

                deallocate cursor lmp_update_cursor
        end /* if @ref_type = 'LMP') */

/* end mod */

        if (@ref_type = 'MOC')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "MOC"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* mod - use detector as table selector */
			and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare moc_update_cursor cursor for
                select ssr_mofftab
                  /* Add modes to the select list, if rft = table */
                ,ssr_cenwave
                ,ssr_detector
                ,ssr_opt_elem
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
/* mod - use detector as table selector */
		and ssr_detector = @ssr_detector
                for update

                open moc_update_cursor

                fetch moc_update_cursor into @ssr_mofftab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_cenwave
                ,@ssr_detector
                ,@ssr_opt_elem

                while (@@sqlstatus = 0) /* While more moc files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
/* mod -wildcard */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_mofftab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_mofftab = "N/A"
                  else if (@new_file_name = @ssr_mofftab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_mofftab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_mofftab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_mofftab
/* mod - wildcard */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_mofftab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_mofftab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_mofftab = "MODERATE"
                             else select @ssr_best_loc_mofftab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_mofftab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_mofftab = @ssr_best_loc_mofftab
                   where  current of moc_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch moc_update_cursor into @ssr_mofftab
                  /* Print modes, if rft = table */
                ,@ssr_cenwave
                ,@ssr_detector
                ,@ssr_opt_elem
 

                end /* while more moc files */

                close moc_update_cursor

                deallocate cursor moc_update_cursor
        end /* if @ref_type = 'MOC') */


        if (@ref_type = 'PHT')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "PHT"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* mod - use detector and obstype as table selectors */
			and stis_row.detector = @ssr_detector
			and stis_row.obstype = @ssr_obstype
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare pht_update_cursor cursor for
                select ssr_phottab
                  /* Add modes to the select list, if rft = table */
                ,ssr_cenwave
                ,ssr_obstype
                ,ssr_detector
                ,ssr_opt_elem
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
/* mod - use detector and obstype as table selectors */
		and ssr_detector = @ssr_detector
		and ssr_obstype = @ssr_obstype
                for update

                open pht_update_cursor

                fetch pht_update_cursor into @ssr_phottab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_cenwave
                ,@ssr_obstype
                ,@ssr_detector
                ,@ssr_opt_elem

                while (@@sqlstatus = 0) /* While more pht files */

                begin
		  if (@ssr_obstype = 'SPECTROSCOPIC') /* mod - use cenwave */
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
/* mod - wildcard */
                        and (stis_row.cenwave =  @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and stis_row.obstype = @ssr_obstype
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
		  else /* don't use cenwave */
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
                        and stis_row.obstype = @ssr_obstype
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_phottab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_phottab = "N/A"
                  else if (@new_file_name = @ssr_phottab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_phottab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_phottab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
		     if (@ssr_obstype = 'SPECTROSCOPIC') /* use cenwave */
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_phottab
/* mod - wildcard */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and stis_row.obstype = @ssr_obstype
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
		     else  /* don't use cenwave */
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_phottab
                        and stis_row.obstype = @ssr_obstype
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_phottab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_phottab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_phottab = "MODERATE"
                             else select @ssr_best_loc_phottab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_phottab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_phottab = @ssr_best_loc_phottab
                   where  current of pht_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch pht_update_cursor into @ssr_phottab
                  /* Print modes, if rft = table */
                ,@ssr_cenwave
                ,@ssr_obstype
                ,@ssr_detector
                ,@ssr_opt_elem
 

                end /* while more pht files */

                close pht_update_cursor

                deallocate cursor pht_update_cursor
        end /* if @ref_type = 'PHT') */


        if (@ref_type = '1DT')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "1DT"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* mod - use detector as table selector */
			and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare onedt_update_cursor cursor for
                select ssr_sptrctab
                  /* Add modes to the select list, if rft = table */
                ,ssr_cenwave
                ,ssr_detector
                ,ssr_opt_elem
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
/* mod - use detector as table selector */
		and ssr_detector = @ssr_detector
                for update

                open onedt_update_cursor

                fetch onedt_update_cursor into @ssr_sptrctab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_cenwave
                ,@ssr_detector
                ,@ssr_opt_elem

                while (@@sqlstatus = 0) /* While more 1dt files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
/* mod - wildcard */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_sptrctab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_sptrctab = "N/A"
                  else if (@new_file_name = @ssr_sptrctab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_sptrctab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_sptrctab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_sptrctab
/* mod - wildcard */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_sptrctab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_sptrctab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_sptrctab = "MODERATE"
                             else select @ssr_best_loc_sptrctab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_sptrctab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_sptrctab = @ssr_best_loc_sptrctab
                   where  current of onedt_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch onedt_update_cursor into @ssr_sptrctab
                  /* Print modes, if rft = table */
                ,@ssr_cenwave
                ,@ssr_detector
                ,@ssr_opt_elem
 

                end /* while more 1dt files */

                close onedt_update_cursor

                deallocate cursor onedt_update_cursor
        end /* if @ref_type = '1DT') */


        if (@ref_type = '1DX')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "1DX"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* mod - use detector as table selector */
			and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare onedx_update_cursor cursor for
                select ssr_xtractab
                  /* Add modes to the select list, if rft = table */
                ,ssr_cenwave
                ,ssr_aperture
                ,ssr_detector
                ,ssr_opt_elem
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
/* mod - use detector as table selector */
		and ssr_detector = @ssr_detector
                for update

                open onedx_update_cursor

                fetch onedx_update_cursor into @ssr_xtractab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_cenwave
                ,@ssr_aperture
                ,@ssr_detector
                ,@ssr_opt_elem

                while (@@sqlstatus = 0) /* While more 1dx files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
/* mod - wildcards */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and (stis_row.aperture = @ssr_aperture or
			     stis_row.aperture = 'ANY')
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_xtractab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_xtractab = "N/A"
                  else if (@new_file_name = @ssr_xtractab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_xtractab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_xtractab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_xtractab
/* mod - wildcard */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and (stis_row.aperture = @ssr_aperture or
			     stis_row.aperture = 'ANY')
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_xtractab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_xtractab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_xtractab = "MODERATE"
                             else select @ssr_best_loc_xtractab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_xtractab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_xtractab = @ssr_best_loc_xtractab
                   where  current of onedx_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch onedx_update_cursor into @ssr_xtractab
                  /* Print modes, if rft = table */
                ,@ssr_cenwave
                ,@ssr_aperture
                ,@ssr_detector
                ,@ssr_opt_elem
 

                end /* while more 1dx files */

                close onedx_update_cursor

                deallocate cursor onedx_update_cursor
        end /* if @ref_type = '1DX') */


        if (@ref_type = 'APD')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
/* mod - remove unnecessary join to stis_row */
                from stis_file stis_file
                        where 
                            stis_file.reference_file_type = "APD"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* The reference file type is table, don't print out the modes */
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare apd_update_cursor cursor for
                select ssr_apdestab
                  /* Add modes to the select list, if rft = table */
                ,ssr_aperture
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
                  /* Modes aren't added to the where clause, if rft = table */
                for update

                open apd_update_cursor

                fetch apd_update_cursor into @ssr_apdestab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_aperture

                while (@@sqlstatus = 0) /* While more apd files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
/* mod - wildcard */
                        and (stis_row.aperture = @ssr_aperture or
			     stis_row.aperture = 'ANY')

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_apdestab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_apdestab = "N/A"
                  else if (@new_file_name = @ssr_apdestab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_apdestab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_apdestab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_apdestab
/* mod - wildcard */
                        and (stis_row.aperture = @ssr_aperture or
			     stis_row.aperture = 'ANY')
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_apdestab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_apdestab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_apdestab = "MODERATE"
                             else select @ssr_best_loc_apdestab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_apdestab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_apdestab = @ssr_best_loc_apdestab
                   where  current of apd_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch apd_update_cursor into @ssr_apdestab
                  /* Print modes, if rft = table */
                ,@ssr_aperture
 

                end /* while more apd files */

                close apd_update_cursor

                deallocate cursor apd_update_cursor
        end /* if @ref_type = 'APD') */


        if (@ref_type = 'CRR')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "CRR"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* mod - use detector as table selector */
			and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare crr_update_cursor cursor for
                select ssr_crrejtab
                  /* Add modes to the select list, if rft = table */
                ,ssr_crsplit
                ,ssr_detector
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
/* mod - use detector as table selector */
		and ssr_detector = @ssr_detector
                for update

                open crr_update_cursor

                fetch crr_update_cursor into @ssr_crrejtab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_crsplit
                ,@ssr_detector

                while (@@sqlstatus = 0) /* While more crr files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
                        and stis_row.crsplit = @ssr_crsplit
                        and stis_row.detector = @ssr_detector

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_crrejtab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_crrejtab = "N/A"
                  else if (@new_file_name = @ssr_crrejtab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_crrejtab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_crrejtab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_crrejtab
                        and stis_row.crsplit = @ssr_crsplit
                        and stis_row.detector = @ssr_detector
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_crrejtab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_crrejtab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_crrejtab = "MODERATE"
                             else select @ssr_best_loc_crrejtab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_crrejtab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_crrejtab = @ssr_best_loc_crrejtab
                   where  current of crr_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch crr_update_cursor into @ssr_crrejtab
                  /* Print modes, if rft = table */
                ,@ssr_crsplit
                ,@ssr_detector
 

                end /* while more crr files */

                close crr_update_cursor

                deallocate cursor crr_update_cursor
        end /* if @ref_type = 'CRR') */


        if (@ref_type = 'IAC')
        begin
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "IAC"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
/* mod - use detector as table selector */
			and stis_row.detector = @ssr_detector
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare iac_update_cursor cursor for
                select ssr_inangtab
                  /* Add modes to the select list, if rft = table */
                ,ssr_cenwave
                ,ssr_detector
                ,ssr_opt_elem
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
/* mod - use detector as table selector */
		and ssr_detector = @ssr_detector
                for update

                open iac_update_cursor

                fetch iac_update_cursor into @ssr_inangtab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_cenwave
                ,@ssr_detector
                ,@ssr_opt_elem

                while (@@sqlstatus = 0) /* While more iac files */

                begin
/* The following section, surrounded by ++++'s, if rft = table */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
/* mod - wildcard */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
                  if (@ssr_inangtab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_inangtab = "N/A"
                  else if (@new_file_name = @ssr_inangtab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_inangtab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_inangtab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_inangtab
/* mod - wildcard */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_inangtab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_inangtab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_inangtab = "MODERATE"
                             else select @ssr_best_loc_inangtab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_inangtab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_inangtab = @ssr_best_loc_inangtab
                   where  current of iac_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch iac_update_cursor into @ssr_inangtab
                  /* Print modes, if rft = table */
                ,@ssr_cenwave
                ,@ssr_detector
                ,@ssr_opt_elem
 

                end /* while more iac files */

                close iac_update_cursor

                deallocate cursor iac_update_cursor
        end /* if @ref_type = 'IAC') */


        if (@ref_type = 'PCT')
        begin
/* begin mod - OPR 35684 - 12/31/97 - Add PCT support */
                        /* get first non-rejected file that has a */
                        /* useafter_date that is greater than the */
                        /* new files useafter_date - use for stop window */
                declare stop_date_cursor cursor for
                select  stis_file.useafter_date
                from stis_file stis_file, stis_row stis_row
                        where stis_row.file_name = stis_file.file_name
                        and stis_row.expansion_number = stis_file.expansion_number
                        and stis_file.reference_file_type = "PCT"
                        and stis_file.reject_flag = "N"
                        and stis_file.opus_flag = "Y"
                        and stis_file.useafter_date > @useafter_date
                        and stis_file.archive_date is not null
			and stis_row.detector = @ssr_detector
			and stis_row.opt_elem = @ssr_opt_elem
			and stis_row.obstype = @ssr_obstype
                order by stis_file.useafter_date
                for read only

                open stop_date_cursor

                fetch stop_date_cursor into @stop_date

                if (@@sqlstatus <> 0)  /* no stop date found-use todays date*/

                        select @stop_date = getdate()

                close stop_date_cursor

                deallocate cursor stop_date_cursor


                declare pct_update_cursor cursor for
                select ssr_pctab
                  /* Add modes to the select list, if rft = table */
                ,ssr_cenwave
                ,ssr_aperture
                ,ssr_detector
                ,ssr_opt_elem
		,ssr_obstype
                from stis_ref_data
                where ssr_texpstrt >= @useafter_date
                and ssr_texpstrt < @stop_date
/* mod - use detector as table selector */
		and ssr_detector = @ssr_detector
		and ssr_opt_elem = @ssr_opt_elem
		and ssr_obstype = @ssr_obstype
                for update

                open pct_update_cursor

                fetch pct_update_cursor into @ssr_pctab
                  /* Add modes to the fetch statement, if rft = table */
                ,@ssr_cenwave
                ,@ssr_aperture
                ,@ssr_detector
                ,@ssr_opt_elem
		,@ssr_obstype

                while (@@sqlstatus = 0) /* While more PCT files */

                begin

                        select @equiv_sev = stis_row.equivalence_class_severe,
                                @equiv_mod = stis_row.equivalence_class_moderate
                        from stis_row stis_row
                        where stis_row.file_name = @new_file_name
                        and stis_row.expansion_number = @new_expansion_number
/* mod - wildcards */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and (stis_row.aperture = @ssr_aperture or
			     stis_row.aperture = 'ANY')
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
			and stis_row.obstype = @ssr_obstype

                select @num_cal_files = @@rowcount
                if (@num_cal_files <> 0)	/* recommended file found */
                begin

                  if (@ssr_pctab = NULL)  /* no file was used in pipeline */
                        select @ssr_best_loc_pctab = "N/A"
                  else if (@new_file_name = @ssr_pctab)  /* recommended = was used, if rft = image or table */
                        select @ssr_best_loc_pctab = "NO CHANGE"
                  else
                        if (@equiv_sev = -1)
                        select @ssr_best_loc_pctab = 'UNKNOWN'
                  else   /* recommended <> was used - compute level of change */
                    begin
                        select        @orig_equiv_sev = stis_row.equivalence_class_severe,
                                @orig_equiv_mod = stis_row.equivalence_class_moderate
                        from        stis_row stis_row
                        where        stis_row.file_name = @ssr_pctab
/* mod - wildcard */
                        and (stis_row.cenwave = @ssr_cenwave or
			     stis_row.cenwave = -1)
                        and (stis_row.aperture = @ssr_aperture or
			     stis_row.aperture = 'ANY')
                        and stis_row.detector = @ssr_detector
                        and stis_row.opt_elem = @ssr_opt_elem
			and stis_row.obstype = @ssr_obstype 

                        if (@orig_equiv_sev = -1)
                        select @ssr_best_loc_pctab = 'UNKNOWN'
                        else if ((@equiv_sev - @orig_equiv_sev) <> 0)
                                select @ssr_best_loc_pctab = "SEVERE"
                        else if ((@equiv_mod - @orig_equiv_mod) <> 0)
                                select @ssr_best_loc_pctab = "MODERATE"
                             else select @ssr_best_loc_pctab = "TRIVIAL"
 
                    end      /*else*/
 
                   /* update row */
                   update stis_ref_data
                   set ssr_best_pctab= @new_file_name, /* if rft = image or table */
                       ssr_best_loc_pctab = @ssr_best_loc_pctab
                   where  current of pct_update_cursor
        
                 end /* if recommended file found, if rft = table */
                  fetch pct_update_cursor into @ssr_pctab
                  /* Print modes, if rft = table */
                ,@ssr_cenwave
                ,@ssr_aperture
                ,@ssr_detector
                ,@ssr_opt_elem
		,@ssr_obstype 

                end /* while more PCT files */

                close pct_update_cursor

                deallocate cursor pct_update_cursor
        end /* if @ref_type = 'PCT') */





fetch new_stis_cursor into @new_file_name, @new_expansion_number

end /* while more newly delivered calibration files */

close new_stis_cursor

deallocate cursor new_stis_cursor
return
go


