use dadsops
go
drop procedure update_fos
go
create procedure update_fos as
/* observation start time */
declare @expstart datetime
/* data set name, to be used for error checking/handling */
declare @data_set_name datasetname
/* severity level variables, to be reused for each reference file type */
declare @orig_equiv_sev int
declare @orig_equiv_mod int
declare @equiv_sev int
declare @equiv_mod int
/* used to store @@rowcount global variable */
declare @num_cal_files int
/* observation modes, calibration files used in the pipeline, */
/* best, and best_loc files */
declare @fsr_fchnl int
declare @fsr_nxsteps int
declare @fsr_overscan int
declare @fsr_ccg2 char(18)
declare @fsr_ccs0 char(18)
declare @fsr_ccs1 char(18)
declare @fsr_ccs2 char(18)
declare @fsr_ccs3 char(18)
declare @fsr_ccs4 char(18)
declare @fsr_ccs5 char(18)
declare @fsr_ccs6 char(18)
declare @fsr_ccs7 char(18)
declare @fsr_ccs8 char(18)
declare @fsr_ccs9 char(18)
declare @fsr_ccsa char(18)
declare @fsr_ccsb char(18)
declare @fsr_ccsc char(18)
declare @fsr_ccsd char(18)
declare @fsr_aper_id char(3)
declare @fsr_fgwa_id char(3)
declare @fsr_detector char(5)
declare @fsr_polar_id char(1)
declare @fsr_aishfile char(18)
declare @fsr_bachfile char(18)
declare @fsr_best_ais char(18)
declare @fsr_best_bac char(18)
declare @fsr_best_ddt char(18)
declare @fsr_best_ret char(18)
declare @fsr_ddthfile char(18)
declare @fsr_dq1hfile char(18)
declare @fsr_dq2hfile char(18)
declare @fsr_fl1hfile char(18)
declare @fsr_fl2hfile char(18)
declare @fsr_iv1hfile char(18)
declare @fsr_iv2hfile char(18)
declare @fsr_rethfile char(18)
declare @fsr_pcphfile char(18)
declare @fsr_best_pcp char(18)
declare @fsr_best_ccg2 char(18)
declare @fsr_best_ccs0 char(18)
declare @fsr_best_ccs1 char(18)
declare @fsr_best_ccs2 char(18)
declare @fsr_best_ccs3 char(18)
declare @fsr_best_ccs4 char(18)
declare @fsr_best_ccs5 char(18)
declare @fsr_best_ccs6 char(18)
declare @fsr_best_ccs7 char(18)
declare @fsr_best_ccs8 char(18)
declare @fsr_best_ccs9 char(18)
declare @fsr_best_ccsa char(18)
declare @fsr_best_ccsb char(18)
declare @fsr_best_ccsc char(18)
declare @fsr_best_ccsd char(18)
declare @fsr_best_flt1 char(18)
declare @fsr_best_flt2 char(18)
declare @fsr_best_ivs1 char(18)
declare @fsr_best_ivs2 char(18)
declare @fsr_best_qin1 char(18)
declare @fsr_best_qin2 char(18)
declare @fsr_best_loc_pcp varchar(9)
declare @fsr_best_loc_ais varchar(9)
declare @fsr_best_loc_bac varchar(9)
declare @fsr_best_loc_ddt varchar(9)
declare @fsr_best_loc_ret varchar(9)
declare @fsr_best_loc_ccg2 varchar(9)
declare @fsr_best_loc_ccs0 varchar(9)
declare @fsr_best_loc_ccs1 varchar(9)
declare @fsr_best_loc_ccs2 varchar(9)
declare @fsr_best_loc_ccs3 varchar(9)
declare @fsr_best_loc_ccs4 varchar(9)
declare @fsr_best_loc_ccs5 varchar(9)
declare @fsr_best_loc_ccs6 varchar(9)
declare @fsr_best_loc_ccs7 varchar(9)
declare @fsr_best_loc_ccs8 varchar(9)
declare @fsr_best_loc_ccs9 varchar(9)
declare @fsr_best_loc_ccsa varchar(9)
declare @fsr_best_loc_ccsb varchar(9)
declare @fsr_best_loc_ccsc varchar(9)
declare @fsr_best_loc_ccsd varchar(9)
declare @fsr_best_loc_flt1 varchar(9)
declare @fsr_best_loc_flt2 varchar(9)
declare @fsr_best_loc_ivs1 varchar(9)
declare @fsr_best_loc_ivs2 varchar(9)
declare @fsr_best_loc_qin1 varchar(9)
declare @fsr_best_loc_qin2 varchar(9)
declare update_fos_cursor  cursor for
select fsr_expstart,fsr_data_set_name
,fsr_fchnl
,fsr_aper_id
,fsr_fgwa_id
,fsr_nxsteps
,fsr_detector
,fsr_overscan
,fsr_polar_id
,fsr_aishfile
,fsr_ddthfile
,fsr_rethfile
,fsr_ccg2
,fsr_ccs0
,fsr_ccs1
,fsr_ccs2
,fsr_ccs3
,fsr_ccs4
,fsr_ccs5
,fsr_ccs6
,fsr_ccs8
,fsr_ccs9
,fsr_ccsb
,fsr_ccsc
,fsr_ccsd
,fsr_fl1hfile
,fsr_fl2hfile	/* mod */
,fsr_iv1hfile
,fsr_iv2hfile	/* mod */
,fsr_dq1hfile
,fsr_dq2hfile	/* mod */
,fsr_ccs7
,fsr_bachfile
,fsr_ccsa
,fsr_pcphfile
from fos_ref_data
where fsr_best_ais is null
or fsr_best_ddt is null
or fsr_best_ret is null
or fsr_best_ccg2 is null
or fsr_best_ccs0 is null
or fsr_best_ccs1 is null
or fsr_best_ccs2 is null
or fsr_best_ccs3 is null
or fsr_best_ccs4 is null
or fsr_best_ccs5 is null
or fsr_best_ccs6 is null
or fsr_best_ccs8 is null
or fsr_best_ccs9 is null
or fsr_best_ccsb is null
or fsr_best_ccsc is null
or fsr_best_ccsd is null
or fsr_best_flt1 is null
or fsr_best_flt2 is null	/* mod */
or fsr_best_ivs1 is null
or fsr_best_ivs2 is null	/* mod */
or fsr_best_qin1 is null
or fsr_best_qin2 is null	/* mod */
or fsr_best_ccs7 is null
or fsr_best_bac is null
or fsr_best_ccsa is null
or fsr_best_pcp is null
 for update
open update_fos_cursor 
fetch update_fos_cursor into @expstart,@data_set_name
,@fsr_fchnl
,@fsr_aper_id
,@fsr_fgwa_id
,@fsr_nxsteps
,@fsr_detector
,@fsr_overscan
,@fsr_polar_id
,@fsr_aishfile
,@fsr_ddthfile
,@fsr_rethfile
,@fsr_ccg2
,@fsr_ccs0
,@fsr_ccs1
,@fsr_ccs2
,@fsr_ccs3
,@fsr_ccs4
,@fsr_ccs5
,@fsr_ccs6
,@fsr_ccs8
,@fsr_ccs9
,@fsr_ccsb
,@fsr_ccsc
,@fsr_ccsd
,@fsr_fl1hfile
,@fsr_fl2hfile
,@fsr_iv1hfile
,@fsr_iv2hfile
,@fsr_dq1hfile
,@fsr_dq2hfile
,@fsr_ccs7
,@fsr_bachfile
,@fsr_ccsa
,@fsr_pcphfile
/**************************************************************************/
/************************ Update fos ***********************/
/**************************************************************************/
while (@@sqlstatus = 0)
begin
select
@fsr_best_ais = null
,@fsr_best_bac = null
,@fsr_best_ddt = null
,@fsr_best_ret = null
,@fsr_best_ccg2 = null
,@fsr_best_ccs0 = null
,@fsr_best_ccs1 = null
,@fsr_best_ccs2 = null
,@fsr_best_ccs3 = null
,@fsr_best_ccs4 = null
,@fsr_best_ccs5 = null
,@fsr_best_ccs6 = null
,@fsr_best_ccs7 = null
,@fsr_best_ccs8 = null
,@fsr_best_ccs9 = null
,@fsr_best_ccsa = null
,@fsr_best_ccsb = null
,@fsr_best_ccsc = null
,@fsr_best_ccsd = null
,@fsr_best_flt1 = null
,@fsr_best_flt2 = null
,@fsr_best_ivs1 = null
,@fsr_best_ivs2 = null
,@fsr_best_qin1 = null
,@fsr_best_qin2 = null
,@fsr_best_pcp = null
,@fsr_best_loc_ais = null
,@fsr_best_loc_bac = null
,@fsr_best_loc_ddt = null
,@fsr_best_loc_ret = null
,@fsr_best_loc_ccg2 = null
,@fsr_best_loc_ccs0 = null
,@fsr_best_loc_ccs1 = null
,@fsr_best_loc_ccs2 = null
,@fsr_best_loc_ccs3 = null
,@fsr_best_loc_ccs4 = null
,@fsr_best_loc_ccs5 = null
,@fsr_best_loc_ccs6 = null
,@fsr_best_loc_ccs7 = null
,@fsr_best_loc_ccs8 = null
,@fsr_best_loc_ccs9 = null
,@fsr_best_loc_ccsa = null
,@fsr_best_loc_ccsb = null
,@fsr_best_loc_ccsc = null
,@fsr_best_loc_ccsd = null
,@fsr_best_loc_flt1 = null
,@fsr_best_loc_flt2 = null
,@fsr_best_loc_ivs1 = null
,@fsr_best_loc_ivs2 = null
,@fsr_best_loc_qin1 = null
,@fsr_best_loc_qin2 = null
,@fsr_best_loc_pcp = null
/**************************************************************************/
/*********** instrument fos ref file type CCG2 ****************/
/**************************************************************************/
select @fsr_best_ccg2 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCG2'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
/* mod - remove detector -values=1,2 in table, amber,blue in dads */
        )
and fos_file_1.reference_file_type = 'CCG2'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
/* mod - remove detector */

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccg2 = 'N/A', @fsr_best_loc_ccg2 = 'N/A'
else
if (@fsr_ccg2 = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccg2 = 'N/A'
else
if (@fsr_best_ccg2 = @fsr_ccg2) /* recommended = was used */
select @fsr_best_loc_ccg2 = 'NO CHANGE'
else
/* mod - can't compute loc - detector values=1,2 in table, amber,blue in dads*/
select @fsr_best_loc_ccg2 = 'N/A'

/**************************************************************************/
/*********** instrument fos ref file type CCS0 ****************/
/**************************************************************************/
select @fsr_best_ccs0 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCS0'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
/* mod - removed modes - need aper_pos - don't compute loc */
        )
and fos_file_1.reference_file_type = 'CCS0'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
/* mod - removed modes - need aper_pos - don't compute loc */

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccs0 = 'N/A', @fsr_best_loc_ccs0 = 'N/A'
else
if (@fsr_ccs0 = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccs0 = 'N/A'
else
if (@fsr_best_ccs0 = @fsr_ccs0) /* recommended = was used */
select @fsr_best_loc_ccs0 = 'NO CHANGE'
else
  select @fsr_best_loc_ccs0 = 'N/A'	/* mod - can't compute loc */

/**************************************************************************/
/*********** instrument fos ref file type CCS1 ****************/
/**************************************************************************/
select @fsr_best_ccs1 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCS1'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
        )
and fos_file_1.reference_file_type = 'CCS1'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccs1 = 'N/A', @fsr_best_loc_ccs1 = 'N/A'
else
if (@fsr_ccs1 = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccs1 = 'N/A'
else
if (@fsr_best_ccs1 = @fsr_ccs1) /* recommended = was used */
select @fsr_best_loc_ccs1 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ccs1 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_ccs1
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ccs1 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ccs1 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ccs1 = 'MODERATE'
     else select @fsr_best_loc_ccs1 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type CCS2 ****************/
/**************************************************************************/
select @fsr_best_ccs2 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCS2'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.fchnl = @fsr_fchnl
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.nxsteps = @fsr_nxsteps
             and fos_row_2.detector = @fsr_detector
        )
and fos_file_1.reference_file_type = 'CCS2'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.fchnl = @fsr_fchnl
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.nxsteps = @fsr_nxsteps
and fos_row_1.detector = @fsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccs2 = 'N/A', @fsr_best_loc_ccs2 = 'N/A'
else
if (@fsr_ccs2 = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccs2 = 'N/A'
else
if (@fsr_best_ccs2 = @fsr_ccs2) /* recommended = was used */
select @fsr_best_loc_ccs2 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ccs2 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_ccs2
and fos_row_1.fchnl = @fsr_fchnl
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.nxsteps = @fsr_nxsteps
and fos_row_1.detector = @fsr_detector

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ccs2 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ccs2 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ccs2 = 'MODERATE'
     else select @fsr_best_loc_ccs2 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type CCS3 ****************/
/**************************************************************************/
select @fsr_best_ccs3 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCS3'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.detector = @fsr_detector
        )
and fos_file_1.reference_file_type = 'CCS3'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.detector = @fsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccs3 = 'N/A', @fsr_best_loc_ccs3 = 'N/A'
else
if (@fsr_ccs3 = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccs3 = 'N/A'
else
if (@fsr_best_ccs3 = @fsr_ccs3) /* recommended = was used */
select @fsr_best_loc_ccs3 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ccs3 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_ccs3
and fos_row_1.detector = @fsr_detector

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ccs3 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ccs3 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ccs3 = 'MODERATE'
     else select @fsr_best_loc_ccs3 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type CCS4 ****************/
/**************************************************************************/
select @fsr_best_ccs4 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCS4'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.polar_id = @fsr_polar_id
        )
and fos_file_1.reference_file_type = 'CCS4'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.polar_id = @fsr_polar_id
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccs4 = 'N/A', @fsr_best_loc_ccs4 = 'N/A'
else
if (@fsr_ccs4 = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccs4 = 'N/A'
else
if (@fsr_best_ccs4 = @fsr_ccs4) /* recommended = was used */
select @fsr_best_loc_ccs4 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ccs4 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_ccs4
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.polar_id = @fsr_polar_id

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ccs4 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ccs4 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ccs4 = 'MODERATE'
     else select @fsr_best_loc_ccs4 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type CCS5 ****************/
/**************************************************************************/
select @fsr_best_ccs5 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCS5'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.nxsteps = @fsr_nxsteps
             and fos_row_2.detector = @fsr_detector
        )
and fos_file_1.reference_file_type = 'CCS5'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.nxsteps = @fsr_nxsteps
and fos_row_1.detector = @fsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccs5 = 'N/A', @fsr_best_loc_ccs5 = 'N/A'
else
if (@fsr_ccs5 = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccs5 = 'N/A'
else
if (@fsr_best_ccs5 = @fsr_ccs5) /* recommended = was used */
select @fsr_best_loc_ccs5 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ccs5 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_ccs5
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.nxsteps = @fsr_nxsteps
and fos_row_1.detector = @fsr_detector

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ccs5 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ccs5 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ccs5 = 'MODERATE'
     else select @fsr_best_loc_ccs5 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type CCS6 ****************/
/**************************************************************************/
select @fsr_best_ccs6 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCS6'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
/* mod - removed modes - need aper_pos,pass_dir to compute loc */
        )
and fos_file_1.reference_file_type = 'CCS6'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
/* mod - removed modes - need aper_pos,pass_dir to compute loc */

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccs6 = 'N/A', @fsr_best_loc_ccs6 = 'N/A'
else
if (@fsr_ccs6 = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccs6 = 'N/A'
else
if (@fsr_best_ccs6 = @fsr_ccs6) /* recommended = was used */
select @fsr_best_loc_ccs6 = 'NO CHANGE'
else
 select @fsr_best_loc_ccs6 = 'N/A'	/* mod - can't compute loc */

/**************************************************************************/
/*********** instrument fos ref file type CCS7 ****************/
/**************************************************************************/
select @fsr_best_ccs7 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCS7'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.detector = @fsr_detector
        )
and fos_file_1.reference_file_type = 'CCS7'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.detector = @fsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccs7 = 'N/A', @fsr_best_loc_ccs7 = 'N/A'
else
if (@fsr_ccs7 = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccs7 = 'N/A'
else
if (@fsr_best_ccs7 = @fsr_ccs7) /* recommended = was used */
select @fsr_best_loc_ccs7 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ccs7 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_ccs7
and fos_row_1.detector = @fsr_detector

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ccs7 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ccs7 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ccs7 = 'MODERATE'
     else select @fsr_best_loc_ccs7 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type CCS8 ****************/
/**************************************************************************/
select @fsr_best_ccs8 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCS8'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.detector = @fsr_detector
        )
and fos_file_1.reference_file_type = 'CCS8'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.detector = @fsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccs8 = 'N/A', @fsr_best_loc_ccs8 = 'N/A'
else
if (@fsr_ccs8 = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccs8 = 'N/A'
else
if (@fsr_best_ccs8 = @fsr_ccs8) /* recommended = was used */
select @fsr_best_loc_ccs8 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ccs8 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_ccs8
and fos_row_1.detector = @fsr_detector

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ccs8 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ccs8 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ccs8 = 'MODERATE'
     else select @fsr_best_loc_ccs8 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type CCS9 ****************/
/**************************************************************************/
select @fsr_best_ccs9 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCS9'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
        )
and fos_file_1.reference_file_type = 'CCS9'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccs9 = 'N/A', @fsr_best_loc_ccs9 = 'N/A'
else
if (@fsr_ccs9 = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccs9 = 'N/A'
else
if (@fsr_best_ccs9 = @fsr_ccs9) /* recommended = was used */
select @fsr_best_loc_ccs9 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ccs9 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_ccs9
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ccs9 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ccs9 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ccs9 = 'MODERATE'
     else select @fsr_best_loc_ccs9 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type CCSA ****************/
/**************************************************************************/
select @fsr_best_ccsa = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCSA'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
        )
and fos_file_1.reference_file_type = 'CCSA'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccsa = 'N/A', @fsr_best_loc_ccsa = 'N/A'
else
if (@fsr_ccsa = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccsa = 'N/A'
else
if (@fsr_best_ccsa = @fsr_ccsa) /* recommended = was used */
select @fsr_best_loc_ccsa = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ccsa = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_ccsa

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ccsa = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ccsa = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ccsa = 'MODERATE'
     else select @fsr_best_loc_ccsa = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type CCSB ****************/
/**************************************************************************/
select @fsr_best_ccsb = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCSB'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
        )
and fos_file_1.reference_file_type = 'CCSB'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccsb = 'N/A', @fsr_best_loc_ccsb = 'N/A'
else
if (@fsr_ccsb = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccsb = 'N/A'
else
if (@fsr_best_ccsb = @fsr_ccsb) /* recommended = was used */
select @fsr_best_loc_ccsb = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ccsb = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_ccsb
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ccsb = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ccsb = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ccsb = 'MODERATE'
     else select @fsr_best_loc_ccsb = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type PCP ****************/
/**************************************************************************/
select @fsr_best_pcp = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'PCP'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
	     and fos_row_2.polar_id = @fsr_polar_id
        )
and fos_file_1.reference_file_type = 'PCP'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.polar_id = @fsr_polar_id
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_pcp = 'N/A', @fsr_best_loc_pcp = 'N/A'
else
if (@fsr_pcphfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_pcp = 'N/A'
else
if (@fsr_best_pcp = @fsr_pcphfile) /* recommended = was used */
select @fsr_best_loc_pcp = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_pcp = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_pcphfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.polar_id = @fsr_polar_id

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_pcp = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_pcp = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_pcp = 'MODERATE'
     else select @fsr_best_loc_pcp = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type CCSC ****************/
/**************************************************************************/
select @fsr_best_ccsc = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCSC'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.detector = @fsr_detector
        )
and fos_file_1.reference_file_type = 'CCSC'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.detector = @fsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccsc = 'N/A', @fsr_best_loc_ccsc = 'N/A'
else
if (@fsr_ccsc = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccsc = 'N/A'
else
if (@fsr_best_ccsc = @fsr_ccsc) /* recommended = was used */
select @fsr_best_loc_ccsc = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ccsc = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_ccsc
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.detector = @fsr_detector

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ccsc = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ccsc = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ccsc = 'MODERATE'
     else select @fsr_best_loc_ccsc = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type CCSD ****************/
/**************************************************************************/
select @fsr_best_ccsd = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'CCSD'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
        )
and fos_file_1.reference_file_type = 'CCSD'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ccsd = 'N/A', @fsr_best_loc_ccsd = 'N/A'
else
if (@fsr_ccsd = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ccsd = 'N/A'
else
if (@fsr_best_ccsd = @fsr_ccsd) /* recommended = was used */
select @fsr_best_loc_ccsd = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ccsd = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_ccsd
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ccsd = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ccsd = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ccsd = 'MODERATE'
     else select @fsr_best_loc_ccsd = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type AIS ****************/
/**************************************************************************/
select @fsr_best_ais = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'AIS'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
        )
and fos_file_1.reference_file_type = 'AIS'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ais = 'N/A', @fsr_best_loc_ais = 'N/A'
else
if (@fsr_aishfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ais = 'N/A'
else
if (@fsr_best_ais = @fsr_aishfile) /* recommended = was used */
select @fsr_best_loc_ais = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ais = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_aishfile
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ais = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ais = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ais = 'MODERATE'
     else select @fsr_best_loc_ais = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type BAC ****************/
/**************************************************************************/
select @fsr_best_bac = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'BAC'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
        )
and fos_file_1.reference_file_type = 'BAC'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_bac = 'N/A', @fsr_best_loc_bac = 'N/A'
else
if (@fsr_bachfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_bac = 'N/A'
else
if (@fsr_best_bac = @fsr_bachfile) /* recommended = was used */
select @fsr_best_loc_bac = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_bac = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_bachfile
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_bac = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_bac = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_bac = 'MODERATE'
     else select @fsr_best_loc_bac = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type DDT ****************/
/**************************************************************************/
select @fsr_best_ddt = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'DDT'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.detector = @fsr_detector
        )
and fos_file_1.reference_file_type = 'DDT'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.detector = @fsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ddt = 'N/A', @fsr_best_loc_ddt = 'N/A'
else
if (@fsr_ddthfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ddt = 'N/A'
else
if (@fsr_best_ddt = @fsr_ddthfile) /* recommended = was used */
select @fsr_best_loc_ddt = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ddt = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_ddthfile
and fos_row_1.detector = @fsr_detector

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ddt = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ddt = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ddt = 'MODERATE'
     else select @fsr_best_loc_ddt = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type RET ****************/
/**************************************************************************/
select @fsr_best_ret = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'RET'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
        )
and fos_file_1.reference_file_type = 'RET'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ret = 'N/A', @fsr_best_loc_ret = 'N/A'
else
if (@fsr_rethfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ret = 'N/A'
else
if (@fsr_best_ret = @fsr_rethfile) /* recommended = was used */
select @fsr_best_loc_ret = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ret = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_rethfile
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ret = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ret = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ret = 'MODERATE'
     else select @fsr_best_loc_ret = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument fos ref file type FLT ****************/
/**************************************************************************/
/* mod - entire section - to handle group params */

if (@fsr_aper_id not in ('A-4', 'A-3', 'A-2', 'C-1') and
   (@fsr_polar_id = 'C'))	/* single aperture */
begin
select @fsr_best_flt1 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'FLT'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'SINGLE'
	     and fos_row_2.pass_dir = 0
        )
and fos_file_1.reference_file_type = 'FLT'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 0

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_flt1 = 'N/A', @fsr_best_loc_flt1 = 'N/A'
else
if (@fsr_fl1hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_flt1 = 'N/A'
else
if (@fsr_best_flt1 = @fsr_fl1hfile) /* recommended = was used */
select @fsr_best_loc_flt1 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_flt1 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_fl1hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 0

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_flt1 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_flt1 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_flt1 = 'MODERATE'
     else select @fsr_best_loc_flt1 = 'TRIVIAL'
end

/* flt2 not used for singles */
select @fsr_best_flt2 = 'N/A', @fsr_best_loc_flt2 = 'N/A'

end /* single */
else
 if (@fsr_aper_id not in ('A-4', 'A-3', 'A-2', 'C-1') and
    (@fsr_polar_id <> 'C'))	/* polarimetry */
 begin
	/* compute flt1 - pass_dir = 1 */
select @fsr_best_flt1 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'FLT'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'SINGLE'
	     and fos_row_2.pass_dir = 1
        )
and fos_file_1.reference_file_type = 'FLT'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 1

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_flt1 = 'N/A', @fsr_best_loc_flt1 = 'N/A'
else
if (@fsr_fl1hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_flt1 = 'N/A'
else
if (@fsr_best_flt1 = @fsr_fl1hfile) /* recommended = was used */
select @fsr_best_loc_flt1 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_flt1 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_fl1hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 1

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_flt1 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_flt1 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_flt1 = 'MODERATE'
     else select @fsr_best_loc_flt1 = 'TRIVIAL'
end

	/* compute flt2 - pass_dir = 2 */
select @fsr_best_flt2 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'FLT'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'SINGLE'
	     and fos_row_2.pass_dir = 2
        )
and fos_file_1.reference_file_type = 'FLT'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 2

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_flt2 = 'N/A', @fsr_best_loc_flt2 = 'N/A'
else
if (@fsr_fl2hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_flt2 = 'N/A'
else
if (@fsr_best_flt2 = @fsr_fl2hfile) /* recommended = was used */
select @fsr_best_loc_flt2 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_flt2 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_fl2hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 2

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_flt2 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_flt2 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_flt2 = 'MODERATE'
     else select @fsr_best_loc_flt2 = 'TRIVIAL'
end

 end /* polarimetry */

else	/* paired apertures */
 if (@fsr_aper_id in ('A-4', 'A-3', 'A-2', 'C-1'))
 begin	/* compute flt1 - lower */
select @fsr_best_flt1 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'FLT'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'LOWER'
        )
and fos_file_1.reference_file_type = 'FLT'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'LOWER'

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_flt1 = 'N/A', @fsr_best_loc_flt1 = 'N/A'
else
if (@fsr_fl1hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_flt1 = 'N/A'
else
if (@fsr_best_flt1 = @fsr_fl1hfile) /* recommended = was used */
select @fsr_best_loc_flt1 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_flt1 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_fl1hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'LOWER'

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_flt1 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_flt1 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_flt1 = 'MODERATE'
     else select @fsr_best_loc_flt1 = 'TRIVIAL'
end

	/* compute flt2 - aper_pos = upper */
select @fsr_best_flt2 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'FLT'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'UPPER'
        )
and fos_file_1.reference_file_type = 'FLT'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'UPPER'

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_flt2 = 'N/A', @fsr_best_loc_flt2 = 'N/A'
else
if (@fsr_fl2hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_flt2 = 'N/A'
else
if (@fsr_best_flt2 = @fsr_fl2hfile) /* recommended = was used */
select @fsr_best_loc_flt2 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_flt2 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_fl2hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'UPPER'

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_flt2 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_flt2 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_flt2 = 'MODERATE'
     else select @fsr_best_loc_flt2 = 'TRIVIAL'
end

 end /* paired apertures*/
/* end mod */

/**************************************************************************/
/*********** instrument fos ref file type IVS ****************/
/**************************************************************************/
/* mod - entire section - to handle group params */

if (@fsr_aper_id not in ('A-4', 'A-3', 'A-2', 'C-1') and
   (@fsr_polar_id = 'C'))	/* single aperture */
begin
select @fsr_best_ivs1 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'IVS'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'SINGLE'
	     and fos_row_2.pass_dir = 0
        )
and fos_file_1.reference_file_type = 'IVS'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 0

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ivs1 = 'N/A', @fsr_best_loc_ivs1 = 'N/A'
else
if (@fsr_iv1hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ivs1 = 'N/A'
else
if (@fsr_best_ivs1 = @fsr_iv1hfile) /* recommended = was used */
select @fsr_best_loc_ivs1 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ivs1 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_iv1hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 0

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ivs1 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ivs1 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ivs1 = 'MODERATE'
     else select @fsr_best_loc_ivs1 = 'TRIVIAL'
end

/* ivs2 not used for singles */
select @fsr_best_ivs2 = 'N/A', @fsr_best_loc_ivs2 = 'N/A'

end /* single */
else
 if (@fsr_aper_id not in ('A-4', 'A-3', 'A-2', 'C-1') and
    (@fsr_polar_id <> 'C'))	/* polarimetry */
 begin
	/* compute ivs1 - pass_dir = 1 */
select @fsr_best_ivs1 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'IVS'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'SINGLE'
	     and fos_row_2.pass_dir = 1
        )
and fos_file_1.reference_file_type = 'IVS'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 1

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ivs1 = 'N/A', @fsr_best_loc_ivs1 = 'N/A'
else
if (@fsr_iv1hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ivs1 = 'N/A'
else
if (@fsr_best_ivs1 = @fsr_iv1hfile) /* recommended = was used */
select @fsr_best_loc_ivs1 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ivs1 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_iv1hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 1

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ivs1 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ivs1 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ivs1 = 'MODERATE'
     else select @fsr_best_loc_ivs1 = 'TRIVIAL'
end

	/* compute ivs2 - pass_dir = 2 */
select @fsr_best_ivs2 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'IVS'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'SINGLE'
	     and fos_row_2.pass_dir = 2
        )
and fos_file_1.reference_file_type = 'IVS'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 2

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ivs2 = 'N/A', @fsr_best_loc_ivs2 = 'N/A'
else
if (@fsr_iv2hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ivs2 = 'N/A'
else
if (@fsr_best_ivs2 = @fsr_iv2hfile) /* recommended = was used */
select @fsr_best_loc_ivs2 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ivs2 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_iv2hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 2

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ivs2 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ivs2 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ivs2 = 'MODERATE'
     else select @fsr_best_loc_ivs2 = 'TRIVIAL'
end

 end /* polarimetry */

else	/* paired apertures */
 if (@fsr_aper_id in ('A-4', 'A-3', 'A-2', 'C-1'))
 begin	/* compute ivs1 - lower */
select @fsr_best_ivs1 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'IVS'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'LOWER'
        )
and fos_file_1.reference_file_type = 'IVS'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'LOWER'

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ivs1 = 'N/A', @fsr_best_loc_ivs1 = 'N/A'
else
if (@fsr_iv1hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ivs1 = 'N/A'
else
if (@fsr_best_ivs1 = @fsr_iv1hfile) /* recommended = was used */
select @fsr_best_loc_ivs1 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ivs1 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_iv1hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'LOWER'

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ivs1 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ivs1 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ivs1 = 'MODERATE'
     else select @fsr_best_loc_ivs1 = 'TRIVIAL'
end

	/* compute ivs2 - aper_pos = upper */
select @fsr_best_ivs2 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'IVS'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'UPPER'
        )
and fos_file_1.reference_file_type = 'IVS'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'UPPER'

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_ivs2 = 'N/A', @fsr_best_loc_ivs2 = 'N/A'
else
if (@fsr_iv2hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_ivs2 = 'N/A'
else
if (@fsr_best_ivs2 = @fsr_iv2hfile) /* recommended = was used */
select @fsr_best_loc_ivs2 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_ivs2 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_iv2hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'UPPER'

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_ivs2 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_ivs2 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_ivs2 = 'MODERATE'
     else select @fsr_best_loc_ivs2 = 'TRIVIAL'
end

 end /* paired apertures*/
/* end mod */

/**************************************************************************/
/*********** instrument fos ref file type QIN ****************/
/**************************************************************************/
/* mod - entire section - to handle group params */

if (@fsr_aper_id not in ('A-4', 'A-3', 'A-2', 'C-1') and
   (@fsr_polar_id = 'C'))	/* single aperture */
begin
select @fsr_best_qin1 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'QIN'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'SINGLE'
	     and fos_row_2.pass_dir = 0
        )
and fos_file_1.reference_file_type = 'QIN'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 0

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_qin1 = 'N/A', @fsr_best_loc_qin1 = 'N/A'
else
if (@fsr_dq1hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_qin1 = 'N/A'
else
if (@fsr_best_qin1 = @fsr_dq1hfile) /* recommended = was used */
select @fsr_best_loc_qin1 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_qin1 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_dq1hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 0

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_qin1 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_qin1 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_qin1 = 'MODERATE'
     else select @fsr_best_loc_qin1 = 'TRIVIAL'
end

/* qin2 not used for singles */
select @fsr_best_qin2 = 'N/A', @fsr_best_loc_qin2 = 'N/A'

end /* single */
else
 if (@fsr_aper_id not in ('A-4', 'A-3', 'A-2', 'C-1') and
    (@fsr_polar_id <> 'C'))	/* polarimetry */
 begin
	/* compute qin1 - pass_dir = 1 */
select @fsr_best_qin1 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'QIN'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'SINGLE'
	     and fos_row_2.pass_dir = 1
        )
and fos_file_1.reference_file_type = 'QIN'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 1

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_qin1 = 'N/A', @fsr_best_loc_qin1 = 'N/A'
else
if (@fsr_dq1hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_qin1 = 'N/A'
else
if (@fsr_best_qin1 = @fsr_dq1hfile) /* recommended = was used */
select @fsr_best_loc_qin1 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_qin1 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_dq1hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 1

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_qin1 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_qin1 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_qin1 = 'MODERATE'
     else select @fsr_best_loc_qin1 = 'TRIVIAL'
end

	/* compute qin2 - pass_dir = 2 */
select @fsr_best_qin2 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'QIN'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'SINGLE'
	     and fos_row_2.pass_dir = 2
        )
and fos_file_1.reference_file_type = 'QIN'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 2

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_qin2 = 'N/A', @fsr_best_loc_qin2 = 'N/A'
else
if (@fsr_dq2hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_qin2 = 'N/A'
else
if (@fsr_best_qin2 = @fsr_dq2hfile) /* recommended = was used */
select @fsr_best_loc_qin2 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_qin2 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_dq2hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'SINGLE'
and fos_row_1.pass_dir = 2

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_qin2 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_qin2 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_qin2 = 'MODERATE'
     else select @fsr_best_loc_qin2 = 'TRIVIAL'
end

 end /* polarimetry */

else	/* paired apertures */
 if (@fsr_aper_id in ('A-4', 'A-3', 'A-2', 'C-1'))
 begin	/* compute qin1 - lower */
select @fsr_best_qin1 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'QIN'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'LOWER'
        )
and fos_file_1.reference_file_type = 'QIN'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'LOWER'

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_qin1 = 'N/A', @fsr_best_loc_qin1 = 'N/A'
else
if (@fsr_dq1hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_qin1 = 'N/A'
else
if (@fsr_best_qin1 = @fsr_dq1hfile) /* recommended = was used */
select @fsr_best_loc_qin1 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_qin1 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_dq1hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'LOWER'

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_qin1 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_qin1 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_qin1 = 'MODERATE'
     else select @fsr_best_loc_qin1 = 'TRIVIAL'
end

	/* compute qin2 - aper_pos = upper */
select @fsr_best_qin2 = fos_file_1.file_name,
@equiv_sev = fos_row_1.equivalence_class_severe,
@equiv_mod = fos_row_1.equivalence_class_moderate
from fos_file fos_file_1, fos_row fos_row_1
where fos_file_1.useafter_date = 
	(select max(fos_file_2.useafter_date)
	from fos_file fos_file_2, fos_row fos_row_2
             where fos_file_2.reference_file_type = 'QIN'
             and fos_file_2.useafter_date <= @expstart
             and fos_file_2.reject_flag = 'N'
             and fos_file_2.opus_flag = 'Y'
             and fos_file_2.archive_date is not null
             and fos_file_2.file_name =fos_row_2.file_name
             and fos_file_2.expansion_number = fos_row_2.expansion_number
             and fos_row_2.aper_id = @fsr_aper_id
             and fos_row_2.fgwa_id = @fsr_fgwa_id
             and fos_row_2.detector = @fsr_detector
             and fos_row_2.overscan = @fsr_overscan
             and fos_row_2.polar_id = @fsr_polar_id
	     and fos_row_2.aper_pos = 'UPPER'
        )
and fos_file_1.reference_file_type = 'QIN'
and fos_file_1.reject_flag = 'N'
and fos_file_1.opus_flag = 'Y'
and fos_file_1.archive_date is not null
and fos_file_1.file_name =fos_row_1.file_name
and fos_file_1.expansion_number = fos_row_1.expansion_number
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'UPPER'

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @fsr_best_qin2 = 'N/A', @fsr_best_loc_qin2 = 'N/A'
else
if (@fsr_dq2hfile = NULL) /* no file was used in the pipeline */
select @fsr_best_loc_qin2 = 'N/A'
else
if (@fsr_best_qin2 = @fsr_dq2hfile) /* recommended = was used */
select @fsr_best_loc_qin2 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @fsr_best_loc_qin2 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = fos_row_1.equivalence_class_severe,
@orig_equiv_mod =  fos_row_1.equivalence_class_moderate
from fos_row fos_row_1
where fos_row_1.file_name = @fsr_dq2hfile
and fos_row_1.aper_id = @fsr_aper_id
and fos_row_1.fgwa_id = @fsr_fgwa_id
and fos_row_1.detector = @fsr_detector
and fos_row_1.overscan = @fsr_overscan
and fos_row_1.polar_id = @fsr_polar_id
and fos_row_1.aper_pos = 'UPPER'

if (@orig_equiv_sev = -1)
	select @fsr_best_loc_qin2 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @fsr_best_loc_qin2 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @fsr_best_loc_qin2 = 'MODERATE'
     else select @fsr_best_loc_qin2 = 'TRIVIAL'
end

 end /* paired apertures*/
/* end mod */


update fos_ref_data
set
fsr_best_ccg2 = @fsr_best_ccg2
,fsr_best_loc_ccg2 = @fsr_best_loc_ccg2
,fsr_best_ccs0 = @fsr_best_ccs0
,fsr_best_loc_ccs0 = @fsr_best_loc_ccs0
,fsr_best_ccs1 = @fsr_best_ccs1
,fsr_best_loc_ccs1 = @fsr_best_loc_ccs1
,fsr_best_ccs2 = @fsr_best_ccs2
,fsr_best_loc_ccs2 = @fsr_best_loc_ccs2
,fsr_best_ccs3 = @fsr_best_ccs3
,fsr_best_loc_ccs3 = @fsr_best_loc_ccs3
,fsr_best_ccs4 = @fsr_best_ccs4
,fsr_best_loc_ccs4 = @fsr_best_loc_ccs4
,fsr_best_ccs5 = @fsr_best_ccs5
,fsr_best_loc_ccs5 = @fsr_best_loc_ccs5
,fsr_best_ccs6 = @fsr_best_ccs6
,fsr_best_loc_ccs6 = @fsr_best_loc_ccs6
,fsr_best_ccs7 = @fsr_best_ccs7
,fsr_best_loc_ccs7 = @fsr_best_loc_ccs7
,fsr_best_ccs8 = @fsr_best_ccs8
,fsr_best_loc_ccs8 = @fsr_best_loc_ccs8
,fsr_best_ccs9 = @fsr_best_ccs9
,fsr_best_loc_ccs9 = @fsr_best_loc_ccs9
,fsr_best_ccsa = @fsr_best_ccsa
,fsr_best_loc_ccsa = @fsr_best_loc_ccsa
,fsr_best_ccsb = @fsr_best_ccsb
,fsr_best_loc_ccsb = @fsr_best_loc_ccsb
,fsr_best_ccsc = @fsr_best_ccsc
,fsr_best_loc_ccsc = @fsr_best_loc_ccsc
,fsr_best_ccsd = @fsr_best_ccsd
,fsr_best_loc_ccsd = @fsr_best_loc_ccsd
,fsr_best_ais = @fsr_best_ais
,fsr_best_loc_ais = @fsr_best_loc_ais
,fsr_best_bac = @fsr_best_bac
,fsr_best_loc_bac = @fsr_best_loc_bac
,fsr_best_ddt = @fsr_best_ddt
,fsr_best_loc_ddt = @fsr_best_loc_ddt
,fsr_best_ret = @fsr_best_ret
,fsr_best_loc_ret = @fsr_best_loc_ret
,fsr_best_flt1 = @fsr_best_flt1
,fsr_best_loc_flt1 = @fsr_best_loc_flt1
,fsr_best_flt2 = @fsr_best_flt2		/* mod */
,fsr_best_loc_flt2 = @fsr_best_loc_flt2	/* mod */
,fsr_best_ivs1 = @fsr_best_ivs1
,fsr_best_loc_ivs1 = @fsr_best_loc_ivs1
,fsr_best_ivs2 = @fsr_best_ivs2		/* mod */
,fsr_best_loc_ivs2 = @fsr_best_loc_ivs2 /* mod */
,fsr_best_qin1 = @fsr_best_qin1
,fsr_best_loc_qin1 = @fsr_best_loc_qin1
,fsr_best_qin2 = @fsr_best_qin2		/* mod */
,fsr_best_loc_qin2 = @fsr_best_loc_qin2 /* mod */
,fsr_best_pcp = @fsr_best_pcp
,fsr_best_loc_pcp = @fsr_best_loc_pcp
where current of update_fos_cursor
fetch update_fos_cursor into @expstart,@data_set_name
,@fsr_fchnl
,@fsr_aper_id
,@fsr_fgwa_id
,@fsr_nxsteps
,@fsr_detector
,@fsr_overscan
,@fsr_polar_id
,@fsr_aishfile
,@fsr_ddthfile
,@fsr_rethfile
,@fsr_ccg2
,@fsr_ccs0
,@fsr_ccs1
,@fsr_ccs2
,@fsr_ccs3
,@fsr_ccs4
,@fsr_ccs5
,@fsr_ccs6
,@fsr_ccs8
,@fsr_ccs9
,@fsr_ccsb
,@fsr_ccsc
,@fsr_ccsd
,@fsr_fl1hfile
,@fsr_fl2hfile	/* mod */
,@fsr_iv1hfile
,@fsr_iv2hfile	/* mod */
,@fsr_dq1hfile
,@fsr_dq2hfile	/* mod */
,@fsr_ccs7
,@fsr_bachfile
,@fsr_ccsa
,@fsr_pcphfile
end
close update_fos_cursor 
deallocate cursor update_fos_cursor 
return
go
