use dadsops
go
drop procedure update_hrs
go
create procedure update_hrs as
/* observation start time */
declare @expstart datetime
/* data set name, to be used for error checking/handling */
declare @data_set_name datasetname
/* severity level variables, to be reused for each reference file type */
declare @orig_equiv_sev int
declare @orig_equiv_mod int
declare @equiv_sev int
declare @equiv_mod int
/* used to store @@rowcount global variable */
declare @num_cal_files int
/* observation modes, calibration files used in the pipeline, */
/* best, and best_loc files */
declare @hsr_ccg2 char(18)
declare @hsr_ccr1 char(18)
declare @hsr_ccr2 char(18)
declare @hsr_ccr3 char(18)
declare @hsr_ccr4 char(18)
declare @hsr_ccr5 char(18)
declare @hsr_ccr6 char(18)
declare @hsr_ccr7 char(18)
declare @hsr_ccr8 char(18)
declare @hsr_ccr9 char(18)
declare @hsr_ccra char(18)
declare @hsr_ccrb char(18)
declare @hsr_ccrc char(18)
declare @hsr_ccrd char(18)
declare @hsr_ccre char(18)
declare @hsr_grating char(9)
declare @hsr_aperture char(8)
declare @hsr_sporder int
declare @hsr_abshfile char(18)
declare @hsr_best_abs char(18)
declare @hsr_best_dio char(18)
declare @hsr_best_net char(18)
declare @hsr_best_phc char(18)
declare @hsr_best_qin char(18)
declare @hsr_best_saa char(18)
declare @hsr_best_vig char(18)
declare @hsr_detector int
declare @hsr_diohfile char(18)
declare @hsr_dqihfile char(18)
declare @hsr_nethfile char(18)
declare @hsr_phchfile char(18)
declare @hsr_saahfile char(18)
declare @hsr_vighfile char(18)
declare @hsr_best_ccg2 char(18)
declare @hsr_best_ccr1 char(18)
declare @hsr_best_ccr2 char(18)
declare @hsr_best_ccr3 char(18)
declare @hsr_best_ccr4 char(18)
declare @hsr_best_ccr5 char(18)
declare @hsr_best_ccr6 char(18)
declare @hsr_best_ccr7 char(18)
declare @hsr_best_ccr8 char(18)
declare @hsr_best_ccr9 char(18)
declare @hsr_best_ccra char(18)
declare @hsr_best_ccrb char(18)
declare @hsr_best_ccrc char(18)
declare @hsr_best_ccrd char(18)
declare @hsr_best_ccre char(18)
declare @hsr_best_loc_abs varchar(9)
declare @hsr_best_loc_dio varchar(9)
declare @hsr_best_loc_net varchar(9)
declare @hsr_best_loc_phc varchar(9)
declare @hsr_best_loc_qin varchar(9)
declare @hsr_best_loc_saa varchar(9)
declare @hsr_best_loc_vig varchar(9)
declare @hsr_best_loc_ccg2 varchar(9)
declare @hsr_best_loc_ccr1 varchar(9)
declare @hsr_best_loc_ccr2 varchar(9)
declare @hsr_best_loc_ccr3 varchar(9)
declare @hsr_best_loc_ccr4 varchar(9)
declare @hsr_best_loc_ccr5 varchar(9)
declare @hsr_best_loc_ccr6 varchar(9)
declare @hsr_best_loc_ccr7 varchar(9)
declare @hsr_best_loc_ccr8 varchar(9)
declare @hsr_best_loc_ccr9 varchar(9)
declare @hsr_best_loc_ccra varchar(9)
declare @hsr_best_loc_ccrb varchar(9)
declare @hsr_best_loc_ccrc varchar(9)
declare @hsr_best_loc_ccrd varchar(9)
declare @hsr_best_loc_ccre varchar(9)
declare update_hrs_cursor  cursor for
select hsr_expstart,hsr_data_set_name
,hsr_sporder
,hsr_aperture
,hsr_grating
,hsr_detector
,hsr_abshfile
,hsr_diohfile
,hsr_nethfile
,hsr_dqihfile
,hsr_ccg2
,hsr_ccr1
,hsr_ccr2
,hsr_ccr5
,hsr_ccr6
,hsr_ccr7
,hsr_ccr8
,hsr_ccr9
,hsr_ccra
,hsr_ccrb
,hsr_ccrc
,hsr_ccrd
,hsr_ccr3
,hsr_phchfile
,hsr_ccr4
,hsr_vighfile
,hsr_saahfile
,hsr_ccre
from hrs_ref_data
where hsr_best_abs is null
or hsr_best_dio is null
or hsr_best_net is null
or hsr_best_qin is null
or hsr_best_ccg2 is null
or hsr_best_ccr1 is null
or hsr_best_ccr2 is null
or hsr_best_ccr5 is null
or hsr_best_ccr6 is null
or hsr_best_ccr7 is null
or hsr_best_ccr8 is null
or hsr_best_ccr9 is null
or hsr_best_ccra is null
or hsr_best_ccrb is null
or hsr_best_ccrc is null
or hsr_best_ccrd is null
or hsr_best_ccr3 is null
or hsr_best_phc is null
or hsr_best_ccr4 is null
or hsr_best_vig is null
or hsr_best_saa is null
or hsr_best_ccre is null
 for update
open update_hrs_cursor 
fetch update_hrs_cursor into @expstart,@data_set_name
,@hsr_sporder
,@hsr_aperture
,@hsr_grating
,@hsr_detector
,@hsr_abshfile
,@hsr_diohfile
,@hsr_nethfile
,@hsr_dqihfile
,@hsr_ccg2
,@hsr_ccr1
,@hsr_ccr2
,@hsr_ccr5
,@hsr_ccr6
,@hsr_ccr7
,@hsr_ccr8
,@hsr_ccr9
,@hsr_ccra
,@hsr_ccrb
,@hsr_ccrc
,@hsr_ccrd
,@hsr_ccr3
,@hsr_phchfile
,@hsr_ccr4
,@hsr_vighfile
,@hsr_saahfile
,@hsr_ccre
/**************************************************************************/
/************************ Update hrs ***********************/
/**************************************************************************/
while (@@sqlstatus = 0)
begin
select
@hsr_best_abs = null
,@hsr_best_dio = null
,@hsr_best_net = null
,@hsr_best_phc = null
,@hsr_best_qin = null
,@hsr_best_saa = null
,@hsr_best_vig = null
,@hsr_best_ccg2 = null
,@hsr_best_ccr1 = null
,@hsr_best_ccr2 = null
,@hsr_best_ccr3 = null
,@hsr_best_ccr4 = null
,@hsr_best_ccr5 = null
,@hsr_best_ccr6 = null
,@hsr_best_ccr7 = null
,@hsr_best_ccr8 = null
,@hsr_best_ccr9 = null
,@hsr_best_ccra = null
,@hsr_best_ccrb = null
,@hsr_best_ccrc = null
,@hsr_best_ccrd = null
,@hsr_best_ccre = null
,@hsr_best_loc_abs = null
,@hsr_best_loc_dio = null
,@hsr_best_loc_net = null
,@hsr_best_loc_phc = null
,@hsr_best_loc_qin = null
,@hsr_best_loc_saa = null
,@hsr_best_loc_vig = null
,@hsr_best_loc_ccg2 = null
,@hsr_best_loc_ccr1 = null
,@hsr_best_loc_ccr2 = null
,@hsr_best_loc_ccr3 = null
,@hsr_best_loc_ccr4 = null
,@hsr_best_loc_ccr5 = null
,@hsr_best_loc_ccr6 = null
,@hsr_best_loc_ccr7 = null
,@hsr_best_loc_ccr8 = null
,@hsr_best_loc_ccr9 = null
,@hsr_best_loc_ccra = null
,@hsr_best_loc_ccrb = null
,@hsr_best_loc_ccrc = null
,@hsr_best_loc_ccrd = null
,@hsr_best_loc_ccre = null
/**************************************************************************/
/*********** instrument hrs ref file type CCG2 ****************/
/**************************************************************************/
select @hsr_best_ccg2 = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCG2'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.detector = @hsr_detector
        )
and hrs_file_1.reference_file_type = 'CCG2'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.detector = @hsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccg2 = 'N/A', @hsr_best_loc_ccg2 = 'N/A'
else
if (@hsr_ccg2 = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccg2 = 'N/A'
else
if (@hsr_best_ccg2 = @hsr_ccg2) /* recommended = was used */
select @hsr_best_loc_ccg2 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccg2 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccg2
and hrs_row_1.detector = @hsr_detector

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccg2 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccg2 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccg2 = 'MODERATE'
     else select @hsr_best_loc_ccg2 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type CCR1 ****************/
/**************************************************************************/
select @hsr_best_ccr1 = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCR1'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.detector = @hsr_detector
        )
and hrs_file_1.reference_file_type = 'CCR1'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.detector = @hsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccr1 = 'N/A', @hsr_best_loc_ccr1 = 'N/A'
else
if (@hsr_ccr1 = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccr1 = 'N/A'
else
if (@hsr_best_ccr1 = @hsr_ccr1) /* recommended = was used */
select @hsr_best_loc_ccr1 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccr1 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccr1
and hrs_row_1.detector = @hsr_detector

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccr1 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccr1 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccr1 = 'MODERATE'
     else select @hsr_best_loc_ccr1 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type CCR2 ****************/
/**************************************************************************/
select @hsr_best_ccr2 = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCR2'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.detector = @hsr_detector
        )
and hrs_file_1.reference_file_type = 'CCR2'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.detector = @hsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccr2 = 'N/A', @hsr_best_loc_ccr2 = 'N/A'
else
if (@hsr_ccr2 = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccr2 = 'N/A'
else
if (@hsr_best_ccr2 = @hsr_ccr2) /* recommended = was used */
select @hsr_best_loc_ccr2 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccr2 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccr2
and hrs_row_1.detector = @hsr_detector

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccr2 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccr2 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccr2 = 'MODERATE'
     else select @hsr_best_loc_ccr2 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type CCR3 ****************/
/**************************************************************************/
select @hsr_best_ccr3 = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCR3'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.detector = @hsr_detector
        )
and hrs_file_1.reference_file_type = 'CCR3'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.detector = @hsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccr3 = 'N/A', @hsr_best_loc_ccr3 = 'N/A'
else
if (@hsr_ccr3 = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccr3 = 'N/A'
else
if (@hsr_best_ccr3 = @hsr_ccr3) /* recommended = was used */
select @hsr_best_loc_ccr3 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccr3 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccr3
and hrs_row_1.detector = @hsr_detector

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccr3 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccr3 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccr3 = 'MODERATE'
     else select @hsr_best_loc_ccr3 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type CCR4 ****************/
/**************************************************************************/
select @hsr_best_ccr4 = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCR4'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.grating = @hsr_grating
        )
and hrs_file_1.reference_file_type = 'CCR4'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.grating = @hsr_grating
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccr4 = 'N/A', @hsr_best_loc_ccr4 = 'N/A'
else
if (@hsr_ccr4 = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccr4 = 'N/A'
else
if (@hsr_best_ccr4 = @hsr_ccr4) /* recommended = was used */
select @hsr_best_loc_ccr4 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccr4 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccr4
and hrs_row_1.grating = @hsr_grating

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccr4 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccr4 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccr4 = 'MODERATE'
     else select @hsr_best_loc_ccr4 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type CCR5 ****************/
/**************************************************************************/
select @hsr_best_ccr5 = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCR5'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.grating = @hsr_grating
        )
and hrs_file_1.reference_file_type = 'CCR5'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.grating = @hsr_grating
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccr5 = 'N/A', @hsr_best_loc_ccr5 = 'N/A'
else
if (@hsr_ccr5 = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccr5 = 'N/A'
else
if (@hsr_best_ccr5 = @hsr_ccr5) /* recommended = was used */
select @hsr_best_loc_ccr5 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccr5 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccr5
and hrs_row_1.grating = @hsr_grating

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccr5 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccr5 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccr5 = 'MODERATE'
     else select @hsr_best_loc_ccr5 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type CCR6 ****************/
/**************************************************************************/
select @hsr_best_ccr6 = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCR6'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.grating = @hsr_grating
        )
and hrs_file_1.reference_file_type = 'CCR6'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.grating = @hsr_grating
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccr6 = 'N/A', @hsr_best_loc_ccr6 = 'N/A'
else
if (@hsr_ccr6 = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccr6 = 'N/A'
else
if (@hsr_best_ccr6 = @hsr_ccr6) /* recommended = was used */
select @hsr_best_loc_ccr6 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccr6 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccr6
and hrs_row_1.grating = @hsr_grating

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccr6 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccr6 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccr6 = 'MODERATE'
     else select @hsr_best_loc_ccr6 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type CCR7 ****************/
/**************************************************************************/
select @hsr_best_ccr7 = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCR7'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.grating = @hsr_grating
        )
and hrs_file_1.reference_file_type = 'CCR7'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.grating = @hsr_grating
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccr7 = 'N/A', @hsr_best_loc_ccr7 = 'N/A'
else
if (@hsr_ccr7 = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccr7 = 'N/A'
else
if (@hsr_best_ccr7 = @hsr_ccr7) /* recommended = was used */
select @hsr_best_loc_ccr7 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccr7 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccr7
and hrs_row_1.grating = @hsr_grating

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccr7 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccr7 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccr7 = 'MODERATE'
     else select @hsr_best_loc_ccr7 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type CCR8 ****************/
/**************************************************************************/
select @hsr_best_ccr8 = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCR8'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.grating = @hsr_grating
             and hrs_row_2.sporder = @hsr_sporder
             and hrs_row_2.aperture = @hsr_aperture
        )
and hrs_file_1.reference_file_type = 'CCR8'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.grating = @hsr_grating
and hrs_row_1.sporder = @hsr_sporder
and hrs_row_1.aperture = @hsr_aperture
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccr8 = 'N/A', @hsr_best_loc_ccr8 = 'N/A'
else
if (@hsr_ccr8 = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccr8 = 'N/A'
else
if (@hsr_best_ccr8 = @hsr_ccr8) /* recommended = was used */
select @hsr_best_loc_ccr8 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccr8 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccr8
and hrs_row_1.grating = @hsr_grating
and hrs_row_1.sporder = @hsr_sporder
and hrs_row_1.aperture = @hsr_aperture

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccr8 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccr8 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccr8 = 'MODERATE'
     else select @hsr_best_loc_ccr8 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type CCR9 ****************/
/**************************************************************************/
select @hsr_best_ccr9 = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCR9'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.grating = @hsr_grating
             and hrs_row_2.sporder = @hsr_sporder
        )
and hrs_file_1.reference_file_type = 'CCR9'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.grating = @hsr_grating
and hrs_row_1.sporder = @hsr_sporder
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccr9 = 'N/A', @hsr_best_loc_ccr9 = 'N/A'
else
if (@hsr_ccr9 = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccr9 = 'N/A'
else
if (@hsr_best_ccr9 = @hsr_ccr9) /* recommended = was used */
select @hsr_best_loc_ccr9 = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccr9 = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccr9
and hrs_row_1.grating = @hsr_grating
and hrs_row_1.sporder = @hsr_sporder

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccr9 = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccr9 = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccr9 = 'MODERATE'
     else select @hsr_best_loc_ccr9 = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type CCRA ****************/
/**************************************************************************/
select @hsr_best_ccra = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCRA'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.grating = @hsr_grating
        )
and hrs_file_1.reference_file_type = 'CCRA'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.grating = @hsr_grating
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccra = 'N/A', @hsr_best_loc_ccra = 'N/A'
else
if (@hsr_ccra = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccra = 'N/A'
else
if (@hsr_best_ccra = @hsr_ccra) /* recommended = was used */
select @hsr_best_loc_ccra = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccra = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccra
and hrs_row_1.grating = @hsr_grating

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccra = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccra = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccra = 'MODERATE'
     else select @hsr_best_loc_ccra = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type CCRB ****************/
/**************************************************************************/
select @hsr_best_ccrb = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCRB'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.grating = @hsr_grating
             and hrs_row_2.sporder = @hsr_sporder
             and hrs_row_2.aperture = @hsr_aperture
        )
and hrs_file_1.reference_file_type = 'CCRB'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.grating = @hsr_grating
and hrs_row_1.sporder = @hsr_sporder
and hrs_row_1.aperture = @hsr_aperture
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccrb = 'N/A', @hsr_best_loc_ccrb = 'N/A'
else
if (@hsr_ccrb = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccrb = 'N/A'
else
if (@hsr_best_ccrb = @hsr_ccrb) /* recommended = was used */
select @hsr_best_loc_ccrb = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccrb = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccrb
and hrs_row_1.grating = @hsr_grating
and hrs_row_1.sporder = @hsr_sporder
and hrs_row_1.aperture = @hsr_aperture

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccrb = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccrb = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccrb = 'MODERATE'
     else select @hsr_best_loc_ccrb = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type CCRC ****************/
/**************************************************************************/
select @hsr_best_ccrc = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCRC'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.grating = @hsr_grating
        )
and hrs_file_1.reference_file_type = 'CCRC'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.grating = @hsr_grating
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccrc = 'N/A', @hsr_best_loc_ccrc = 'N/A'
else
if (@hsr_ccrc = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccrc = 'N/A'
else
if (@hsr_best_ccrc = @hsr_ccrc) /* recommended = was used */
select @hsr_best_loc_ccrc = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccrc = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccrc
and hrs_row_1.grating = @hsr_grating

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccrc = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccrc = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccrc = 'MODERATE'
     else select @hsr_best_loc_ccrc = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type CCRD ****************/
/**************************************************************************/
select @hsr_best_ccrd = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCRD'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.detector = @hsr_detector
        )
and hrs_file_1.reference_file_type = 'CCRD'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.detector = @hsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccrd = 'N/A', @hsr_best_loc_ccrd = 'N/A'
else
if (@hsr_ccrd = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccrd = 'N/A'
else
if (@hsr_best_ccrd = @hsr_ccrd) /* recommended = was used */
select @hsr_best_loc_ccrd = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccrd = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccrd
and hrs_row_1.detector = @hsr_detector

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccrd = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccrd = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccrd = 'MODERATE'
     else select @hsr_best_loc_ccrd = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type CCRE ****************/
/**************************************************************************/
select @hsr_best_ccre = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'CCRE'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
        )
and hrs_file_1.reference_file_type = 'CCRE'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_ccre = 'N/A', @hsr_best_loc_ccre = 'N/A'
else
if (@hsr_ccre = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_ccre = 'N/A'
else
if (@hsr_best_ccre = @hsr_ccre) /* recommended = was used */
select @hsr_best_loc_ccre = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_ccre = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_ccre

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_ccre = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_ccre = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_ccre = 'MODERATE'
     else select @hsr_best_loc_ccre = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type ABS ****************/
/**************************************************************************/
select @hsr_best_abs = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'ABS'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.grating = @hsr_grating
        )
and hrs_file_1.reference_file_type = 'ABS'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.grating = @hsr_grating
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_abs = 'N/A', @hsr_best_loc_abs = 'N/A'
else
if (@hsr_abshfile = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_abs = 'N/A'
else
if (@hsr_best_abs = @hsr_abshfile) /* recommended = was used */
select @hsr_best_loc_abs = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_abs = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_abshfile
and hrs_row_1.grating = @hsr_grating

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_abs = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_abs = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_abs = 'MODERATE'
     else select @hsr_best_loc_abs = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type DIO ****************/
/**************************************************************************/
select @hsr_best_dio = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'DIO'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.detector = @hsr_detector
        )
and hrs_file_1.reference_file_type = 'DIO'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.detector = @hsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_dio = 'N/A', @hsr_best_loc_dio = 'N/A'
else
if (@hsr_diohfile = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_dio = 'N/A'
else
if (@hsr_best_dio = @hsr_diohfile) /* recommended = was used */
select @hsr_best_loc_dio = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_dio = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_diohfile
and hrs_row_1.detector = @hsr_detector

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_dio = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_dio = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_dio = 'MODERATE'
     else select @hsr_best_loc_dio = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type NET ****************/
/**************************************************************************/
select @hsr_best_net = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'NET'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.grating = @hsr_grating
        )
and hrs_file_1.reference_file_type = 'NET'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.grating = @hsr_grating
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_net = 'N/A', @hsr_best_loc_net = 'N/A'
else
if (@hsr_nethfile = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_net = 'N/A'
else
if (@hsr_best_net = @hsr_nethfile) /* recommended = was used */
select @hsr_best_loc_net = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_net = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_nethfile
and hrs_row_1.grating = @hsr_grating

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_net = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_net = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_net = 'MODERATE'
     else select @hsr_best_loc_net = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type PHC ****************/
/**************************************************************************/
select @hsr_best_phc = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'PHC'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.grating = @hsr_grating
        )
and hrs_file_1.reference_file_type = 'PHC'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.grating = @hsr_grating
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_phc = 'N/A', @hsr_best_loc_phc = 'N/A'
else
if (@hsr_phchfile = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_phc = 'N/A'
else
if (@hsr_best_phc = @hsr_phchfile) /* recommended = was used */
select @hsr_best_loc_phc = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_phc = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_phchfile
and hrs_row_1.grating = @hsr_grating

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_phc = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_phc = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_phc = 'MODERATE'
     else select @hsr_best_loc_phc = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type QIN ****************/
/**************************************************************************/
select @hsr_best_qin = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'QIN'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.detector = @hsr_detector
        )
and hrs_file_1.reference_file_type = 'QIN'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.detector = @hsr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_qin = 'N/A', @hsr_best_loc_qin = 'N/A'
else
if (@hsr_dqihfile = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_qin = 'N/A'
else
if (@hsr_best_qin = @hsr_dqihfile) /* recommended = was used */
select @hsr_best_loc_qin = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_qin = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_dqihfile
and hrs_row_1.detector = @hsr_detector

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_qin = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_qin = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_qin = 'MODERATE'
     else select @hsr_best_loc_qin = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type SAA ****************/
/**************************************************************************/
select @hsr_best_saa = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'SAA'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
        )
and hrs_file_1.reference_file_type = 'SAA'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_saa = 'N/A', @hsr_best_loc_saa = 'N/A'
else
if (@hsr_saahfile = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_saa = 'N/A'
else
if (@hsr_best_saa = @hsr_saahfile) /* recommended = was used */
select @hsr_best_loc_saa = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_saa = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_saahfile

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_saa = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_saa = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_saa = 'MODERATE'
     else select @hsr_best_loc_saa = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument hrs ref file type VIG ****************/
/**************************************************************************/
select @hsr_best_vig = hrs_file_1.file_name,
@equiv_sev = hrs_row_1.equivalence_class_severe,
@equiv_mod = hrs_row_1.equivalence_class_moderate
from hrs_file hrs_file_1, hrs_row hrs_row_1
where hrs_file_1.useafter_date = 
	(select max(hrs_file_2.useafter_date)
	from hrs_file hrs_file_2, hrs_row hrs_row_2
             where hrs_file_2.reference_file_type = 'VIG'
             and hrs_file_2.useafter_date <= @expstart
             and hrs_file_2.reject_flag = 'N'
             and hrs_file_2.opus_flag = 'Y'
             and hrs_file_2.archive_date is not null
             and hrs_file_2.file_name =hrs_row_2.file_name
             and hrs_file_2.expansion_number = hrs_row_2.expansion_number
             and hrs_row_2.grating = @hsr_grating
        )
and hrs_file_1.reference_file_type = 'VIG'
and hrs_file_1.reject_flag = 'N'
and hrs_file_1.opus_flag = 'Y'
and hrs_file_1.archive_date is not null
and hrs_file_1.file_name =hrs_row_1.file_name
and hrs_file_1.expansion_number = hrs_row_1.expansion_number
and hrs_row_1.grating = @hsr_grating
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @hsr_best_vig = 'N/A', @hsr_best_loc_vig = 'N/A'
else
if (@hsr_vighfile = NULL) /* no file was used in the pipeline */
select @hsr_best_loc_vig = 'N/A'
else
if (@hsr_best_vig = @hsr_vighfile) /* recommended = was used */
select @hsr_best_loc_vig = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @hsr_best_loc_vig = 'UNKNOWN'
else
begin

select @orig_equiv_sev = hrs_row_1.equivalence_class_severe,
@orig_equiv_mod =  hrs_row_1.equivalence_class_moderate
from hrs_row hrs_row_1
where hrs_row_1.file_name = @hsr_vighfile
and hrs_row_1.grating = @hsr_grating

if (@orig_equiv_sev = -1)
	select @hsr_best_loc_vig = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @hsr_best_loc_vig = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @hsr_best_loc_vig = 'MODERATE'
     else select @hsr_best_loc_vig = 'TRIVIAL'
end

update hrs_ref_data
set
hsr_best_ccg2 = @hsr_best_ccg2
,hsr_best_loc_ccg2 = @hsr_best_loc_ccg2
,hsr_best_ccr1 = @hsr_best_ccr1
,hsr_best_loc_ccr1 = @hsr_best_loc_ccr1
,hsr_best_ccr2 = @hsr_best_ccr2
,hsr_best_loc_ccr2 = @hsr_best_loc_ccr2
,hsr_best_ccr3 = @hsr_best_ccr3
,hsr_best_loc_ccr3 = @hsr_best_loc_ccr3
,hsr_best_ccr4 = @hsr_best_ccr4
,hsr_best_loc_ccr4 = @hsr_best_loc_ccr4
,hsr_best_ccr5 = @hsr_best_ccr5
,hsr_best_loc_ccr5 = @hsr_best_loc_ccr5
,hsr_best_ccr6 = @hsr_best_ccr6
,hsr_best_loc_ccr6 = @hsr_best_loc_ccr6
,hsr_best_ccr7 = @hsr_best_ccr7
,hsr_best_loc_ccr7 = @hsr_best_loc_ccr7
,hsr_best_ccr8 = @hsr_best_ccr8
,hsr_best_loc_ccr8 = @hsr_best_loc_ccr8
,hsr_best_ccr9 = @hsr_best_ccr9
,hsr_best_loc_ccr9 = @hsr_best_loc_ccr9
,hsr_best_ccra = @hsr_best_ccra
,hsr_best_loc_ccra = @hsr_best_loc_ccra
,hsr_best_ccrb = @hsr_best_ccrb
,hsr_best_loc_ccrb = @hsr_best_loc_ccrb
,hsr_best_ccrc = @hsr_best_ccrc
,hsr_best_loc_ccrc = @hsr_best_loc_ccrc
,hsr_best_ccrd = @hsr_best_ccrd
,hsr_best_loc_ccrd = @hsr_best_loc_ccrd
,hsr_best_ccre = @hsr_best_ccre
,hsr_best_loc_ccre = @hsr_best_loc_ccre
,hsr_best_abs = @hsr_best_abs
,hsr_best_loc_abs = @hsr_best_loc_abs
,hsr_best_dio = @hsr_best_dio
,hsr_best_loc_dio = @hsr_best_loc_dio
,hsr_best_net = @hsr_best_net
,hsr_best_loc_net = @hsr_best_loc_net
,hsr_best_phc = @hsr_best_phc
,hsr_best_loc_phc = @hsr_best_loc_phc
,hsr_best_qin = @hsr_best_qin
,hsr_best_loc_qin = @hsr_best_loc_qin
,hsr_best_saa = @hsr_best_saa
,hsr_best_loc_saa = @hsr_best_loc_saa
,hsr_best_vig = @hsr_best_vig
,hsr_best_loc_vig = @hsr_best_loc_vig
where current of update_hrs_cursor
fetch update_hrs_cursor into @expstart,@data_set_name
,@hsr_sporder
,@hsr_aperture
,@hsr_grating
,@hsr_detector
,@hsr_abshfile
,@hsr_diohfile
,@hsr_nethfile
,@hsr_dqihfile
,@hsr_ccg2
,@hsr_ccr1
,@hsr_ccr2
,@hsr_ccr5
,@hsr_ccr6
,@hsr_ccr7
,@hsr_ccr8
,@hsr_ccr9
,@hsr_ccra
,@hsr_ccrb
,@hsr_ccrc
,@hsr_ccrd
,@hsr_ccr3
,@hsr_phchfile
,@hsr_ccr4
,@hsr_vighfile
,@hsr_saahfile
,@hsr_ccre
end
close update_hrs_cursor 
deallocate cursor update_hrs_cursor 
return
go
