use dadsops
go
drop procedure update_stis
go
create procedure update_stis as
/* observation start time */
declare @expstart datetime
/* data set name, to be used for error checking/handling */
declare @data_set_name datasetname
/* severity level variables, to be reused for each reference file type */
declare @orig_equiv_sev int
declare @orig_equiv_mod int
declare @equiv_sev int
declare @equiv_mod int
/* used to store @@rowcount global variable */
declare @num_cal_files int
/* observation modes, calibration files used in the pipeline, */
/* best, and best_loc files */
declare @ssr_cenwave int
declare @ssr_ccdoffst int
declare @ssr_ccdamp char(3)
declare @ssr_ccdtab char(18)
declare @ssr_idctab char(18)
declare @ssr_sdctab char(18)
declare @ssr_apertab char(18)
declare @ssr_atodtab char(18)
declare @ssr_bpixtab char(18)
declare @ssr_ccdgain int
declare @ssr_crsplit int
declare @ssr_disptab char(18)
declare @ssr_lamptab char(18)
declare @ssr_mlintab char(18)
declare @ssr_mofftab char(18)
declare @ssr_phottab char(18)
declare @ssr_apdestab char(18)
declare @ssr_biasfile char(18)
declare @ssr_binaxis1 int
declare @ssr_binaxis2 int
declare @ssr_crrejtab char(18)
declare @ssr_darkfile char(18)
declare @ssr_dfltfile char(18)
declare @ssr_inangtab char(18)
declare @ssr_lfltfile char(18)
declare @ssr_pfltfile char(18)
declare @ssr_sdstfile char(18)
declare @ssr_shadfile char(18)
declare @ssr_sptrctab char(18)
declare @ssr_xtractab char(18)
declare @ssr_pctab char(18)
declare @ssr_best_bias char(18)
declare @ssr_best_dark char(18)
declare @ssr_best_dflt char(18)
declare @ssr_best_lflt char(18)
declare @ssr_best_pflt char(18)
declare @ssr_best_sdst char(18)
declare @ssr_best_shad char(18)
declare @ssr_obstype varchar(14)
declare @ssr_opt_elem varchar(8)
declare @ssr_aperture varchar(16)
declare @ssr_best_ccdtab char(18)
declare @ssr_best_idctab char(18)
declare @ssr_best_sdctab char(18)
declare @ssr_detector varchar(10)
declare @ssr_best_apertab char(18)
declare @ssr_best_atodtab char(18)
declare @ssr_best_bpixtab char(18)
declare @ssr_best_disptab char(18)
declare @ssr_best_lamptab char(18)
declare @ssr_best_mlintab char(18)
declare @ssr_best_mofftab char(18)
declare @ssr_best_phottab char(18)
declare @ssr_best_apdestab char(18)
declare @ssr_best_crrejtab char(18)
declare @ssr_best_inangtab char(18)
declare @ssr_best_sptrctab char(18)
declare @ssr_best_xtractab char(18)
declare @ssr_best_pctab char(18)
declare @ssr_best_loc_pctab varchar(9)
declare @ssr_best_loc_bias varchar(9)
declare @ssr_best_loc_dark varchar(9)
declare @ssr_best_loc_dflt varchar(9)
declare @ssr_best_loc_lflt varchar(9)
declare @ssr_best_loc_pflt varchar(9)
declare @ssr_best_loc_sdst varchar(9)
declare @ssr_best_loc_shad varchar(9)
declare @ssr_best_loc_ccdtab varchar(9)
declare @ssr_best_loc_idctab varchar(9)
declare @ssr_best_loc_sdctab varchar(9)
declare @ssr_best_loc_apertab varchar(9)
declare @ssr_best_loc_atodtab varchar(9)
declare @ssr_best_loc_bpixtab varchar(9)
declare @ssr_best_loc_disptab varchar(9)
declare @ssr_best_loc_lamptab varchar(9)
declare @ssr_best_loc_mlintab varchar(9)
declare @ssr_best_loc_mofftab varchar(9)
declare @ssr_best_loc_phottab varchar(9)
declare @ssr_best_loc_apdestab varchar(9)
declare @ssr_best_loc_crrejtab varchar(9)
declare @ssr_best_loc_inangtab varchar(9)
declare @ssr_best_loc_sptrctab varchar(9)
declare @ssr_best_loc_xtractab varchar(9)
declare update_stis_cursor  cursor for
select ssr_texpstrt,ssr_data_set_name
,ssr_aperture
,ssr_binaxis1
,ssr_binaxis2
,ssr_ccdamp
,ssr_ccdgain
,ssr_ccdoffst
,ssr_cenwave
,ssr_crsplit
,ssr_detector
,ssr_obstype
,ssr_opt_elem
,ssr_sptrctab
,ssr_xtractab
,ssr_atodtab
,ssr_apdestab
,ssr_apertab
,ssr_biasfile
,ssr_bpixtab
,ssr_ccdtab
,ssr_crrejtab
,ssr_dfltfile
,ssr_darkfile
,ssr_disptab
,ssr_inangtab
,ssr_idctab
,ssr_lfltfile
,ssr_mlintab
,ssr_lamptab
,ssr_mofftab
,ssr_pfltfile
,ssr_phottab
,ssr_sdctab
,ssr_shadfile
,ssr_sdstfile
,ssr_pctab
from stis_ref_data
where ssr_best_sptrctab is null
or ssr_best_xtractab is null
or ssr_best_atodtab is null
or ssr_best_apdestab is null
or ssr_best_apertab is null
or ssr_best_bias is null
or ssr_best_bpixtab is null
or ssr_best_ccdtab is null
or ssr_best_crrejtab is null
or ssr_best_dflt is null
or ssr_best_dark is null
or ssr_best_disptab is null
or ssr_best_inangtab is null
or ssr_best_idctab is null
or ssr_best_lflt is null
or ssr_best_mlintab is null
or ssr_best_lamptab is null
or ssr_best_mofftab is null
or ssr_best_pflt is null
or ssr_best_phottab is null
or ssr_best_sdctab is null
or ssr_best_shad is null
or ssr_best_sdst is null
or ssr_best_pctab is null
 for update
open update_stis_cursor 
fetch update_stis_cursor into @expstart,@data_set_name
,@ssr_aperture
,@ssr_binaxis1
,@ssr_binaxis2
,@ssr_ccdamp
,@ssr_ccdgain
,@ssr_ccdoffst
,@ssr_cenwave
,@ssr_crsplit
,@ssr_detector
,@ssr_obstype
,@ssr_opt_elem
,@ssr_sptrctab
,@ssr_xtractab
,@ssr_atodtab
,@ssr_apdestab
,@ssr_apertab
,@ssr_biasfile
,@ssr_bpixtab
,@ssr_ccdtab
,@ssr_crrejtab
,@ssr_dfltfile
,@ssr_darkfile
,@ssr_disptab
,@ssr_inangtab
,@ssr_idctab
,@ssr_lfltfile
,@ssr_mlintab
,@ssr_lamptab
,@ssr_mofftab
,@ssr_pfltfile
,@ssr_phottab
,@ssr_sdctab
,@ssr_shadfile
,@ssr_sdstfile
,@ssr_pctab
/**************************************************************************/
/************************ Update stis ***********************/
/**************************************************************************/
while (@@sqlstatus = 0)
begin
select
@ssr_best_bias = null
,@ssr_best_dark = null
,@ssr_best_dflt = null
,@ssr_best_lflt = null
,@ssr_best_pflt = null
,@ssr_best_sdst = null
,@ssr_best_shad = null
,@ssr_best_ccdtab = null
,@ssr_best_idctab = null
,@ssr_best_sdctab = null
,@ssr_best_apertab = null
,@ssr_best_atodtab = null
,@ssr_best_bpixtab = null
,@ssr_best_disptab = null
,@ssr_best_lamptab = null
,@ssr_best_mlintab = null
,@ssr_best_mofftab = null
,@ssr_best_phottab = null
,@ssr_best_apdestab = null
,@ssr_best_crrejtab = null
,@ssr_best_inangtab = null
,@ssr_best_loc_bias = null
,@ssr_best_loc_dark = null
,@ssr_best_loc_dflt = null
,@ssr_best_loc_lflt = null
,@ssr_best_loc_pflt = null
,@ssr_best_loc_sdst = null
,@ssr_best_loc_shad = null
,@ssr_best_sptrctab = null
,@ssr_best_xtractab = null
,@ssr_best_pctab = null
,@ssr_best_loc_pctab = null
,@ssr_best_loc_ccdtab = null
,@ssr_best_loc_idctab = null
,@ssr_best_loc_sdctab = null
,@ssr_best_loc_apertab = null
,@ssr_best_loc_atodtab = null
,@ssr_best_loc_bpixtab = null
,@ssr_best_loc_disptab = null
,@ssr_best_loc_lamptab = null
,@ssr_best_loc_mlintab = null
,@ssr_best_loc_mofftab = null
,@ssr_best_loc_phottab = null
,@ssr_best_loc_apdestab = null
,@ssr_best_loc_crrejtab = null
,@ssr_best_loc_inangtab = null
,@ssr_best_loc_sptrctab = null
,@ssr_best_loc_xtractab = null
/**************************************************************************/
/*********** instrument stis ref file type BIA ****************/
/**************************************************************************/
select @ssr_best_bias = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'BIA'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.ccdamp = @ssr_ccdamp
             and stis_row_2.ccdgain = @ssr_ccdgain
             and stis_row_2.binaxis1 = @ssr_binaxis1
             and stis_row_2.binaxis2 = @ssr_binaxis2
             and stis_row_2.ccdoffst = @ssr_ccdoffst
             and stis_row_2.detector = @ssr_detector
        )
and stis_file_1.reference_file_type = 'BIA'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.ccdamp = @ssr_ccdamp
and stis_row_1.ccdgain = @ssr_ccdgain
and stis_row_1.binaxis1 = @ssr_binaxis1
and stis_row_1.binaxis2 = @ssr_binaxis2
and stis_row_1.ccdoffst = @ssr_ccdoffst
and stis_row_1.detector = @ssr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_bias = 'N/A', @ssr_best_loc_bias = 'N/A'
else
if (@ssr_biasfile = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_bias = 'N/A'
else
if (@ssr_best_bias = @ssr_biasfile) /* recommended = was used */
select @ssr_best_loc_bias = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_bias = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_biasfile
and stis_row_1.ccdamp = @ssr_ccdamp
and stis_row_1.ccdgain = @ssr_ccdgain
and stis_row_1.binaxis1 = @ssr_binaxis1
and stis_row_1.binaxis2 = @ssr_binaxis2
and stis_row_1.ccdoffst = @ssr_ccdoffst
and stis_row_1.detector = @ssr_detector

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_bias = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_bias = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_bias = 'MODERATE'
     else select @ssr_best_loc_bias = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type DFL ****************/
/**************************************************************************/
select @ssr_best_dflt = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'DFL'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.detector = @ssr_detector
        )
and stis_file_1.reference_file_type = 'DFL'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.detector = @ssr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_dflt = 'N/A', @ssr_best_loc_dflt = 'N/A'
else
if (@ssr_dfltfile = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_dflt = 'N/A'
else
if (@ssr_best_dflt = @ssr_dfltfile) /* recommended = was used */
select @ssr_best_loc_dflt = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_dflt = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_dfltfile
and stis_row_1.detector = @ssr_detector

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_dflt = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_dflt = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_dflt = 'MODERATE'
     else select @ssr_best_loc_dflt = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type DRK ****************/
/**************************************************************************/
/* begin mod - entire section */

if (@ssr_detector = 'CCD')   /* use ccdamp and ccdgain to select */
select @ssr_best_dark = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'DRK'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.ccdamp = @ssr_ccdamp
             and stis_row_2.ccdgain = @ssr_ccdgain
             and stis_row_2.detector = @ssr_detector
        )
and stis_file_1.reference_file_type = 'DRK'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.ccdamp = @ssr_ccdamp
and stis_row_1.ccdgain = @ssr_ccdgain
and stis_row_1.detector = @ssr_detector

else  /* not ccd mode - only use detector to select */
select @ssr_best_dark = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'DRK'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.detector = @ssr_detector
        )
and stis_file_1.reference_file_type = 'DRK'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.detector = @ssr_detector


select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_dark = 'N/A', @ssr_best_loc_dark = 'N/A'
else
if (@ssr_darkfile = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_dark = 'N/A'
else
if (@ssr_best_dark = @ssr_darkfile) /* recommended = was used */
select @ssr_best_loc_dark = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_dark = 'UNKNOWN'
else
begin

if (@ssr_detector = 'CCD')
select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_darkfile
and stis_row_1.ccdamp = @ssr_ccdamp
and stis_row_1.ccdgain = @ssr_ccdgain
and stis_row_1.detector = @ssr_detector
else  /* ccdamp and ccdgain not used */
select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_darkfile
and stis_row_1.detector = @ssr_detector

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_dark = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_dark = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_dark = 'MODERATE'
     else select @ssr_best_loc_dark = 'TRIVIAL'
end
/* end mod */
/**************************************************************************/
/*********** instrument stis ref file type LFL ****************/
/**************************************************************************/
/* begin mod - entire section */

if (@ssr_obstype = 'IMAGING')    /*cenwave doesn't apply */
select @ssr_best_lflt = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'LFL'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.obstype = @ssr_obstype
             and stis_row_2.aperture = @ssr_aperture 
             and stis_row_2.detector = @ssr_detector
             and stis_row_2.opt_elem = @ssr_opt_elem
        )
and stis_file_1.reference_file_type = 'LFL'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.obstype = @ssr_obstype
and stis_row_1.aperture = @ssr_aperture 
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem

else /* @ssr_obstype = 'SPECTROSCOPIC' - aperture doesn't apply */

select @ssr_best_lflt = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'LFL'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.cenwave = @ssr_cenwave 
             and stis_row_2.obstype = @ssr_obstype
             and stis_row_2.detector = @ssr_detector
             and stis_row_2.opt_elem = @ssr_opt_elem
        )
and stis_file_1.reference_file_type = 'LFL'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.cenwave = @ssr_cenwave 
and stis_row_1.obstype = @ssr_obstype
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_lflt = 'N/A', @ssr_best_loc_lflt = 'N/A'
else
if (@ssr_lfltfile = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_lflt = 'N/A'
else
if (@ssr_best_lflt = @ssr_lfltfile) /* recommended = was used */
select @ssr_best_loc_lflt = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_lflt = 'UNKNOWN'
else
begin

 if (@ssr_obstype = 'IMAGING')
  select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
  @orig_equiv_mod =  stis_row_1.equivalence_class_moderate
  from stis_row stis_row_1
  where stis_row_1.file_name = @ssr_lfltfile
  and stis_row_1.obstype = @ssr_obstype
  and stis_row_1.aperture = @ssr_aperture 
  and stis_row_1.detector = @ssr_detector
  and stis_row_1.opt_elem = @ssr_opt_elem
 else
  select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
  @orig_equiv_mod =  stis_row_1.equivalence_class_moderate
  from stis_row stis_row_1
  where stis_row_1.file_name = @ssr_lfltfile
  and stis_row_1.cenwave = @ssr_cenwave 
  and stis_row_1.obstype = @ssr_obstype
  and stis_row_1.detector = @ssr_detector
  and stis_row_1.opt_elem = @ssr_opt_elem

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_lflt = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_lflt = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_lflt = 'MODERATE'
     else select @ssr_best_loc_lflt = 'TRIVIAL'
end
/* end mod */

/**************************************************************************/
/*********** instrument stis ref file type PFL ****************/
/**************************************************************************/
/* begin mod - entire section  */

if (@ssr_obstype = 'IMAGING')    /*cenwave doesn't apply */
select @ssr_best_pflt = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'PFL'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.obstype = @ssr_obstype
             and stis_row_2.aperture = @ssr_aperture 
             and stis_row_2.detector = @ssr_detector
             and stis_row_2.opt_elem = @ssr_opt_elem
        )
and stis_file_1.reference_file_type = 'PFL'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.obstype = @ssr_obstype
and stis_row_1.aperture = @ssr_aperture 
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem

else   /* ssr_obstype = 'SPECTROSCOPIC' - aperture doesn't apply */

select @ssr_best_pflt = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'PFL'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.obstype = @ssr_obstype
             and stis_row_2.cenwave = @ssr_cenwave 
             and stis_row_2.detector = @ssr_detector
             and stis_row_2.opt_elem = @ssr_opt_elem
        )
and stis_file_1.reference_file_type = 'PFL'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.obstype = @ssr_obstype
and stis_row_1.cenwave = @ssr_cenwave 
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_pflt = 'N/A', @ssr_best_loc_pflt = 'N/A'
else
if (@ssr_pfltfile = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_pflt = 'N/A'
else
if (@ssr_best_pflt = @ssr_pfltfile) /* recommended = was used */
select @ssr_best_loc_pflt = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_pflt = 'UNKNOWN'
else
begin


 if (@ssr_obstype = 'IMAGING')    /*cenwave doesn't apply */
  select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
  @orig_equiv_mod =  stis_row_1.equivalence_class_moderate
  from stis_row stis_row_1
  where stis_row_1.file_name = @ssr_pfltfile
  and stis_row_1.obstype = @ssr_obstype
  and stis_row_1.aperture = @ssr_aperture 
  and stis_row_1.detector = @ssr_detector
  and stis_row_1.opt_elem = @ssr_opt_elem
 else   /* ssr_obstype = 'SPECTROSCOPIC' - aperture doesn't apply */
  select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
  @orig_equiv_mod =  stis_row_1.equivalence_class_moderate
  from stis_row stis_row_1
  where stis_row_1.file_name = @ssr_pfltfile
  and stis_row_1.cenwave = @ssr_cenwave 
  and stis_row_1.obstype = @ssr_obstype
  and stis_row_1.detector = @ssr_detector
  and stis_row_1.opt_elem = @ssr_opt_elem

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_pflt = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_pflt = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_pflt = 'MODERATE'
     else select @ssr_best_loc_pflt = 'TRIVIAL'
end
/* end mod */
/**************************************************************************/
/*********** instrument stis ref file type SSC ****************/
/**************************************************************************/
select @ssr_best_shad = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'SSC'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.detector = @ssr_detector
        )
and stis_file_1.reference_file_type = 'SSC'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.detector = @ssr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_shad = 'N/A', @ssr_best_loc_shad = 'N/A'
else
if (@ssr_shadfile = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_shad = 'N/A'
else
if (@ssr_best_shad = @ssr_shadfile) /* recommended = was used */
select @ssr_best_loc_shad = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_shad = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_shadfile
and stis_row_1.detector = @ssr_detector

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_shad = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_shad = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_shad = 'MODERATE'
     else select @ssr_best_loc_shad = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type SSD ****************/
/**************************************************************************/
select @ssr_best_sdst = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'SSD'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.detector = @ssr_detector
        )
and stis_file_1.reference_file_type = 'SSD'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.detector = @ssr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_sdst = 'N/A', @ssr_best_loc_sdst = 'N/A'
else
if (@ssr_sdstfile = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_sdst = 'N/A'
else
if (@ssr_best_sdst = @ssr_sdstfile) /* recommended = was used */
select @ssr_best_loc_sdst = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_sdst = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_sdstfile
and stis_row_1.detector = @ssr_detector

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_sdst = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_sdst = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_sdst = 'MODERATE'
     else select @ssr_best_loc_sdst = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type CCD ****************/
/**************************************************************************/
select @ssr_best_ccdtab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'CCD'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.ccdamp = @ssr_ccdamp
/* modify - look for wildcards */
             and (stis_row_2.ccdgain = @ssr_ccdgain or
		  stis_row_2.ccdgain = -1)
             and (stis_row_2.binaxis1 = @ssr_binaxis1 or
		  stis_row_2.binaxis1 = -1)
             and (stis_row_2.binaxis2 = @ssr_binaxis2 or
		  stis_row_2.binaxis2 = -1)
             and (stis_row_2.ccdoffst = @ssr_ccdoffst or
		  stis_row_2.ccdoffst = -1)
             and stis_row_2.detector = @ssr_detector
        )
and stis_file_1.reference_file_type = 'CCD'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.ccdamp = @ssr_ccdamp
and (stis_row_1.ccdgain = @ssr_ccdgain or
     stis_row_1.ccdgain = -1)
and (stis_row_1.binaxis1 = @ssr_binaxis1 or
     stis_row_1.binaxis1 = -1)
and (stis_row_1.binaxis2 = @ssr_binaxis2 or
     stis_row_1.binaxis2 = -1)
and (stis_row_1.ccdoffst = @ssr_ccdoffst or
     stis_row_1.ccdoffst = -1)
and stis_row_1.detector = @ssr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_ccdtab = 'N/A', @ssr_best_loc_ccdtab = 'N/A'
else
if (@ssr_ccdtab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_ccdtab = 'N/A'
else
if (@ssr_best_ccdtab = @ssr_ccdtab) /* recommended = was used */
select @ssr_best_loc_ccdtab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_ccdtab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_ccdtab
and stis_row_1.ccdamp = @ssr_ccdamp
/* modify - check for wildcards */
and (stis_row_1.ccdgain = @ssr_ccdgain or
     stis_row_1.ccdgain = -1)
and (stis_row_1.binaxis1 = @ssr_binaxis1 or
     stis_row_1.binaxis1 = -1)
and (stis_row_1.binaxis2 = @ssr_binaxis2 or
     stis_row_1.binaxis2 = -1)
and (stis_row_1.ccdoffst = @ssr_ccdoffst or
     stis_row_1.ccdoffst = -1)
and stis_row_1.detector = @ssr_detector

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_ccdtab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_ccdtab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_ccdtab = 'MODERATE'
     else select @ssr_best_loc_ccdtab = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type IDC ****************/
/**************************************************************************/
select @ssr_best_idctab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'IDC'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.aperture = @ssr_aperture
             and stis_row_2.detector = @ssr_detector
/* modify - check for wildcard */
             and (stis_row_2.opt_elem = @ssr_opt_elem or
		  stis_row_2.opt_elem = 'ANY')
        )
and stis_file_1.reference_file_type = 'IDC'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.aperture = @ssr_aperture
and stis_row_1.detector = @ssr_detector
/* modify - check for wildcard */
and (stis_row_1.opt_elem = @ssr_opt_elem or
     stis_row_1.opt_elem = 'ANY')
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_idctab = 'N/A', @ssr_best_loc_idctab = 'N/A'
else
if (@ssr_idctab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_idctab = 'N/A'
else
if (@ssr_best_idctab = @ssr_idctab) /* recommended = was used */
select @ssr_best_loc_idctab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_idctab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_idctab
and stis_row_1.aperture = @ssr_aperture
and stis_row_1.detector = @ssr_detector
/* modify - check for wildcard */
and (stis_row_1.opt_elem = @ssr_opt_elem or
     stis_row_1.opt_elem = 'ANY')

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_idctab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_idctab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_idctab = 'MODERATE'
     else select @ssr_best_loc_idctab = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type SDC ****************/
/**************************************************************************/
select @ssr_best_sdctab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'SDC'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
/* mod - check for wildcard */
             and (stis_row_2.cenwave = @ssr_cenwave or
		  stis_row_2.cenwave = -1)
             and stis_row_2.detector = @ssr_detector
             and stis_row_2.opt_elem = @ssr_opt_elem
        )
and stis_file_1.reference_file_type = 'SDC'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
/* mod - check for wildcard */
and (stis_row_1.cenwave = @ssr_cenwave or
     stis_row_1.cenwave = -1)
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_sdctab = 'N/A', @ssr_best_loc_sdctab = 'N/A'
else
if (@ssr_sdctab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_sdctab = 'N/A'
else
if (@ssr_best_sdctab = @ssr_sdctab) /* recommended = was used */
select @ssr_best_loc_sdctab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_sdctab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_sdctab
/* mod - check for wildcard */
and (stis_row_1.cenwave = @ssr_cenwave or
     stis_row_1.cenwave = -1)
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_sdctab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_sdctab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_sdctab = 'MODERATE'
     else select @ssr_best_loc_sdctab = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type A2D ****************/
/**************************************************************************/
select @ssr_best_atodtab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'A2D'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
/* modify - check for wildcards */
             and (stis_row_2.ccdamp = @ssr_ccdamp or
		  stis_row_2.ccdamp = 'ANY')
             and (stis_row_2.ccdgain = @ssr_ccdgain or
		  stis_row_2.ccdgain = -1)
             and stis_row_2.detector = @ssr_detector
        )
and stis_file_1.reference_file_type = 'A2D'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
/* modify - check for wildcards */
and (stis_row_1.ccdamp = @ssr_ccdamp or
     stis_row_1.ccdamp = 'ANY')
and (stis_row_1.ccdgain = @ssr_ccdgain or
     stis_row_1.ccdgain = -1)
and stis_row_1.detector = @ssr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_atodtab = 'N/A', @ssr_best_loc_atodtab = 'N/A'
else
if (@ssr_atodtab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_atodtab = 'N/A'
else
if (@ssr_best_atodtab = @ssr_atodtab) /* recommended = was used */
select @ssr_best_loc_atodtab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_atodtab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_atodtab
/* modify check for wildcards */
and (stis_row_1.ccdamp = @ssr_ccdamp or
     stis_row_1.ccdamp = 'ANY')
and (stis_row_1.ccdgain = @ssr_ccdgain or
     stis_row_1.ccdgain = -1)
and stis_row_1.detector = @ssr_detector

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_atodtab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_atodtab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_atodtab = 'MODERATE'
     else select @ssr_best_loc_atodtab = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type APT ****************/
/**************************************************************************/
select @ssr_best_apertab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'APT'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.aperture = @ssr_aperture
        )
and stis_file_1.reference_file_type = 'APT'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.aperture = @ssr_aperture
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_apertab = 'N/A', @ssr_best_loc_apertab = 'N/A'
else
if (@ssr_apertab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_apertab = 'N/A'
else
if (@ssr_best_apertab = @ssr_apertab) /* recommended = was used */
select @ssr_best_loc_apertab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_apertab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_apertab
and stis_row_1.aperture = @ssr_aperture

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_apertab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_apertab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_apertab = 'MODERATE'
     else select @ssr_best_loc_apertab = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type BPX ****************/
/**************************************************************************/
select @ssr_best_bpixtab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'BPX'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.detector = @ssr_detector
        )
and stis_file_1.reference_file_type = 'BPX'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.detector = @ssr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_bpixtab = 'N/A', @ssr_best_loc_bpixtab = 'N/A'
else
if (@ssr_bpixtab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_bpixtab = 'N/A'
else
if (@ssr_best_bpixtab = @ssr_bpixtab) /* recommended = was used */
select @ssr_best_loc_bpixtab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_bpixtab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_bpixtab
and stis_row_1.detector = @ssr_detector

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_bpixtab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_bpixtab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_bpixtab = 'MODERATE'
     else select @ssr_best_loc_bpixtab = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type DSP ****************/
/**************************************************************************/
select @ssr_best_disptab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'DSP'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
/* mod - check for wildcard */
             and (stis_row_2.cenwave = @ssr_cenwave or
		  stis_row_2.cenwave = -1)
             and stis_row_2.detector = @ssr_detector
             and stis_row_2.opt_elem = @ssr_opt_elem
        )
and stis_file_1.reference_file_type = 'DSP'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
/* mod -check for wildcard */
and (stis_row_1.cenwave = @ssr_cenwave or
     stis_row_1.cenwave = -1)
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_disptab = 'N/A', @ssr_best_loc_disptab = 'N/A'
else
if (@ssr_disptab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_disptab = 'N/A'
else
if (@ssr_best_disptab = @ssr_disptab) /* recommended = was used */
select @ssr_best_loc_disptab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_disptab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_disptab
/* mod - check for wildcard */
and (stis_row_1.cenwave = @ssr_cenwave or
     stis_row_1.cenwave = -1)
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_disptab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_disptab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_disptab = 'MODERATE'
     else select @ssr_best_loc_disptab = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type LIN ****************/
/**************************************************************************/
select @ssr_best_mlintab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'LIN'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.detector = @ssr_detector
        )
and stis_file_1.reference_file_type = 'LIN'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.detector = @ssr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_mlintab = 'N/A', @ssr_best_loc_mlintab = 'N/A'
else
if (@ssr_mlintab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_mlintab = 'N/A'
else
if (@ssr_best_mlintab = @ssr_mlintab) /* recommended = was used */
select @ssr_best_loc_mlintab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_mlintab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_mlintab
and stis_row_1.detector = @ssr_detector

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_mlintab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_mlintab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_mlintab = 'MODERATE'
     else select @ssr_best_loc_mlintab = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type LMP ****************/
/**************************************************************************/
/* begin mod - OPR 35873 - 12/30/97 - useafter_date is only selection   */
/*                                    criteria                          */

select @ssr_best_lamptab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'LMP'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
        )
and stis_file_1.reference_file_type = 'LMP'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_lamptab = 'N/A', @ssr_best_loc_lamptab = 'N/A'
else
if (@ssr_lamptab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_lamptab = 'N/A'
else
if (@ssr_best_lamptab = @ssr_lamptab) /* recommended = was used */
select @ssr_best_loc_lamptab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_lamptab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_lamptab

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_lamptab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_lamptab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_lamptab = 'MODERATE'
     else select @ssr_best_loc_lamptab = 'TRIVIAL'
end

/* end mod */
/**************************************************************************/
/*********** instrument stis ref file type MOC ****************/
/**************************************************************************/
select @ssr_best_mofftab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'MOC'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and (stis_row_2.cenwave = @ssr_cenwave or /* mod -check for */
                  stis_row_2.cenwave = -1)             /* wildcards */
             and stis_row_2.detector = @ssr_detector
             and stis_row_2.opt_elem = @ssr_opt_elem
        )
and stis_file_1.reference_file_type = 'MOC'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and (stis_row_1.cenwave = @ssr_cenwave or /* mod -check for wildcards */
     stis_row_1.cenwave = -1)
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_mofftab = 'N/A', @ssr_best_loc_mofftab = 'N/A'
else
if (@ssr_mofftab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_mofftab = 'N/A'
else
if (@ssr_best_mofftab = @ssr_mofftab) /* recommended = was used */
select @ssr_best_loc_mofftab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_mofftab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_mofftab
and (stis_row_1.cenwave = @ssr_cenwave or /* mod -check for wildcards */
     stis_row_1.cenwave = -1)
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_mofftab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_mofftab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_mofftab = 'MODERATE'
     else select @ssr_best_loc_mofftab = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type PHT ****************/
/**************************************************************************/
/* begin mod - entire section */

if (@ssr_obstype = 'SPECTROSCOPIC')  /* use cenwave */
select @ssr_best_phottab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'PHT'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and (stis_row_2.cenwave = @ssr_cenwave or 
                  stis_row_2.cenwave = -1)
             and stis_row_2.obstype = @ssr_obstype
             and stis_row_2.detector = @ssr_detector
             and stis_row_2.opt_elem = @ssr_opt_elem
        )
and stis_file_1.reference_file_type = 'PHT'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and (stis_row_1.cenwave = @ssr_cenwave or
     stis_row_1.cenwave = -1)
and stis_row_1.obstype = @ssr_obstype
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem

else  /* @ssr_obstype = 'IMAGING' - don't use cenwave */

select @ssr_best_phottab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'PHT'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.obstype = @ssr_obstype
             and stis_row_2.detector = @ssr_detector
             and stis_row_2.opt_elem = @ssr_opt_elem
        )
and stis_file_1.reference_file_type = 'PHT'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.obstype = @ssr_obstype
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem

select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_phottab = 'N/A', @ssr_best_loc_phottab = 'N/A'
else
if (@ssr_phottab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_phottab = 'N/A'
else
if (@ssr_best_phottab = @ssr_phottab) /* recommended = was used */
select @ssr_best_loc_phottab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_phottab = 'UNKNOWN'
else
begin

if (@ssr_obstype = 'SPECTROSCOPIC')    /* use cenwave */
select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_phottab
and (stis_row_1.cenwave = @ssr_cenwave or
     stis_row_1.cenwave = -1)
and stis_row_1.obstype = @ssr_obstype
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem

else  /* @ssr_obstype='IMAGING' - don't use cenwave */

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_phottab
and stis_row_1.obstype = @ssr_obstype
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_phottab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_phottab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_phottab = 'MODERATE'
     else select @ssr_best_loc_phottab = 'TRIVIAL'
end
/* end mod */
/**************************************************************************/
/*********** instrument stis ref file type 1DT ****************/
/**************************************************************************/
select @ssr_best_sptrctab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = '1DT'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
/* mod - check for wildcard */
             and (stis_row_2.cenwave = @ssr_cenwave or
		  stis_row_2.cenwave = -1)
             and stis_row_2.detector = @ssr_detector
             and stis_row_2.opt_elem = @ssr_opt_elem
        )
and stis_file_1.reference_file_type = '1DT'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
/* mod - check for wildcard */
and (stis_row_1.cenwave = @ssr_cenwave or
     stis_row_1.cenwave = -1)
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_sptrctab = 'N/A', @ssr_best_loc_sptrctab = 'N/A'
else
if (@ssr_sptrctab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_sptrctab = 'N/A'
else
if (@ssr_best_sptrctab = @ssr_sptrctab) /* recommended = was used */
select @ssr_best_loc_sptrctab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_sptrctab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_sptrctab
/* mod - check for wildcard */
and (stis_row_1.cenwave = @ssr_cenwave or
     stis_row_1.cenwave = -1)
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_sptrctab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_sptrctab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_sptrctab = 'MODERATE'
     else select @ssr_best_loc_sptrctab = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type 1DX ****************/
/**************************************************************************/
select @ssr_best_xtractab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = '1DX'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
/* mod -check for wildcards */
             and (stis_row_2.cenwave = @ssr_cenwave or
                  stis_row_2.cenwave = -1)
             and (stis_row_2.aperture = @ssr_aperture or
                  stis_row_2.aperture = 'ANY')
             and stis_row_2.detector = @ssr_detector
             and stis_row_2.opt_elem = @ssr_opt_elem
        )
and stis_file_1.reference_file_type = '1DX'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
/* mod - check for wildcards */
and (stis_row_1.cenwave = @ssr_cenwave or
     stis_row_1.cenwave = -1)
and (stis_row_1.aperture = @ssr_aperture or
     stis_row_1.aperture = 'ANY')
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_xtractab = 'N/A', @ssr_best_loc_xtractab = 'N/A'
else
if (@ssr_xtractab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_xtractab = 'N/A'
else
if (@ssr_best_xtractab = @ssr_xtractab) /* recommended = was used */
select @ssr_best_loc_xtractab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_xtractab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_xtractab
/* mod -check for wildcards */
and (stis_row_1.cenwave = @ssr_cenwave or
     stis_row_1.cenwave = -1)
and (stis_row_1.aperture = @ssr_aperture or
     stis_row_1.aperture = 'ANY')
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_xtractab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_xtractab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_xtractab = 'MODERATE'
     else select @ssr_best_loc_xtractab = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type APD ****************/
/**************************************************************************/
select @ssr_best_apdestab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'APD'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
/* mod - check for wildcards */
             and (stis_row_2.aperture = @ssr_aperture or
		  stis_row_2.aperture = 'ANY')
        )
and stis_file_1.reference_file_type = 'APD'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
/* mod - check for wildcards */
and (stis_row_1.aperture = @ssr_aperture or
     stis_row_1.aperture = 'ANY')


select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_apdestab = 'N/A', @ssr_best_loc_apdestab = 'N/A'
else
if (@ssr_apdestab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_apdestab = 'N/A'
else
if (@ssr_best_apdestab = @ssr_apdestab) /* recommended = was used */
select @ssr_best_loc_apdestab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_apdestab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_apdestab
/* mod - check for wildcard */
and (stis_row_1.aperture = @ssr_aperture or
     stis_row_1.aperture = 'ANY')

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_apdestab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_apdestab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_apdestab = 'MODERATE'
     else select @ssr_best_loc_apdestab = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type CRR ****************/
/**************************************************************************/
select @ssr_best_crrejtab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'CRR'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
             and stis_row_2.crsplit = @ssr_crsplit
             and stis_row_2.detector = @ssr_detector
        )
and stis_file_1.reference_file_type = 'CRR'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
and stis_row_1.crsplit = @ssr_crsplit
and stis_row_1.detector = @ssr_detector
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_crrejtab = 'N/A', @ssr_best_loc_crrejtab = 'N/A'
else
if (@ssr_crrejtab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_crrejtab = 'N/A'
else
if (@ssr_best_crrejtab = @ssr_crrejtab) /* recommended = was used */
select @ssr_best_loc_crrejtab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_crrejtab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_crrejtab
and stis_row_1.crsplit = @ssr_crsplit
and stis_row_1.detector = @ssr_detector

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_crrejtab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_crrejtab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_crrejtab = 'MODERATE'
     else select @ssr_best_loc_crrejtab = 'TRIVIAL'
end
/**************************************************************************/
/*********** instrument stis ref file type IAC ****************/
/**************************************************************************/
select @ssr_best_inangtab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'IAC'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
/* mod - check for wildcard */
             and (stis_row_2.cenwave = @ssr_cenwave or
		  stis_row_2.cenwave = -1)
             and stis_row_2.detector = @ssr_detector
             and stis_row_2.opt_elem = @ssr_opt_elem
        )
and stis_file_1.reference_file_type = 'IAC'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
/* mod - check for wildcard */
and (stis_row_1.cenwave = @ssr_cenwave or
     stis_row_1.cenwave = -1)
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_inangtab = 'N/A', @ssr_best_loc_inangtab = 'N/A'
else
if (@ssr_inangtab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_inangtab = 'N/A'
else
if (@ssr_best_inangtab = @ssr_inangtab) /* recommended = was used */
select @ssr_best_loc_inangtab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_inangtab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_inangtab
/* mod - check for wildcard */
and (stis_row_1.cenwave = @ssr_cenwave or
     stis_row_1.cenwave = -1)
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_inangtab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_inangtab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_inangtab = 'MODERATE'
     else select @ssr_best_loc_inangtab = 'TRIVIAL'
end

/**************************************************************************/
/*********** instrument stis ref file type PCT             ****************/
/**************************************************************************/
/* begin mod - OPR 35684 - 12/31/97 - Add support for PCT */

select @ssr_best_pctab = stis_file_1.file_name,
@equiv_sev = stis_row_1.equivalence_class_severe,
@equiv_mod = stis_row_1.equivalence_class_moderate
from stis_file stis_file_1, stis_row stis_row_1
where stis_file_1.useafter_date = 
	(select max(stis_file_2.useafter_date)
	from stis_file stis_file_2, stis_row stis_row_2
             where stis_file_2.reference_file_type = 'PCT'
             and stis_file_2.useafter_date <= @expstart
             and stis_file_2.reject_flag = 'N'
             and stis_file_2.opus_flag = 'Y'
             and stis_file_2.archive_date is not null
             and stis_file_2.file_name =stis_row_2.file_name
             and stis_file_2.expansion_number = stis_row_2.expansion_number
/* mod -check for wildcards */
             and (stis_row_2.cenwave = @ssr_cenwave or
                  stis_row_2.cenwave = -1)
             and (stis_row_2.aperture = @ssr_aperture or
                  stis_row_2.aperture = 'ANY')
             and stis_row_2.detector = @ssr_detector
             and stis_row_2.opt_elem = @ssr_opt_elem
	     and stis_row_2.obstype = @ssr_obstype
        )
and stis_file_1.reference_file_type = 'PCT'
and stis_file_1.reject_flag = 'N'
and stis_file_1.opus_flag = 'Y'
and stis_file_1.archive_date is not null
and stis_file_1.file_name =stis_row_1.file_name
and stis_file_1.expansion_number = stis_row_1.expansion_number
/* mod - check for wildcards */
and (stis_row_1.cenwave = @ssr_cenwave or
     stis_row_1.cenwave = -1)
and (stis_row_1.aperture = @ssr_aperture or
     stis_row_1.aperture = 'ANY')
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem
and stis_row_1.obstype = @ssr_obstype
select @num_cal_files = @@rowcount
if (@num_cal_files = 0)    /* no recommended file found */
select @ssr_best_pctab = 'N/A', @ssr_best_loc_pctab = 'N/A'
else
if (@ssr_pctab = NULL) /* no file was used in the pipeline */
select @ssr_best_loc_pctab = 'N/A'
else
if (@ssr_best_pctab = @ssr_pctab) /* recommended = was used */
select @ssr_best_loc_pctab = 'NO CHANGE'
else
if (@equiv_sev = -1)
	select @ssr_best_loc_pctab = 'UNKNOWN'
else
begin

select @orig_equiv_sev = stis_row_1.equivalence_class_severe,
@orig_equiv_mod =  stis_row_1.equivalence_class_moderate
from stis_row stis_row_1
where stis_row_1.file_name = @ssr_pctab
/* mod -check for wildcards */
and (stis_row_1.cenwave = @ssr_cenwave or
     stis_row_1.cenwave = -1)
and (stis_row_1.aperture = @ssr_aperture or
     stis_row_1.aperture = 'ANY')
and stis_row_1.detector = @ssr_detector
and stis_row_1.opt_elem = @ssr_opt_elem
and stis_row_1.obstype = @ssr_obstype

if (@orig_equiv_sev = -1)
	select @ssr_best_loc_pctab = 'UNKNOWN'
else if ((@equiv_sev - @orig_equiv_sev) <> 0)
	select @ssr_best_loc_pctab = 'SEVERE'
else if ((@equiv_mod - @orig_equiv_mod) <> 0)
		select @ssr_best_loc_pctab = 'MODERATE'
     else select @ssr_best_loc_pctab = 'TRIVIAL'
end
/* end mod */

update stis_ref_data
set
ssr_best_bias = @ssr_best_bias
,ssr_best_loc_bias = @ssr_best_loc_bias
,ssr_best_dflt = @ssr_best_dflt
,ssr_best_loc_dflt = @ssr_best_loc_dflt
,ssr_best_dark = @ssr_best_dark
,ssr_best_loc_dark = @ssr_best_loc_dark
,ssr_best_lflt = @ssr_best_lflt
,ssr_best_loc_lflt = @ssr_best_loc_lflt
,ssr_best_pflt = @ssr_best_pflt
,ssr_best_loc_pflt = @ssr_best_loc_pflt
,ssr_best_shad = @ssr_best_shad
,ssr_best_loc_shad = @ssr_best_loc_shad
,ssr_best_sdst = @ssr_best_sdst
,ssr_best_loc_sdst = @ssr_best_loc_sdst
,ssr_best_ccdtab = @ssr_best_ccdtab
,ssr_best_loc_ccdtab = @ssr_best_loc_ccdtab
,ssr_best_idctab = @ssr_best_idctab
,ssr_best_loc_idctab = @ssr_best_loc_idctab
,ssr_best_sdctab = @ssr_best_sdctab
,ssr_best_loc_sdctab = @ssr_best_loc_sdctab
,ssr_best_atodtab = @ssr_best_atodtab
,ssr_best_loc_atodtab = @ssr_best_loc_atodtab
,ssr_best_apertab = @ssr_best_apertab
,ssr_best_loc_apertab = @ssr_best_loc_apertab
,ssr_best_bpixtab = @ssr_best_bpixtab
,ssr_best_loc_bpixtab = @ssr_best_loc_bpixtab
,ssr_best_disptab = @ssr_best_disptab
,ssr_best_loc_disptab = @ssr_best_loc_disptab
,ssr_best_mlintab = @ssr_best_mlintab
,ssr_best_loc_mlintab = @ssr_best_loc_mlintab
,ssr_best_lamptab = @ssr_best_lamptab
,ssr_best_loc_lamptab = @ssr_best_loc_lamptab
,ssr_best_mofftab = @ssr_best_mofftab
,ssr_best_loc_mofftab = @ssr_best_loc_mofftab
,ssr_best_phottab = @ssr_best_phottab
,ssr_best_loc_phottab = @ssr_best_loc_phottab
,ssr_best_sptrctab = @ssr_best_sptrctab
,ssr_best_loc_sptrctab = @ssr_best_loc_sptrctab
,ssr_best_xtractab = @ssr_best_xtractab
,ssr_best_loc_xtractab = @ssr_best_loc_xtractab
,ssr_best_apdestab = @ssr_best_apdestab
,ssr_best_loc_apdestab = @ssr_best_loc_apdestab
,ssr_best_crrejtab = @ssr_best_crrejtab
,ssr_best_loc_crrejtab = @ssr_best_loc_crrejtab
,ssr_best_inangtab = @ssr_best_inangtab
,ssr_best_loc_inangtab = @ssr_best_loc_inangtab
,ssr_best_pctab = @ssr_best_pctab
,ssr_best_loc_pctab = @ssr_best_loc_pctab
where current of update_stis_cursor
fetch update_stis_cursor into @expstart,@data_set_name
,@ssr_aperture
,@ssr_binaxis1
,@ssr_binaxis2
,@ssr_ccdamp
,@ssr_ccdgain
,@ssr_ccdoffst
,@ssr_cenwave
,@ssr_crsplit
,@ssr_detector
,@ssr_obstype
,@ssr_opt_elem
,@ssr_sptrctab
,@ssr_xtractab
,@ssr_atodtab
,@ssr_apdestab
,@ssr_apertab
,@ssr_biasfile
,@ssr_bpixtab
,@ssr_ccdtab
,@ssr_crrejtab
,@ssr_dfltfile
,@ssr_darkfile
,@ssr_disptab
,@ssr_inangtab
,@ssr_idctab
,@ssr_lfltfile
,@ssr_mlintab
,@ssr_lamptab
,@ssr_mofftab
,@ssr_pfltfile
,@ssr_phottab
,@ssr_sdctab
,@ssr_shadfile
,@ssr_sdstfile
,@ssr_pctab
end
close update_stis_cursor 
deallocate cursor update_stis_cursor 
return
go
