/* SYSTEM.H -- Definitions dependent on the operating system */

#ifndef  SYSTEM_H
#define  SYSTEM_H


/**** Host machine and installation dependent macros ****/

#define  TIB		/* Change me when installing on a new machine!! */

#ifdef   RA
#define  CDBSDIR	"/data/cdbs1/"
#define  DATADIR	"/data/lilac1/bsimon/newcdbs/data/"
#define  CGIBIN		"http://ra.stsci.edu/cgi-bin/"

#else
#ifdef   TIB
#define  CDBSDIR	"/data/cdbs1/"
#define  DATADIR	"/data/cdbs1/calvin_test/data/"
#define  CGIBIN		"http://ra.stsci.edu/cgi-bin/"

#else
#ifdef   MARVEL
#define  CDBSDIR	"/data/cdbs1/"
#define  DATADIR	"/opt/httpd/cgi-bin/cdbs/data/"
#define  CGIBIN		"http://www.stsci.edu/cgi-bin/cdbs/"

#endif
#endif
#endif

#define  VERSION_STRING "1 Apr 1998"	/* Update with every release!! */


/**** OS and compiler dependent macros ****/

#ifdef __VMS
#include <ssdef.h>
#include <signal.h>

#ifdef __ALPHA
#pragma  extern_model common_block
#define  MAIN_TYPE	int
#define  MAIN_RETURN(x)	return(x)

#else
#pragma  extern_model common_block shr
#define  MAIN_TYPE	void
#define  MAIN_RETURN(x)		/* nothing */
#endif

#define  DIR_SEPCHAR	'.'
#define  DIR_ENDCHAR	']'

#define  NORMAL_EXIT	SS$_NORMAL
#define  ERROR_EXIT	2

#else
#include <stdlib.h>
#include <unistd.h>

#define  DIR_SEPCHAR	'/'
#define  DIR_ENDCHAR	'/'

#define  NORMAL_EXIT	EXIT_SUCCESS
#define  ERROR_EXIT	EXIT_FAILURE

#define  MAIN_TYPE	int
#define  MAIN_RETURN(x)	return(x)

#endif

#endif

