#include <string.h>
#include "error.h"
#include "config.h"
#include "loadfile.h"
#include "reffile.h"
#include "cdbslib.h"
#include "mkload.h"

/* MKLOAD_HEADER -- Write header keywords to table
 *
 * i: tab		table descriptor
 * i: ref		reference file descriptor
 * i: instrument	instrument associated with reference file
 * i: reftype		reference file type
 */

void mkload_header (table *tab, reffile *ref, char *instrument, char *reftype)
{
    char	nilstr[] = "";
    char	useafter[SZ_STRING+1], date[SZ_STRING+1];

    /* Write filename to loadfile header */

    put_tab_key (tab, "FILE_NAME", basename (name_reffile(ref)));

    /* Write the instrument and reference file type */

    put_tab_key (tab, "INSTRUMENT", instrument);
    put_tab_key (tab, "REFERENCE_FILE_TYPE", reftype);

    /* Get useafter date from the reference file header, if present */

    if (get_hdr_reffile (ref, "useafter", useafter, SZ_STRING) == ERR) {
	date[0] = EOS;
    } else {
	mkload_date (useafter, date, SZ_STRING);
    }

    put_tab_key (tab, "USEAFTER_DATE", date);

    /* Set comparsion file to initial value for now until
     * we can add the code to read the filename from the
     * database.
     */
    put_tab_key (tab, "COMPARISON_FILE", "(INITIAL)");

    /* Set remaining loadfile header keywords to blank */
    put_tab_key (tab, "OPUS_FLAG", nilstr);
    put_tab_key (tab, "COMMENT", nilstr);

}
