/*****************************************************************************/
/*                                                                           */
/*  File name :   cdbs_mode_data.sql                                         */
/*                                                                           */
/*  Related file : <instrument>_row.sql, file_extensions_data.sql,           */
/*                 opus_fields_data.sql, relation_info_data.sql              */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  07/08/96               sk   Original                                     */
/*  04/09/97   33811       sk   Add stis reference_file_type "MOC"           */
/*  04/30/97   34029       sk   remove STIS/PHT/aperture entry               */
/*  05/16/97               sk   add foc.unitab modes                         */
/*  12/17/97   35926       sk   remove STIS/LMP/sclamp and lampset data      */
/*  12/17/97   35928       sk   add 5 new STIS/PCT data                      */
/*  03/05/98   36456       sk   add 4 new FOS/PCP data                       */
/*                                                                           */
/*****************************************************************************/

/* cdbs_mode data */
delete from cdbs_mode
go

/* instrument, reference_file_type, modes, file_select */

insert into cdbs_mode values ('FOC', 'BAC', 'optcrly', 'Y')
go
insert into cdbs_mode values ('FOC', 'BAC', 'pxformt', 'Y')
go
insert into cdbs_mode values ('FOC', 'ITF', 'optcrly', 'Y')
go
insert into cdbs_mode values ('FOC', 'ITF', 'pxformt', 'Y')
go
insert into cdbs_mode values ('FOC', 'ITF', 'sampoff', 'Y')
go
insert into cdbs_mode values ('FOC', 'ITF', 'samppln', 'Y')
go
insert into cdbs_mode values ('FOC', 'ITF', 'lineoff', 'Y')
go
insert into cdbs_mode values ('FOC', 'ITF', 'linepfm', 'Y')
go
insert into cdbs_mode values ('FOC', 'SDE', 'pxformt', 'Y')
go
insert into cdbs_mode values ('FOC', 'SDE', 'optelt1', 'Y')
go
insert into cdbs_mode values ('FOC', 'SDE', 'optelt2', 'Y')
go
insert into cdbs_mode values ('FOC', 'GEO', 'optcrly', 'Y')
go
insert into cdbs_mode values ('FOC', 'GEO', 'pxformt', 'Y')
go
insert into cdbs_mode values ('FOC', 'GEO', 'optelt1', 'Y')
go
insert into cdbs_mode values ('FOC', 'GEO', 'optelt2', 'Y')
go
insert into cdbs_mode values ('FOC', 'GEO', 'sampoff', 'Y')
go
insert into cdbs_mode values ('FOC', 'GEO', 'samppln', 'Y')
go
insert into cdbs_mode values ('FOC', 'GEO', 'lineoff', 'Y')
go
insert into cdbs_mode values ('FOC', 'GEO', 'linepfm', 'Y')
go
insert into cdbs_mode values ('FOC', 'GEO', 'cammode', 'Y')
go
insert into cdbs_mode values ('FOC', 'GEO', 'smmmode', 'Y')
go
insert into cdbs_mode values ('FOC', 'BLM', 'optcrly', 'Y')
go
insert into cdbs_mode values ('FOC', 'BLM', 'pxformt', 'Y')
go
insert into cdbs_mode values ('FOC', 'UNI', 'optcrly', 'Y')
go
insert into cdbs_mode values ('FOC', 'UNI', 'cammode', 'Y')
go
insert into cdbs_mode values ('FOC', 'UNI', 'wavelength', 'Y')
go
insert into cdbs_mode values ('FOC', 'UNITAB', 'optcrly', 'N')
go
insert into cdbs_mode values ('FOC', 'UNITAB', 'cammode', 'N')
go
insert into cdbs_mode values ('FOC', 'UNITAB', 'wavelength', 'N')
go
insert into cdbs_mode values ('FOC', 'UNITAB', 'uni_file_name', 'N')
go

insert into cdbs_mode values ('HSP', 'CCP0', 'aper_name', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP1', 'det_num', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP1', 'type', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP1', 'voltage', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP2', 'det_num', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP2', 'vgaind', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP3', 'det_num', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP3', 'type', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP4', 'aper_name', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP4', 'det_num', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP7', 'det_num', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP7', 'vgaind', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP8', 'det_num', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP8', 'voltage', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP8', 'thresh', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP9', 'aper_name', 'N')
go
insert into cdbs_mode values ('HSP', 'CCP9', 'det_num', 'N')
go

insert into cdbs_mode values ('FOS', 'AIS', 'detector', 'Y')
go
insert into cdbs_mode values ('FOS', 'AIS', 'overscan', 'Y')
go
insert into cdbs_mode values ('FOS', 'AIS', 'polar_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'AIS', 'fgwa_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'AIS', 'pass_dir', 'Y')
go
insert into cdbs_mode values ('FOS', 'BAC', 'detector', 'Y')
go
insert into cdbs_mode values ('FOS', 'BAC', 'overscan', 'Y')
go
insert into cdbs_mode values ('FOS', 'FLT', 'detector', 'Y')
go
insert into cdbs_mode values ('FOS', 'FLT', 'overscan', 'Y')
go
insert into cdbs_mode values ('FOS', 'FLT', 'aper_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'FLT', 'aper_pos', 'Y')
go
insert into cdbs_mode values ('FOS', 'FLT', 'polar_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'FLT', 'fgwa_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'FLT', 'pass_dir', 'Y')
go
insert into cdbs_mode values ('FOS', 'IVS', 'detector', 'Y')
go
insert into cdbs_mode values ('FOS', 'IVS', 'overscan', 'Y')
go
insert into cdbs_mode values ('FOS', 'IVS', 'aper_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'IVS', 'aper_pos', 'Y')
go
insert into cdbs_mode values ('FOS', 'IVS', 'polar_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'IVS', 'fgwa_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'IVS', 'pass_dir', 'Y')
go
insert into cdbs_mode values ('FOS', 'RET', 'detector', 'Y')
go
insert into cdbs_mode values ('FOS', 'RET', 'overscan', 'Y')
go
insert into cdbs_mode values ('FOS', 'RET', 'polar_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'RET', 'fgwa_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'DDT', 'detector', 'Y')
go
insert into cdbs_mode values ('FOS', 'QIN', 'detector', 'Y')
go
insert into cdbs_mode values ('FOS', 'QIN', 'overscan', 'Y')
go
insert into cdbs_mode values ('FOS', 'QIN', 'aper_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'QIN', 'aper_pos', 'Y')
go
insert into cdbs_mode values ('FOS', 'QIN', 'polar_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'QIN', 'fgwa_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'QIN', 'pass_dir', 'Y')
go
insert into cdbs_mode values ('FOS', 'PCP', 'detector', 'Y')
go
insert into cdbs_mode values ('FOS', 'PCP', 'aper_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'PCP', 'polar_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'PCP', 'fgwa_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'LSF', 'detector', 'Y')
go
insert into cdbs_mode values ('FOS', 'LSF', 'aper_id', 'Y')
go
insert into cdbs_mode values ('FOS', 'LSF', 'wavelength', 'Y')
go
insert into cdbs_mode values ('FOS', 'PSF', 'detector', 'Y')
go
insert into cdbs_mode values ('FOS', 'PSF', 'wavelength', 'Y')
go
insert into cdbs_mode values ('FOS', 'CCS0', 'detector', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS0', 'aper_id', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS0', 'aper_pos', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS1', 'detector', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS1', 'fgwa_id', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS2', 'detector', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS2', 'fgwa_id', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS2', 'fchnl', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS2', 'nxsteps', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS3', 'detector', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS4', 'detector', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS4', 'polar_id', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS4', 'fgwa_id', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS5', 'detector', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS5', 'aper_id', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS5', 'fgwa_id', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS5', 'nxsteps', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS6', 'detector', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS6', 'aper_id', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS6', 'aper_pos', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS6', 'polar_id', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS6', 'fgwa_id', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS6', 'pass_dir', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS7', 'detector', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS8', 'detector', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS9', 'detector', 'N')
go
insert into cdbs_mode values ('FOS', 'CCS9', 'fgwa_id', 'N')
go
insert into cdbs_mode values ('FOS', 'CCSB', 'detector', 'N')
go
insert into cdbs_mode values ('FOS', 'CCSB', 'aper_id', 'N')
go
insert into cdbs_mode values ('FOS', 'CCSB', 'fgwa_id', 'N')
go
insert into cdbs_mode values ('FOS', 'CCSC', 'detector', 'N')
go
insert into cdbs_mode values ('FOS', 'CCSC', 'aper_id', 'N') 
go
insert into cdbs_mode values ('FOS', 'CCSD', 'detector', 'N')
go
insert into cdbs_mode values ('FOS', 'CCSD', 'fgwa_id', 'N')
go
insert into cdbs_mode values ('FOS', 'CCG2', 'detector', 'N')
go

insert into cdbs_mode values ('HRS', 'DIO', 'detector', 'Y')
go
insert into cdbs_mode values ('HRS', 'PHC', 'grating', 'Y')
go
insert into cdbs_mode values ('HRS', 'VIG', 'grating', 'Y')
go
insert into cdbs_mode values ('HRS', 'ABS', 'grating', 'Y')
go
insert into cdbs_mode values ('HRS', 'NET', 'grating', 'Y')
go
insert into cdbs_mode values ('HRS', 'QIN', 'detector', 'Y')
go
insert into cdbs_mode values ('HRS', 'WAVECAL', 'targetid', 'N')
go
insert into cdbs_mode values ('HRS', 'CCR1', 'detector', 'N')
go
insert into cdbs_mode values ('HRS', 'CCR2', 'detector', 'N')
go
insert into cdbs_mode values ('HRS', 'CCR3', 'detector', 'N')
go
insert into cdbs_mode values ('HRS', 'CCR4', 'grating', 'N')
go
insert into cdbs_mode values ('HRS', 'CCR5', 'grating', 'N')
go
insert into cdbs_mode values ('HRS', 'CCR6', 'grating', 'N')
go
insert into cdbs_mode values ('HRS', 'CCR7', 'grating', 'N')
go
insert into cdbs_mode values ('HRS', 'CCR8', 'grating', 'N')
go
insert into cdbs_mode values ('HRS', 'CCR8', 'aperture', 'N')
go
insert into cdbs_mode values ('HRS', 'CCR8', 'sporder', 'N')
go
insert into cdbs_mode values ('HRS', 'CCR9', 'grating', 'N')
go
insert into cdbs_mode values ('HRS', 'CCR9', 'sporder', 'N')
go
insert into cdbs_mode values ('HRS', 'CCRA', 'grating', 'N')
go
insert into cdbs_mode values ('HRS', 'CCRB', 'grating', 'N')
go
insert into cdbs_mode values ('HRS', 'CCRB', 'aperture', 'N')
go
insert into cdbs_mode values ('HRS', 'CCRB', 'sporder', 'N')
go
insert into cdbs_mode values ('HRS', 'CCRC', 'grating', 'N')
go
insert into cdbs_mode values ('HRS', 'CCRD', 'detector', 'N')
go
insert into cdbs_mode values ('HRS', 'CCG2', 'detector', 'N')
go

insert into cdbs_mode values ('WFPC2', 'MSK', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC2', 'A2D', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC2', 'A2D', 'atodgain', 'Y')
go
insert into cdbs_mode values ('WFPC2', 'BAS', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC2', 'BAS', 'atodgain', 'Y')
go
insert into cdbs_mode values ('WFPC2', 'DRK', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC2', 'DRK', 'atodgain', 'Y')
go
insert into cdbs_mode values ('WFPC2', 'DRK', 'serials', 'Y')
go
insert into cdbs_mode values ('WFPC2', 'FLT', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC2', 'FLT', 'filter1', 'Y')
go
insert into cdbs_mode values ('WFPC2', 'FLT', 'filter2', 'Y')
go
insert into cdbs_mode values ('WFPC2', 'SHD', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC2', 'SHD', 'shutter', 'Y')
go

insert into cdbs_mode values ('WFPC', 'A2D', 'camera', 'Y')
go
insert into cdbs_mode values ('WFPC', 'A2D', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC', 'BAS', 'camera', 'Y')
go
insert into cdbs_mode values ('WFPC', 'BAS', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC', 'DRK', 'camera', 'Y')
go
insert into cdbs_mode values ('WFPC', 'DRK', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC', 'DRK', 'clock', 'Y')
go
insert into cdbs_mode values ('WFPC', 'FLT', 'camera', 'Y')
go
insert into cdbs_mode values ('WFPC', 'FLT', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC', 'FLT', 'filter1', 'Y')
go
insert into cdbs_mode values ('WFPC', 'FLT', 'filter2', 'Y')
go
insert into cdbs_mode values ('WFPC', 'DFLT', 'camera', 'Y')
go
insert into cdbs_mode values ('WFPC', 'DFLT', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC', 'DFLT', 'filter1', 'Y')
go
insert into cdbs_mode values ('WFPC', 'DFLT', 'filter2', 'Y')
go
insert into cdbs_mode values ('WFPC', 'DFLT', 'filtnam1', 'Y')
go
insert into cdbs_mode values ('WFPC', 'DFLT', 'filtnam2', 'Y')
go
insert into cdbs_mode values ('WFPC', 'MSK', 'camera', 'Y')
go
insert into cdbs_mode values ('WFPC', 'MSK', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC', 'PRF', 'camera', 'Y')
go
insert into cdbs_mode values ('WFPC', 'PRF', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC', 'PRF', 'shutter', 'Y')
go
insert into cdbs_mode values ('WFPC', 'PSF', 'camera', 'Y')
go
insert into cdbs_mode values ('WFPC', 'PSF', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC', 'PSF', 'filtnam1', 'Y')
go
insert into cdbs_mode values ('WFPC', 'PSF', 'filtnam2', 'Y')
go
insert into cdbs_mode values ('WFPC', 'PUR', 'camera', 'Y')
go
insert into cdbs_mode values ('WFPC', 'PUR', 'mode', 'Y')
go
insert into cdbs_mode values ('WFPC', 'PHOTTAB', 'photmode', 'N')
go

insert into cdbs_mode values ('STIS', 'BIA', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'BIA', 'ccdamp', 'Y')
go
insert into cdbs_mode values ('STIS', 'BIA', 'ccdgain', 'Y')
go
insert into cdbs_mode values ('STIS', 'BIA', 'ccdoffst', 'Y')
go
insert into cdbs_mode values ('STIS', 'BIA', 'binaxis1', 'Y')
go
insert into cdbs_mode values ('STIS', 'BIA', 'binaxis2', 'Y')
go
insert into cdbs_mode values ('STIS', 'DRK', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'DRK', 'ccdamp', 'Y')
go
insert into cdbs_mode values ('STIS', 'DRK', 'ccdgain', 'Y')
go
insert into cdbs_mode values ('STIS', 'SSC', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'PFL', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'PFL', 'opt_elem', 'Y')
go
insert into cdbs_mode values ('STIS', 'PFL', 'obstype', 'Y')
go
insert into cdbs_mode values ('STIS', 'PFL', 'aperture', 'Y')
go
insert into cdbs_mode values ('STIS', 'PFL', 'cenwave', 'Y')
go
insert into cdbs_mode values ('STIS', 'DFL', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'LFL', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'LFL', 'opt_elem', 'Y')
go
insert into cdbs_mode values ('STIS', 'LFL', 'obstype', 'Y')
go
insert into cdbs_mode values ('STIS', 'LFL', 'aperture', 'Y')
go
insert into cdbs_mode values ('STIS', 'LFL', 'cenwave', 'Y')
go
insert into cdbs_mode values ('STIS', 'SSD', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'CCD', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'CCD', 'ccdamp', 'N')
go
insert into cdbs_mode values ('STIS', 'CCD', 'ccdgain', 'N')
go
insert into cdbs_mode values ('STIS', 'CCD', 'ccdoffst', 'N')
go
insert into cdbs_mode values ('STIS', 'CCD', 'binaxis1', 'N')
go
insert into cdbs_mode values ('STIS', 'CCD', 'binaxis2', 'N')
go
insert into cdbs_mode values ('STIS', 'A2D', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'A2D', 'ccdamp', 'N')
go
insert into cdbs_mode values ('STIS', 'A2D', 'ccdgain', 'N')
go
insert into cdbs_mode values ('STIS', 'CRR', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'CRR', 'crsplit', 'N')
go
insert into cdbs_mode values ('STIS', 'BPX', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'LIN', 'detector', 'N')
go
insert into cdbs_mode values ('STIS', 'PHT', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'PHT', 'opt_elem', 'N')
go
insert into cdbs_mode values ('STIS', 'PHT', 'obstype', 'Y')
go
insert into cdbs_mode values ('STIS', 'PHT', 'cenwave', 'N')
go
insert into cdbs_mode values ('STIS', 'APT', 'aperture', 'N')
go
insert into cdbs_mode values ('STIS', 'APD', 'aperture', 'N')
go
insert into cdbs_mode values ('STIS', 'IDC', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'IDC', 'opt_elem', 'N')
go
insert into cdbs_mode values ('STIS', 'IDC', 'aperture', 'N')
go
insert into cdbs_mode values ('STIS', 'SDC', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'SDC', 'opt_elem', 'N')
go
insert into cdbs_mode values ('STIS', 'SDC', 'cenwave', 'N')
go
insert into cdbs_mode values ('STIS', 'IAC', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'IAC', 'opt_elem', 'N')
go
insert into cdbs_mode values ('STIS', 'IAC', 'cenwave', 'N')
go
insert into cdbs_mode values ('STIS', 'DSP', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'DSP', 'opt_elem', 'N')
go
insert into cdbs_mode values ('STIS', 'DSP', 'cenwave', 'N')
go
insert into cdbs_mode values ('STIS', '1DT', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', '1DT', 'opt_elem', 'N')
go
insert into cdbs_mode values ('STIS', '1DT', 'cenwave', 'N')
go
insert into cdbs_mode values ('STIS', '1DX', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', '1DX', 'opt_elem', 'N')
go
insert into cdbs_mode values ('STIS', '1DX', 'aperture', 'N')
go
insert into cdbs_mode values ('STIS', '1DX', 'cenwave', 'N')
go
insert into cdbs_mode values ('STIS', 'MOC', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'MOC', 'opt_elem', 'N')
go
insert into cdbs_mode values ('STIS', 'MOC', 'cenwave', 'N')
go
insert into cdbs_mode values ('STIS', 'PCT', 'detector', 'Y')
go
insert into cdbs_mode values ('STIS', 'PCT', 'opt_elem', 'Y')
go
insert into cdbs_mode values ('STIS', 'PCT', 'obstype', 'Y')
go
insert into cdbs_mode values ('STIS', 'PCT', 'aperture', 'N')
go
insert into cdbs_mode values ('STIS', 'PCT', 'cenwave', 'N')
go

insert into cdbs_mode values ('NIC', 'MSK', 'camera', 'Y')
go
insert into cdbs_mode values ('NIC', 'NOI', 'camera', 'Y')
go
insert into cdbs_mode values ('NIC', 'NOI', 'readout', 'Y')
go
insert into cdbs_mode values ('NIC', 'NOI', 'nread', 'Y')
go
insert into cdbs_mode values ('NIC', 'LIN', 'camera', 'Y')
go
insert into cdbs_mode values ('NIC', 'DRK', 'camera', 'Y')
go
insert into cdbs_mode values ('NIC', 'DRK', 'readout', 'Y')
go
insert into cdbs_mode values ('NIC', 'DRK', 'nread', 'Y')
go
insert into cdbs_mode values ('NIC', 'DRK', 'samp_seq', 'Y')
go
insert into cdbs_mode values ('NIC', 'FLT', 'camera', 'Y')
go
insert into cdbs_mode values ('NIC', 'FLT', 'filter', 'Y')
go
insert into cdbs_mode values ('NIC', 'ILM', 'camera', 'Y')
go
insert into cdbs_mode values ('NIC', 'ILM', 'filter', 'Y')
go
insert into cdbs_mode values ('NIC', 'BKG', 'camera', 'N')
go
insert into cdbs_mode values ('NIC', 'BKG', 'filter', 'N')
go

insert into cdbs_mode values ('MULTI', 'PHOFLDS', 'fld_name', 'N')
go
insert into cdbs_mode values ('MULTI', 'SPECOBS', 'targetid', 'N')
go
insert into cdbs_mode values ('MULTI', 'SPECOBS', 'obsmode', 'N')
go
insert into cdbs_mode values ('MULTI', 'SPECTRUM', 'targetid', 'N')
go

insert into cdbs_mode values ('SYNPHOT', 'THROUGHPUT', 'compname', 'N')
go
