/*****************************************************************************/
/*                                                                           */
/*  File name :   file_extensions_data.sql                                   */
/*                                                                           */
/*  Related file : <instrument>_row.sql, cdbs_mode_data.sql                  */
/*                 opus_fields_data.sql, relation_info_data.sql              */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  07/08/96               sk   Original                                     */
/*  04/09/97   33811       sk   Add stis reference_file_type "MOC"           */
/*  12/11/97   35928       sk   Add stis reference_file_type "PCT"           */
/*  03/05/98   36456       sk   add FOS reference_file_type "PCP"            */
/*                                                                           */
/*****************************************************************************/

/* file_extensions data: reference_file_type, instrument, extension */
delete from file_extensions
go

/*     foc      */
insert into file_extensions values ('BAC', 'FOC', 'R0H')
go
insert into file_extensions values ('BAC', 'FOC', 'R0D')
go
insert into file_extensions values ('ITF', 'FOC', 'R1H')
go
insert into file_extensions values ('ITF', 'FOC', 'R1D')
go
insert into file_extensions values ('SDE', 'FOC', 'R3H')
go
insert into file_extensions values ('SDE', 'FOC', 'R3D')
go
insert into file_extensions values ('GEO', 'FOC', 'R5H')
go
insert into file_extensions values ('GEO', 'FOC', 'R5D')
go
insert into file_extensions values ('BLM', 'FOC', 'R7H')
go
insert into file_extensions values ('BLM', 'FOC', 'R7D')
go
insert into file_extensions values ('UNI', 'FOC', 'R2H')
go
insert into file_extensions values ('UNI', 'FOC', 'R2D')
go
insert into file_extensions values ('UNITAB', 'FOC', 'CXU')
go

/*     hsp      */
insert into file_extensions values ('CCP0', 'HSP', 'CV0')
go
insert into file_extensions values ('CCP1', 'HSP', 'CV1')
go
insert into file_extensions values ('CCP2', 'HSP', 'CV2')
go
insert into file_extensions values ('CCP3', 'HSP', 'CV3')
go
insert into file_extensions values ('CCP4', 'HSP', 'CV4')
go
insert into file_extensions values ('CCP5', 'HSP', 'CV5')
go
insert into file_extensions values ('CCP7', 'HSP', 'CV7')
go
insert into file_extensions values ('CCP8', 'HSP', 'CV8')
go
insert into file_extensions values ('CCP9', 'HSP', 'CV9')
go


/*     fos      */
insert into file_extensions values ('AIS', 'FOS', 'R8H')
go   /* AIS = average inverse sensitivity  */
insert into file_extensions values ('AIS', 'FOS', 'R8D')
go
insert into file_extensions values ('BAC', 'FOS', 'R0H')
go
insert into file_extensions values ('BAC', 'FOS', 'R0D')
go
insert into file_extensions values ('FLT', 'FOS', 'R1H')
go
insert into file_extensions values ('FLT', 'FOS', 'R1D')
go
insert into file_extensions values ('IVS', 'FOS', 'R2H')
go
insert into file_extensions values ('IVS', 'FOS', 'R2D')
go
insert into file_extensions values ('RET', 'FOS', 'R3H')
go
insert into file_extensions values ('RET', 'FOS', 'R3D')
go
insert into file_extensions values ('DDT', 'FOS', 'R4H')
go
insert into file_extensions values ('DDT', 'FOS', 'R4D')
go
insert into file_extensions values ('QIN', 'FOS', 'R5H')
go
insert into file_extensions values ('QIN', 'FOS', 'R5D')
go
insert into file_extensions values ('PCP', 'FOS', 'R9H')
go
insert into file_extensions values ('PCP', 'FOS', 'R9D')
go
insert into file_extensions values ('LSF', 'FOS', 'R7H')
go
insert into file_extensions values ('LSF', 'FOS', 'R7D')
go
insert into file_extensions values ('PSF', 'FOS', 'TAB')
go
insert into file_extensions values ('CCS0', 'FOS', 'CY0')
go
insert into file_extensions values ('CCS1', 'FOS', 'CY1')
go
insert into file_extensions values ('CCS2', 'FOS', 'CY2')
go
insert into file_extensions values ('CCS3', 'FOS', 'CY3')
go
insert into file_extensions values ('CCS4', 'FOS', 'CY4')
go
insert into file_extensions values ('CCS5', 'FOS', 'CY5')
go
insert into file_extensions values ('CCS6', 'FOS', 'CY6')
go
insert into file_extensions values ('CCS7', 'FOS', 'CY7')
go
insert into file_extensions values ('CCS8', 'FOS', 'CY8')
go
insert into file_extensions values ('CCS9', 'FOS', 'CY9')
go
insert into file_extensions values ('CCSA', 'FOS', 'CYA')
go
insert into file_extensions values ('CCSB', 'FOS', 'CYB')
go
insert into file_extensions values ('CCSC', 'FOS', 'CYC')
go
insert into file_extensions values ('CCSD', 'FOS', 'CYD')
go
insert into file_extensions values ('CCG2', 'FOS', 'CMG')
go

/*     hrs      */
insert into file_extensions values ('DIO', 'HRS', 'R0H')
go
insert into file_extensions values ('DIO', 'HRS', 'R0D')
go
insert into file_extensions values ('PHC', 'HRS', 'R1H')
go
insert into file_extensions values ('PHC', 'HRS', 'R1D')
go
insert into file_extensions values ('VIG', 'HRS', 'R2H')
go
insert into file_extensions values ('VIG', 'HRS', 'R2D')
go
insert into file_extensions values ('ABS', 'HRS', 'R3H')
go
insert into file_extensions values ('ABS', 'HRS', 'R3D')
go
insert into file_extensions values ('NET', 'HRS', 'R4H')
go
insert into file_extensions values ('NET', 'HRS', 'R4D')
go
insert into file_extensions values ('QIN', 'HRS', 'R5H')
go
insert into file_extensions values ('QIN', 'HRS', 'R5D')
go
insert into file_extensions values ('SAA', 'HRS', 'R6H')
go
insert into file_extensions values ('WAVECAL', 'HRS', 'TAB')
go
insert into file_extensions values ('CCR1', 'HRS', 'CZ1')
go
insert into file_extensions values ('CCR2', 'HRS', 'CZ2')
go
insert into file_extensions values ('CCR3', 'HRS', 'CZ3')
go
insert into file_extensions values ('CCR4', 'HRS', 'CZ4')
go
insert into file_extensions values ('CCR5', 'HRS', 'CZ5')
go
insert into file_extensions values ('CCR6', 'HRS', 'CZ6')
go
insert into file_extensions values ('CCR7', 'HRS', 'CZ7')
go
insert into file_extensions values ('CCR8', 'HRS', 'CZ8')
go
insert into file_extensions values ('CCR9', 'HRS', 'CZ9')
go
insert into file_extensions values ('CCRA', 'HRS', 'CZA')
go
insert into file_extensions values ('CCRB', 'HRS', 'CZB')
go
insert into file_extensions values ('CCRC', 'HRS', 'CZC')
go
insert into file_extensions values ('CCRD', 'HRS', 'CZD')
go
insert into file_extensions values ('CCG2', 'HRS', 'CMG')
go
insert into file_extensions values ('PTNELINEC', 'HRS', 'TAB')
go
insert into file_extensions values ('SCOFFC', 'HRS', 'TAB')
go
insert into file_extensions values ('CZE', 'HRS', 'TAB')
go

/*     wfpc2    */
insert into file_extensions values ('MSK', 'WFPC2', 'R0H')
go
insert into file_extensions values ('MSK', 'WFPC2', 'R0D')
go
insert into file_extensions values ('A2D', 'WFPC2', 'R1H')
go
insert into file_extensions values ('A2D', 'WFPC2', 'R1D')
go
insert into file_extensions values ('BAS', 'WFPC2', 'R2H')   
go
insert into file_extensions values ('BAS', 'WFPC2', 'B2H')   
go 
insert into file_extensions values ('BAS', 'WFPC2', 'R2D')   
go
insert into file_extensions values ('BAS', 'WFPC2', 'B2D')   
go
insert into file_extensions values ('DRK', 'WFPC2', 'R3H')   
go
insert into file_extensions values ('DRK', 'WFPC2', 'B3H')   
go
insert into file_extensions values ('DRK', 'WFPC2', 'R3D')   
go
insert into file_extensions values ('DRK', 'WFPC2', 'B3D')   
go
insert into file_extensions values ('FLT', 'WFPC2', 'R4H')
go
insert into file_extensions values ('FLT', 'WFPC2', 'B4H')
go
insert into file_extensions values ('FLT', 'WFPC2', 'R4D')
go
insert into file_extensions values ('FLT', 'WFPC2', 'B4D')
go
insert into file_extensions values ('SHD', 'WFPC2', 'R5H')
go
insert into file_extensions values ('SHD', 'WFPC2', 'R5D')
go

/*     wfpc    */
insert into file_extensions values ('A2D', 'WFPC', 'R1H')
go
insert into file_extensions values ('A2D', 'WFPC', 'R1D')
go
insert into file_extensions values ('BAS', 'WFPC', 'R2H')
go
insert into file_extensions values ('BAS', 'WFPC', 'B2H')
go
insert into file_extensions values ('BAS', 'WFPC', 'R2D')
go
insert into file_extensions values ('BAS', 'WFPC', 'B2D')
go
insert into file_extensions values ('DRK', 'WFPC', 'R5H')
go
insert into file_extensions values ('DRK', 'WFPC', 'B5H')
go
insert into file_extensions values ('DRK', 'WFPC', 'R5D')
go
insert into file_extensions values ('DRK', 'WFPC', 'B5D')
go
insert into file_extensions values ('FLT', 'WFPC', 'R6H')
go
insert into file_extensions values ('FLT', 'WFPC', 'B6H')
go
insert into file_extensions values ('FLT', 'WFPC', 'R6D')
go
insert into file_extensions values ('FLT', 'WFPC', 'B6D')
go
insert into file_extensions values ('MSK', 'WFPC', 'R0H')
go
insert into file_extensions values ('MSK', 'WFPC', 'R0D')
go
insert into file_extensions values ('PRF', 'WFPC', 'R3H')
go
insert into file_extensions values ('PRF', 'WFPC', 'B3H')
go
insert into file_extensions values ('PRF', 'WFPC', 'R3D')
go
insert into file_extensions values ('PRF', 'WFPC', 'B3D')
go
insert into file_extensions values ('PUR', 'WFPC', 'R4H')
go
insert into file_extensions values ('PUR', 'WFPC', 'B4H')
go
insert into file_extensions values ('PUR', 'WFPC', 'R4D')
go
insert into file_extensions values ('PUR', 'WFPC', 'B4D')
go
insert into file_extensions values ('PHOTTAB', 'WFPC', 'CW0') 
go
insert into file_extensions values ('PSF', 'WFPC', 'R7H')  
go
insert into file_extensions values ('DFLT', 'WFPC', 'R8H')
go

/*     stis     */
insert into file_extensions values ('BIA', 'STIS', 'FITS')
go
insert into file_extensions values ('DRK', 'STIS', 'FITS')
go
insert into file_extensions values ('SSC', 'STIS', 'FITS')
go
insert into file_extensions values ('PFL', 'STIS', 'FITS')
go
insert into file_extensions values ('DFL', 'STIS', 'FITS')
go
insert into file_extensions values ('LFL', 'STIS', 'FITS')
go
insert into file_extensions values ('SSD', 'STIS', 'FITS')
go
insert into file_extensions values ('CCD', 'STIS', 'FITS')
go
insert into file_extensions values ('A2D', 'STIS', 'FITS')
go
insert into file_extensions values ('CRR', 'STIS', 'FITS')
go
insert into file_extensions values ('BPX', 'STIS', 'FITS')
go
insert into file_extensions values ('LIN', 'STIS', 'FITS')
go
insert into file_extensions values ('PHT', 'STIS', 'FITS')
go
insert into file_extensions values ('APT', 'STIS', 'FITS')
go
insert into file_extensions values ('APD', 'STIS', 'FITS')
go
insert into file_extensions values ('LMP', 'STIS', 'FITS')
go
insert into file_extensions values ('IDC', 'STIS', 'FITS')
go
insert into file_extensions values ('SDC', 'STIS', 'FITS')
go
insert into file_extensions values ('IAC', 'STIS', 'FITS')
go
insert into file_extensions values ('DSP', 'STIS', 'FITS')
go
insert into file_extensions values ('1DT', 'STIS', 'FITS')
go
insert into file_extensions values ('1DX', 'STIS', 'FITS')
go
insert into file_extensions values ('MOC', 'STIS', 'FITS')
go
insert into file_extensions values ('PCT', 'STIS', 'FITS')
go

/*     nic      */
insert into file_extensions values ('MSK', 'NIC', 'FITS')
go
insert into file_extensions values ('NOI', 'NIC', 'FITS')
go
insert into file_extensions values ('LIN', 'NIC', 'FITS')
go
insert into file_extensions values ('DRK', 'NIC', 'FITS')
go
insert into file_extensions values ('FLT', 'NIC', 'FITS')
go
insert into file_extensions values ('ILM', 'NIC', 'FITS')
go
insert into file_extensions values ('PHT', 'NIC', 'FITS')
go
insert into file_extensions values ('BKG', 'NIC', 'FITS')
go

/*     synphot      */
insert into file_extensions values ('THROUGHPUT', 'SYNPHOT', 'TAB')
go
insert into file_extensions values ('GRAPHTAB', 'SYNPHOT', 'TMG')
go
insert into file_extensions values ('COMPTAB', 'SYNPHOT', 'TMC')
go

/*     multi      */
insert into file_extensions values ('CLUSTERPOS', 'MULTI', 'TAB')
go
insert into file_extensions values ('PHOFLDS', 'MULTI', 'TAB')
go
insert into file_extensions values ('PHOTOBS', 'MULTI', 'TAB')
go
insert into file_extensions values ('POLAROBS', 'MULTI', 'TAB')
go
insert into file_extensions values ('SPECOBS', 'MULTI', 'TAB')
go
insert into file_extensions values ('SPECTRUM', 'MULTI', 'TAB')
go

