/*****************************************************************************/
/*                                                                           */
/*  File name :   foc_file.sql                                               */
/*                                                                           */
/*  Description : instrucment "foc" file level table                         */
/*                associated row level table : foc_row                       */
/*                                                                           */
/*  Note :        for any given delivery, row level data should be inserted  */
/*                to "foc_row" prior insert file level data to "foc_file"    */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  07/08/96               sk   Original                                     */
/*                                                                           */
/*****************************************************************************/

create table foc_file (
   file_name                  varchar(50) not null,
   expansion_number           int         not null,
   delivery_number            int         not null,
   reference_file_type        varchar(50) not null,
   useafter_date              datetime    not null,
   opus_flag                  char(1)     not null,
   comment                    text        not null,
   general_availability_date  datetime    null,
   opus_load_date             datetime    null,
   archive_date               datetime    null,
   reject_flag                char(1)     not null,
   reject_delivery_number     int         null,
   reject_by_file_name        varchar(50) null,
   reject_by_expansion_number int         null,
   comparison_file_name       varchar(50) not null)
go
