/*****************************************************************************/
/*                                                                           */
/*  File name :   foc_row.sql                                                */
/*                                                                           */
/*  Description : instrucment "foc" row level table                          */
/*                associated file level table : foc_file                     */
/*                                                                           */
/*  Note :        for any given delivery, row level data should be inserted  */
/*                to "foc_row" prior insert file level data to "foc_file"    */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  07/08/96               sk   Original                                     */
/*  02/19/97               sk   change smallint mode to int                  */
/*  04/30/97    34040      sk   add uni_file_name to hold UNITAB's UNI files */
/*                                                                           */
/*****************************************************************************/
  
create table foc_row (
   file_name                   varchar(50) not null,
   expansion_number            int         not null,
   delivery_number             int         not null,

   /* observation_mode  */
   uni_file_name               varchar(50) not null,
   optcrly                     varchar(8)  not null,
   pxformt                     varchar(8)  not null,
   optelt1                     int         not null,
   optelt2                     int         not null,
   sampoff                     int         not null,
   samppln                     int         not null,
   lineoff                     int         not null,
   linepfm                     int         not null,
   cammode                     varchar(8)  not null,
   smmmode                     varchar(8)  not null,
   wavelength                  int         not null,

   /* equivalence_class */
   equivalence_class_severe    int         not null,
   equivalence_class_moderate  int         not null,

   pedigree                    varchar(50) not null,
   observation_begin_date      datetime    null,
   observation_end_date        datetime    null,
   comment                     text        null)
go

sp_bindefault cdbs_char_default, 'foc_row.uni_file_name'
go
sp_bindefault cdbs_char_default, 'foc_row.optcrly'
go
sp_bindefault cdbs_char_default, 'foc_row.pxformt'
go
sp_bindefault cdbs_int_default, 'foc_row.optelt1'
go
sp_bindefault cdbs_int_default, 'foc_row.optelt2'
go
sp_bindefault cdbs_int_default, 'foc_row.sampoff'
go
sp_bindefault cdbs_int_default, 'foc_row.samppln'
go
sp_bindefault cdbs_int_default, 'foc_row.lineoff'
go
sp_bindefault cdbs_int_default, 'foc_row.linepfm '
go
sp_bindefault cdbs_char_default, 'foc_row.cammode'
go
sp_bindefault cdbs_char_default, 'foc_row.smmmode'
go
sp_bindefault cdbs_int_default, 'foc_row.wavelength'
go
