/*****************************************************************************/
/*                                                                           */
/*  File name :   fos_row.sql                                                */
/*                                                                           */
/*  Description : instrucment "fos" row level table                          */
/*                associated file level table : fos_file                     */
/*                                                                           */
/*  Note :        for any given delivery, row level data should be inserted  */
/*                to "fos_row" prior insert file level data to "fos_file"    */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  07/08/96               sk   Original                                     */
/*  02/19/97               sk   change smallint mode to int                  */
/*                                                                           */
/*****************************************************************************/
  
create table fos_row (
   file_name                   varchar(50) not null,
   expansion_number            int         not null,
   delivery_number             int         not null,

   /* observation_mode  */
   detector                    varchar(5)  not null,
   overscan                    int         not null,
   aper_id                     varchar(3)  not null,
   aper_pos                    varchar(6)  not null,
   polar_id                    char(1)     not null,
   fgwa_id                     varchar(3)  not null,
   pass_dir                    int         not null,
   fchnl                       int         not null,
   nxsteps                     int         not null,
   wavelength                  int         not null,

   /* equivalence_class */
   equivalence_class_severe    int         not null,
   equivalence_class_moderate  int         not null,

   pedigree                    varchar(50) not null,
   observation_begin_date      datetime    null,
   observation_end_date        datetime    null,
   comment                     text        null)
go

sp_bindefault cdbs_char_default, 'fos_row.detector'
go
sp_bindefault cdbs_int_default, 'fos_row.overscan'
go
sp_bindefault cdbs_char_default, 'fos_row.aper_id'
go
sp_bindefault cdbs_char_default, 'fos_row.aper_pos'
go
sp_bindefault cdbs_char_default, 'fos_row.polar_id'
go
sp_bindefault cdbs_char_default, 'fos_row.fgwa_id'
go
sp_bindefault cdbs_int_default, 'fos_row.pass_dir'
go
sp_bindefault cdbs_int_default, 'fos_row.fchnl'
go
sp_bindefault cdbs_int_default, 'fos_row.nxsteps'
go
sp_bindefault cdbs_int_default, 'fos_row.wavelength'
go
