/*****************************************************************************/
/*                                                                           */
/*  File name :   hrs_row.sql                                                */
/*                                                                           */
/*  Description : instrucment "hrs" row level table                          */
/*                associated file level table : hrs_file                     */
/*                                                                           */
/*  Note :        for any given delivery, row level data should be inserted  */
/*                to "hrs_row" prior insert file level data to "hrs_file"    */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  07/08/96               sk   Original                                     */
/*  02/19/97               sk   change smallint mode to int                  */
/*                                                                           */
/*****************************************************************************/
  
create table hrs_row (
   file_name                   varchar(50) not null,
   expansion_number            int         not null,
   delivery_number             int         not null,

   /* observation_mode  */
   detector                    int         not null,
   grating                     varchar(9)  not null,
   aperture                    varchar(3)  not null,
   sporder                     int         not null,
   targetid                    varchar(18) not null,

   /* equivalence_class */
   equivalence_class_severe    int         not null,
   equivalence_class_moderate  int         not null,

   pedigree                    varchar(50) not null,
   observation_begin_date      datetime    null,
   observation_end_date        datetime    null,
   comment                     text        null)
go

sp_bindefault cdbs_int_default, 'hrs_row.detector'
go
sp_bindefault cdbs_char_default, 'hrs_row.grating'
go
sp_bindefault cdbs_char_default, 'hrs_row.aperture'
go
sp_bindefault cdbs_int_default, 'hrs_row.sporder'
go
sp_bindefault cdbs_char_default, 'hrs_row.targetid'
go
