/*****************************************************************************/
/*                                                                           */
/*  File name :   hsp_row.sql                                                */
/*                                                                           */
/*  Description : instrucment "hsp" row level table                          */
/*                associated file level table : hsp_file                     */
/*                                                                           */
/*  Note :        for any given delivery, row level data should be inserted  */
/*                to "hsp_row" prior insert file level data to "hsp_file"    */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  07/08/96               sk   Original                                     */
/*  02/19/97               sk   change smallint mode to int                  */
/*                                                                           */
/*****************************************************************************/
  
create table hsp_row (
   file_name                   varchar(50) not null,
   expansion_number            int         not null,
   delivery_number             int         not null,

   /* observation_mode  */
   aper_name                   varchar(10) not null,
   det_num                     int         not null,
   type                        varchar(7)  not null,
   voltage                     int         not null,
   vgaind                      int         not null,
   thresh                      int         not null,

   /* equivalence_class */
   equivalence_class_severe    int         not null,
   equivalence_class_moderate  int         not null,

   pedigree                    varchar(50) not null,
   observation_begin_date      datetime    null,
   observation_end_date        datetime    null,
   comment                     text        null)
go

sp_bindefault cdbs_char_default, 'hsp_row.aper_name'
go
sp_bindefault cdbs_int_default, 'hsp_row.det_num'
go
sp_bindefault cdbs_char_default, 'hsp_row.type'
go
sp_bindefault cdbs_int_default, 'hsp_row.voltage'
go
sp_bindefault cdbs_int_default, 'hsp_row.vgaind'
go
sp_bindefault cdbs_int_default, 'hsp_row.thresh'
go
