/*****************************************************************************/
/*                                                                           */
/*  File name :   multi_row.sql                                              */
/*                                                                           */
/*  Description : multi row level table                                      */
/*                associated file level table : multi_file                   */
/*                                                                           */
/*  Note :        for any given delivery, row level data should be inserted  */
/*                to "multi_row" prior insert file level data to             */
/*                "multi_file"                                               */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  07/08/96               sk   Original                                     */
/*                                                                           */
/*****************************************************************************/
  
create table multi_row (
   file_name                   varchar(50) not null,
   expansion_number            int         not null,
   delivery_number             int         not null,

   /* observation_mode  */
   targetid                    varchar(18) not null,
   fld_name                    varchar(18) not null,
   obsmode                     varchar(18) not null,

   /* equivalence_class */
   equivalence_class_severe    int         null,
   equivalence_class_moderate  int         null,

   pedigree                    varchar(50) null,
   observation_begin_date      datetime    null,
   observation_end_date        datetime    null,
   comment                     text        null)
go

sp_bindefault cdbs_char_default, 'multi_row.targetid'
go
sp_bindefault cdbs_char_default, 'multi_row.fld_name'
go
sp_bindefault cdbs_char_default, 'multi_row.obsmode'
go
