/*****************************************************************************/
/*                                                                           */
/*  File name :   nic_row.sql                                                */
/*                                                                           */
/*  Description : instrucment "nicmos" file level table                      */
/*                associated file level table : nic_file                     */
/*                                                                           */
/*  Note :        for any given delivery, row level data should be inserted  */
/*                to "nic_row" prior insert file level data to "nic_file"    */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  07/08/96               sk   Original                                     */
/*  02/19/97               sk   change smallint mode to int                  */
/*  04/22/97   33869       sk   change filter size                           */
/*  05/19/97   34279       sk   change samp_seq size to varchar(8)           */
/*                                                                           */
/*****************************************************************************/
  
create table nic_row (
   file_name                   varchar(50) not null,
   expansion_number            int         not null,
   delivery_number             int         not null,

   /* observation_mode  */
   camera                      int         not null, /* 1,2,3 */
   filter                      varchar(7)  not null,
   readout                     varchar(5)  not null, /* FAST,SLOW */
   nread                       int         not null,
   samp_seq                    varchar(8)  not null,

   /* equivalence_class */
   equivalence_class_severe    int         not null,
   equivalence_class_moderate  int         not null,

   pedigree                    varchar(50) not null,
   observation_begin_date      datetime    null,
   observation_end_date        datetime    null,
   comment                     text        null)
go

sp_bindefault cdbs_int_default, 'nic_row.camera'
go
sp_bindefault cdbs_char_default, 'nic_row.filter'
go
sp_bindefault cdbs_char_default, 'nic_row.readout'
go
sp_bindefault cdbs_int_default, 'nic_row.nread'
go
sp_bindefault cdbs_char_default, 'nic_row.samp_seq'
go
