/*****************************************************************************/
/*                                                                           */
/*  File:    opus_log.sql                                                    */
/*                                                                           */
/*  Description : Support for SQL generation to OPUS                         */
/*                "opus_log" data were produced through each instrument's    */
/*                trigger action where instrument file level table's column  */
/*                opus_flag='Y', user should not manually modify the data    */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  07/08/96               sk   Original                                     */
/*                                                                           */
/*****************************************************************************/
  
create table opus_log ( 
   delivery_number     int         not null,
   file_name           varchar(50) not null,
   expansion_number    int         not null,
   instrument          varchar(50) not null, /* instrument name */
   reference_file_type varchar(50) not null,
   operation           char(1)     not null) /* I=insert, R=reject, D=delete */
go
