/*****************************************************************************/
/*                                                                           */
/*  File name :   relation_info_data.sql                                     */
/*                                                                           */
/*  Related file : <instrument>_row.sql, file_extensions_data.sql,           */
/*                 opus_fields_data.sql, cdbs_mode_data.sql                  */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  07/08/96               sk   Original                                     */
/*  04/09/97   33811       sk   Add stis reference_file_type "MOC"           */
/*  12/17/97   35928       sk   Add stis reference_file_type "PCT"           */
/*  03/05/98   36456       sk   add FOS reference_file_type "PCP"            */
/*                                                                           */
/*****************************************************************************/

/* relation_info data */
delete from relation_info
go

/* reference_file_type, instrument, type, opus_table */

insert into relation_info values ('BAC', 'FOC', 'I', 'ccab_foc_ref')
go
insert into relation_info values ('ITF', 'FOC', 'I', 'ccab_foc_ref')
go
insert into relation_info values ('SDE', 'FOC', 'I', 'ccab_foc_ref')
go
insert into relation_info values ('GEO', 'FOC', 'I', 'ccab_foc_ref')
go
insert into relation_info values ('BLM', 'FOC', 'I', 'ccab_foc_ref')
go
insert into relation_info values ('UNI', 'FOC', 'I', 'ccab_foc_ref')
go
insert into relation_info values ('UNITAB', 'FOC', 'T', 'caltable')
go

insert into relation_info values ('CCP0', 'HSP', 'T', 'caltable')
go
insert into relation_info values ('CCP1', 'HSP', 'T', 'caltable')
go
insert into relation_info values ('CCP2', 'HSP', 'T', 'caltable')
go
insert into relation_info values ('CCP3', 'HSP', 'T', 'caltable')
go
insert into relation_info values ('CCP4', 'HSP', 'T', 'caltable')
go
insert into relation_info values ('CCP5', 'HSP', 'T', 'caltable')
go
insert into relation_info values ('CCP7', 'HSP', 'T', 'caltable')
go
insert into relation_info values ('CCP8', 'HSP', 'T', 'caltable')
go
insert into relation_info values ('CCP9', 'HSP', 'T', 'caltable')
go

insert into relation_info values ('AIS', 'FOS', 'I', 'ccac_fos_ref')
go
insert into relation_info values ('BAC', 'FOS', 'I', 'ccac_fos_ref')
go
insert into relation_info values ('FLT', 'FOS', 'I', 'ccac_fos_ref')
go
insert into relation_info values ('IVS', 'FOS', 'I', 'ccac_fos_ref')
go
insert into relation_info values ('RET', 'FOS', 'I', 'ccac_fos_ref')
go
insert into relation_info values ('DDT', 'FOS', 'I', 'ccac_fos_ref')
go
insert into relation_info values ('QIN', 'FOS', 'I', 'ccac_fos_ref')
go
insert into relation_info values ('PCP', 'FOS', 'I', 'ccac_fos_ref')
go
insert into relation_info values ('LSF', 'FOS', 'I', 'ccac_fos_ref')
go
insert into relation_info values ('PSF', 'FOS', 'I', 'ccac_fos_ref')
go
insert into relation_info values ('CCS0', 'FOS', 'T', 'caltable')
go
insert into relation_info values ('CCS1', 'FOS', 'T', 'caltable')
go
insert into relation_info values ('CCS2', 'FOS', 'T', 'caltable')
go
insert into relation_info values ('CCS3', 'FOS', 'T', 'caltable')
go
insert into relation_info values ('CCS4', 'FOS', 'T', 'caltable')
go
insert into relation_info values ('CCS5', 'FOS', 'T', 'caltable')
go
insert into relation_info values ('CCS6', 'FOS', 'T', 'caltable')
go
insert into relation_info values ('CCS7', 'FOS', 'T', 'caltable')
go
insert into relation_info values ('CCS8', 'FOS', 'T', 'caltable')
go
insert into relation_info values ('CCS9', 'FOS', 'T', 'caltable')
go
insert into relation_info values ('CCSA', 'FOS', 'T', 'caltable')
go
insert into relation_info values ('CCSB', 'FOS', 'T', 'caltable')
go
insert into relation_info values ('CCSC', 'FOS', 'T', 'caltable')
go
insert into relation_info values ('CCSD', 'FOS', 'T', 'caltable')
go
insert into relation_info values ('CCG2', 'FOS', 'T', 'caltable')
go 

insert into relation_info values ('DIO', 'HRS', 'I', 'ccad_hrs_ref')
go
insert into relation_info values ('PHC', 'HRS', 'I', 'ccad_hrs_ref')
go
insert into relation_info values ('VIG', 'HRS', 'I', 'ccad_hrs_ref')
go
insert into relation_info values ('ABS', 'HRS', 'I', 'ccad_hrs_ref')
go
insert into relation_info values ('NET', 'HRS', 'I', 'ccad_hrs_ref')
go
insert into relation_info values ('QIN', 'HRS', 'I', 'ccad_hrs_ref')
go
insert into relation_info values ('SAA', 'HRS', 'I', 'ccad_hrs_ref')
go
insert into relation_info values ('WAVECAL', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCR1', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCR2', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCR3', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCR4', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCR5', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCR6', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCR7', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCR8', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCR9', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCRA', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCRB', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCRC', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCRD', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCG2', 'HRS', 'T', 'caltable')
go 
insert into relation_info values ('PTNELINEC', 'HRS', 'T', 'caltable')
go 
insert into relation_info values ('SCOFFC', 'HRS', 'T', 'caltable')
go
insert into relation_info values ('CCRE', 'HRS', 'T', 'caltable')
go 

insert into relation_info values ('MSK', 'WFPC2', 'I', 'ccau_wf2_ref')
go
insert into relation_info values ('A2D', 'WFPC2', 'I', 'ccau_wf2_ref')
go
insert into relation_info values ('BAS', 'WFPC2', 'I', 'ccau_wf2_ref')
go
insert into relation_info values ('DRK', 'WFPC2', 'I', 'ccau_wf2_ref')
go
insert into relation_info values ('FLT', 'WFPC2', 'I', 'ccau_wf2_ref')
go
insert into relation_info values ('SHD', 'WFPC2', 'I', 'ccau_wf2_ref')
go

insert into relation_info values ('A2D', 'WFPC', 'I', 'ccaa_wfc_ref')
go
insert into relation_info values ('BAS', 'WFPC', 'I', 'ccaa_wfc_ref')
go
insert into relation_info values ('DRK', 'WFPC', 'I', 'ccaa_wfc_ref')
go
insert into relation_info values ('FLT', 'WFPC', 'I', 'ccaa_wfc_ref')
go
insert into relation_info values ('DFLT', 'WFPC', 'I', 'ccaa_wfc_ref')
go
insert into relation_info values ('MSK', 'WFPC', 'I', 'ccaa_wfc_ref')
go
insert into relation_info values ('PRF', 'WFPC', 'I', 'ccaa_wfc_ref')
go
insert into relation_info values ('PSF', 'WFPC', 'I', 'ccaa_wfc_ref')
go
insert into relation_info values ('PUR', 'WFPC', 'I', 'ccaa_wfc_ref')
go
insert into relation_info values ('PHOTTAB', 'WFPC', 'T', 'caltable')
go

insert into relation_info values ('BIA', 'STIS', 'I', 'ccao_stis_ref')
go
insert into relation_info values ('DRK', 'STIS', 'I', 'ccao_stis_ref')
go
insert into relation_info values ('SSC', 'STIS', 'I', 'ccao_stis_ref')
go
insert into relation_info values ('PFL', 'STIS', 'I', 'ccao_stis_ref')
go
insert into relation_info values ('DFL', 'STIS', 'I', 'ccao_stis_ref')
go
insert into relation_info values ('LFL', 'STIS', 'I', 'ccao_stis_ref')
go
insert into relation_info values ('SSD', 'STIS', 'I', 'ccao_stis_ref')
go
insert into relation_info values ('CCD', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('A2D', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('CRR', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('BPX', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('LIN', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('PHT', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('APT', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('APD', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('LMP', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('IDC', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('SDC', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('IAC', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('DSP', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('1DT', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('1DX', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('MOC', 'STIS', 'T', 'ccao_stis_ref')
go
insert into relation_info values ('PCT', 'STIS', 'T', 'ccao_stis_ref')
go

insert into relation_info values ('MSK', 'NIC', 'I', 'ccan_nicmos_ref')
go
insert into relation_info values ('NOI', 'NIC', 'I', 'ccan_nicmos_ref')
go
insert into relation_info values ('LIN', 'NIC', 'I', 'ccan_nicmos_ref')
go
insert into relation_info values ('DRK', 'NIC', 'I', 'ccan_nicmos_ref')
go
insert into relation_info values ('FLT', 'NIC', 'I', 'ccan_nicmos_ref')
go
insert into relation_info values ('ILM', 'NIC', 'I', 'ccan_nicmos_ref')
go
insert into relation_info values ('PHT', 'NIC', 'T', 'caltable')
go
insert into relation_info values ('BKG', 'NIC', 'T', 'caltable')
go

insert into relation_info values ('GRAPHTAB', 'SYNPHOT', 'T', 'caltable')
go   
insert into relation_info values ('COMPTAB', 'SYNPHOT', 'T', 'caltable')
go
insert into relation_info values ('THROUGHPUT', 'SYNPHOT', 'T', 'caltable')
go
