/*****************************************************************************/
/*                                                                           */
/*  File name :   synphot_row.sql                                            */
/*                                                                           */
/*  Description : synphot row level table                                    */
/*                associated file level table : synphot_file                 */
/*                                                                           */
/*  Note :        for any given delivery, row level data should be inserted  */
/*                to "synphot_row" prior insert file level data to           */
/*                "synphot_file"                                             */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  07/08/96               sk   Original                                     */
/*                                                                           */
/*****************************************************************************/
  
create table synphot_row (
   file_name                   varchar(50) not null,
   expansion_number            int         not null,
   delivery_number             int         not null,

   /* observation_mode  */
   compname                    varchar(50) not null,

   /* equivalence_class */
   equivalence_class_severe    int         null,
   equivalence_class_moderate  int         null,

   pedigree                    varchar(50) null,
   observation_begin_date      datetime    null,
   observation_end_date        datetime    null,
   comment                     text        null)
go

sp_bindefault cdbs_char_default, 'synphot_row.compname'
go
