/*****************************************************************************/
/*                                                                           */
/*  File name :   wfpc2_row.sql                                              */
/*                                                                           */
/*  Description : instrucment "wfpc2" row level table                        */
/*                associated file level table : wfpc2_file                   */
/*                                                                           */
/*  Note :        for any given delivery, row level data should be inserted  */
/*                to "wfpc2_row" prior insert file level data to             */
/*                "wfpc2_file"                                               */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  07/08/96               sk   Original                                     */
/*  02/19/97               sk   change smallint mode to int                  */
/*                                                                           */
/*****************************************************************************/
  
create table wfpc2_row (
   file_name                   varchar(50) not null,
   expansion_number            int         not null,
   delivery_number             int         not null,

   /* observation_mode  */
   atodgain                    int         not null,
   mode                        varchar(4)  not null,
   serials                     varchar(3)  not null,
   shutter                     char(1)     not null,
   filter1                     int         not null,
   filter2                     int         not null,

   /* equivalence_class */
   equivalence_class_severe    int         not null,
   equivalence_class_moderate  int         not null,

   pedigree                    varchar(50) not null,
   observation_begin_date      datetime    null,
   observation_end_date        datetime    null,
   comment                     text        null)
go

sp_bindefault cdbs_int_default, 'wfpc2_row.atodgain'
go
sp_bindefault cdbs_char_default, 'wfpc2_row.mode'
go
sp_bindefault cdbs_char_default, 'wfpc2_row.serials'
go
sp_bindefault cdbs_char_default, 'wfpc2_row.shutter'
go
sp_bindefault cdbs_int_default, 'wfpc2_row.filter1'
go
sp_bindefault cdbs_int_default, 'wfpc2_row.filter2'
go
