/*****************************************************************************/
/*                                                                           */
/*  File name :   wfpc_row.sql                                               */
/*                                                                           */
/*  Description : instrucment "wfpc" row level table                         */
/*                associated file level table : wfpc_file                    */
/*                                                                           */
/*  Note :        for any given delivery, row level data should be inserted  */
/*                to "wfpc_row" prior insert file level data to "wfpc_file"  */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  07/08/96               sk   Original                                     */
/*  02/19/97               sk   change smallint mode to int                  */
/*                                                                           */
/*****************************************************************************/
 
create table wfpc_row (
   file_name                   varchar(50) not null,
   expansion_number            int         not null,
   delivery_number             int         not null,

   /* observation_mode  */
   camera                      varchar(2)  not null,
   mode                        varchar(4)  not null,
   clock                       varchar(3)  not null,
   filter1                     int         not null,
   filter2                     int         not null,
   filtnam1                    varchar(6)  not null,
   filtnam2                    varchar(6)  not null,
   shutter                     char(1)     not null,
   photmode                    varchar(48) not null,

   /* equivalence_class */
   equivalence_class_severe    int         not null,
   equivalence_class_moderate  int         not null,

   pedigree                    varchar(50) not null,
   observation_begin_date      datetime    null,
   observation_end_date        datetime    null,
   comment                     text        null)
go

sp_bindefault cdbs_char_default, 'wfpc_row.camera'
go
sp_bindefault cdbs_char_default, 'wfpc_row.mode'
go
sp_bindefault cdbs_char_default, 'wfpc_row.clock'
go
sp_bindefault cdbs_int_default, 'wfpc_row.filter1'
go
sp_bindefault cdbs_int_default, 'wfpc_row.filter2'
go
sp_bindefault cdbs_char_default, 'wfpc_row.filtnam1'
go
sp_bindefault cdbs_char_default, 'wfpc_row.filtnam2'
go
sp_bindefault cdbs_char_default, 'wfpc_row.shutter'
go
sp_bindefault cdbs_char_default, 'wfpc_row.photmode'
go
