#include <stdlib.h>
#include "config.h"

/* BIND_QRYVARS -- Allocate and bind query variables to a list of field names
 *
 * i: db	database connection
 * i: field	database field names
 */

char **bind_qryvars (int db, char **field)
{
    int		ivar, nvar;
    char 	**value;

    /* Value is an array of character strings */

    for (ivar = 0; field[ivar][0] != EOS; ivar ++)
	;

    nvar = ivar;
    value = (char **) malloc ((nvar + 1) * sizeof (char *));

    /* Allocate one string for each field to serve as the bound variable */

    for (ivar = 0; ivar < nvar; ivar ++) {
	value[ivar] = (char *) malloc (SZ_DBFIELD+1);
	stdb_bind_string (db, field[ivar], value[ivar], SZ_DBFIELD);
    }

    /* Set the remaining location to the NULL pointer */

    value[nvar] = NULL;
    return (value);
}

/* FREE_QRYVARS -- Free memory allocated to hold bind variables
 *
 * i: value	array of bind variables
 */

void free_qryvars (char **value)
{
    int		ivar;

    for (ivar = 0; value[ivar] != NULL; ivar ++)
	free (value[ivar]);

    free (value);
}
