#include "config.h"
#include "cdbslib.h"

/* BUILD_LIST -- Add a string to the end of a comma separated list
 *
 * str		i: string to add to list
 * list		o: comma separated list of strings
 * maxch	i: maximum length of list
 */

int build_list (const char *str, char *list, int maxch)
{
    int		ic, jc, nc;

    /* Find number of non-blank chars in output string */

    for (ic = 0; str[ic] != EOS; ic ++) {
	if (str[ic] > ' ')
	    nc = ic + 1;
    }

    /* get length of list. If new string would 
     * exceed length, take error exit
     */

    jc = strlen (list);
    if (jc + nc > maxch - 3) {
	safecat (list, "...", maxch);
	return (ERR);
    }

    /* Separate string from rest of list with comma */

    if (jc > 0)
	list[jc++] = ',';

    /* Copy non-blank part of string to list */

    for (ic = 0; nc > 0; nc --) 
	list[jc++] = str[ic++];

    list[jc] = EOS;
    return (OK);
}
