/* ERRORMSG.H -- Text of error messages used by CDBS */

static char *error_msg[] = {
    "Unrecognized error code",			/* UNKNOWN */
    "Cannot open file",				/* NOTOPEN */
    "Illegal value",				/* NOMATCH */
    "Ambiguous value",				/* AMBIG */
    "Cannot determine reference file type",	/* NOLOOK */
    "Unrecognized data file type",		/* FTYPE */
    "Record not in linked list",		/* NOREC */
    "Unrecognized rule function",		/* BADFUNC */
    "Internal error: value not in list",	/* BADLIST */
    "Wrote file",				/* WFILE */
    "Column not found in catalog",		/* NOCOL */
    "Too many keywords in catalog line",	/* MAXKEY */
    "Error in date format",			/* NODATE */
    "Cannot rename file",			/* RENAME */
    "Cannot process load file",			/* NOLOAD */
    "Cannot write to file",			/* NOWRITE */
    "Unrecognized instrument name",		/* BADINST */
    "Cannot determine iraf directory",		/* NOIRAF */
    "Unrecognized reference file type",		/* BADREF */
    "Query variable not in list",		/* NOVAR */
    "Can't break query at blank",		/* QRYLEN */
    "String too long for internal buffer",	/* TOOLONG */
    "File renamed",				/* NEWNAME */
    "Wrong number of arguments to task",	/* USAGE */
    "Number of widths does not match columns",	/* BADWIDTH */
    "No throughput column found in table",	/* NOTHRU */
    "Recursive logical name translation",	/* MAXDEF */
    "No translation for logical name",		/* NOTRANS */
    "Column not found in table",		/* BADFIELD */
    "Rule file syntax error",			/* SYNTAX */
    "Match not found in throughput catalog",	/* BADTHRU */
    "Illegal value in template file field",	/* BADRULE */
    "Unknown extension for reference file",	/* BADEXT */
    "Cannot read file as its supposed type",	/* BADTYPE */
    "Could not match keywords in header",	/* BADKEY */
    "Header keyword not found in file",		/* NOHDRKEY */
    "Cannot get number of rows in file",	/* BADNROW */
    "File has already been expanded",		/* EXPANDED */
    "Contained file can't be renamed",		/* NOCHILD */
    "Can't generate unique file name",		/* NONUNIQ */
    "Can't modify filenames in file",		/* NOSETNAM */
    "No rows matched in database table",	/* NODBROWS */
    "CDBS task installation date",		/* VERSION */
    "Option name not recognized",		/* NOOPT */
    "Could not parse option",			/* BADOPT */
    "Only one observation may be queried",	/* MULTIREF */
    "Cannot pass file name list as an arg",	/* NOLIST */
    "Syntax error in query format",		/* BADQRYFMT */
    "Can't get instrument from file name",	/* NOICODE */
    "Observation mode not found in list",	/* NOMODE */
    "Root name not found in database",		/* NOROOT */
    "Reference file not found in database",	/* NOREFFILE */
    "Too many arguments on command line",	/* EXTRAPAR */
    "Can't add column to table",		/* NOADDCOL */
    "Database table column name is ambiguous",	/* AMGIGCOL */
    "No translation for string in dictionary",	/* NODICT */
    "Closing quote missing from string",	/* NOQUOTE */
    "Closing dot missing from operator",	/* NODOT */
    "Too many database tables in query",	/* MANYTAB */
    "Database columns not found"		/* NODBCOLS */
};
