#include "config.h"
#include "cdbslib.h"

/* PATHNAME -- Put a directory from one filename on a second 
 *
 * o: ofile	output filename 
 * i: ifile1	first input filename
 * i: ifile2	second input filename
 * i: maxch	length of filenames
 */

void pathname (char *ofile, const char *ifile1, const char *ifile2, int maxch)
{
    char	dir[SZ_FNAME+1], root[SZ_FNAME+1], ext[SZ_FNAME+1];

    breakfname (ifile2, dir, root, ext, SZ_FNAME);

    if (dir[0] != EOS) {
	safecopy (ofile, ifile2, maxch);

    } else {
	breakfname (ifile1, dir, root, ext, SZ_FNAME);

	safecopy (ofile, dir, maxch);
	safecat (ofile, ifile2, maxch);
    }
}
