#include "config.h"
#include "error.h"
#include "cdbslib.h"

/* STRXTRACT -- Extract a substring from a dictionary string
 *
 * i: dict	list of strings separated by pipe chars
 * i: index	subtring to extract (one indexed)
 */

char * strxtract (char *dict, int index) 
{
    static char		buffer[SZ_STRING+1];
    int			ic, jc, idict;

    /* Count separation chars and start copying when index is reached */

    jc = 0;
    idict = 1;
    for (ic = 0; dict[ic] != EOS && idict <= index; ic ++) {
        if (dict[ic] == '|') {
	    idict ++;

        } else if (idict == index && jc < SZ_STRING) {
	    buffer[jc++] = dict[ic];
	}
    }

    buffer[jc] = EOS;

    /* Send error message if no match found */

    if (jc == 0)
        cdbs_error (BADLIST, "%d", index);

    return (buffer);
}
