#include "loadfile.h"
#include "config.h"
#include "datafile.h"
#include "cdbslib.h"
#include "certify.h"
#include "template.h"

/* TASK -- Driver for the certify task 
 *
 * i: argc	number of task arguments
 * o: argv	array of pointers to task arguments
 */

/* This task is dedicated to Rob McCool, author of the Mosaic server,
 * who wrote of the server, "Early on, I decided not to document things." 
 * Rob is now getting big bucks from Netscape, showing God smiles on
 * computer hackers.
 */

void task (int argc, char ** argv)
{
    char	catalog[] = CATALOG_NAME;
    char	catcols[] = CATALOG_COLS;
    table	*look;
    tpl_file	*oldtpl;
    int		iarg;

    look = open_lookup (catalog, catcols);

    /* The template is cached in oldtpl, to keep from opening the template
     * file on each call of certify. Oldtpl is initially set to null to
     * show the cache is empty. After finishing the task, the cached
     * template must be freed
     */

    oldtpl = NULL;
    for (iarg = 1; iarg < argc; iarg ++) {
	 if (is_datafile (argv[iarg]) == NO)
	      certify (look, argv[iarg], oldtpl);
    }

    close_template (oldtpl);
    close_lookup (look);
}

