#! /bin/sh
isql -S$CDBS_SERVER << EOF 
use $CDBS_DB
go

/* Check all no two deliveries with same instrument and */
/* reference_file_type have unset opus_load_dates */

if  exists (select * from $1_file 
            where opus_load_date is null and opus_flag = "Y"
               group by reference_file_type
               having count (*) > 1 and opus_load_date is null
               and count (distinct delivery_number) > 1)
begin
 print "-> CDBS ERROR:"
 print "->  Two or more deliveries for instrument $1 have unset opus_load_dates"
 print "->  with the same reference_file_type."
 print "->      file name                                          delivery_number"
 select distinct "->", file_name, delivery_number 
         from $1_file f
         where opus_load_date is null and opus_flag = "Y"
               group by reference_file_type
               having count (*) > 1 and opus_load_date is null
               and count (distinct delivery_number) > 1
 print "->"
end
go
