#! /bin/sh
isql -S$CDBS_SERVER << EOF 
use $CDBS_DB
go

/* Check that no deliveries have unset opus_load_dates */

if  exists (select * from $1_file 
            where opus_load_date is null and 
                  opus_flag = "Y" and 
                  delivery_number < $2)
begin
 print "-> CDBS WARNING:"
 print "->  OPUS load date not set in previous $1 delivery"
 print "->      file name                                          delivery_number"
 select distinct "->", file_name, delivery_number 
         from $1_file f
         where opus_load_date is null and 
               opus_flag = "Y" and 
               delivery_number < $2
 print "->"
end
go
