#! /bin/sh
isql -S$CDBS_SERVER << EOF 
use $CDBS_DB
go

/* Check that the last delivery, if a foc-uni delivery, has */
/* all uni files listed in the unitab file and has all uni files */
/* in some unitab file. */

if exists (select * from foc_file 
            where delivery_number = $1 
              and (reference_file_type = "UNITAB" or
                   reference_file_type = "UNI" ) )
begin
print "UNI or TAB"
if  exists (select * from foc_row, foc_file 
            where foc_row.delivery_number = $1
             and reference_file_type = "UNITAB" 
             and foc_row.file_name = foc_file.file_name
             and foc_row.expansion_number = foc_file.expansion_number
             and foc_row.uni_file_name not in (select file_name from foc_row) )
begin
 print "-> CDBS ERROR:"
 print "->  UNITAB file references a missing UNI file."
 print "->           unitab file name            uni_file_name"
 select "->"+" "+foc_row.file_name+"     "+foc_row.uni_file_name 
           from foc_row, foc_file 
            where foc_row.delivery_number = $1
             and reference_file_type = "UNITAB" 
             and foc_row.file_name = foc_file.file_name
             and foc_row.expansion_number = foc_file.expansion_number
             and foc_row.uni_file_name not in (select file_name from foc_row) 
 print "->"
end

if  exists (select * from foc_file fi, foc_row fr
             where fi.reference_file_type = "UNI" 
               and fr.file_name = fi.file_name
               and fr.expansion_number = fi.expansion_number
               and fr.delivery_number = $1
               and fr.file_name 
                   not in (select uni_file_name from foc_row
                               where delivery_number = $1) )
begin
 print "-> CDBS ERROR:"
 print "->  UNI file(s) not used in a UNITAB file for current delivery."
 print "->  uni file name "
 select "->"+" "+fr.file_name
             from foc_file fi, foc_row fr
             where fi.reference_file_type = "UNI" 
               and fr.file_name = fi.file_name
               and fr.expansion_number = fi.expansion_number
               and fr.delivery_number = $1
               and fr.file_name 
                   not in (select uni_file_name from foc_row
                               where delivery_number = $1) 
 print "->"
end

end
go
