#! /bin/csh
set err = 0
# Look at each load file in the current directory
foreach file (*.lod)
  echo "load file: $file"
 # Rename the load file
  set ft = $file"_tmp"
  mv -f $file $ft

 # Determine the data file name
  set head_fn = `awk -f $CDBS_TOP/src/check_load/awk.fits $ft | tr A-Z a-z`
  echo "header file: $head_fn"
  if ( `echo $head_fn | wc -l` == 0) then
   echo "CDBS ERROR: No header file name found in $file"
   mv -f $ft $file
   set err = 1
   goto jump
  endif

  if ( ! -e $head_fn) then
   echo "CDBS ERROR: No header file $head_fn found"
   mv -f $ft $file
   set err = 1
   goto jump
  endif

 # Run mkload
  $CDBS_TOP/bin/mkload $head_fn 

  if ( ! -e $file) then
   echo "CDBS ERROR: New load file $file not found"
   mv -f $ft $file
   set err = 1
   goto jump
  endif

 # Swap the file names
  mv -f $file $file"_tmp1"
  mv -f $ft $file
  mv -f $file"_tmp1" $ft

  set file_save = N
 # Compare the file names
  diff -iw $file $ft > diff.tmp

  if ( `grep "FILE_NAME =" diff.tmp | wc -l` != 0) then
    echo "CDBS ERROR: Header file names do not match. See files $file and $ft"
    set err = 1
    set file_save = Y
  endif

 # Compare the instruments
  if ( `grep "INSTRUMENT =" diff.tmp | wc -l` != 0) then
    echo "CDBS ERROR: Instruments do not match. See files $file and $ft"
    set err = 1
    set file_save = Y
  endif

 # Compare the file types
  if ( `grep "REFERENCE_FILE_TYPE =" diff.tmp | wc -l` != 0) then
    echo "CDBS ERROR: reference_file_types do not match. See files $file and $ft"
    set err = 1
    set file_save = Y
  endif

 # Compare the useafter dates
  if ( `grep "USEAFTER_DATE =" diff.tmp | wc -l` != 0) then
    echo "CDBS ERROR: Useafter dates do not match. See files $file and $ft"
    set err = 1
    set file_save = Y
  endif
  
  rm diff.tmp
  if ($file_save == "N") then
   rm $ft
   echo "no differences for file $file"
  endif

jump:
end
exit $err
