#! /bin/csh
echo "-----------------"

 # create a subdirectory to run the test
if ( ! -e load_file_test_d) then
   mkdir load_file_test_d
endif
cd load_file_test_d

# Look at each load file in the upper current directory
foreach file (../*.lod)
  echo "load file: $file"

 # Determine the data file name
  set head_fn = `awk -f $CDBS_TOP/src/check_load/awk.fits $file | tr A-Z a-z`
  echo "header file: $head_fn"
  if ( `echo $head_fn | wc -l` == 0) then
   echo "CDBS ERROR: No header file name found in $file"
   exit 1
  endif

  if ( ! -e ../$head_fn) then
   echo "CDBS ERROR: No header file ../$head_fn found"
   exit 1
  endif

 # Run mkload
  $CDBS_TOP/bin/mkload ../$head_fn 

  if ( ! -e load_file_test_d/$file) then
   echo "CDBS ERROR: New load file load_file_test_d/$file not found"
   exit 1
  endif

  set file_save = N
 # Compare the file names
  diff -iw $file load_file_test_d/$file > diff.tmp

  if ( `grep "FILE_NAME =" diff.tmp | wc -l` != 0) then
    echo "CDBS ERROR: Header file names do not match. See files $file and load_file_test_d/$file"
    set file_save = Y
  endif

 # Compare the instruments
  if ( `grep "INSTRUMENT =" diff.tmp | wc -l` != 0) then
    echo "CDBS ERROR: Instruments do not match. See files $file and load_file_test_d/$file"
    set file_save = Y
  endif

 # Compare the file types
  if ( `grep "REFERENCE_FILE_TYPE =" diff.tmp | wc -l` != 0) then
    echo "CDBS ERROR: reference_file_types do not match. See files $file and load_file_test_d/$file"
    set file_save = Y
  endif

 # Compare the useafter dates
  if ( `grep "USEAFTER_DATE =" diff.tmp | wc -l` != 0) then
    echo "CDBS ERROR: Useafter dates do not match. See files $file and load_file_test_d/$file"
    set file_save = Y
  endif
  
  rm diff.tmp
  if ($file_save == "N") then
   rm load_file_test_d/$file
   echo "no differences for file $file"
   exit 0
  else
   exit 1
  endif

end

