#! /bin/sh
DSQUERY=$CDBS_SERVER
isql -S$CDBS_SERVER << EOF 
use $1
go

/* Run the stored procedure to delete the delivery */
begin transaction

  declare @number int

  select @number = value from delivery_number
  print "Delivery number =  %1!", @number
  
  delete from opus_log where delivery_number = @number

  delete foc_row from foc_row, foc_file 
    where 
    foc_row.expansion_number = foc_file.expansion_number and
    foc_row.file_name = foc_file.file_name and
    foc_file.delivery_number = @number

  delete from foc_file where delivery_number = @number

  update foc_file 
    set reject_flag = "N", reject_delivery_number=null,
        reject_by_file_name = null, reject_by_expansion_number = null
        where reject_delivery_number = @number

  delete hsp_row from hsp_row, hsp_file 
    where 
    hsp_row.expansion_number = hsp_file.expansion_number and
    hsp_row.file_name = hsp_file.file_name and
    hsp_file.delivery_number = @number

  delete from hsp_file where delivery_number = @number

  update hsp_file 
    set reject_flag = "N", reject_delivery_number=null,
        reject_by_file_name = null, reject_by_expansion_number = null
        where reject_delivery_number = @number

  delete fos_row from fos_row, fos_file 
    where 
    fos_row.expansion_number = fos_file.expansion_number and
    fos_row.file_name = fos_file.file_name and
    fos_file.delivery_number = @number

  delete from fos_file where delivery_number = @number

  update fos_file 
    set reject_flag = "N", reject_delivery_number=null,
        reject_by_file_name = null, reject_by_expansion_number = null
        where reject_delivery_number = @number

  delete hrs_row from hrs_row, hrs_file 
    where 
    hrs_row.expansion_number = hrs_file.expansion_number and
    hrs_row.file_name = hrs_file.file_name and
    hrs_file.delivery_number = @number

  delete from hrs_file where delivery_number = @number

  update hrs_file 
    set reject_flag = "N", reject_delivery_number=null,
        reject_by_file_name = null, reject_by_expansion_number = null
        where reject_delivery_number = @number

  delete wfpc2_row from wfpc2_row, wfpc2_file 
    where 
    wfpc2_row.expansion_number = wfpc2_file.expansion_number and
    wfpc2_row.file_name = wfpc2_file.file_name and
    wfpc2_file.delivery_number = @number

  delete from wfpc2_file where delivery_number = @number

  update wfpc2_file 
    set reject_flag = "N", reject_delivery_number=null,
        reject_by_file_name = null, reject_by_expansion_number = null
        where reject_delivery_number = @number

  delete wfpc_row from wfpc_row, wfpc_file 
    where 
    wfpc_row.expansion_number = wfpc_file.expansion_number and
    wfpc_row.file_name = wfpc_file.file_name and
    wfpc_file.delivery_number = @number

  delete from wfpc_file where delivery_number = @number

  update wfpc_file 
    set reject_flag = "N", reject_delivery_number=null,
        reject_by_file_name = null, reject_by_expansion_number = null
        where reject_delivery_number = @number

  delete stis_row from stis_row, stis_file 
    where 
    stis_row.expansion_number = stis_file.expansion_number and
    stis_row.file_name = stis_file.file_name and
    stis_file.delivery_number = @number

  delete from stis_file where delivery_number = @number

  update stis_file 
    set reject_flag = "N", reject_delivery_number=null,
        reject_by_file_name = null, reject_by_expansion_number = null
        where reject_delivery_number = @number

  delete nic_row from nic_row, nic_file 
    where 
    nic_row.expansion_number = nic_file.expansion_number and
    nic_row.file_name = nic_file.file_name and
    nic_file.delivery_number = @number

  delete from nic_file where delivery_number = @number

  update nic_file 
    set reject_flag = "N", reject_delivery_number=null,
        reject_by_file_name = null, reject_by_expansion_number = null
        where reject_delivery_number = @number

  delete synphot_row from synphot_row, synphot_file 
    where 
    synphot_row.expansion_number = synphot_file.expansion_number and
    synphot_row.file_name = synphot_file.file_name and
    synphot_file.delivery_number = @number

  delete from synphot_file where delivery_number = @number

  update synphot_file 
    set reject_flag = "N", reject_delivery_number=null,
        reject_by_file_name = null, reject_by_expansion_number = null
        where reject_delivery_number = @number

  delete multi_row from multi_row, multi_file 
    where 
    multi_row.expansion_number = multi_file.expansion_number and
    multi_row.file_name = multi_file.file_name and
    multi_file.delivery_number = @number

  delete from multi_file where delivery_number = @number

  update multi_file 
    set reject_flag = "N", reject_delivery_number=null,
        reject_by_file_name = null, reject_by_expansion_number = null
        where reject_delivery_number = @number

  print "Delivery number %1! has been deleted from the database", @number

commit transaction
go



