#! /bin/sh
export CDBS_SERVER CDBS_DB

echo "starting deliver_cdbs"
echo "database " ${CDBS_DB?"CDBS_ERROR: CDBS_DB is undefined"}
echo "server " ${CDBS_SERVER?"CDBS_ERROR: CDBS_SERVER is undefined"}
date

od=1
for task in certify_delivery loopfits_delivery fitsverify_delivery \
           check_load cdbs_sql_gen run_delivery_sql check_cdbs \
            opus_sql_gen  update_ga_date opus_catalog 
  do 
   echo "---------------------------------------------"
   if [ \( "$task" = opus_sql_gen \) ]
   then
    od=`$CDBS_TOP/src/deliver_cdbs/opus_count.s | \
    awk -f $CDBS_TOP/src/deliver_cdbs/awk.oc`
    if test $od -eq 0
      then
       echo "no files being delivered to opus"
       echo "---------------------------------------------"
    fi
   fi

   if [ "$od" -eq 0 -a \( \( "$task" = opus_sql_gen \) -o \( "$task" = opus_catalog \) \) ]
   then
     echo "omitting $task"
   else
     $CDBS_TOP/bin/$task

     if test $? -ne 0
     then
       echo "CDBS ERROR: $task failure. Exiting."
       exit 1
     fi
     echo "$task succeeded"
   fi
  done

echo "---------------------------------------------"
echo "deliver_cdbs completed"
date
echo " "
echo "total execution times:"
exit 0

