#include "config.h"
#include "cdbslib.h"
#include "loadfile.h"
#include "expload.h"

#define  MAXLIST	5

/* COPY_LAYOUT -- Copy column names from one table to another
 *
 * i: itab	table copied from
 * u: otab	table copied to
 * i: newcols	additional column names for table
 */

void copy_layout (table *itab, table *otab, char *newcols)
{
    int		icol;
    char	*newlist, *colname[MAXLIST];

    /* Copy column names from input to output table */

    for (icol = 0; icol < ncol_table(itab); icol ++) {
        colname[0] = get_tab_colname (itab, icol);
	add_tab_col (otab, colname[0]);
    }

    /* Add new column names from third argument */

    newlist = strclone (newcols);
    strsplit (',', newlist, colname, MAXLIST);

    for (icol = 0; colname[icol][0] != EOS; icol ++)
        add_tab_col (otab, colname[icol]);

    free (newlist);
}
