#include "config.h"
#include "cdbslib.h"
#include "loadfile.h"
#include "expload.h"

/* MOVE_TABROW -- Move non-blank, non-control columns from one table to another
 *
 * i: itab	input table descriptor
 * i: irow	input table row
 * o: otab	output table descriptor
 * i: orow	output table row
 */

void move_tabrow (table *itab, int irow, table *otab, int orow)
{
    int		icol;
    char	*colname, *colval, *colname2, *colval2;

    for (icol = 0; icol < ncol_table(itab); icol ++) {
        /* Check to see if value is blank */

	colval = get_tab_cell_bynum (itab, icol, irow);
	if (colval[0] != EOS) {
	    colname = get_tab_colname (itab, icol);

	    /* Control columns start with a leading underscore */

	    if (colname[0] != '_') {

	        /* Copy from input table if column is found in output table */

	        if (get_tab_colnum (otab, colname) != BAD) {
	            colval = get_tab_cell (itab, colname, irow);

		    /* Temporary string copies are necessary because
		     * when the output and input tables are the same
		     * table, doing the put may invalidate the pointers
		     */

		    if (itab != otab) {
		        put_tab_cell (otab, colname, orow, colval);

		    } else {
		        colname2 = strclone (colname);
			colval2 = strclone (colval);

			put_tab_cell (otab, colname2, orow, colval2);

			free (colname2);
			free (colval2);
		    }
		}
	    }
	}
    }
}
