#include <stdio.h>
#include "error.h"
#include "system.h"
#include "cdbslib.h"
#include "expload.h"

/* OPEN_RULES -- Open the rules file
 * 
 * rules	i: rules file name
 */

FILE *open_rules (char *rules)
{
    FILE	*fd;
    char	dir[SZ_FNAME+1], root[SZ_FNAME+1], ext[SZ_FNAME+1];
    char	fname[SZ_FNAME+1];

    /* First, look for rules file under its original name */

    fd = fopen (rules, "r");

    /* If it's not there and the filename does not have a directory on it
     * look in the data directory for the rules file
     */

    if (fd == NULL) {
	breakfname (rules, dir, root, ext, SZ_FNAME);
	if (dir[0] == EOS) {
	    safecopy (fname, DATADIR, SZ_FNAME);
	    safecat (fname, rules, SZ_FNAME);

	    fd = fopen (fname, "r");
	}
    }

    if (fd == NULL)
	cdbs_error (NOTOPEN, "%s", rules);

    return (fd);
}
