#include <string.h>
#include "getobsmode.h"

/* GETWFPC2MODE -- Get the observation mode for a wfpc2 observation
 *
 * This code is Based on wfpc$calwp2/u_phot.x and should track 
 * changes in it.
 *
 * i: root	observation rootname
 * o: obsmode	observation mode
 */

void getwfpc2mode (char *root, char *obsmode)
{
    int		atodgain;
    char	filter1[SZ_FIELD+1], filter2[SZ_FIELD+1];

    /* Get observation mode fields from the database */

    if (qrywfpc2mode (root, &atodgain, filter1, filter2) == NOMATCH) {
	obsmode[0] = '\0';

    } else {
	strcpy (obsmode, "WFPC2,");

	/* Convert the gain from a number to a keyword */

	if (atodgain == 7)
	    strcat (obsmode, "A2D7");
	else if (atodgain == 15)
	    strcat (obsmode, "A2D15");
	else
	    strcat (obsmode, "A2D7");

	/* Add the filters, if present. For the linear ramp filter,
	 * add a pseudo-wavelength
	 */

	if (filter1[0] != '\0') {
	    strcat (obsmode, ",");
	    strcat (obsmode, filter1);
	    if (strcmp (filter1, "LRF") == 0) 
		strcat (obsmode ,"#5000");
	}

	if (filter2[0] != '\0') {
	    strcat (obsmode, ",");
	    strcat (obsmode, filter2);
	    if (strcmp (filter2, "LRF") == 0) 
		strcat (obsmode ,"#5000");
	}

	/* Add calibration keyword */

	strcat (obsmode, ",CAL");
    }
}

