#include <string.h>
#include "getobsmode.h"

/* GETWFPCMODE -- Get the observation mode for a wfpc observation
 *
 * This code is based on wfpc$calwfp/w_phot.x and should track
 * changes in it
 *
 * i: root	observation rootname
 * o: obsmode	observation mode
 */

void getwfpcmode (char *root, char *obsmode)
{
    int		filter1, filter2;
    char	camera[SZ_FIELD+1];

    char	*filtname[] = { "", "F122M", "F157W", "F194W", "F230W",
    "F284W", "F336W", "F439W", "F569W", "F675W", "F791W", "F850LP", "F606W",
    "F725LP", "F128LP", "F673N", "F8ND", "POL0", "POL60", "POL120", "G200L",
    "G450L", "G800L", "F702W", "F368M", "F413M", "F622W", "F492M", "F547M",
    "F555W", "F648M", "F718M", "F814W", "F875M", "F785LP", "F1042M", "F375N",
    "F469N", "F437N", "F487M", "F502N", "F517N", "F588N", "F631N", "F656N",
    "F664N", "F889N", "F1083N", "F658N" };

    if (qrywfpcmode (root, camera, &filter1, &filter2) == NOMATCH) {
	obsmode[0] = '\0';

    } else {
	/* Set the keywords which do not change */

	strcpy (obsmode, "WFPC,DN,CAL");

	/* Add the filters, if present */

	if (filter1 != 0) {
	    strcat (obsmode, ",");
	    strcat (obsmode, filtname[filter1]);
	}

	if (filter2 != 0) {
	    strcat (obsmode, ",");
	    strcat (obsmode, filtname[filter2]);
	}

	/* Add the camera last */

	strcat (obsmode, ",");
	strcat (obsmode, camera);
    }
}

