#include <string.h>
#include "ostdb.h"
#include "getobsmode.h"

/* QRYHSPMODE -- Query the database for the hsp observation mode fields
 *
 * i: root	observation rootname
 * o: detector	detector used
 * o: aperture	aperture used
 */

int qryhspmode (char *root, int *detector, char *aperture)
{
    int		status;
    char	query[SZ_COMMAND+1];

    char	qryformat[] = "select a.hpr_detectob, a.hpr_apertobj from "
	"hsp_ref_data a where a.hpr_data_set_name = '%s'\n";

    /* Start query and bind output variables */

    ostdb_query_setup (OBS_CHANNEL, "qryhspmode", 1, STDB_SQL,  
		       OBS_SERVER, OBS_DBNAME, NULL);

    stdb_bind_int (OBS_CHANNEL, "hpr_detectob", detector);
    stdb_bind_string (OBS_CHANNEL, "hpr_apertobj", aperture, SZ_FIELD);

    /* Build query */

    sprintf (query, qryformat, root);
    stdb_query (OBS_CHANNEL, query);
    
    /* Execute query, saving results in bound variables */

    if (ostdb_get_exec(OBS_CHANNEL) == STDB_CONTINUE) {
	trim_qryfield (aperture);
	status = MATCH;
    } else {
	status = NOMATCH;
    }

    /* Clean up after query */

    stdb_close_query (OBS_CHANNEL);
    return (status);
}
