#include "dbquery.h"
#include "error.h"
#include "cdbslib.h"
#include "loadfile.h"
#include "getref.h"

/* GETREF_ONE -- Provide detailed information about a single reference file
 *
 */

table *getref_one (void) 
{
    context	*qry;
    table	*tab;
    char	*root, *reffile;
    char	*cdbsname[MAXMODE], *dadsname[MAXMODE];

    qry = init_query ();

    /* Read task arguments */

    root = get_option ("root");
    reffile = get_option ("reffile");

    /* Get observation mode field names */

    qry_obsmode (qry, reffile, cdbsname, dadsname, MAXMODE);

    /* Perform different queries depending on whether : */

    if (cdbsname[0][0] == EOS) {
	/* There are no mode fields for this table */
	tab = qry_nomode (qry, root, reffile);

    } else if (root[0] == EOS) {
	/* The observation set is unknown */
	tab = qry_noroot (qry, reffile, cdbsname);

    } else {
	/* We know the observation set and have a mode */
	tab = qry_hasroot (qry, root, reffile, cdbsname, dadsname);
	if (nrow_table (tab) == 0) {
	    /* We cannot match on the mode */
	    free_table (tab);
	    tab = qry_noroot (qry, reffile, cdbsname);
	}
    }

    free_query (qry);

    if (nrow_table (tab) == 0)
	cdbs_error (NOREFFILE, "%s", reffile);

    return (tab);
}
