#include <stdarg.h>
#include <stdio.h>
#include <time.h>
#include "config.h"
#include "cdbslib.h"

#define  MKLOG		YES
#define  LOGFILE	"/tmp/bsimon/getreflog.txt"

/* HTML_LOG -- Log messages for html
 *
 * i: fmt	print format
 */

void html_log (const char *fmt, ...)
{
    va_list	ptr;
    time_t	now;
    static FILE *log;
    char	message[SZ_LINE+1];

    /* Bypass logger if define not set */

    if (MKLOG != YES)
	return;

    /* Open log file and print header */

    if (log == NULL) {
	log = fopen (LOGFILE, "a");

	now = time (NULL);
	safecopy (message, ctime (&now), SZ_LINE);
	strclean (message);

	fprintf (log, "== %s ==\n", message);
    }

    /* Format message arguments as a string */

    va_start (ptr, fmt);
    vsprintf (message, fmt, ptr);
    va_end (ptr);

    /* Write message to log file */

    fprintf (log, "%s\n", message);

}

