#include <stdio.h>
#include "loadfile.h"
#include "getref.h"

static char *	html_vname (FILE *);

/* HTML_TEMPLATE -- Print html template file, pausing when a variable is found
 *
 * i: fp	template file descriptor
 */

char * html_template (FILE *fp)
{
    int		ch, ic, jc;
    char	*start_var = "<!-- $";

/* Look for the start of the variable name. When it's found, 
 * scarf up the name and spit it back at the caller
 */

    ic = 0;
    while ((ch = getc (fp)) != EOF) {
	if (ch != start_var[ic]) {
	    /* Print out chars that were matched so far */
	    for (jc = 0; jc < ic; jc ++)
		putchar (start_var[jc]);

	    putchar (ch);
	    ic = 0;

	} else if (start_var[++ic] == EOS) {
	    /* Match was successful, so get variable name */
	    return (html_vname (fp));
	}
    }

    for (jc = 0; jc < ic; jc ++)
	putchar (start_var[jc]);

    return (NULL);
}

/* HTML_TEMPLATE -- Read variable name from template file
 *
 * i: fp	template file descriptor
 */

static char * html_vname (FILE *fp)
{
    int		ch, ic, jc, kc;
    char	*end_var = "-->";

    static char	buffer[SZ_LINE+1];

    ic = kc = 0;
    while ((ch = getc (fp)) != EOF) {
	/* Accumulate characters until end of the comment is seen */
	if (ch != end_var[ic]) {
	    for (jc = 0; jc < ic; jc ++) {
		if (kc < SZ_LINE)
		    buffer[kc++] = end_var[jc];
	    }

	    ic = 0;
	    if (kc < SZ_LINE)
		buffer[kc++] = ch;

	} else if (end_var[++ic] == EOS) {
	    /* Matched end of comment, trim blanks and return name */
	    buffer[kc] = EOS;
	    strclean (buffer);
	    return (buffer);
	}
    }

    return (NULL);
}
