#include <string.h>
#include "config.h"
#include "loadfile.h"
#include "cdbslib.h"
#include "getref.h"

/* OUTPUT_ASC -- Produce ascii output from a table
 *
 * i: tab	table descriptor
 */

void output_asc (table *tab)
{
    char	*value;
    static char	*quotes = "\"\"";
    int		*colwidth;
    int		html, icol, irow, width;

    if (tab == NULL)
	return;

    /* Calculate the width of the widest column */

    colwidth = (int *) malloc (ncol_table(tab) * sizeof (int));

    for (icol = 0; icol < ncol_table (tab); icol ++) {
	colwidth[icol] = strlen (get_tab_colname (tab, icol)) + 1;
	if (icol == 0)
	    colwidth[icol] += 1;

	for (irow = 0; irow < nrow_table(tab); irow ++) {
	    width = strlen (get_tab_cell_bynum (tab, icol, irow)) + 1;
	    if (width > colwidth[icol])
		colwidth[icol] = width;
	}
    }

    /* Print the html response header if called as a cgi script */

    html = yorn (get_option ("HTML"));
    if (html == YES)
	printf ("Content-type: text/plain\n\n");

    /* Print the title line */

    printf ("#");
    colwidth[0] -= 1;

    for (icol = 0; icol < ncol_table(tab); icol ++)
	printf ("%-*s", colwidth[icol], get_tab_colname (tab, icol));
    printf ("\n");

    /* Print the cells in the table */

    colwidth[0] += 1;
    for (irow = 0; irow < nrow_table(tab); irow ++) {
	for (icol = 0; icol < ncol_table(tab); icol ++) {
	    value = get_tab_cell_bynum (tab, icol, irow);
	    if (value[0] == EOS)
		value = quotes;

	    printf ("%-*s", colwidth[icol], value);
	}
	printf ("\n");
    }

    free (colwidth);
}
