#include <string.h>
#include "error.h"
#include "config.h"
#include "cdbslib.h"
#include "getref.h"

/* WHICH_QRY -- Determine which type of query the user is asking for
 *
 */

int which_qry (void)
{
    int		html, qry;
    char	*root, *reffile;

    /* Get task parameters from options list */

    html = yorn (get_option ("HTML"));
    root = get_option ("root");
    reffile = get_option ("reffile");

    /* Set query according to value of reffile */

    if (reffile[0] == EOS) {
	if (root[0] == EOS) {
	    qry = NOREF;
	} else {
	    qry = ALLREF;
	}

    } else {
	qry = ONEREF;
    }

    /* Check for illegal combinations of options */

    if ((html == YES || qry == ONEREF) && root[0] == '@')
	cdbs_error (NOLIST, "%s", root);

    if (qry == ONEREF && strchr (root, ',') != NULL)
	cdbs_error (MULTIREF, "%s", root);

    return (qry);
}
