/* CONFIG.H -- CDBS configurable constants */

#ifndef  CONFIG_H
#define  CONFIG_H

#ifdef   SZ_FNAME
#undef   SZ_FNAME
#endif

#ifdef   SZ_LINE
#undef   SZ_LINE
#endif

#define  EOS		'\0'	/* end of string marker */
#define  ERR		(-1)	/* status indicating error return */
#define  OK		0	/* status indicating no error */
#define  NO		0	/* boolean return value */
#define  YES		1	/* boolean return value */

#define  MAXPARAM	2000	/* max command line parameters */
#define  SZ_STRING	63	/* max length typical string */
#define  SZ_FNAME	127	/* max filename length */
#define  SZ_LINE	511	/* max input line length */
#define  SZ_QRYLINE	60	/* max query line length */
#define  SZ_DBFIELD	255	/* max length of db string field */

/* The columns in the catalog file */

#define  CATALOG_COLS	"instrument,reftype,filetype,tplfile,extension,keyword"

/* The list of possible wildcard values in observation mode fields */

#define  WILDCARD_LIST   "-1|any"

/* The list of instrument keywords, as read from the first column
 * of catalog file and the associated code letters.
 */

#define  INSTRUMENTS	"foc|fos|hrs|hsp|nic|stis|synphot|wfpc2|wfpc"
#define  ICODES		"xyzvnomuw"

#define  NO_INST	0
#define  FOC		1
#define  FOS		2
#define  HRS		3
#define  HSP		4
#define  NIC		5
#define  STIS		6
#define  SYNPHOT	7
#define  WFPC2		8
#define  WFPC		9

#endif
