#include <stdlib.h>
#include "config.h"
#include "cdbslib.h"
#include "loadfile.h"
#include "mkcomptab.h"

/* INIT_COMPTAB -- Set up the header and columns of the component tavle
 *
 * u: comptab	component table descriptor
 */

void init_comptab (char *tabcols, table *comptab)
{
    double	mjd;
    int		icol;
    char	*tablist, *colname[NCOL_COMPTAB];
    char	date[SZ_STRING+1], history[SZ_STRING+1];

    static char *comment =
	"The lookup table for the HST component throughputs";

    /* Write header keywords */

    put_tab_key (comptab, "INSTRUME", "HST");
    put_tab_key (comptab, "DBTABLE", "CRCOMPLIST");
    put_tab_key (comptab, "DESCRIP", comment);

    /* Including time file was created */

    mjd = get_now();
    put_sybase_date (mjd, date, SZ_STRING);

    safecopy (history, "Created on ", SZ_STRING);
    safecat (history, date, SZ_STRING);

    put_tab_key (comptab, "HISTORY", history);

    /* Add table columns */

    tablist = strclone (tabcols);
    strsplit (',', tablist, colname, NCOL_COMPTAB);

    for (icol = 0; icol < NCOL_COMPTAB; icol ++)
	add_tab_col (comptab, colname[icol]);

    free (tablist);
}
