#include "error.h"
#include "config.h"
#include "loadfile.h"
#include "cdbslib.h"
#include "mkcomptab.h"

/* MKCOMPTAB -- Create a loadfile table containing component lookup info
 *
 * u: comptab	component lookup table
 */

void mkcomptab (table *comptab)
{
    char	*date;
    char	useafter[SZ_STRING+1];
    double	time;
    static char	*dbcols = DBCOL_COMPTAB;
    static char *tabcols = CNAME_COMPTAB;

    /* Set up the table columns and header keywords */

    init_comptab (tabcols, comptab);

    /* Get the useafter date and store it in the alist */

    date = get_option ("date");

    if (date[0] == EOS) {
	time = get_now ();
    } else {
	time = get_dash_date (date);
    }

    if (time < 0.0) 
	cdbs_error (NODATE, "%s", date);

    put_sybase_date (time, useafter, SZ_STRING);

    /* Read the throughput table names into the component table */

    comptab_qry (useafter, NCOL_COMPTAB, dbcols, tabcols, comptab);

    /* Update component name from throughput column names */

    update_comp (comptab);
}
