/* OBSMODE.C -- Definition of HST observation mode variables */

#ifndef  OBSMODE_C
#define  OBSMODE_C

#include "config.h"

/* The list of instrument keywords, as read from cdbscatalog.dat */

char *hstlist = INSTRUMENTS;

/* The names of the observation mode keywords, 
 * as they occur in the database
 */

char *db_obsmode[10][15] = {
{"optcrly", "pxformt", "optelt1", "optelt2", "sampoff", 
 "samppln", "lineoff", "linepfm", "cammode", "smmmode", 
 "wavelength", "",     "",        "",        ""},
 
{"detector", "overscan", "aper_id", "aper_pos", "polar_id", 
 "fgwa_id",  "pass_dir", "fchnl",   "nxsteps",  "", 
   "",           "",     "",        "",     ""},

{"detector", "grating", "aperture", "sporder", "", 
 "",         "",         "",        "",        "",
  "",         "",         "",        "",        ""},

{"aper_name", "det_num", "type", "voltage", "vgaind", 
 "data_fmt",  "mode",    "thresh", "",      "",
  "",          "",        "",        "",     ""},

{"mode", "", "", "", "",
 "",     "", "", "", "",
  "",     "", "", "", ""},

{"camera",   "filter", "readout", "nread", "",
 "",	   "",       "",         "",  "",
  "",       "",       "",         "",  ""},

{"detector",  "ccdamp",  "ccdgain",   " opt_elem",  "obstype", 
 "aperture",  "cenwave", "nbinpix",     "", 	    "", 
  "",            "",         "",         "",         ""},

{"mode", "", "", "", "",
 "",     "", "", "", "",
  "",     "", "", "", ""},

{"atodgain", "mode", "serials", "shutter", "filter1", 
 "filter2", "",      "",        "",        "",
  "",        "",      "",        "",        ""},

{"camera",    "mode",    "clock",   "filter1",    "filter2", 
 "filtnam1", "filtnam2", "shutter", "flatfield",  "",
  "",         "",         "",        "",         ""}
};

/* The names of the observation mode keywords, 
 * as they occur in the reference file header
 */

char *ref_obsmode[10][15] = {
{"optcrly", "pxformt", "optelt1", "optelt2", "sampoff", 
 "samppln", "lineoff", "linepfm", "cammode", "smmmode", 
 "wavelength", "",     "",        "",        ""},
 
{"detector", "overscan", "aper_id", "aper_pos", "polar_id", 
 "fgwa_id",  "pass_dir", "fchnl",   "nxsteps",  "", 
  "",           "",     "",        "",     ""},

{"detector", "grating", "aperture", "sporder", "", 
  "",         "",         "",        "",       "",
  "",         "",         "",        "",        ""},

{"aper_name", "det_num", "type", "voltage", "vgaind", 
 "data_fmt",  "mode",    "thresh", "",      "",
  "",          "",        "",        "",     ""},

{"compname", "", "", "", "",
 "",     "", "", "", "",
  "",     "", "", "", ""},

{"camera",   "filter", "readout", "nread", "",
 "",	   "",       "",         "",  "",
  "",       "",       "",         "",  ""},

{"detector",  "ccdamp",  "ccdgain",   " opt_elem",  "obstype", 
 "aperture",  "cenwave", "nbinpix",     "", 	    "", 
  "",            "",         "",         "",         ""},

{"compname", "", "", "", "",
 "",     "", "", "", "",
  "",     "", "", "", ""},

{"atodgain", "mode", "serials", "shutter", "filter1", 
 "filter2", "",      "",        "",        "",
  "",        "",      "",        "",        ""},

{"camera",    "mode",    "clock",   "filter1", "filter2", 
 "filtnam1", "filtnam2", "shutter", "flatfield", "",
  "",         "",         "",        "",         ""}
};

#endif
