#include "config.h"
#include "reffile.h"
#include "loadfile.h"
#include "mkload.h"

/* READ_HEADER -- Read observation mode fields from the reference file header
 *
 * i: ref	reference file descriptor
 * i: obsmode	list of observation mode field names
 * o: obsvals	list of observation mode values
 */

void read_header (reffile *ref, textbuf *obsmode, textbuf *obsvals)
{
    int		ikey;
    char	*keyword;
    char	value[SZ_STRING+1];

    init_text (obsvals, 20, 200);

    for (ikey = 0; keyword = get_text (obsmode, ikey); ikey ++) {
        if (get_hdr_reffile (ref, keyword, value, SZ_STRING) == ERR)
	    safecopy (value, "\n", SZ_STRING);

        add_text (obsvals, value);
    }
}
