#!/bin/sh
export CDBS_DB CDBS_SERVER
echo "starting opus_catalog"
echo "database " ${CDBS_DB?"CDBS_ERROR: CDBS_DB is undefined"}
echo "server " ${CDBS_SERVER?"CDBS_ERROR: CDBS_SERVER is undefined"}
date

if test $# -lt 2
then
  # Determine the latest opus delivery number
  delivery_number=`delivery_number.s | awk -f awk.dn`
else
delivery_number=$2
fi
echo "delivery_number=" $delivery_number

# Determine whether the ga date has been set in the delivery
w=`ga_date1.s $delivery_number | fgrep "ERROR" | wc -c`
if test $w -gt 0
then
   ga_date1.s $delivery_number
   echo "No catalog was generated."
   exit 1
fi

# Determine the instrument abbreviation
instr=`instrument_abbreviation.s $delivery_number | awk -f awk.ab`
echo "instr=" $instr
cat_file="opus_"$delivery_number"_"$instr".cat"
echo "catalog file=" $cat_file

# List files for insertion to OPUS
inserted_deleted.s $delivery_number | awk -f awk.sr > $1/$cat_file
exit 0
