/*****************************************************************************/
/*                                                                           */
/*  File:    opus_catalog_files.sp                                           */
/*                                                                           */
/*  Modification History:                                                    */
/*                                                                           */
/*    Date       OPR      Who                       Reason                   */
/*  --------   -------    ---   -------------------------------------------  */
/*  08/14/96               sl   Original                                     */
/*                                                                           */
/*****************************************************************************/

create procedure opus_catalog_files @delivery_number int
as

/* Insert table file in opus store */
select distinct "OPUS_ROW", 
       substring(file_name,1,patindex("%.%", file_name)-1), "I", "T" 
  from opus_log l, relation_info r
 where l.delivery_number = @delivery_number 
   and (l.operation="I" OR l.operation = "S")
   and l.reference_file_type = r.reference_file_type 
   and l.instrument = r.instrument
   and r.type = "T"

/* Insert image file in opus store */
select distinct "OPUS_ROW", 
       substring(file_name,1,patindex("%.%", file_name)-1), "I", "R" 
  from opus_log l, delivery_number d, relation_info r
 where l.delivery_number = @delivery_number 
   and (l.operation="I" OR l.operation = "S")
   and l.reference_file_type = r.reference_file_type 
   and l.instrument = r.instrument
   and r.type = "I"

/* Delete table file in opus store */
select distinct "OPUS_ROW", 
       substring(file_name,1,patindex("%.%", file_name)-1), "D", "T" 
  from opus_log l, delivery_number d, relation_info r
 where l.delivery_number = @delivery_number 
   and (l.operation="D" OR l.operation="E")
   and l.reference_file_type = r.reference_file_type 
   and l.instrument = r.instrument
   and r.type = "T"

/* Delete image file in opus store */
select distinct "OPUS_ROW", 
       substring(file_name,1,patindex("%.%", file_name)-1), "D", "R" 
  from opus_log l, delivery_number d, relation_info r
 where l.delivery_number = @delivery_number 
   and (l.operation="D" OR l.operation="E")
   and l.reference_file_type = r.reference_file_type 
   and l.instrument = r.instrument
   and r.type = "I"
go

grant execute on opus_catalog_files to public
go
