begin tran

/* store current time to local variable @load_date for use by load_time  */
/* fields in OPUS, the format is "dd-MMM-yyyy hh:mm:ss" */
declare @load_date    varchar(20)
declare @dbtime       varchar(20)
declare @current_time datetime
select @current_time = getdate()
select @dbtime=convert(char(11), @current_time, 106)+' '+
       convert(char(8), @current_time, 108)
select @load_date = substring(@dbtime, 1, 2) + '-' + substring(@dbtime, 4, 1) +
       upper(substring(@dbtime, 5, 1)) + upper(substring(@dbtime, 6, 1)) +
       '-' + substring(@dbtime, 8, 13)


print "LOAD_DATE_%1!= %2!", "USED", @current_time
print "DELIVERY_NUMBER_%1!= %2!", "USED", "10038"

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1713, 'CCD', 
'H2I1351SO_PFL.FITS', 'SPECTROSCOPIC', 'G230MB', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1854, 'CCD', 
'H2I1351TO_PFL.FITS', 'SPECTROSCOPIC', 'G230MB', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1995, 'CCD', 
'H2I13520O_PFL.FITS', 'SPECTROSCOPIC', 'G230MB', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2276, 'CCD', 
'H2I13521O_PFL.FITS', 'SPECTROSCOPIC', 'G230MB', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2557, 'CCD', 
'H2I13522O_PFL.FITS', 'SPECTROSCOPIC', 'G230MB', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2794, 'CCD', 
'H2I13523O_PFL.FITS', 'SPECTROSCOPIC', 'G230MB', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2976, 'CCD', 
'H2I13524O_PFL.FITS', 'SPECTROSCOPIC', 'G230MB', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 3305, 'CCD', 
'H2I13525O_PFL.FITS', 'SPECTROSCOPIC', 'G430M', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 3680, 'CCD', 
'H2I13526O_PFL.FITS', 'SPECTROSCOPIC', 'G430M', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 3843, 'CCD', 
'H2I13527O_PFL.FITS', 'SPECTROSCOPIC', 'G430M', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 3936, 'CCD', 
'H2I13528O_PFL.FITS', 'SPECTROSCOPIC', 'G430M', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('25MAMA', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRCUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('2X2', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRCUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('6X6', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRCUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25YLA', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRFUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25QTZ', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRFUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25SRF2', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRFUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25ND3', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRFUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25ND5', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRFUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ1', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRFUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ2', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRFUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ3', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRFUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ4', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRFUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25CN182', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25CIII', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25MGII', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25SRF2', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25QTZ', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25CN270', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25ND3', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25ND5', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ1', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ2', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ3', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ4', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('25MAMA', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('2X2', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('6X6', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRNUV', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F28X50LP', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F28X50OII', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F28X50OIII', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25ND3', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25ND5', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ1', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ2', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ3', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ4', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('50CCD', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('50CORON', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('BAR10', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEA2.8', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEA2.5', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEA2.0', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEA1.8', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEA1.0', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEB2.8', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEB2.5', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEB2.0', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEB1.8', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEB1.0', -999, 'FUV-MAMA', 
'H2I13529O_LFL.FITS', 'IMAGING', 'MIRVIS', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('25MAMA', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRCUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('2X2', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRCUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('6X6', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRCUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25YLA', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRFUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25QTZ', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRFUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25SRF2', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRFUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25ND3', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRFUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25ND5', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRFUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ1', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRFUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ2', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRFUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ3', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRFUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ4', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRFUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25CN182', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25CIII', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25MGII', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25SRF2', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25QTZ', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25CN270', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25ND3', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25ND5', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ1', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ2', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ3', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ4', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('25MAMA', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('2X2', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('6X6', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRNUV', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F28X50LP', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F28X50OII', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F28X50OIII', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25ND3', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25ND5', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ1', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ2', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ3', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('F25NDQ4', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('50CCD', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('50CORON', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('BAR10', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEA2.8', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEA2.5', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEA2.0', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEA1.8', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEA1.0', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEB2.8', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEB2.5', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEB2.0', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEB1.8', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('WEDGEB1.0', -999, 'FUV-MAMA', 
'H2I1352AO_PFL.FITS', 'IMAGING', 'MIRVIS', 'PFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1425, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140L', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1575, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140L', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1173, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1218, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1222, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1272, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1321, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1371, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1387, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1400, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1420, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1470, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1518, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1540, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1550, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1567, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1616, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1640, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1665, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1714, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1425, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'E140M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1234, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'E140H', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1271, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'E140H', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1307, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'E140H', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1343, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'E140H', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1380, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'E140H', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1416, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'E140H', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1453, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'E140H', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1489, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'E140H', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1526, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'E140H', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1562, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'E140H', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1598, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'E140H', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2376, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230L', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1687, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1769, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1851, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1884, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1933, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2014, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2095, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2176, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2257, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2338, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2419, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2499, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2579, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2600, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2659, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2739, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2800, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2818, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2828, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2898, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2977, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 3055, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'G230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 1978, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'E230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2124, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS', 'SPECTROSCOPIC', 'E230M', 'LFL', '1996.275:00:00:00', 
@load_date)

insert ccao_stis_ref (aperture, cenwave, detector, data_file, obstype, opt_elem,
 filetype, use_after, load_time) values ('NOT APPLICABLE', 2269, 'FUV-MAMA', 
'H2I1352BO_LFL.FITS