#include <ctype.h>
#include <string.h>
#include "config.h"
#include "query.h"

#define  XDIGIT(x)	((x) < 10 ? (x) + '0' : (x) - 10 + 'a')

/* CGI_ENCODE -- Convert a value into its cgi encoded form
 *
 * i: name	cgi parameter name
 * i: value	cgi parameter value
 * o: output	encoded string
 * i: maxch	max length of encoded string
 */

static void	hex_encode (int, int *, char *, int);

void cgi_encode (char *name, char *value, char *output, int maxch)
{
    int		ic, jc;

    /* Copy parameter name without change */
 
    safecopy (output, name, maxch);
    safecat (output, "=", maxch);

    /* Encode value */

    jc = strlen (output);
    for (ic = 0; value[ic] != EOS && jc < maxch; ic ++) {
        
	if (value[ic] == ' ') {
	    /* Convert blanks to plus signs */
	    output[jc++] = '+';

	} else if (value[ic] == '&' || value[ic] == '+' || 
		   value[ic] == '"' || value[ic] == '='   ) {
	    /* Convert chars with special significance to hex */
	    hex_encode (value[ic], &jc, output, maxch);

	} else if (iscntrl(value[ic])) {
	    /* Convert control chars to hex */
	    hex_encode (value[ic], &jc, output, maxch);

	} else {
	    /* Copy all other chars without change */
	    output[jc++] = value[ic];
	}
    }

    output[jc] = EOS;
}

/* HEX_ENCODE -- Convert character to its hex encoding
 * 
 * i: ch	character to be converted
 * i: jc	next position in encoded string
 * o: output	encoded string
 * i: maxch	max length of encoded string
 */

void hex_encode (int ch, int *jc, char *output, int maxch)
{
    /* See if there is enough rome to copy the encoded char */

    if (*jc < maxch - 3) {
        /* Each char converts to two hexadecimal digits preceded by
	 * a percent sign
	 */

        output[(*jc)++] = '%';
	output[(*jc)++] = XDIGIT(ch / 16);
	output[(*jc)++] = XDIGIT(ch % 16);

    } else {
        /* Terminate the string and set jc so no more chars
	 * will be added to string
	 */

        output[*jc] = EOS;
	*jc = maxch;
    }
}
