#include "config.h"
#include "cdbslib.h"

/* JOINARGS -- Join command line arguments with blanks for output
 *
 * i: argc      number of task arguments
 * i: argv      array of pointers to task arguments
 */

char *joinargs (int argc, char ** argv)
{
    int		iarg;
    static char	buffer[SZ_LINE+1];

    if (argc <= 1) {
        buffer[0] = EOS;
    } else {
        safecopy (buffer, argv[1], SZ_LINE);
    }

    for (iarg = 2; iarg < argc; iarg ++) {
        safecat (buffer, " ", SZ_LINE);
        safecat (buffer, argv[iarg], SZ_LINE);
    }

    return (buffer);
}
