#include <string.h>
#include <stdlib.h>
#include "config.h"
#include "cdbslib.h"

/* QUALNAME -- Return a db column name qualified by its table alias 
 *
 * i: colname	database column name
 * i: itab	table index
 */

char * qualname (char *colname, int itab)
{
    int		qlen, ic;
    char	*qcolname;

    /* Allocate array to hold qualified name */

    qlen = strlen (colname) + 2;
    qcolname = (char *) malloc (qlen + 1);

    /* Copy qualifier into name */

    qcolname[0] = 'a' + itab;
    qcolname[1] = '.';

    /* Concatenate column name to qualifier */

    for (ic = 0; colname[ic] != EOS; ic ++)
        qcolname[ic+2] = colname[ic];

    /* Return qualified name */

    qcolname[ic+2] = EOS;
    return (qcolname);
}
