#include <string.h>
#include <stdlib.h>
#include "config.h"
#include "cdbslib.h"
#include "query.h"

/* STRIP_COLLIST -- Remove prefixes from column names to create aliases
 *
 * i: qcollist	array of prefixed column names
 */

char ** strip_collist (char **qcollist)
{
    char	**collist, *column;
    int		icol, jcol, ncol, len, maxlen, match;

    /* Count number of columns and get longest length */

    maxlen = 0;
    for (icol = 0; qcollist[icol][0] != EOS; icol ++) {
      if ((len = strlen (qcollist[icol])) > maxlen)
	  maxlen = len;
    }

    /* Allocate array and temporary buffer */

    ncol = icol;
    column = (char *) malloc (maxlen + 1);
    collist = (char **) malloc ((ncol + 1) * sizeof (char *));

    /* Copy column name minus the two character prefix */

    for (icol = 0; icol < ncol; icol ++) {
        match = NO;

	/* Check for duplicate names. If found, append prefix as a suffix */

 	for (jcol = 0; jcol < ncol; jcol ++) {
	    if (icol != jcol) {
	        if (strcmp (&qcollist[icol][2], &qcollist[jcol][2]) == 0) {
		    safecopy (column, &qcollist[icol][2], maxlen);
		    len = strlen (column);
		    column[len++] = '_';
		    column[len++] = qcollist[icol][0];
		    column[len] = EOS;
		    match = YES;
		    break;
		}
	    }
	}

	if (match == NO) {
	    collist[icol] = strclone (&qcollist[icol][2]);
	} else {
	    collist[icol] = strclone (column);
	}
    }

    /* Mark end of array with a zero length string */

    collist[ncol] = strclone ("");

    /* Retuen array of column names minus prefixes */

    free (column);
    return (collist);
}
