#include <ctype.h>
#include "config.h"

/* CLEAN_NAME -- Revise a string so it can be used as a legal iraf file name
 *
 * i: oldname	original name
 * o: newname	cleaned name
 * i: maxch	max length of cleaned name
 */

void clean_name (char *oldname, char *newname, int maxch)
{
    int		ic;

    for (ic = 0; oldname[ic] != EOS && ic < maxch; ic ++) {
	if (isalnum (oldname[ic])) {
	    /* Convert  upper case to lower case */
	    newname[ic] = tolower(oldname[ic]);	
	} else {
	    /* Replace non-alphanumeric chars with underscores */
	    newname[ic] = '_';
	}
    }

    newname[ic] = EOS;
}
