#include <stdlib.h>
#include "config.h"
#include "cdbslib.h"
#include "loadfile.h"
#include "flist.h"

/* ADD_FLIST -- Add a new filename to the list if it isn't there already 
 *
 * i: flist	list of filenames
 * i: fname	filename
 */

void add_flist (flist *list, char *fname)
{
    char	*name;

    name = strclone (fname);
    strlcase (name);
    strclean (name);

    if (find_text (&list->names, name) == BAD)
	add_text (&list->names, name);

    free (name);
}

/* CREATE_FLIST -- Create list of filenames from task argument list
 *
 * i: narg	number of arguments
 * i: arg	list of arguments
 */

flist *create_flist (int narg, char **arg)
{
    int		iarg, ilist;
    flist	*list;

    list = (flist *) malloc (sizeof (flist));
    init_text (&list->names, 10, 400);
    list->index = 0;


    ilist = 0;
    for (iarg = 0; iarg < narg; iarg ++) {
	if (is_datafile (arg[iarg]) == NO)
	    put_text (&list->names, ilist ++, arg[iarg]);
    }

    return (list);
}

/* FREE_FLIST -- Free list of filenames 
 *
 * i: flist	list of filenames
 */

void free_flist (flist *list)
{
    free_text (&list->names);
    free (list);
}

/* NEXT_FLIST -- Return next filename from list of filename (or NULL) 
 *
 * i: flist	list of filenames
 */

char * next_flist (flist *list)
{
    return (get_text (&list->names, list->index ++));
}
