#include "config.h"
#include "reffile.h"
#include "cdbslib.h"
#include "loadfile.h"

/* GETASCTYPE -- Get filetype of associated file
 *
 * i: ref	reference file descriptor
 * o: asctype	associated type string
 * i: maxch	length of associated type
 */

int getasctype (table *look, reffile *ref, char *asctype, int maxch)
{
    char	fname[SZ_FNAME+1];
    char	*str;
    int		row;

    /* Load files contain the name of the reference file associated
     * with them in the header. For renaming it is important to
     * determine the type of the associated file. For other file
     * type, there is no associated file, so the associated file type 
     * is set to the type of the original file.
     */

    switch (kind_reffile (ref)) {
    case IMAGE:
	safecopy (asctype, "image", maxch);
	break;

    case TABLE:
	safecopy (asctype, "table", maxch);
	break;

    case LOADFILE:
	if (get_hdr_reffile (ref, "FILE_NAME", fname, SZ_FNAME) == ERR)
	    return (ERR);

	strlcase (fname);
	if ((row = find_lookup (look, fname)) == ERR)
	    return (ERR);

	if ((str = get_tab_cell (look, "filetype", row)) == NULL)
	    return (ERR);

	safecopy (asctype, str, maxch);
	break;

    default:
	return (ERR);
    }

    /* The task returns ERR if it cannot determine the associated file type
     * and OK if it and
     */

    return (OK);
}

