#!/bin/sh

echo "starting update_ga_date "
echo "database " ${CDBS_DB?"CDBS_ERROR: CDBS_DB is undefined"}
echo "server " ${CDBS_SERVER?"CDBS_ERROR: CDBS_SERVER is undefined"}
date
if test $# -lt 1
then
  # Determine the latest opus delivery number
  delivery_number=`delivery_number.s $CDBS_DB | awk -f awk.dn`
else
delivery_number=$1
fi
echo "delivery number = " $delivery_number

# Execute the stored procedure
res=`update_ga_date_sql.s $CDBS_DB $delivery_number`

if test `echo $res | grep "OK" | wc -l` -ne 0
then
  echo "general availability date was updated"
  exit 0
fi
echo $res
exit 1

