USE cdbs_ops
GO
INSERT stis_row
	( file_name,
	 expansion_number,
	 delivery_number,
	 binaxis1,
	 binaxis2,
	 ccdamp,
	 ccdgain,
	 ccdoffst,
	 detector,
	 equivalence_class_severe,
	 equivalence_class_moderate,
	 pedigree,
	 observation_begin_date,
	 observation_end_date)
VALUES ('K5Q11160O_BIA.FITS',
	0,
	10675,
	1,
	2,
	'D',
	1,
	3,
	'CCD',
	170675,
	170676,
	'INFLIGHT',
	'MAR 9 2000',
	'MAR 22 2000')
GO
INSERT stis_file
	(delivery_number,
	reference_file_type,
	file_name,
	expansion_number,
	useafter_date,
	comparison_file_name,
	opus_flag,
	comment,
	reject_flag)
VALUES (10675,
	'BIA',
	'K5Q11160O_BIA.FITS',
	0,
	'MAR 09 2000 00:00:00',
	'K471339MO_BIA.FITS',
	'Y',
	"Superbias created by R. Diaz-Miller
Created on May 25, 2000 using the cl scripts                          
'refbias' and 'refaver', which are available                          
in the (local) xstis package within STSDAS.                           
Superbias image, combination of 28 input bias frames                  
taken in CCDGAIN=1, BINAXIS1=1, BINAXIS2=2 mode.                      
All input frames were from Cycle 8 Proposal 8439:                     
'CCD Bias Monitor C8'.                                                
The following input files were used:                                  
o5lr15040                                                             
o5lr16040                                                             
o5lr17040                                                             
o5lr18040                                                             
o5lr19040                                                             
o5lr1a040                                                             
o5lr1b040                                                             
o5lr1c040                                                             
o5lr1d040                                                             
o5lr1e040                                                             
o5lr1f040                                                             
o5lr1g040                                                             
o5lr1h040                                                             
o5lr1i040                                                             
cl script 'refbias' was run on these input files,                     
after having split them up into sub-lists of less                     
than 30 imsets each. After running 'refbias' on the                   
individual sub-lists, script 'refaver' was run to                     
average the reference files resulting from the                        
individual 'refbias' runs together.                                   
The 'refbias' procedure works as follows. After                       
joining the files together into a multi-imset file,                   
overscan subtraction is performed for every individual                
bias frame. The bias frames in the multi-imset file                   
are then combined using ocrreject, which performs a                   
three-step iterative cosmic-ray rejection with                        
rejection thresholds of 5, 4, and 3 sigma,                            
respectively.                                                         
After cosmic ray rejection, the combined bias was                     
divided by the number of frames combined (ocrreject                   
adds images instead of averaging them), using the                     
stsdas.toolbox.imgtools.mstools.msarith routine.                      
Subsequently, hot pixels (and columns) were identified                
as follows. A median-filtered version of the averaged                 
bias is created (kernel = 15 x 3 pixels) and                          
subtracted from the averaged bias, leaving a                          
'residual' image containing hot pixels and columns.                   
The pixels hotter than 5 sigma of the effective RMS                   
noise in the residual bias image are then identified,                 
and flagged as such in the Data Quality (DQ)                          
extension of the output reference bias file.                          
",
	'N')
GO
INSERT stis_row
	( file_name,
	 expansion_number,
	 delivery_number,
	 binaxis1,
	 binaxis2,
	 ccdamp,
	 ccdgain,
	 ccdoffst,
	 detector,
	 equivalence_class_severe,
	 equivalence_class_moderate,
	 pedigree,
	 observation_begin_date,
	 observation_end_date)
VALUES ('K5Q11161O_BIA.FITS',
	0,
	10675,
	2,
	1,
	'D',
	1,
	3,
	'CCD',
	170677,
	170678,
	'INFLIGHT',
	'MAR 9 2000',
	'MAR 22 2000')
GO
INSERT stis_file
	(delivery_number,
	reference_file_type,
	file_name,
	expansion_number,
	useafter_date,
	comparison_file_name,
	opus_flag,
	comment,
	reject_flag)
VALUES (10675,
	'BIA',
	'K5Q11161O_BIA.FITS',
	0,
	'MAR 09 2000 00:00:00',
	'K4B08293O_BIA.FITS',
	'Y',
	"Superbias created by R. Diaz-Miller
Created on May 25, 2000 using the cl scripts                          
'refbias' and 'refaver', which are available                          
in the (local) xstis package within STSDAS.                           
Superbias image, combination of 28 input bias frames                  
taken in CCDGAIN=1, BINAXIS1=2, BINAXIS2=1 mode.                      
All input frames were from Cycle 8 Proposal 8439:                     
'CCD Bias Monitor C8'.                                                
The following input files were used:                                  
o5lr15030                                                             
o5lr16030                                                             
o5lr17030                                                             
o5lr18030                                                             
o5lr19030                                                             
o5lr1a030                                                             
o5lr1b030                                                             
o5lr1c030                                                             
o5lr1d030                                                             
o5lr1e030                                                             
o5lr1f030                                                             
o5lr1g030                                                             
o5lr1h030                                                             
o5lr1i030                                                             
cl script 'refbias' was run on these input files,                     
after having split them up into sub-lists of less                     
than 30 imsets each. After running 'refbias' on the                   
individual sub-lists, script 'refaver' was run to                     
average the reference files resulting from the                        
individual 'refbias' runs together.                                   
The 'refbias' procedure works as follows. After                       
joining the files together into a multi-imset file,                   
overscan subtraction is performed for every individual                
bias frame. The bias frames in the multi-imset file                   
are then combined using ocrreject, which performs a                   
three-step iterative cosmic-ray rejection with                        
rejection thresholds of 5, 4, and 3 sigma,                            
respectively.                                                         
After cosmic ray rejection, the combined bias was                     
divided by the number of frames combined (ocrreject                   
adds images instead of averaging them), using the                     
stsdas.toolbox.imgtools.mstools.msarith routine.                      
Subsequently, hot pixels (and columns) were identified                
as follows. A median-filtered version of the averaged                 
bias is created (kernel = 15 x 3 pixels) and                          
subtracted from the averaged bias, leaving a                          
'residual' image containing hot pixels and columns.                   
The pixels hotter than 5 sigma of the effective RMS                   
noise in the residual bias image are then identified,                 
and flagged as such in the Data Quality (DQ)                          
extension of the output reference bias file.                          
",
	'N')
GO
INSERT stis_row
	( file_name,
	 expansion_number,
	 delivery_number,
	 binaxis1,
	 binaxis2,
	 ccdamp,
	 ccdgain,
	 ccdoffst,
	 detector,
	 equivalence_class_severe,
	 equivalence_class_moderate,
	 pedigree,
	 observation_begin_date,
	 observation_end_date)
VALUES ('K5Q11162O_BIA.FITS',
	0,
	10675,
	2,
	2,
	'D',
	1,
	3,
	'CCD',
	170679,
	170680,
	'INFLIGHT',
	'MAR 9 2000',
	'MAR 22 2000')
GO
INSERT stis_file
	(delivery_number,
	reference_file_type,
	file_name,
	expansion_number,
	useafter_date,
	comparison_file_name,
	opus_flag,
	comment,
	reject_flag)
VALUES (10675,
	'BIA',
	'K5Q11162O_BIA.FITS',
	0,
	'MAR 09 2000 00:00:00',
	'K4I1656HO_BIA.FITS',
	'Y',
	"Superbias created by R. Diaz-Miller
Created on May 25, 2000 using the cl scripts                          
'refbias' and 'refaver', which are available                          
in the (local) xstis package within STSDAS.                           
Superbias image, combination of 28 input bias frames                  
taken in CCDGAIN=1, BINAXIS1=2, BINAXIS2=2 mode.                      
All input frames were from Cycle 8 Proposal 8439:                     
'CCD Bias Monitor C8'.                                                
The following input files were used:                                  
o5lr15050                                                             
o5lr16050                                                             
o5lr17050                                                             
o5lr18050                                                             
o5lr19050                                                             
o5lr1a050                                                             
o5lr1b050                                                             
o5lr1c050                                                             
o5lr1d050                                                             
o5lr1e050                                                             
o5lr1f050                                                             
o5lr1g050                                                             
o5lr1h050                                                             
o5lr1i050                                                             
cl script 'refbias' was run on these input files,                     
after having split them up into sub-lists of less                     
than 30 imsets each. After running 'refbias' on the                   
individual sub-lists, script 'refaver' was run to                     
average the reference files resulting from the                        
individual 'refbias' runs together.                                   
The 'refbias' procedure works as follows. After                       
joining the files together into a multi-imset file,                   
overscan subtraction is performed for every individual                
bias frame. The bias frames in the multi-imset file                   
are then combined using ocrreject, which performs a                   
three-step iterative cosmic-ray rejection with                        
rejection thresholds of 5, 4, and 3 sigma,                            
respectively.                                                         
After cosmic ray rejection, the combined bias was                     
divided by the number of frames combined (ocrreject                   
adds images instead of averaging them), using the                     
stsdas.toolbox.imgtools.mstools.msarith routine.                      
Subsequently, hot pixels (and columns) were identified                
as follows. A median-filtered version of the averaged                 
bias is created (kernel = 15 x 3 pixels) and                          
subtracted from the averaged bias, leaving a                          
'residual' image containing hot pixels and columns.                   
The pixels hotter than 5 sigma of the effective RMS                   
noise in the residual bias image are then identified,                 
and flagged as such in the Data Quality (DQ)                          
extension of the output reference bias file.                          
",
	'N')
GO
INSERT stis_row
	( file_name,
	 expansion_number,
	 delivery_number,
	 binaxis1,
	 binaxis2,
	 ccdamp,
	 ccdgain,
	 ccdoffst,
	 detector,
	 equivalence_class_severe,
	 equivalence_class_moderate,
	 pedigree,
	 observation_begin_date,
	 observation_end_date)
VALUES ('K5Q11163O_BIA.FITS',
	0,
	10675,
	1,
	2,
	'D',
	1,
	3,
	'CCD',
	170681,
	170682,
	'INFLIGHT',
	'MAR 23 2000',
	'APR 5 2000')
GO
INSERT stis_file
	(delivery_number,
	reference_file_type,
	file_name,
	expansion_number,
	useafter_date,
	comparison_file_name,
	opus_flag,
	comment,
	reject_flag)
VALUES (10675,
	'BIA',
	'K5Q11163O_BIA.FITS',
	0,
	'MAR 23 2000 00:00:00',
	'K471339MO_BIA.FITS',
	'Y',
	"Superbias created by R. Diaz-Miller
Created on May 25, 2000 using the cl scripts                          
'refbias' and 'refaver', which are available                          
in the (local) xstis package within STSDAS.                           
Superbias image, combination of 28 input bias frames                  
taken in CCDGAIN=1, BINAXIS1=1, BINAXIS2=2 mode.                      
All input frames were from Cycle 8 Proposal 8439:                     
'CCD Bias Monitor C8'.                                                
The following input files were used:                                  
o5lr1j040                                                             
o5lr1k040                                                             
o5lr1l040                                                             
o5lr1m040                                                             
o5lr1n040                                                             
o5lr1o040                                                             
o5lr1p040                                                             
o5lr1q040                                                             
o5lr1r040                                                             
o5lr1s040                                                             
o5lr1t040                                                             
o5lr1u040                                                             
o5lr1v040                                                             
o5lr1w040                                                             
cl script 'refbias' was run on these input files,                     
after having split them up into sub-lists of less                     
than 30 imsets each. After running 'refbias' on the                   
individual sub-lists, script 'refaver' was run to                     
average the reference files resulting from the                        
individual 'refbias' runs together.                                   
The 'refbias' procedure works as follows. After                       
joining the files together into a multi-imset file,                   
overscan subtraction is performed for every individual                
bias frame. The bias frames in the multi-imset file                   
are then combined using ocrreject, which performs a                   
three-step iterative cosmic-ray rejection with                        
rejection thresholds of 5, 4, and 3 sigma,                            
respectively.                                                         
After cosmic ray rejection, the combined bias was                     
divided by the number of frames combined (ocrreject                   
adds images instead of averaging them), using the                     
stsdas.toolbox.imgtools.mstools.msarith routine.                      
Subsequently, hot pixels (and columns) were identified                
as follows. A median-filtered version of the averaged                 
bias is created (kernel = 15 x 3 pixels) and                          
subtracted from the averaged bias, leaving a                          
'residual' image containing hot pixels and columns.                   
The pixels hotter than 5 sigma of the effective RMS                   
noise in the residual bias image are then identified,                 
and flagged as such in the Data Quality (DQ)                          
extension of the output reference bias file.                          
",
	'N')
GO
INSERT stis_row
	( file_name,
	 expansion_number,
	 delivery_number,
	 binaxis1,
	 binaxis2,
	 ccdamp,
	 ccdgain,
	 ccdoffst,
	 detector,
	 equivalence_class_severe,
	 equivalence_class_moderate,
	 pedigree,
	 observation_begin_date,
	 observation_end_date)
VALUES ('K5Q11164O_BIA.FITS',
	0,
	10675,
	2,
	1,
	'D',
	1,
	3,
	'CCD',
	170683,
	170684,
	'INFLIGHT',
	'MAR 23 2000',
	'APR 5 2000')
GO
INSERT stis_file
	(delivery_number,
	reference_file_type,
	file_name,
	expansion_number,
	useafter_date,
	comparison_file_name,
	opus_flag,
	comment,
	reject_flag)
VALUES (10675,
	'BIA',
	'K5Q11164O_BIA.FITS',
	0,
	'MAR 23 2000 00:00:00',
	'K4B08293O_BIA.FITS',
	'Y',
	"Superbias created by R. Diaz-Miller
Created on May 25, 2000 using the cl scripts                          
'refbias' and 'refaver', which are available                          
in the (local) xstis package within STSDAS.                           
Superbias image, combination of 28 input bias frames                  
taken in CCDGAIN=1, BINAXIS1=2, BINAXIS2=1 mode.                      
All input frames were from Cycle 8 Proposal 8439:                     
'CCD Bias Monitor C8'.                                                
The following input files were used:                                  
o5lr1j030                                                             
o5lr1k030                                                             
o5lr1l030                                                             
o5lr1m030                                                             
o5lr1n030                                                             
o5lr1o030                                                             
o5lr1p030                                                             
o5lr1q030                                                             
o5lr1r030                                                             
o5lr1s030                                                             
o5lr1t030                                                             
o5lr1u030                                                             
o5lr1v030                                                             
o5lr1w030                                                             
cl script 'refbias' was run on these input files,                     
after having split them up into sub-lists of less                     
than 30 imsets each. After running 'refbias' on the                   
individual sub-lists, script 'refaver' was run to                     
average the reference files resulting from the                        
individual 'refbias' runs together.                                   
The 'refbias' procedure works as follows. After                       
joining the files together into a multi-imset file,                   
overscan subtraction is performed for every individual                
bias frame. The bias frames in the multi-imset file                   
are then combined using ocrreject, which performs a                   
three-step iterative cosmic-ray rejection with                        
rejection thresholds of 5, 4, and 3 sigma,                            
respectively.                                                         
After cosmic ray rejection, the combined bias was                     
divided by the number of frames combined (ocrreject                   
adds images instead of averaging them), using the                     
stsdas.toolbox.imgtools.mstools.msarith routine.                      
Subsequently, hot pixels (and columns) were identified                
as follows. A median-filtered version of the averaged                 
bias is created (kernel = 15 x 3 pixels) and                          
subtracted from the averaged bias, leaving a                          
'residual' image containing hot pixels and columns.                   
The pixels hotter than 5 sigma of the effective RMS                   
noise in the residual bias image are then identified,                 
and flagged as such in the Data Quality (DQ)                          
extension of the output reference bias file.                          
",
	'N')
GO
INSERT stis_row
	( file_name,
	 expansion_number,
	 delivery_number,
	 binaxis1,
	 binaxis2,
	 ccdamp,
	 ccdgain,
	 ccdoffst,
	 detector,
	 equivalence_class_severe,
	 equivalence_class_moderate,
	 pedigree,
	 observation_begin_date,
	 observation_end_date)
VALUES ('K5Q11165O_BIA.FITS',
	0,
	10675,
	2,
	2,
	'D',
	1,
	3,
	'CCD',
	170685,
	170686,
	'INFLIGHT',
	'MAR 23 2000',
	'APR 5 2000')
GO
INSERT stis_file
	(delivery_number,
	reference_file_type,
	file_name,
	expansion_number,
	useafter_date,
	comparison_file_name,
	opus_flag,
	comment,
	reject_flag)
VALUES (10675,
	'BIA',
	'K5Q11165O_BIA.FITS',
	0,
	'MAR 23 2000 00:00:00',
	'K4I1656HO_BIA.FITS',
	'Y',
	"Superbias created by R. Diaz-Miller
Created on May 25, 2000 using the cl scripts                          
'refbias' and 'refaver', which are available                          
in the (local) xstis package within STSDAS.                           
Superbias image, combination of 28 input bias frames                  
taken in CCDGAIN=1, BINAXIS1=2, BINAXIS2=2 mode.                      
All input frames were from Cycle 8 Proposal 8439:                     
'CCD Bias Monitor C8'.                                                
The following input files were used:                                  
o5lr1j050                                                             
o5lr1k050                                                             
o5lr1l050                                                             
o5lr1m050                                                             
o5lr1n050                                                             
o5lr1o050                                                             
o5lr1p050                                                             
o5lr1q050                                                             
o5lr1r050                                                             
o5lr1s050                                                             
o5lr1t050                                                             
o5lr1u050                                                             
o5lr1v050                                                             
o5lr1w050                                                             
cl script 'refbias' was run on these input files,                     
after having split them up into sub-lists of less                     
than 30 imsets each. After running 'refbias' on the                   
individual sub-lists, script 'refaver' was run to                     
average the reference files resulting from the                        
individual 'refbias' runs together.                                   
The 'refbias' procedure works as follows. After                       
joining the files together into a multi-imset file,                   
overscan subtraction is performed for every individual                
bias frame. The bias frames in the multi-imset file                   
are then combined using ocrreject, which performs a                   
three-step iterative cosmic-ray rejection with                        
rejection thresholds of 5, 4, and 3 sigma,                            
respectively.                                                         
After cosmic ray rejection, the combined bias was                     
divided by the number of frames combined (ocrreject                   
adds images instead of averaging them), using the                     
stsdas.toolbox.imgtools.mstools.msarith routine.                      
Subsequently, hot pixels (and columns) were identified                
as follows. A median-filtered version of the averaged                 
bias is created (kernel = 15 x 3 pixels) and                          
subtracted from the averaged bias, leaving a                          
'residual' image containing hot pixels and columns.                   
The pixels hotter than 5 sigma of the effective RMS                   
noise in the residual bias image are then identified,                 
and flagged as such in the Data Quality (DQ)                          
extension of the output reference bias file.                          
",
	'N')
GO
INSERT stis_row
	( file_name,
	 expansion_number,
	 delivery_number,
	 binaxis1,
	 binaxis2,
	 ccdamp,
	 ccdgain,
	 ccdoffst,
	 detector,
	 equivalence_class_severe,
	 equivalence_class_moderate,
	 pedigree,
	 observation_begin_date,
	 observation_end_date)
VALUES ('K5Q11166O_BIA.FITS',
	0,
	10675,
	1,
	2,
	'D',
	1,
	3,
	'CCD',
	170687,
	170688,
	'INFLIGHT',
	'APR 7 2000',
	'APR 21 2000')
GO
INSERT stis_file
	(delivery_number,
	reference_file_type,
	file_name,
	expansion_number,
	useafter_date,
	comparison_file_name,
	opus_flag,
	comment,
	reject_flag)
VALUES (10675,
	'BIA',
	'K5Q11166O_BIA.FITS',
	0,
	'APR 07 2000 00:00:00',
	'K471339MO_BIA.FITS',
	'Y',
	"Superbias created by R. Diaz-Miller
Created on May 25, 2000 using the cl scripts                          
'refbias' and 'refaver', which are available                          
in the (local) xstis package within STSDAS.                           
Superbias image, combination of 30 input bias frames                  
taken in CCDGAIN=1, BINAXIS1=1, BINAXIS2=2 mode.                      
All input frames were from Cycle 8 Proposal 8439:                     
'CCD Bias Monitor C8'.                                                
The following input files were used:                                  
o5lr1y040                                                             
o5lr1z040                                                             
o5lr20040                                                             
o5lr21040                                                             
o5lr22040                                                             
o5lr23040                                                             
o5lr24040                                                             
o5lr25040                                                             
o5lr26040                                                             
o5lr27040                                                             
o5lr28040                                                             
o5lr29040                                                             
o5lr2a040                                                             
o5lr2b040                                                             
o5lr2c040                                                             
cl script 'refbias' was run on these input files,                     
after having split them up into sub-lists of less                     
than 30 imsets each. After running 'refbias' on the                   
individual sub-lists, script 'refaver' was run to                     
average the reference files resulting from the                        
individual 'refbias' runs together.                                   
The 'refbias' procedure works as follows. After                       
joining the files together into a multi-imset file,                   
overscan subtraction is performed for every individual                
bias frame. The bias frames in the multi-imset file                   
are then combined using ocrreject, which performs a                   
three-step iterative cosmic-ray rejection with                        
rejection thresholds of 5, 4, and 3 sigma,                            
respectively.                                                         
After cosmic ray rejection, the combined bias was                     
divided by the number of frames combined (ocrreject                   
adds images instead of averaging them), using the                     
stsdas.toolbox.imgtools.mstools.msarith routine.                      
Subsequently, hot pixels (and columns) were identified                
as follows. A median-filtered version of the averaged                 
bias is created (kernel = 15 x 3 pixels) and                          
subtracted from the averaged bias, leaving a                          
'residual' image containing hot pixels and columns.                   
The pixels hotter than 5 sigma of the effective RMS                   
noise in the residual bias image are then identified,                 
and flagged as such in the Data Quality (DQ)                          
extension of the output reference bias file.                          
",
	'N')
GO
INSERT stis_row
	( file_name,
	 expansion_number,
	 delivery_number,
	 binaxis1,
	 binaxis2,
	 ccdamp,
	 ccdgain,
	 ccdoffst,
	 detector,
	 equivalence_class_severe,
	 equivalence_class_moderate,
	 pedigree,
	 observation_begin_date,
	 observation_end_date)
VALUES ('K5Q11167O_BIA.FITS',
	0,
	10675,
	2,
	1,
	'D',
	1,
	3,
	'CCD',
	170689,
	170690,
	'INFLIGHT',
	'APR 7 2000',
	'APR 21 2000')
GO
INSERT stis_file
	(delivery_number,
	reference_file_type,
	file_name,
	expansion_number,
	useafter_date,
	comparison_file_name,
	opus_flag,
	comment,
	reject_flag)
VALUES (10675,
	'BIA',
	'K5Q11167O_BIA.FITS',
	0,
	'APR 07 2000 00:00:00',
	'K4B08293O_BIA.FITS',
	'Y',
	"Superbias created by R. Diaz-Miller
Created on May 25, 2000 using the cl scripts                          
'refbias' and 'refaver', which are available                          
in the (local) xstis package within STSDAS.                           
Superbias image, combination of 30 input bias frames                  
taken in CCDGAIN=1, BINAXIS1=2, BINAXIS2=1 mode.                      
All input frames were from Cycle 8 Proposal 8439:                     
'CCD Bias Monitor C8'.                                                
The following input files were used:                                  
o5lr1y030                                                             
o5lr1z030                                                             
o5lr20030                                                             
o5lr21030                                                             
o5lr22030                                                             
o5lr23030                                                             
o5lr24030                                                             
o5lr25030                                                             
o5lr26030                                                             
o5lr27030                                                             
o5lr28030                                                             
o5lr29030                                                             
o5lr2a030                                                             
o5lr2b030                                                             
o5lr2c030                                                             
cl script 'refbias' was run on these input files,                     
after having split them up into sub-lists of less                     
than 30 imsets each. After running 'refbias' on the                   
individual sub-lists, script 'refaver' was run to                     
average the reference files resulting from the                        
individual 'refbias' runs together.                                   
The 'refbias' procedure works as follows. After                       
joining the files together into a multi-imset file,                   
overscan subtraction is performed for every individual                
bias frame. The bias frames in the multi-imset file                   
are then combined using ocrreject, which performs a                   
three-step iterative cosmic-ray rejection with                        
rejection thresholds of 5, 4, and 3 sigma,                            
respectively.                                                         
After cosmic ray rejection, the combined bias was                     
divided by the number of frames combined (ocrreject                   
adds images instead of averaging them), using the                     
stsdas.toolbox.imgtools.mstools.msarith routine.                      
Subsequently, hot pixels (and columns) were identified                
as follows. A median-filtered version of the averaged                 
bias is created (kernel = 15 x 3 pixels) and                          
subtracted from the averaged bias, leaving a                          
'residual' image containing hot pixels and columns.                   
The pixels hotter than 5 sigma of the effective RMS                   
noise in the residual bias image are then identified,                 
and flagged as such in the Data Quality (DQ)                          
extension of the output reference bias file.                          
",
	'N')
GO
INSERT stis_row
	( file_name,
	 expansion_number,
	 delivery_number,
	 binaxis1,
	 binaxis2,
	 ccdamp,
	 ccdgain,
	 ccdoffst,
	 detector,
	 equivalence_class_severe,
	 equivalence_class_moderate,
	 pedigree,
	 observation_begin_date,
	 observation_end_date)
VALUES ('K5Q11168O_BIA.FITS',
	0,
	10675,
	2,
	2,
	'D',
	1,
	3,
	'CCD',
	170691,
	170692,
	'INFLIGHT',
	'APR 7 2000',
	'APR 21 2000')
GO
INSERT stis_file
	(delivery_number,
	reference_file_type,
	file_name,
	expansion_number,
	useafter_date,
	comparison_file_name,
	opus_flag,
	comment,
	reject_flag)
VALUES (10675,
	'BIA',
	'K5Q11168O_BIA.FITS',
	0,
	'APR 07 2000 00:00:00',
	'K4I1656HO_BIA.FITS',
	'Y',
	"Superbias created by R. Diaz-Miller
Created on May 25, 2000 using the cl scripts                          
'refbias' and 'refaver', which are available                          
in the (local) xstis package within STSDAS.                           
Superbias image, combination of 30 input bias frames                  
taken in CCDGAIN=1, BINAXIS1=2, BINAXIS2=2 mode.                      
All input frames were from Cycle 8 Proposal 8439:                     
'CCD Bias Monitor C8'.                                                
The following input files were used:                                  
o5lr1y050                                                             
o5lr1z050                                                             
o5lr20050                                                             
o5lr21050                                                             
o5lr22050                                                             
o5lr23050                                                             
o5lr24050                                                             
o5lr25050                                                             
o5lr26050                                                             
o5lr27050                                                             
o5lr28050                                                             
o5lr29050                                                             
o5lr2a050                                                             
o5lr2b050                                                             
o5lr2c050                                                             
cl script 'refbias' was run on these input files,                     
after having split them up into sub-lists of less                     
than 30 imsets each. After running 'refbias' on the                   
individual sub-lists, script 'refaver' was run to                     
average the reference files resulting from the                        
individual 'refbias' runs together.                                   
The 'refbias' procedure works as follows. After                       
joining the files together into a multi-imset file,                   
overscan subtraction is performed for every individual                
bias frame. The bias frames in the multi-imset file                   
are then combined using ocrreject, which performs a                   
three-step iterative cosmic-ray rejection with                        
rejection thresholds of 5, 4, and 3 sigma,                            
respectively.                                                         
After cosmic ray rejection, the combined bias was                     
divided by the number of frames combined (ocrreject                   
adds images instead of averaging them), using the                     
stsdas.toolbox.imgtools.mstools.msarith routine.                      
Subsequently, hot pixels (and columns) were identified                
as follows. A median-filtered version of the averaged                 
bias is created (kernel = 15 x 3 pixels) and                          
subtracted from the averaged bias, leaving a                          
'residual' image containing hot pixels and columns.                   
The pixels hotter than 5 sigma of the effective RMS                   
noise in the residual bias image are then identified,                 
and flagged as such in the Data Quality (DQ)                          
extension of the output reference bias file.                          
",
	'N')
GO
INSERT stis_row
	( file_name,
	 expansion_number,
	 delivery_number,
	 binaxis1,
	 binaxis2,
	 ccdamp,
	 ccdgain,
	 ccdoffst,
	 detector,
	 equivalence_class_severe,
	 equivalence_class_moderate,
	 pedigree,
	 observation_begin_date,
	 observation_end_date)
VALUES ('K5Q11169O_BIA.FITS',
	0,
	10675,
	1,
	2,
	'D',
	1,
	3,
	'CCD',
	170693,
	170694,
	'INFLIGHT',
	'APR 22 2000',
	'MAY 5 2000')
GO
INSERT stis_file
	(delivery_number,
	reference_file_type,
	file_name,
	expansion_number,
	useafter_date,
	comparison_file_name,
	opus_flag,
	comment,
	reject_flag)
VALUES (10675,
	'BIA',
	'K5Q11169O_BIA.FITS',
	0,
	'APR 22 2000 00:00:00',
	'K471339MO_BIA.FITS',
	'Y',
	"Superbias created by R. Diaz-Miller
Created on May 25, 2000 using the cl scripts                          
'refbias' and 'refaver', which are available                          
in the (local) xstis package within STSDAS.                           
Superbias image, combination of 28 input bias frames                  
taken in CCDGAIN=1, BINAXIS1=1, BINAXIS2=2 mode.                      
All input frames were from Cycle 8 Proposal 8439:                     
'CCD Bias Monitor C8'.                                                
The following input files were used:                                  
o5lr2d040                                                             
o5lr2e040                                                             
o5lr2f040                                                             
o5lr2g040                                                             
o5lr2h040                                                             
o5lr2i040                                                             
o5lr2j040                                                             
o5lr2k040                                                             
o5lr2l040                                                             
o5lr2m040                                                             
o5lr2n040                                                             
o5lr2o040                                                             
o5lr2p040                                                             
o5lr2q040                                                             
cl script 'refbias' was run on these input files,                     
after having split them up into sub-lists of less                     
than 30 imsets each. After running 'refbias' on the                   
individual sub-lists, script 'refaver' was run to                     
average the reference files resulting from the                        
individual 'refbias' runs together.                                   
The 'refbias' procedure works as follows. After                       
joining the files together into a multi-imset file,                   
overscan subtraction is performed for every individual                
bias frame. The bias frames in the multi-imset file                   
are then combined using ocrreject, which performs a                   
three-step iterative cosmic-ray rejection with                        
rejection thresholds of 5, 4, and 3 sigma,                            
respectively.                                                         
After cosmic ray rejection, the combined bias was                     
divided by the number of frames combined (ocrreject                   
adds images instead of averaging them), using the                     
stsdas.toolbox.imgtools.mstools.msarith routine.                      
Subsequently, hot pixels (and columns) were identified                
as follows. A median-filtered version of the averaged                 
bias is created (kernel = 15 x 3 pixels) and                          
subtracted from the averaged bias, leaving a                          
'residual' image containing hot pixels and columns.                   
The pixels hotter than 5 sigma of the effective RMS                   
noise in the residual bias image are then identified,                 
and flagged as such in the Data Quality (DQ)                          
extension of the output reference bias file.                          
",
	'N')
GO
INSERT stis_row
	( file_name,
	 expansion_number,
	 delivery_number,
	 binaxis1,
	 binaxis2,
	 ccdamp,
	 ccdgain,
	 ccdoffst,
	 detector,
	 equivalence_class_severe,
	 equivalence_class_moderate,
	 pedigree,
	 observation_begin_date,
	 observation_end_date)
VALUES ('K5Q1116AO_BIA.FITS',
	0,
	10675,
	2,
	1,
	'D',
	1,
	3,
	'CCD',
	170695,
	170696,
	'INFLIGHT',
	'APR 22 2000',
	'MAY 5 2000')
GO
INSERT stis_file
	(delivery_number,
	reference_file_type,
	file_name,
	expansion_number,
	useafter_date,
	comparison_file_name,
	opus_flag,
	comment,
	reject_flag)
VALUES (10675,
	'BIA',
	'K5Q1116AO_BIA.FITS',
	0,
	'APR 22 2000 00:00:00',
	'K4B08293O_BIA.FITS',
	'Y',
	"Superbias created by R. Diaz-Miller
Created on May 25, 2000 using the cl scripts                          
'refbias' and 'refaver', which are available                          
in the (local) xstis package within STSDAS.                           
Superbias image, combination of 28 input bias frames                  
taken in CCDGAIN=1, BINAXIS1=2, BINAXIS2=1 mode.                      
All input frames were from Cycle 8 Proposal 8439:                     
'CCD Bias Monitor C8'.                                                
The following input files were used:                                  
o5lr2d030                                                             
o5lr2e030                                                             
o5lr2f030                                                             
o5lr2g030                                                             
o5lr2h030                                                             
o5lr2i030                                                             
o5lr2j030                                                             
o5lr2k030                                                             
o5lr2l030                                                             
o5lr2m030                                                             
o5lr2n030                                                             
o5lr2o030                                                             
o5lr2p030                                                             
o5lr2q030                                                             
cl script 'refbias' was run on these input files,                     
after having split them up into sub-lists of less                     
than 30 imsets each. After running 'refbias' on the                   
individual sub-lists, script 'refaver' was run to                     
average the reference files resulting from the                        
individual 'refbias' runs together.                                   
The 'refbias' procedure works as follows. After                       
joining the files together into a multi-imset file,                   
overscan subtraction is performed for every individual                
bias frame. The bias frames in the multi-imset file                   
are then combined using ocrreject, which performs a                   
three-step iterative cosmic-ray rejection with                        
rejection thresholds of 5, 4, and 3 sigma,                            
respectively.                                                         
After cosmic ray rejection, the combined bias was                     
divided by the number of frames combined (ocrreject                   
adds images instead of averaging them), using the                     
stsdas.toolbox.imgtools.mstools.msarith routine.                      
Subsequently, hot pixels (and columns) were identified                
as follows. A median-filtered version of the averaged                 
bias is created (kernel = 15 x 3 pixels) and                          
subtracted from the averaged bias, leaving a                          
'residual' image containing hot pixels and columns.                   
The pixels hotter than 5 sigma of the effective RMS                   
noise in the residual bias image are then identified,                 
and flagged as such in the Data Quality (DQ)                          
extension of the output reference bias file.                          
",
	'N')
GO
INSERT stis_row
	( file_name,
	 expansion_number,
	 delivery_number,
	 binaxis1,
	 binaxis2,
	 ccdamp,
	 ccdgain,
	 ccdoffst,
	 detector,
	 equivalence_class_severe,
	 equivalence_class_moderate,
	 pedigree,
	 observation_begin_date,
	 observation_end_date)
VALUES ('K5Q1116BO_BIA.FITS',
	0,
	10675,
	2,
	2,
	'D',
	1,
	3,
	'CCD',
	170697,
	170698,
	'INFLIGHT',
	'APR 22 2000',
	'MAY 5 2000')
GO
INSERT stis_file
	(delivery_number,
	reference_file_type,
	file_name,
	expansion_number,
	useafter_date,
	comparison_file_name,
	opus_flag,
	comment,
	reject_flag)
VALUES (10675,
	'BIA',
	'K5Q1116BO_BIA.FITS',
	0,
	'APR 22 2000 00:00:00',
	'K4I1656HO_BIA.FITS',
	'Y',
	"Superbias created by R. Diaz-Miller
Created on May 25, 2000 using the cl scripts                          
'refbias' and 'refaver', which are available                          
in the (local) xstis package within STSDAS.                           
Superbias image, combination of 28 input bias frames                  
taken in CCDGAIN=1, BINAXIS1=2, BINAXIS2=2 mode.                      
All input frames were from Cycle 8 Proposal 8439:                     
'CCD Bias Monitor C8'.                                                
The following input files were used:                                  
o5lr2d050                                                             
o5lr2e050                                                             
o5lr2f050                                                             
o5lr2g050                                                             
o5lr2h050                                                             
o5lr2i050                                                             
o5lr2j050                                                             
o5lr2k050                                                             
o5lr2l050                                                             
o5lr2m050                                                             
o5lr2n050                                                             
o5lr2o050                                                             
o5lr2p050                                                             
o5lr2q050                                                             
cl script 'refbias' was run on these input files,                     
after having split them up into sub-lists of less                     
than 30 imsets each. After running 'refbias' on the                   
individual sub-lists, script 'refaver' was run to                     
average the reference files resulting from the                        
individual 'refbias' runs together.                                   
The 'refbias' procedure works as follows. After                       
joining the files together into a multi-imset file,                   
overscan subtraction is performed for every individual                
bias frame. The bias frames in the multi-imset file                   
are then combined using ocrreject, which performs a                   
three-step iterative cosmic-ray rejection with                        
rejection thresholds of 5, 4, and 3 sigma,                            
respectively.                                                         
After cosmic ray rejection, the combined bias was                     
divided by the number of frames combined (ocrreject                   
adds images instead of averaging them), using the                     
stsdas.toolbox.imgtools.mstools.msarith routine.                      
Subsequently, hot pixels (and columns) were identified                
as follows. A median-filtered version of the averaged                 
bias is created (kernel = 15 x 3 pixels) and                          
subtracted from the averaged bias, leaving a                          
'residual' image containing hot pixels and columns.                   
The pixels hotter than 5 sigma of the effective RMS                   
noise in the residual bias image are then identified,                 
and flagged as such in the Data Quality (DQ)                          
extension of the output reference bias file.                          
",
	'N')
GO
