/* CDBSLIB.H -- Function templates for cdbs library routines */

#ifndef  CDBSLIB_H
#define  CDBSLIB_H

#include <stdio.h>
#include "loadfile.h"
#include "reffile.h"

extern void	addsubdir (char *, char *, char *, int);
extern char *	basename (const char *);
extern void	breakfname (const char *, char *, char *, char *, int);
extern void	cdbs_error (const int, const char *, ...);
extern void	cdbs_info (const int, const char *, ...);
extern void	cdbs_message (const int, const char *);
extern void	cdbs_warn (const int, const char *, ...);
extern char *	dtoa (double);
extern char *	enquote (char *);
extern int	first_char (char *);
extern int	getirafdir (reffile *, char *, char *, char *, char *, int);
extern int	is_continued (char *);
extern int	is_datafile (char *);
extern int	is_number (char *);
extern int	is_upcase (char *);
extern char *	itoa (int);
extern void	lastfile (const char *, char *, int);
extern char *	nospaces (char *);
extern void	pathname (char *, const char *, const char *, int);
extern int	patmatch (const char *, const char *);
extern int	rdlines (FILE *, char *, const int);
extern void	safecat (char *, const char *, int);
extern void	safecopy (char *, const char *, int);
extern int	similar (char *, char *);
extern int	strabbrev (const char *, const char *);
extern char *	strclone (const char *);
extern int	strmatch (const char *, const char *);
extern void	strsplit (const int, char *, char **, const int);
extern void 	task (int, char **);
extern void	unquote (char *);
extern void	wild_expand (const char *, const int, int *, char **);
extern void	write_sdastab (table *, int, int *, char *);
extern void	xlate_fname (char *, char *, int);

extern double	get_cdbs_date (const char *);
extern double	get_now (void);
extern double	get_slash_date (const char *);
extern double	get_sybase_date (const char *);
extern void	put_short_date (double, char *, int);
extern void	put_sybase_date (double, char *, int);

extern void	close_lookup (table *);
extern int	find_lookup (table *, char *);
extern char *	name_lookup (table *);
extern table *	open_lookup (char *, char *);

#endif
