/* ERROR.H -- Error codes used in CDBS, must match src/cdbslib/errormsg.h */

#ifndef  ERROR_H
#define  ERROR_H

/* Error message levels */

#define	 INFO_MSG	0
#define  WARN_MSG	1
#define  ERROR_MSG	2

/* Error message symbolic codes */

#define  UNKNOWN	0
#define  NOTOPEN	1
#define  NOMATCH	2
#define  AMBIG		3
#define  NOLOOK		4
#define  FTYPE		5
#define  NOREC		6
#define  BADFUNC	7
#define  BADLIST	8
#define  WFILE		9
#define  NOCOL		10
#define  MAXKEY		11
#define  NODATE		12
#define  RENAME		13
#define  NOLOAD		14
#define  NOWRITE	15
#define  BADINST	16
#define  NOIRAF		17
#define  BADREF		18
#define  NOVAR		19
#define  QRYLEN		20
#define  TOOLONG	21
#define  NEWNAME	22
#define  USAGE		23
#define  BADWIDTH	24
#define  NOTHRU		25
#define  MAXDEF		26
#define  NOTRANS	27
#define  BADFIELD	28
#define  SYNTAX		29
#define  BADTHRU	30
#define  BADRULE	31
#define  BADEXT		32
#define  BADTYPE	33
#define  BADKEY		34
#define  NOHDRKEY	35
#define  BADNROW	36
#define  EXPANDED	37
#define  NOCHILD	38
#define  NONUNIQ	39
#define  NOSETNAM	40
#define	 NODBROWS	41
#define  VERSION	42
#define  NOOPT		43
#define  BADOPT		44
#define  MULTIREF	45
#define  NOLIST		46
#define  BADQRYFMT	47
#define  NOICODE	48
#define  NOMODE		49
#define  NOROOT		50
#define  NOREFFILE	51
#define  EXTRAPAR	52
#define  NOADDCOL	53
#define  AMBIGCOL	54
#define  NODICT		55
#define  NOQUOTE	56
#define  NODOT		57
#define  MANYTAB	58
#define  NODBCOLS	59

#define  MAXERR		NODBCOLS	/* Highest error mesage */

/* Variable signalling whether an error condition has occured */

extern int	cdbs_errorflag;

/* Variable containing pointer to function with optional error handler */

extern void	(*cdbs_errhandler) (int, const char *);

#endif

