/* LOADFILE.H -- Structure and constant definitions for the loadfile library */

#ifndef  LOADFILE_H
#define  LOADFILE_H

#include "system.h"

#define  GOOD		(0)
#define	 BAD		(-1)

#define  nrow_table(tab)	((tab)->nrow)
#define  ncol_table(tab)	((tab)->ncol)
#define  nkey_table(tab)	((tab)->keyname.nline)

typedef struct {
char	*info;
int	next;
int	size;
int	increment;
} charbuf;

typedef struct {
int	*info;
int	next;
int	size;
int	increment;
} intbuf;

typedef struct {
charbuf	string;
intbuf	line;
int	nline;
} textbuf;

typedef struct {
textbuf	keyname;
textbuf keyval;
textbuf colname;
textbuf cell;
int	nrow;
int	ncol;
} table;

extern char	*lod_error;

extern table *	read_loadfile (char *);
extern int	write_loadfile (char *, table *);

extern int	add_tab_col (table *, char *);
extern int	cat_tab_cell (table *, char *, int, char *);
extern int	cat_tab_key (table *, char *, char *);
extern table *	create_table (void);
extern void	free_table (table *);
extern char *	get_tab_cell (table *, char *, int);
extern char *	get_tab_cell_bynum (table *, int, int);
extern char *	get_tab_colname (table *, int);
extern int	get_tab_colnum (table *, char *);
extern char *	get_tab_key (table *, char *);
extern char *	get_tab_keyname_bynum (table *, int);
extern char *	get_tab_keyval_bynum (table *, int);
extern int	put_tab_cell (table *, char *, int, char *);
extern int	put_tab_key (table *, char *, char *);
extern void	trunc_table (table *, int);

extern int	add_text (textbuf *, char *);
extern int	cat_text (textbuf *, int, char *);
extern int	copy_text (textbuf *, int, int);
extern int	find_text (textbuf *, char *);
extern void	free_text (textbuf *);
extern char *	get_text (textbuf *, int);
extern void	init_text (textbuf *, int, int);
extern int	put_text (textbuf *, int, char *);

extern void	init_char_buf (charbuf *, int);
extern void	init_int_buf (intbuf *, int);
extern int	put_char_buf (charbuf *, char *);
extern int	put_int_buf (intbuf *, int);
extern int	top_char_buf (charbuf *, int);

extern void	strclean (char *);
extern void	strlcase (char *);
extern void	strucase (char *);

#endif
