/* SYSTEM.H -- Definitions dependent on the operating system */

#ifndef  SYSTEM_H
#define  SYSTEM_H

#ifdef __VMS
#include <ssdef.h>
#include <signal.h>

#ifdef __ALPHA
#pragma  extern_model common_block
#define  MAIN_TYPE	int
#define  MAIN_RETURN(x)	return(x)

#else
#pragma  extern_model common_block shr
#define  MAIN_TYPE	void
#define  MAIN_RETURN(x)		/* nothing */
#endif

#define  DIR_SEPCHAR	'.'
#define  DIR_ENDCHAR	']'

#define  NORMAL_EXIT	SS$_NORMAL
#define  ERROR_EXIT	2

#define  CDBSDIR	"disk$reference:[cdbsdata.refer]"
#define  DATADIR	"disk$user6:[bsimon.iraf.newcdbs.data]" #x

#else
#include <stdlib.h>
#include <unistd.h>

#define  DIR_SEPCHAR	'/'
#define  DIR_ENDCHAR	'/'

#define  NORMAL_EXIT	EXIT_SUCCESS
#define  ERROR_EXIT	EXIT_FAILURE

#define  MAIN_TYPE	int
#define  MAIN_RETURN(x)	return(x)

/* ** setup for cdbs test environment **
 * #define  CDBSDIR	"/data/cdbs1/"
 * #define  DATADIR(x)	"/data/ralph2/cdbs_d/code_d/cdbs_test/data/" #x
 */

/* ** setup for Bernie Simon's test environment ** */
#define  CDBSDIR	"/project/ra3/refer/"
#define  DATADIR(x)	"/data/lilac1/bsimon/iraf/newcdbs/data/" #x

#endif

#define  CATALOG_NAME	DATADIR(cdbscatalog.dat)
#define  DIRECTORY_NAME	DATADIR(directory.dat)
#define  THRUCAT_NAME   DATADIR(thrucat.dat)

#endif
