#include <string.h>
#include <stdlib.h>
#include "config.h"
#include "system.h"
#include "cdbslib.h"

#define  MAXSUBDIR		8

/* ADDSUBDIR -- Add a subdirectory onto a directory name
 * 
 * i: rootdir	root directory
 * i: subdir	subdirectory
 * o: fulldir	full directory specification
 * i: maxch	max length of full directory specification
 */

void addsubdir (char *rootdir, char *subdir, char *fulldir, int maxch)
{
    int		nc, idir;
    char	*ch, *sublist, *dir[MAXSUBDIR];

    /* Subdirectory name is assumed to be in Unix format:
     * directories separated by slashes, above directory
     * indicated by "..".
     */

    sublist = strclone (subdir);
    strsplit ('/', sublist, dir, MAXSUBDIR);

    /* Remove trailing char from root directory specification */

    safecopy (fulldir, rootdir, maxch);

    nc = strlen (fulldir);
    if (fulldir[nc-1] == DIR_ENDCHAR)
	fulldir[--nc] = EOS;

    /* Add subdirectory names */

    for (idir = 0; idir < MAXSUBDIR && dir[idir][0] != EOS; idir ++) {
	if (strcmp ("..", dir[idir]) == 0) {
	    ch = strrchr (fulldir, DIR_SEPCHAR);
	    if (ch != NULL)
		ch = EOS;

	} else {
	    fulldir[nc++] = DIR_SEPCHAR;
	    fulldir[nc] = EOS;
	    safecat (fulldir, dir[idir], maxch);
	    nc = strlen (fulldir);
	}
    }

    /* Add trailing char back on */

    fulldir[nc++] = DIR_ENDCHAR;
    fulldir[nc] = EOS;

    free (sublist);
}
