#include <stdlib.h>
#include "ostdb.h"
#include "dbquery.h"
#include "config.h"
#include "cdbslib.h"

/* INIT_QUERY -- Initialize the query context
 *
 */

context *init_query (void)
{
    context	*qry;
    char	*server, *cdbs_db, *dads_db, *user;

    qry = (context *) malloc (sizeof (context));

    qry->connection = STDB_CONN_1;

    server = getenv ("CDBS_SERVER");
    if (server == NULL || server[0] == EOS) {
	safecopy (qry->server, CDBS_SERVER, SZ_STRING);
    } else {
	safecopy (qry->server, server, SZ_STRING);
    }

    cdbs_db = getenv ("CDBS_DB");
    if (cdbs_db == NULL || cdbs_db[0] == EOS) {
	safecopy (qry->cdbs_db, CDBS_DB, SZ_STRING);
    } else {
	safecopy (qry->cdbs_db, cdbs_db, SZ_STRING);
    }

    dads_db = getenv ("DADS_DB");
    if (dads_db == NULL || dads_db[0] == EOS) {
	safecopy (qry->dads_db, DADS_DB, SZ_STRING);
    } else {
	safecopy (qry->dads_db, dads_db, SZ_STRING);
    }

    user = getenv ("CDBS_USER");
    if (user == NULL || user[0] == EOS || strcmp (user, CDBS_USER) == 0) {
	ostdb_setup (qry->connection, STDB_USERNAME, CDBS_USER);
	ostdb_setup (qry->connection, STDB_PASSWORD, CDBS_PASSWORD);
    } else {
	ostdb_setup (qry->connection, STDB_USERNAME, user);
    }

    return (qry);
}

