#include <string.h>
#include "config.h"
#include "cdbslib.h"

/* IS_DATAFILE -- Determine if a file is the datafile of an image
 *
 * i: fname	name of file to be checked
 */

int is_datafile (char *fname)
{
    int		status;
    char	header[SZ_FNAME+1];
    char	dir[SZ_FNAME+1], root[SZ_FNAME+1], ext[SZ_FNAME+1];

    /* Extract the extension from the filename */

    breakfname (fname, dir, root, ext, SZ_FNAME);

    if (strcmp (ext, ".pix") == 0) {
	/* Iraf format image data file */
	status = YES;

    } else if (strcmp (ext, ".lod") == 0) {
	/* Load file */
	status = NO;

    } else if (ext[3] == 'd' && ext[4] == EOS) {
	/* SDAS format data file. Also check for the presence of header */
	ext[3] = 'h';

	safecopy (header, dir, SZ_FNAME);
	safecat (header, root, SZ_FNAME);
	safecat (header, ext, SZ_FNAME);

	status = access_reffile (header, "image", "r");

    } else {
	/* Any other extension is not a datafile */
	status = NO;
    }

    return (status);
}
