#include <ctype.h>
#include <string.h>
#include "config.h"
#include "cdbslib.h"
#include "loadfile.h"

#define BASE16(x)	((x)>'9' ? (x)-'a'+10 : (x)-'0')

static void	decode_cgi (char *);
static int	decode_hex (char *, int *);

/* PARSE_CGI -- Retrieve task parameters from CGI input
 *
 * u: buf	buffer containing cgi input
 */

void parse_cgi (char *buf)
{
    int		ipar;
    char	*param[MAXPARAM+1];

    strlcase (buf);
    strsplit ('&', buf, param, MAXPARAM);

    for (ipar = 0; param[ipar][0] != EOS; ipar ++) {
	decode_cgi (param[ipar]);
	if (strchr (param[ipar], '=') != NULL)
	    put_option (param[ipar]);
    }
}

/* DECODE_CGI -- Convert escaped characters to their ascii representation
 *
 * i: param	parameter string to decode
 */

static void decode_cgi (char *param)
{
    int		ic, jc;

    for (ic = jc = 0; param[ic] != EOS; ic ++, jc ++) {
	if (param[ic] == '+') {
	    param[jc] = ' ';
	} else if (param[ic] == '%') {
	    param[jc] = decode_hex (param, &ic);
	} else if (jc < ic) {
	    param[jc] = param[ic];
	}
    }

    param[jc] = EOS;
}


/* Convert a hex encoded character into ascii
 *
 * i: param	parameter containing hex encoded sequences
 + u: ic	index of start of hex sequence
 */

static int decode_hex (char *param, int *ic)
{
    int		ch;

    if (! isxdigit(param[*ic+1]) || ! isxdigit(param[*ic+2])) {
	ch = param[*ic];
    } else {
	ch = 16 * BASE16(param[*ic+1]) + BASE16(param[*ic+2]);
	*ic += 2;
    }

    return(ch);
}
