#include "config.h"
#include "cdbslib.h"

/* PATMATCH -- Simple filename pattern matching */

int patmatch (const char *pattern, const char *str)
{
    int		ic, jc;

    ic = 0;
    jc = 0;

    for (;;) {
	if (pattern[ic] == '*') {
	    if (pattern[ic+1] == str[jc] || str[jc] == EOS) {
		ic ++;
	    } else {
		jc ++;
	    }

	} else if (pattern[ic] == '?' && str[jc] != EOS) {
	    ic ++;
	    jc ++;

	} else if (pattern[ic] == EOS) {
	    return (str[jc] == EOS);

	} else if (pattern[ic] == str[jc]) {
	    ic ++;
	    jc ++;

	} else {
	    return (0);
	}
    }
}
