#include <stdlib.h>
#include "config.h"
#include "cdbslib.h"
#include "loadfile.h"
#include "error.h"

/* STRMATCH -- Find index of string in dictionary which matches input string
 *
 * i: input	input string
 * i: dict	dictionary
 */

int strmatch (const char *input, const char *dict)
{
    char	*str;
    int		ic, jc, state, match, index;

    /* Make lower case copy of input for case independent match */

    str = strclone (input);
    strlcase (str);

    jc = 0;
    state = 0;
    index = 1;		/* current string in dictionary */

    /* Two states:
     * 0 = matching input to dictionary
     * 1 = skipping dictionary chars until next string
     */

    for (ic = 0; dict[ic] != EOS; ic ++) {
	/* Return index of dictionary string which matches input */

	if (str[jc] == EOS && dict[ic] == '|')
	    break;

	if (dict[ic] == '|') {
	    /* Check for end of dictionary entry */

	    jc = 0;
	    index ++;
	    state = 0;

	} else if (state == 0) {
	    /* Match input against dictionary 
	     * If no match, skip to next entry
	     */

	    if (dict[ic] == str[jc]) {
		jc ++;
	    } else {
		jc = 0;
		state = 1;
	    }
	}
    }

    if (str[jc] != EOS)
	index = 0;

    free (str);
    return (index);
}
