/* TEMPLATE.H -- Structures and function prototypes for template files */

#ifndef TEMPLATE_H
#define TEMPLATE_H

#include <stdio.h>
#include "reffile.h"

#define	 SZ_FIELD	31	/* max length field name */
#define  SZ_RULE	4095	/* max record in template file */

typedef union {
char			*str;
double			num;
} value;

typedef int (*cmpfunc)(value, value);

typedef struct {
int			keytype;
int			datatype;
int			presence;
int			sorted;
int			nval;
int			(*function)(char *);
value			*min;
value			*max;
char			field[SZ_FIELD+1];
} rule_rec;

struct tpl_rec_ {
struct tpl_rec_ 	*next;
rule_rec		*rule;
int			skip;
};

typedef struct tpl_rec_ tpl_record;

typedef struct {
tpl_record 		*header;
char			name[SZ_FNAME];
} tpl_file ;

extern void		close_template (tpl_file *);
extern tpl_record *	next_template (tpl_file *, tpl_record *);
extern tpl_file	*	open_template (const char *, tpl_file *);
extern int 		skip_template (tpl_file *);

extern int 		body_rule (tpl_record *);
extern void		check_rule (tpl_record *, reffile *, int);
extern void		free_rule (rule_rec *);
extern rule_rec	*	parse_rule (char *);
extern void		study_rule (tpl_record *);

#endif


