#include <stdio.h>
#include "error.h"
#include "config.h"
#include "loadfile.h"

/* TASK -- Driver for the checkload task
 *
 * i: argc	number of task arguments
 * o: argv	array of pointers to task arguments
 */

/* This task opens the loadfile and prints any error messages the loadfile
 * library may generate.
 */

void task (int argc, char **argv)
{
    int		iarg;
    table	*tab;
    char	message[SZ_LINE+1];

    /* Open each loadfile. If the open fails print an error message */

    for (iarg = 1; iarg < argc; iarg ++) {
        sprintf (message, "== Checking %s ==\n", argv[iarg]);
	cdbs_message (INFO_MSG, message);

	tab = read_loadfile (argv[iarg]);
	if (tab != NULL) {
	    free_table (tab);
	} else {
	     sprintf (message, "%s\n", lod_error);
	     cdbs_message (WARN_MSG, message);
	}
    }

}
