#include <string.h>
#include "loadfile.h"
#include "cdbslib.h"
#include "expload.h"

/* APPLY_RULE -- Use action table to expand work table row
 *
 * u: target	target table descriptor
 * i: action	action table descriptor
 * u: work	work table descriptor
 */

int apply_rule (table *target, table *action, table *work)
{
    char	*value;
    int		wrow, trow, arow, last;

    /* Retrieve row number from work, action, and target tables */

    wrow = nrow_table(work) - 1;

    value = get_tab_cell (work, "_TARGET", wrow);
    trow = atoi (value);

    value = get_tab_cell (work, "_INDEX", wrow);
    arow = atoi (value);

    /* Get last row in action table associated with target rule */

    value = get_tab_cell (target, "_LAST", trow);
    last = atoi (value);

    if (arow > last) {
        /* If all actions have been applied, pop work table */

        trunc_table (work, wrow);

    } else {
        /* Push top row of work table onto new row and copy
	 * non-empty strings from action table onto it
	 */

        move_tabrow (work, wrow, work, wrow+1);
	move_tabrow (action, arow, work, wrow+1);
	put_tab_cell (work, "_USED", wrow+1, itoa(trow));
	put_tab_cell (work, "_INDEX", wrow, itoa(arow+1));
    }
}
