#include <stdio.h>
#include "error.h"
#include "parse.h"
#include "expload.h"

/* PARSE_RULES -- Parse the rules file to produce target and action tables
 *
 * i: rules	name of rules file
 * i: itab	input table descriptor
 * u: target	target table descriptor
 * u: action	action table descriptor
 */

void parse_rules (char *rules, table *itab, table *target, table *action)
{
    FILE 	*fd;

    /* Define the columns in the target and action tables */

    copy_layout (itab, target, "_FIRST,_LAST");
    copy_layout (itab, action, "");

    /* Open the rules file */

    fd = fopen (rules, "r");
    if (fd == NULL) 
      cdbs_error (NOTOPEN, "%s", rules);

    /* Define the global variables used by the parser */

    yyin = fd;
    xline = 1;
    xtarget = target;
    xaction = action;

    /* Parse the rules file */

    yyparse ();

    /* Close the rules file */

    fclose (fd);

    /* Debugging prints -- Write the target and action files 
     *  
     *
     * write_loadfile ("target.lod", target);
     * write_loadfile ("action.lod", action);
     */

}
