#include <string.h>
#include "ostdb.h"
#include "getobsmode.h"

/* QRYFOCMODE -- Query the database for the foc observation mode fields
 *
 * i: root	observation rootname
 */

int qryfocmode (char *root, char *optcrly, char *smmmode, char *cammode, 
		char *kxdeploy, char *filtnam1, char *filtnam2, 
		char *filtnam3, char *filtnam4, char *pxformt, int *samppln, 
		int *linepfm, int *sampoff, int *lineoff)
{
    int		status;
    char	query[SZ_COMMAND+1];

    char	qryformat[] = "select a.fcr_optcrly, a.fcr_smmmode, "
	"a.fcr_filtnam3, a.fcr_cammode, a.fcr_kxdeploy, a.fcr_filtnam1, "
	"a.fcr_filtnam2, a.fcr_filtnam4, a.fcr_pxformt, a.fcr_samppln, "
	"a.fcr_linepfm, a.fcr_sampoff, a.fcr_lineoff from foc_ref_data a "
	"where a.fcr_data_set_name = '%s'\n";

    /* Start query and bind output variables */

    ostdb_query_setup (OBS_CHANNEL, "qryfocmode", 1, STDB_SQL,  
		       OBS_SERVER, OBS_DBNAME, NULL);

    stdb_bind_string (OBS_CHANNEL, "fcr_optcrly", optcrly, SZ_FIELD);
    stdb_bind_string (OBS_CHANNEL, "fcr_smmmode", smmmode, SZ_FIELD);
    stdb_bind_string (OBS_CHANNEL, "fcr_cammode", cammode, SZ_FIELD);
    stdb_bind_string (OBS_CHANNEL, "fcr_kxdeploy", kxdeploy, SZ_FIELD);
    stdb_bind_string (OBS_CHANNEL, "fcr_filtnam1", filtnam1, SZ_FIELD);
    stdb_bind_string (OBS_CHANNEL, "fcr_filtnam2", filtnam2, SZ_FIELD);
    stdb_bind_string (OBS_CHANNEL, "fcr_filtnam3", filtnam3, SZ_FIELD);
    stdb_bind_string (OBS_CHANNEL, "fcr_filtnam4", filtnam4, SZ_FIELD);
    stdb_bind_string (OBS_CHANNEL, "fcr_pxformt", pxformt, SZ_FIELD);
    stdb_bind_int (OBS_CHANNEL, "fcr_samppln", samppln);
    stdb_bind_int (OBS_CHANNEL, "fcr_linepfm", linepfm);
    stdb_bind_int (OBS_CHANNEL, "fcr_sampoff", sampoff);
    stdb_bind_int (OBS_CHANNEL, "fcr_lineoff", lineoff);

    /* Build query */

    sprintf (query, qryformat, root);
    stdb_query (OBS_CHANNEL, query);
    
    /* Execute query, saving results in bound variables */

    if (ostdb_get_exec(OBS_CHANNEL) == STDB_CONTINUE) {
	trim_qryfield (optcrly);
	trim_qryfield (smmmode);
	trim_qryfield (cammode);
	trim_qryfield (kxdeploy);
	trim_qryfield (filtnam1);
	trim_qryfield (filtnam2);
	trim_qryfield (filtnam3);
	trim_qryfield (filtnam4);
	trim_qryfield (pxformt);
	status = MATCH;
    } else {
	status = NOMATCH;
    }

    /* Clean up after query */

    stdb_close_query (OBS_CHANNEL);
    return (status);
}
