#include <string.h>
#include "ostdb.h"
#include "getobsmode.h"

/* QRYNICMODE -- Query the database for the nicmos observation mode fields
 *
 * i: root	observation rootname
 * o: camera	camera used
 * o: filter	filter used
 */

int qrynicmode (char *root, int *camera, char *filter)
{
    int		status;
    char	query[SZ_COMMAND+1];

    char	qryformat[] = "select a.nsr_camera, a.nsr_filter from "
	"nicmos_ref_data a where a.nsr_data_set_name = '%s'\n";

    /* Start query and bind output variables */

    ostdb_query_setup (OBS_CHANNEL, "qrynicmode", 1, STDB_SQL,  
		       OBS_SERVER, OBS_DBNAME, NULL);

    stdb_bind_int (OBS_CHANNEL, "nsr_camera", camera);
    stdb_bind_string (OBS_CHANNEL, "nsr_filter", filter, SZ_FIELD);

    /* Build query */

    sprintf (query, qryformat, root);
    stdb_query (OBS_CHANNEL, query);
    
    /* Execute query, saving results in bound variables */

    if (ostdb_get_exec(OBS_CHANNEL) == STDB_CONTINUE) {
	trim_qryfield (filter);
	status = MATCH;
    } else {
	status = NOMATCH;
    }

    /* Clean up after query */

    stdb_close_query (OBS_CHANNEL);
    return (status);
}
