#include <string.h>
#include "ostdb.h"
#include "getobsmode.h"

/* QRYWFPC2MODE -- Query the database for the wfpc2 observation mode fields
 *
 * i: root	observation rootname
 * o: atodgain	value of gain
 * o: filter1	first filter used
 * o: filter2	second filter used
 */

int qrywfpc2mode (char *root, int *atodgain, char *filter1, char *filter2)
{
    int		status;
    char	query[SZ_COMMAND+1];

    char	qryformat[] = "select a.w2r_atodgain, a.w2r_filtnam1, "
	"a.w2r_filtnam2 from wfpc2_ref_data a where "
	"a.w2r_data_set_name = '%s'\n";

    /* Start query and bind output variables */

    ostdb_query_setup (OBS_CHANNEL, "qrywfpc2mode", 1, STDB_SQL,  
		       OBS_SERVER, OBS_DBNAME, NULL);

    stdb_bind_int (OBS_CHANNEL, "w2r_atodgain", atodgain);
    stdb_bind_string (OBS_CHANNEL, "w2r_filtnam1", filter1, SZ_FIELD);
    stdb_bind_string (OBS_CHANNEL, "w2r_filtnam2", filter2, SZ_FIELD);

    /* Build query */

    sprintf (query, qryformat, root);
    stdb_query (OBS_CHANNEL, query);
    
    /* Execute query, saving results in bound variables */

    if (ostdb_get_exec(OBS_CHANNEL) == STDB_CONTINUE) {
	trim_qryfield (filter1);
	trim_qryfield (filter2);
	status = MATCH;
    } else {
	status = NOMATCH;
    }

    /* Clean up after query */

    stdb_close_query (OBS_CHANNEL);
    return (status);
}
