#include <string.h>
#include "ostdb.h"
#include "getobsmode.h"

/* QRYWFPCMODE -- Query the database for the wfpc observation mode fields
 *
 * i: root	observation rootname
 * o: camera	camera used
 * o: filter1	first filter used
 * o: filter2	second filter used
 */

int qrywfpcmode (char *root, char *camera, int *filter1, int *filter2)
{
    int		status;
    char	query[SZ_COMMAND+1];

    char	qryformat[] = "select a.wcr_camera, a.wcr_filter1, "
	"a.wcr_filter2 from wfpc_ref_data a where "
	"a.wcr_data_set_name = '%s'\n";

    /* Start query and bind output variables */

    ostdb_query_setup (OBS_CHANNEL, "qrywfpcmode", 1, STDB_SQL,  
		       OBS_SERVER, OBS_DBNAME, NULL);

    stdb_bind_string (OBS_CHANNEL, "wcr_camera", camera, SZ_FIELD);
    stdb_bind_int (OBS_CHANNEL, "wcr_filter1", filter1);
    stdb_bind_int (OBS_CHANNEL, "wcr_filter2", filter2);

    /* Build query */

    sprintf (query, qryformat, root);
    stdb_query (OBS_CHANNEL, query);
    
    /* Execute query, saving results in bound variables */

    if (ostdb_get_exec(OBS_CHANNEL) == STDB_CONTINUE) {
	trim_qryfield (camera);
	status = MATCH;
    } else {
	status = NOMATCH;
    }

    /* Clean up after query */

    stdb_close_query (OBS_CHANNEL);
    return (status);
}
