#include <string.h>
#include "error.h"
#include "config.h"
#include "cdbslib.h"
#include "getref.h"

/* GETICODE_OBS -- Get index of instrument from observation set name
 *
 * i: obset	observation set name
 */

int get_icode_obs (char *obset)
{
    char	*ch;
    char	*icodes = ICODES;

    ch = strchr (icodes, obset[0]);
    if (ch == NULL)
	cdbs_error (NOICODE, "%s", obset);

    return (ch - icodes);
}

/* GETICODE_REF -- Get index of instrument from reference file name
 *
 * i: reffile	reference file name
 */

int get_icode_ref (char *reffile)
{
    int		nc;
    char	*ch, *pos;
    char	*icodes = ICODES;
    char	root[SZ_STRING+1], ext[SZ_STRING+1];

    breakfname (reffile, NULL, root, ext, SZ_STRING);

    ch = NULL;
    nc = strlen (root);

    if (strncmp (ext, ".fit", 4) == 0) {
	pos = strrchr (root, '_');
    } else if (nc > 0) {
	pos = root + nc;
    } else {
	pos = NULL;
    }

    if (pos != NULL)
	ch = strchr (icodes, *(pos-1));

    if (ch == NULL)
	cdbs_error (NOICODE, "%s", reffile);

    return (ch - icodes);
}
