/* GETREF.H -- Constants and functions used by getref */

#ifndef GETREF_H
#define GETREF_H

#include <stdio.h>
#include "system.h"
#include "dbquery.h"
#include "loadfile.h"

#define  SZ_PARAM	255

#define  NOREF		0
#define  ALLREF		1
#define  ONEREF		2

#define	 MAXINST	10
#define  MAXREF		30
#define  MAXMODE	15
#define  MAXDETAIL	10

extern char * 	instrument[MAXINST];
extern char *	cdbsfile[MAXINST];
extern char *	cdbsrow[MAXINST];
extern char *	dadstab[MAXINST];
extern char *	obsfield[MAXINST];
extern char *	keyword[MAXINST][MAXREF];
extern char *	bestref[MAXINST][MAXREF];
extern char *	oldref[MAXINST][MAXREF];
extern char *	cdbsmode[MAXINST][MAXMODE];
extern char *	dadsmode[MAXINST][MAXMODE];
extern char *	detail_filecol[MAXDETAIL];
extern char *	detail_rowcol[MAXDETAIL];

extern void	clean_data (char *);
extern void	free_qryvars (char **);
extern int	get_icode_obs (char *);
extern int	get_icode_ref (char *);
extern table *	getref_all (void);
extern table *	getref_one (void);
extern void 	html_log (const char *, ...);
extern int	is_reffile (char *);
extern table *	qry_hasroot (context *, char *, char *, char **, char **);
extern table *	qry_nomode (context *, char *, char *);
extern table *	qry_noroot (context *, char *, char **);
extern void	qry_obsmode (context *, char *, char **, char **, int);
extern char *	mkanchor (char *, char *, char *, char *);
extern void	output_asc (table *);
extern void	output_html (char *, table *);
extern int	which_qry (void);
extern void	xtract_root (char *, char *, int);

#endif
