procedure loopfits (input)

string	input	{prompt = "Input file name template"}
struct	*ilist	# list of input file names
struct	*tlist	# list of output from tinfo

begin

file 	ifile	# temporary file to hold list of input file names
string	iname	# input file name from list of file names
string	oname	# output file name derived from input
file	tfile	# file containing output from tinfo
string	tline	# line of output from tinfo
bool	table	# is file a table?
int	nc	# the number of characters in the extension

	# create a temporary file in the user's uparm directory

	ifile = mktemp("tmp$")

	# create a list of file names that match the given pattern
	# redirect it to a temporary file

	files(input,>ifile)

	# read the temporary file using a list structured parameter
	# this assigns one line from the file to the parameter each
	# time it is used in the script

	ilist = ifile
	while (fscan(ilist,iname) != EOF) {
		# Try to determine if file is a table

		tfile = mktemp("tmp$")
		tinfo (iname,ttout-,>&tfile)

		tlist = tfile
		table = fscan(tlist,tline) == EOF

		delete (tfile)

		# extract file name sections from input name
		fparse(iname)

		nc = strlen (fparse.extension)

		if (table) {
			oname = fparse.directory +
				fparse.root + 
				"_" +
				substr (fparse.extension, 2, nc) +
				".fits"

		} else {
			# change last letter of extension
			oname = fparse.directory + 
				fparse.root +
				substr (fparse.extension, 1, nc-1) +
				"f"
		}

		# run the fits writer
		stwfits (iname, oname, no, binary+, gftoxdim+)

	}

	# delete the temporary file

	delete(ifile)
end	
