#include "query.h"
#include "loadfile.h"
#include "cdbslib.h"
#include "mkcomptab.h"

/* MKCOMPTAB -- Create a loadfile table containing component lookup info
 *
 * u: comptab	component lookup table
 */

void mkcomptab (table *comptab)
{
    context	*qry;
    static char	*dbcols = DBCOL_COMPTAB;
    static char *tabcols = CNAME_COMPTAB;

    /* Set up the table columns and header keywords */

    init_comptab (tabcols, comptab);

    /* Read the throughput table names into the component table */

    qry = init_query ();
    comptab_query (qry, NCOL_COMPTAB, dbcols, tabcols, comptab);
    free_query (qry);

    /* Update component name from throughput column names */

    update_comp (comptab);
}
