#include "alist.h"
#include "loadfile.h"
#include "cdbslib.h"
#include "mkload.h"

/* READ_OBSMODE -- Read observation mode from table into list
 *
 * i: tab	table descriptor
 * o: obsmode	observation mode list
 */

void read_obsmode (table *tab, alist *obsmode)
{
    int		icol;
    char	*obscol, *obsval;

    static char	*nonobsmode = "change_level|pedigree|\
observation_begin_date|observation_end_date|expansion_number|comment";

    /* Skip non-obsmode columns in table all others are obsmode and
     * should be added to the list.
     *
     * NB: Changes to mkloadbody must be coordinated with this function.
     */

    for (icol = 0; icol < ncol_table (tab); icol ++) {
	obscol = get_tab_colname (tab, icol);

	if (strmatch (obscol, nonobsmode) == 0) {
	    obsval = get_tab_cell_bynum (tab, icol, 0);
	    add_alist (obsmode, obscol, obsval);
	}
    }
}
