#include <stdlib.h>
#include "cdbslib.h"
#include "query.h"

#define  MAXFIELD	255

/* SPLIT_LIST -- Split delimeter separated list into an array of strings
 * 
 * i: list	list of values
 * i: delim	delimeter
 */

char ** split_list (char *list, int delim)
{
    char	*list2;
    char	**array;
    char	*field[MAXFIELD+1];
    int		ifield, nfield;

    /* Clone the input string so we don't modify it
     * and split it at the delimeter
     */

    list2 = strclone (list);
    strsplit (delim, list2, field, MAXFIELD);

    /* Count the number of fields */

    for (nfield = 0; field[nfield][0] != EOS; nfield ++)
        ;

    /* Allocate arrays and copy fields into it */

    array = (char **) malloc ((nfield + 1) * sizeof (char *));
    for (ifield = 0; ifield < nfield; ifield ++)
        array[ifield] = strclone (field[ifield]);

    /* Mark end of array with a zero length string */

    array[nfield] = strclone ("");

    free (list2);
    return (array);
}
