#include <stdio.h>
#include "xsynphot.h"
#include "error.h"
#include "config.h"
#include "cdbslib.h"
#include "syndemo.h"

#define  MAXSYNFILES	20

/* TASK -- Driver for the syndemo task
 *
 * i: argc	number of task arguments
 * o: argv	array of pointers to task arguments
 */

/* This task demonstrates how to call the synphot interface from a C 
 * program. It prints the throughput files associated with an observation
 * mode.
 */

void task (int argc, char **argv)
{
    char	graphtab[SZ_FNAME+1], comptab[SZ_FNAME+1];
    char	thruput[MAXSYNFILES][SZ_FNAME+1];
    char	obsmode[SZ_LINE+1];
    int		iarg, ithru, nthru;

    /* Get the names of the most recently installed synphot tables */

    getsyntab (".tmg", graphtab, SZ_FNAME);
    getsyntab (".tmc", comptab, SZ_FNAME);

    /* Task arguments form the observation mode. Combine them into
     * a comma separated string
     */

    obsmode[0] = EOS;
    for (iarg = 1; iarg < argc; iarg ++) {
        if (iarg > 1)
	    safecat (obsmode, ",", SZ_LINE);

        safecat (obsmode, argv[iarg], SZ_LINE);
    }

    /* Must initialize synphot before you can call its routines */

    c_inisyntab ();

    /* Get the array of throughput file names associated with
     * the observation mode.
     */

    c_graffiles (obsmode, graphtab, comptab, SZ_FNAME, MAXSYNFILES, 
		 &nthru, thruput);

    if (c_iraferr () != 0)
      cdbs_message (ERROR_MSG, "Incomplete or invalid observation mode\n");
 
    /* Print names to STDOUT */

    printf ("Throughput table names:\n");
    for (ithru = 0; ithru < nthru; ithru ++)
        printf ("%s\n", thruput[ithru]);
}
