#include "cdbslib.h"
#include "config.h"
#include "alist.h"
#include "uniqname.h"

/* GETLISTNAME -- Retrieve name from list of stored names
 *
 * i: newlist		list of stored names
 * i: oldname		current file name
 * o: newname		name retrieved from list
 * i: maxch		max length of retrieved name
 */

int getlistname (alist *newlist, char *oldname, char *newname, int maxch)
{
    char	dir[SZ_FNAME+1], root[SZ_FNAME+1], ext[SZ_FNAME+1];
    char	*newroot;
    int 	status;

    breakfname (oldname, dir, root, ext, SZ_FNAME);

    if ((newroot = find_alist (newlist, root)) == NULL) {
	newname[0] = EOS;
	status = ERR;

    } else {
	safecopy (newname, dir, maxch);
	safecat (newname, newroot, maxch);
	safecat (newname, ext, maxch);
	status = OK;
    }

    return (status);
}
