#include "cdbslib.h"
#include "config.h"
#include "uniqname.h"

/* OLDINSTNAME -- Calculate a unique name for the old (pre-97) instruments
 *
 * i: cdbsdir		the directory the reference file will be stored in
 * i: code		the instrument code number
 * o: newroot		the unique root name
 * i: maxch		maximum length of calculated name
 */

void oldinstname (char *cdbsdir, int code, char *newroot, int maxch)
{
    static char	*icode = ICODES;

    char	trailer[SZ_FNAME+1], cdbsname[SZ_FNAME+1];
    char	cdbsroot[SZ_FNAME+1];

    /* The last letter of the filename root is the instrument code
     * combined with the extension it forms the "trailer"
     */

    trailer[0] = icode[code-1];
    trailer[1] = EOS;
    safecat (trailer, ".*", SZ_FNAME);
	
    /* Loop until we create a new file name root not already 
     * in the cdbs directories
     */

    do {
        makeid (newroot);

	safecopy (cdbsname, cdbsdir, SZ_FNAME);
	safecat (cdbsname, newroot, SZ_FNAME);
	safecat (cdbsname, trailer, SZ_FNAME);

	lastfile (cdbsname, cdbsroot, SZ_FNAME);
    } while (strcmp (cdbsname, cdbsroot) != 0);
	
    trailer[1] = EOS;
    safecat (newroot, trailer, SZ_FNAME);
}
